#include "Camera3D.h"
#include "Basic3DMath.h"

Matrix Basic3D::Camera3D::createViewMatrix()
{
    Vector3D w = m_vpn; w.normalize();
    Vector3D u = w % m_vup; u.normalize();
    Vector3D v = u % w;

    Matrix Tuvw;
    Basic3DMath::affine( &Tuvw, &u, &v, &w, &m_vrp );

    Matrix iTuvw;
    Basic3DMath::invert( &iTuvw, &Tuvw );

    //Transform3D Tshear(ZSHEAR, -eye.X()/eye.Z(), -eye.Y()/eye.Z());

    //perspective projection
    Matrix Teye;
    Basic3DMath::translate( &Teye, -m_eye.x, -m_eye.y, -m_eye.z );

    Matrix Tnorm;

    Basic3DMath::scale( &Tnorm,
                   -2 * m_eye.z / ( m_window.width * m_bp * m_zoom ),
                   -2 * m_eye.z / ( m_window.height * m_bp * m_zoom ),
                   1 / m_bp );

    Matrix Tpers;
    Basic3DMath::perspective( &Tpers, m_fp, m_bp, &m_vp );

    m_view = iTuvw * Teye * Tnorm * Tpers;

    return m_view;
}



