#include "Matrix.h"

Matrix::Matrix()
{
    for ( int i = 0; i < 4; ++i )
    {
        for ( int j = 0; j < 4; ++j )
        {
            //m[i][j] = 0.0;
            m[i][j] = ( i == j );
        }
    }
}

Matrix::Matrix( const Matrix& m )
{
    for ( int i = 0; i < 4; ++i )
    {
        for ( int j = 0; j < 4; ++j )
        {
            this->m[i][j] = m.m[i][j];
        }
    }
}

Matrix::Matrix( double _11, double _12, double _13, double _14,
                double _21, double _22, double _23, double _24,
                double _31, double _32, double _33, double _34,
                double _41, double _42, double _43, double _44 )
{
    this->_11 = _11; this->_12 = _12; this->_13 = _13; this->_14 = _14;
    this->_21 = _21; this->_22 = _22; this->_23 = _23; this->_24 = _24;
    this->_31 = _31; this->_32 = _32; this->_33 = _33; this->_34 = _34;
    this->_41 = _41; this->_42 = _42; this->_43 = _43; this->_44 = _44;
}

Matrix Matrix::operator*( const Matrix& m ) const
{
    Matrix res;

    for ( int i = 0; i < 4; ++i )
    {
        for( int j = 0; j < 4; ++j )
        {
            res.m[i][j] = 0;

            for ( int k = 0; k < 4; k++ )
            {
                res.m[i][j] += this->m[i][k] * m.m[k][j];
            }
        }
    }

    return res;
}

Matrix& Matrix::operator*=( const Matrix& m )
{
    *this = (*this) * m;
    return *this;
}
