#ifndef TABLEEDITOR3DDEFS_H
#define TABLEEDITOR3DDEFS_H


#include "../common/types/IntArray.h"


class TE3D_CursorMovingMode
{
    public:
        enum Id
        {
            CMM_RELATIVE,
            CMM_ABSOLUTE,
        };

        static int          stringToId( const wxString& align );
        static wxString     idToConfigString( int align );
        static wxString     idToLabelString( int align );

    private:
        ~TE3D_CursorMovingMode();
};


class TE3D_Align
{
    public:
        enum Id
        {
            TOP_LEFT,
            TOP_RIGHT,
            BOTTOM_LEFT,
            BOTTOM_RIGHT,
        };

        static int              stringToId( const wxString& align );
        static wxString         idToConfigString( int align );
        static wxString         idToLabelString( int align );
        static wxArrayString    getLabels();
        static int              getWxAlign( int align );

    private:
        ~TE3D_Align();
};

class TE3D_Font
{
    public:
        const static size_t MIN_SIZE;
        const static size_t MAX_SIZE;
        const static size_t DEFAULT_SIZE;

        static IntArray         getValidSizes();
        static wxArrayString    getValidSizesStrings();
        static wxString         getDefaultSizeStr();

    private:
        ~TE3D_Font();
};

#endif // TABLEEDITOR3DDEFS_H
