#ifndef TABLEEDITOR3DPARAMS_H
#define TABLEEDITOR3DPARAMS_H

#include "TableEditor3DDefs.h"


struct TableEditor3DParams
{
    int     cursorMovingMode;
    double  rotationAngleX;
    double  rotationAngleY;
    double  cameraEyeX;
    double  cameraEyeY;
    double  zoom;
    bool    showAxes;
    int     selectedLabelAlign;
    int     markedLabelAlign;
    int     labelFontSize;

    TableEditor3DParams()
        : cursorMovingMode ( TE3D_CursorMovingMode::CMM_RELATIVE )
        , rotationAngleX ( -0.645772 )
        , rotationAngleY ( 5.672320 )
        , cameraEyeX ( 0.0 )
        , cameraEyeY ( 0.1 )
        , zoom ( 1.0 )
        , showAxes ( false )
        , selectedLabelAlign ( TE3D_Align::TOP_LEFT )
        , markedLabelAlign ( TE3D_Align::TOP_LEFT )
        , labelFontSize ( 14 )
    {}
};

#endif // TABLEEDITOR3DPARAMS_H
