#ifndef AUIPANETOOLBAR_H
#define AUIPANETOOLBAR_H

#include <wx/wx.h>
#include <wx/aui/aui.h>

class AuiPaneToolBar
{
    public:
        AuiPaneToolBar(wxWindow *parent, const wxString &ori, const wxString &name, long style = 0 );
        virtual ~AuiPaneToolBar();

        wxString GetName() { return m_name; };
        wxToolBar *GetToolBar() { return m_toolBar; };
        wxString GetOrientation() { return m_orientation; };
        wxAuiPaneInfo &GetAuiPaneInfo() { return m_auiInfo; };
        void UpdateSize();

        wxSize          m_size;

        wxAuiPaneInfo   m_auiInfo;

        int ItemID;

    private:

        wxToolBar       *m_toolBar;

        wxString        m_orientation;
        wxString        m_name;
        wxSize          m_minSize;
};

WX_DECLARE_STRING_HASH_MAP(AuiPaneToolBar*, AuiPaneToolBarHash);

#endif // AUIPANETOOLBAR_H
