#include "CommunicationBase.h"
#include "logger.h"

CommunicationBase::CommunicationBase()
{
    //ctor
}

CommunicationBase::~CommunicationBase()
{
    //dtor
}


bool CommunicationBase::getAnswer(uint8_t* command, int expLen, int acceptedLen, int maxTryCount, wxString* response)
{
#ifdef SFILE_LIB
    bool isOk = false;
	int result;
	clear();
	int delay = (expLen+strlen((const char*)command)*50)*10*1000/(getBaudRate()); // len*10bit*msec/baudrate
	wxMilliSleep(delay);
	result = SendString(command, strlen((const char*)command));
	wxMilliSleep(delay);

    result = ReadString(m_buffer, expLen, maxTryCount);
    Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() len:%i"), result);
    if(result < acceptedLen){
        //response->Format() = new wxString(_T("INVALID"));
        *response = wxString(_T("INVALID"));
        isOk = false;
    }else{
        if(result >= 26){
            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer(): %02X, %02X"), m_buffer[24], m_buffer[25]);
        }
        *response = wxString::From8BitData((char*)m_buffer, result);
        //Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer():")+ (const wxString)(*response) +_T("||"));
        isOk = true;
    }
	return isOk;
#else
    bool isOk = false;
    int tryCount = 0;
    int result;
     clear();
        //Logger::logf(LOG_MSG,_T("VemsProtocol::getFirmwareInfo() getFirmwareInfo 13"));
    result = SendString(command, strlen((const char*)command));

    //response->Clear();
    do{
         //Logger::logf(LOG_MSG,_T("VemsProtocol::getFirmwareInfo() getFirmwareInfo 14"));
        result = ReadString(m_buffer, expLen, maxTryCount);
        Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() len:%i"), result);
        if(result < acceptedLen){
            //response->Format() = new wxString(_T("INVALID"));
            *response = wxString(_T("INVALID"));
            tryCount++;
            isOk = false;
        }else{
            //m_buffer[result] = '\0';
            //response = new wxString( wxString::FromAscii((char*)m_buffer) );
        /*
            wxString asciiStr ( wxString::FromAscii((char*)m_buffer) );
            wxString byteStr ( wxString::From8BitData((char*)m_buffer), result );
            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() ascii Len:%i"), asciiStr.Len() );
            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() byte  Len:%i"), byteStr.Len() );
            wxChar last = byteStr.Last();

            //byteStr.Trim();
            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() trimed byte  Len:%i"), byteStr.Len() );
            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() trimed byte last:%02X"), last);

            Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer() trimed byte last buff:%02X"), m_buffer[result-1]);
          */
            if(result >= 26){

                Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer(): %02X, %02X"), m_buffer[24], m_buffer[25]);

            }

            *response = wxString::From8BitData((char*)m_buffer, result);
            //Logger::logf(LOG_MSG,_T("CommunicationBase::getAnswer():")+ (const wxString)(*response) +_T("||"));
            isOk = true;
        }
      }while( (!isOk) && (tryCount < maxTryCount) );

    return isOk;
#endif
}

