#include "CommunicationModelApp.h"

#ifdef COMM_MODEL_WITH_GUI
    #include "CommModelGUIMain.h"
#else
    #include "CommunicationModelMainFrame.h"
#endif
#include "logger.h"
#include "DirHelper.h"
#include "MTConfigHelper.h"
#include "configmanager/ConfigHelper2.h"
#include "common/VemsMessageHashHelper.h"
#include "common/VemsContext.h"

#include <wx/filename.h>

IMPLEMENT_APP(MyApp);

bool MyApp::OnInit()
{
    wxFileName prgName = wxFileName(argv[0]);

    wxString path = prgName.GetPath();
    if(path.StartsWith(_T("."))){
        path  = wxFileName::GetCwd();
    }

    DirHelper::SetProgramRootDir(path);

    wxString logfile = DirHelper::GetPath( dDEBUGLOG ) + _T("filelog.txt");
    Logger::initLog( logfile );

    ::wxInitAllImageHandlers();

    wxObject* obj = VemsContext::initObject(_T("VemsMessageHashClass"));
    VemsMessageHashHelper::Parse( *((VemsMessageHashClass*)obj) );

    ConfigHelper2::init();

    MTConfigHelper::createMTConfigData();

	MyFrame* frame = new MyFrame(0L, _("wxWidgets Application Template"));
	frame->Show();

	return true;
}

int MyApp::OnExit()
{
    ConfigHelper2::cleanup();
	MTConfigHelper::cleanup();

	VemsContext::cleanup();

    return 0;
}
