#include "ConfigEditFrame.h"

#include "ConfigEditPanel.h"
#include "SessionSelectPanel.h"

ConfigEditFrame::ConfigEditFrame(ConfigBase * configBase,
wxWindow* parent, wxWindowID id,const wxString& title, const wxPoint& pos, const wxSize& size, long style)
                : wxFrame( parent, id, title, pos, size, style )
{
    SetIcon(wxIcon(_T("vemsLogoIcon2")));
    wxPanel* mainPanel      = new wxPanel( this, wxID_ANY );
    wxBoxSizer* frameSizer  = new wxBoxSizer( wxVERTICAL );

//    wxString path       = _T("/sessions/")+ Helper::getCurSession() +_T("/params/");

    wxString defPath    = _T("/defaultparams/");
    wxString subPath    = _T("/params/");

    m_configEditPanel = new ConfigEditPanel( mainPanel, wxID_ANY, _T("/params")
                                             , configBase, defPath, defPath, subPath );

    m_sessionSelectPanel = new SessionSelectPanel( mainPanel, wxID_ANY, _T("Project") );

    m_sessionSelectPanel->registerObserver( m_configEditPanel );

    frameSizer->Add( m_sessionSelectPanel, 0, wxEXPAND | wxALL, 5 );
    frameSizer->Add( m_configEditPanel, 0, wxEXPAND | wxALL, 5 );

    mainPanel->SetSizer( frameSizer );
    mainPanel->Fit();

    SetClientSize( mainPanel->GetSize() );
    SetMinSize( GetSize() );
}

ConfigEditFrame::~ConfigEditFrame()
{
    m_sessionSelectPanel->unRegisterObserver( m_configEditPanel );
}


