#ifndef CONFIGEDITPANEL_H
#define CONFIGEDITPANEL_H

#include <wx/statline.h>
#include <wx/sizer.h>
#include <wx/panel.h>
#include <wx/wx.h>
#include "ObserverBase.h"


WX_DEFINE_ARRAY( wxStaticText*, wxStaticTextArray );
WX_DEFINE_ARRAY( wxTextCtrl*, wxTextCtrlArray);

class ConfigBase;

class ConfigEditPanel: public wxPanel, public ObserverBase
{
	public:

		ConfigEditPanel(wxWindow* parent,wxWindowID id=wxID_ANY, const wxString& boxTitle= wxEmptyString
                        , ConfigBase* configBase=NULL, const wxString& path= wxEmptyString
                        , const wxString& defPath = wxEmptyString, const wxString& subPath = wxEmptyString );

		virtual ~ConfigEditPanel();

        //ObserverBase virtual functions
        void notify( int i ) {}
        void notify( const wxString& str );
        void notify( int i, int idx ) {}
        void Init( const wxString& name, const wxString& msg, const int max ) {}

	protected:
	private:
        static const long ID_saveButton;

        wxStaticTextArray   m_staticTextArray;  //param labels
        wxTextCtrlArray     m_textCtrlArray;    //param values
        wxString            m_path;             //paramsfull path ( session path + sub path )
        wxString            m_defaultPath;      //default param values path
        wxString            m_subPath;
        ConfigBase*         m_configBase;

        void buildGUI( const wxString& boxTitle, const wxString& path );
        void loadValues( const wxString& session );

		void saveValueInFile( wxCommandEvent& event );
        DECLARE_EVENT_TABLE()
};
//WX_DEFINE_ARRAY(wxStaticText *,wxStaticTextArray);
#endif
