#include "FileHelper.h"

#include <wx/dir.h>
#include <wx/ffile.h>
#include <wx/regex.h>
#include <wx/filename.h>

wxString FileHelper::GetFileContents(const wxString& filepath, wxMBConv& conv)
{
    if( !wxFileName::FileExists(filepath) ) return wxEmptyString;

    wxFFile file(filepath, _T("r"));

    wxString str;

    file.ReadAll(&str,conv);

    return str;
}

bool FileHelper::PutFileContents(const wxString& filepath, const wxString& content, wxMBConv& conv)
{
    wxFFile file(filepath, _T("w"));

    return file.Write(content, conv);
}

bool FileHelper::GetFilesExp(const wxString& path, wxArrayString& arr, const wxString& fileSpecExp, size_t limit, FileSortOrders sortByFilename)
{
    wxArrayString tmp;

    wxDir::GetAllFiles(path, &tmp, _T(""), wxDIR_FILES );

    if(!tmp.GetCount()) return false;

    wxRegEx exp;
    bool compres = exp.Compile(fileSpecExp);

    if(!compres) return false;

    if(sortByFilename != ORDER_NONE) tmp.Sort( sortByFilename == ORDER_DESC ? true : false );

    size_t curr_limit = limit == NO_FILE_LIMIT ? tmp.GetCount() : limit;

    for(size_t a=0;a<tmp.GetCount();a++){
        if(exp.Matches(tmp[a])) {
            arr.Add(tmp[a]);
            if(arr.GetCount()>=curr_limit) break;
        }
    }

    return arr.GetCount();
}
