#ifndef FIRMWAREMGRDIALOG_H
#define FIRMWAREMGRDIALOG_H


#include <wx/wx.h>

#include "SerialException.h"
#include "unidlg2test.h"
#include "FirmwareTypes.h"
#include "wx/progdlg.h"


class wxThread;
class VemsTuneController;
class ObserverBase;
class BootModeBase;
class FirmwareConfigItemArray;
class VemsProtocol;


class FirmwareMgrDialog
{
    public:
        FirmwareMgrDialog(wxWindow* parent, VemsTuneController* vemsController, ObserverBase* observer);
        virtual ~FirmwareMgrDialog();

        void verify();
        void upload();
        void quickFirmwareMgr(bool enable = true, int mode = VERIFY);

    private:
        VemsTuneController* m_vemsController;
        VemsProtocol*       m_pVemsProtocol;
        ObserverBase*       m_observer;
        BootModeBase*       m_bootModeBase;
        wxWindow*           m_parent;
        wxString            m_projectCaption;

    private:
        void verifyUpdate(int type);
        void serialErrorMsgDialog();
		void serialErrorMsgDialog(SerialException& se);
		void showFirmwareResult(int result, int type);
        void verifyUpdate(int type, FirmwareConfigItemArray* configItemA);
        void setupVerifyUploadDialog(int type, Unidlg2Test& dlg);
        void roundSFloodHack();

        wxThread*   startSflood();
        void        stopSflood(wxThread* thread);
        DECLARE_NO_COPY_CLASS(FirmwareMgrDialog);
};



class LockerHelper
{
    public:
        LockerHelper(VemsTuneController* vemsController);
        virtual ~LockerHelper();

    private:
         VemsTuneController* m_vemsController;


};


#endif // FIRMWAREMGRDIALOG_H
