#ifndef FIRMWAREMGRFRAME_H
#define FIRMWAREMGRFRAME_H

#include <wx/wx.h>

class MainPanel;
class VemsTuneController;
class DeviceEvent;


class FirmwareMgrFrame: public wxFrame
{
    public:
        FirmwareMgrFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);
        virtual ~FirmwareMgrFrame();

//        void CreateFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = _T("frame"));


        void SetVemsTuneCtrl(VemsTuneController *ctrl);

        void Init();

    protected:

        void SetMenuState(int device);

    private:

        void OnDeviceEvent(DeviceEvent& event);
        void OnFirmwareInfo(wxCommandEvent& event);

        //////////////////////////////////////////////////////////////
        void OnVerifyFirmware(wxCommandEvent& event);
        void OnUploadFirmware(wxCommandEvent& event);

        void OnVerifyConfig(wxCommandEvent& event);
        void OnUploadConfig(wxCommandEvent& event);
        void OnDownloadConfig(wxCommandEvent& event);
        //////////////////////////////////////////////////////////////

        void OnClearLog(wxCommandEvent& event);

        MainPanel           *m_panel;
        wxMenu              *m_fileMenu;

        VemsTuneController  *m_vemsTuneCtrl;

        DECLARE_EVENT_TABLE();

        wxBoxSizer          *m_mainSizer;

};



#endif // FIRMWAREMGRFRAME_H
