#include "NMEAParse.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "../Math.h"
//#include "../logger.h"

char m_gprmc_state_array[] = {  START,
                                FORMAT,
                                NMEA_UTC,
                                STATUS,
                                LATITUDE,
                                LATITUDEIN,
                                LONGNITUDE,
                                LONGNITUDEIN,
                                SPEED,
                                COURSE,
                                DATEOFPOSITION,
                                MAGNETICVARIATION,
                                MAGNETICVARIATIONIN,
                                MODEINDICATOR,
                                CHECKSUM,
                                END};

char m_gpgga_state_array[] = {  START,
                                FORMAT,
                                NMEA_UTC,
                                LATITUDE,
                                LATITUDEIN,
                                LONGNITUDE,
                                LONGNITUDEIN,
                                POSITIONINDICATOR,
                                NOOFSATELITE,
                                HORIZDILUTIONOFPRECISION,
                                ANTENNAHEIGH,
                                RECIVEM,
                                GEODIALHEIGH,
                                RECIVEM,
                                AGEOFDGPS,
                                REFERENCESTATION,
                                CHECKSUM,
                                END};

char m_unknown_state_array[] = {START,
                                FORMAT,
                                UNKNOWN_FORMAT,
                                CHECKSUM,
                                START}; /// Unknown type do not use END state

NMEAParse::NMEAParse()
:m_calculatedchecksum(0)
,m_tempnumber(0)
,m_counter(0)
,m_idx(0)
{
    m_statearray = m_gprmc_state_array;
    gpsdata.errorbyte=0;
     // m_testvektor2 = "$GPRMC,160342.000,A,4728.5725,N,01914.0230,E,0.00,,";
     // m_testvektor = "$GPRMC,160346.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*7B";

        //m_testvektor = "$GPRMC,160347.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*78$GPRMC,160346.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*7B";
        m_testvektor = "$GPGGA,160339.000,4728.5725,N,01914.0230,E,1,07,1.1,164.1,M,41.0,M,,0000*52";
}

NMEAParse::~NMEAParse()
{
    //dtor
}

void NMEAParse::printTestVektor()
{
    printf("print_testvektor()");
    int nn = 0;
    for(nn = 0; nn < 100; nn++){
//     if(*(m_testvektor+nn) == NULL){break;}
     printf("n=%d m_testvektor=%c\n ",nn,m_testvektor[nn]);
    }
     printf("END print_testvektor()");
}

int NMEAParse::feedGPScharacter(char c)
{
    int currentState = -2;

   if(c == '$' ){
       //initiation();
        m_idx = 1;
        m_calculatedchecksum = 0;
        m_counter = 0;
        gpsdata.errorbyte = 0;
        //m_noOfdecimalfraction = -1;
        m_formatNow = -1;
    }else{
            char state = m_statearray[m_idx];
            switch(state){
                        case START:
                                //printf("waiting for $ character\n");
                                currentState = START;
                        break;

                        case FORMAT:
                            m_calculatedchecksum ^=c;
                            m_noOfdecimalfraction = CHARACTER;
                            if( isNextSate(c) ){
                                if( m_formatNow == GPS_FORMAT_GPRMC ){
                                    m_statearray = m_gprmc_state_array;
                                    gpsdata.dataFormat = GPS_FORMAT_GPRMC;
                                    m_counter = 0;
                                    currentState = GPS_FORMAT_GPRMC;
                                    //Logger::logf( LOG_MSG, _T("NMEAParse::feedGPScharacter() GPS_FORMAT_GPRMC"));

                                }else if( m_formatNow == GPS_FORMAT_GPGGA ){
                                    m_statearray = m_gpgga_state_array;
                                    gpsdata.dataFormat = GPS_FORMAT_GPGGA;
                                    m_counter = 0;
                                    currentState = GPS_FORMAT_GPGGA;
                                    //Logger::logf( LOG_MSG, _T("NMEAParse::feedGPScharacter() GPS_FORMAT_GPGGA"));
                                }else{
                                    m_statearray = m_unknown_state_array;
                                    currentState  =  UNKNOWN_FORMAT;
                                    //Logger::logf( LOG_MSG, _T("NMEAParse::feedGPScharacter() NOT_PARSED_FORMAT"));
                                }
                                break;
                            }
                            m_formatNow = wichformat(c);
                            break;
                        case NMEA_UTC:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 2;
                                //printf("utc=%d",m_tempnumber);
                                if( isNextSate(c) ){
                                    gpsdata.utc = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case STATUS:
                                //printf("------------UTC%c\n",c);
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                gpsdata.status = c ;
                                break;
                        case LATITUDE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 4;
                                if( isNextSate(c) ){
                                    gpsdata.latitude = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case LATITUDEIN:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                if( ( c == 'N' ) || ( c == 'S')){
                                    gpsdata.latitudeindicator = c ;
                                }
                                break;
                        case LONGNITUDE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 4;
                                if( isNextSate(c)){
                                    gpsdata.longnitude = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case LONGNITUDEIN:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                if( ( c == 'E' ) || ( c == 'W')){
                                    gpsdata.longnitudeindicator = c ;
                                }
                                break;
                        case SPEED:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.speed = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case COURSE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.course = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case DATEOFPOSITION:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 0;
                                if( isNextSate(c) ){
                                    gpsdata.dateofposition = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case MAGNETICVARIATION:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.magneticvariation = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case MAGNETICVARIATIONIN:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                if( ( c == 'E' ) || ( c == 'W' ) ) {
                                    gpsdata.magneticvariationdirection = c ;
                                }
                                break;
                        case MODEINDICATOR :
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                m_calculatedchecksum ^=c;
                                if( ( c == 'N' ) || ( c == 'A' ) || ( c == 'D' ) || ( c == 'E' ) ) {
                                    gpsdata.modeindicator = c ;
                                }
                                break;
                        case CHECKSUM :
                                if(m_counter == 0){
                                    gpsdata.checksum = 0;
                                    //printf("----------------%c",c);
                                    gpsdata.checksum = (hextobin(c) << 4 );
                                    m_counter++;
                                    break;
                                }
                                if(m_counter == 1){
                                    //printf("----------------%c",c);
                                    gpsdata.checksum += hextobin(c) ;
                                    m_idx++;
                                }
                                if(gpsdata.checksum == m_calculatedchecksum){
                                    //printf("data is valid");
                                }
                                m_counter = 0;
                                break;
                        case POSITIONINDICATOR  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                if( (c == '0' ) || ( c == '1' ) || ( c == '2' ) ){
                                        gpsdata.positionindic = c - '0';
                                }
                                break;
                        case NOOFSATELITE  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.noofsatellite = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case HORIZDILUTIONOFPRECISION  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.horizontalprecision = m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case ANTENNAHEIGH  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.antennaheight = m_tempnumber;
                                    m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        /*gpgga format include M character after and before geoidal height*/
                        case RECIVEM :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                break;

                        case GEODIALHEIGH  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if( isNextSate(c) ){
                                    gpsdata.geodialheight =m_tempnumber;
                                     m_tempnumber = 0;
                                    break;
                                }
                                storeNumber(c);
                                break;
                        case AGEOFDGPS  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = CHARACTER;
                                if( isNextSate(c) ){
                                    break;
                                }
                                break;

                        case REFERENCESTATION   :
                                m_noOfdecimalfraction = 0;
                                if( isNextSate(c) ){
                                    gpsdata.station = m_tempnumber;
                                    m_tempnumber = 0;
                                    break;
                                }
                                m_calculatedchecksum ^=c;
                                storeNumber(c);
                                break;
                        case END  :
                            currentState = END;
                            m_idx = 0;
                            break;
                        case UNKNOWN_FORMAT:
                            currentState  =  UNKNOWN_FORMAT;
                            if(c == '*'){
                                m_idx = 3; // CHEKSUM idx;
                                m_counter =0;
                            }else{
                                m_calculatedchecksum ^=c;
                            }
                            break;
            }
        }
        //Logger::logf( LOG_MSG, _T("NMEAParse::feedGPScharacter():char=%c, currentState=%i"),c,currentState );
        return currentState;
}

void nextSate()
{


}
//m_tempnumber
bool NMEAParse::isNextSate(char c)
{
    if( (c == ',') || (c == '*') ){
        if(m_noOfdecimalfraction >= 0){
            checkout();
            m_counter = 0;
            m_idx++;
            return true;
        }else{
            m_counter = 0;
            m_idx++;
            return true;
        }
    }
    return false;
}

/**character's to number  ***/
int NMEAParse::storeNumber(char c)
{
    if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
        if( m_counter >= 1 ){

            m_counter++;
        }

        if(m_counter > m_noOfdecimalfraction +1 ){
            return m_tempnumber;
        }


        if((c != '.')){
            m_tempnumber *=10;
            m_tempnumber += c - '0' ;
        }else{
            m_counter = 1;
        }
    }
    return m_tempnumber;
}

/** if recived less character we want (m_noOfdecimalfraction)  compensate it (return 0)
**/
int NMEAParse::checkout()
{
    m_counter--;
    if(m_counter <  m_noOfdecimalfraction ){
        m_tempnumber *= (int)pow(10.0, (double)(m_noOfdecimalfraction  - m_counter));
        return 0;
    }else{
        return 1;
    }
}


void NMEAParse::print_struct()
{  printf("print_struct(int n)\n");

    printf("UTC = %d\n",gpsdata.utc);
    printf("status = %c\n",gpsdata.status);
    printf("latitude = %d\n",gpsdata.latitude);
    printf("latitudeindicator = %c\n",gpsdata.latitudeindicator);
    printf("longnitude = %d\n",gpsdata.longnitude);
    printf("longnitudeindicator = %c\n",gpsdata.longnitudeindicator);
    printf("speed = %d\n",gpsdata.speed);
    printf("course = %d\n",gpsdata.course);
    printf("dateofposition = %d\n",gpsdata.dateofposition);
    printf("m_magneticvariation = %d\n",gpsdata.magneticvariation);
    printf("magneticvariationdirection = %c\n",gpsdata.magneticvariationdirection);
    printf("modeindicator = %c\n",gpsdata. modeindicator);
    printf("gpsdata.checksum = %d\n",gpsdata.checksum);
    printf("positionindic = %d\n", gpsdata.positionindic);
    printf("noofsatellite = %d\n", gpsdata.noofsatellite);
    printf("horizontalprecision = %d\n", gpsdata.horizontalprecision);
    printf("antennaheight = %d\n", gpsdata.antennaheight);
    printf("geodialheight = %d\n", gpsdata.geodialheight);
    printf("dgps = %d\n", gpsdata.dgps);
    printf("station = %d\n", gpsdata.station);
    printf("errorbyte = %d\n", gpsdata.errorbyte);
    printf("calculatedchecksum = %d\n", m_calculatedchecksum);
    printf("recived checksum = %d\n",gpsdata.checksum);
}

int NMEAParse::hextobin(char c)
{
    if( ( c >= '0' ) && ( c <= '9' ) ){
    return c -48;
    }

    if( ( c >= 'A' ) && ( c <= 'F' ) ){
    return c - ('A' - 10);
    }
//    printf("invalid data");
    return -1;
}
/**
set null all data in gpsdat
**/
void NMEAParse::initiation()
{
                int nn;
                for(nn=0;nn<5;nn++)
                {
                    gpsdata.format[nn] = 0;
                }
                gpsdata.dataFormat = -1;
                gpsdata.utc = 0;
                gpsdata.status = 0;
                gpsdata.latitude = 0;
                gpsdata.latitudeindicator = 0;
                gpsdata.longnitude = 0;
                gpsdata.longnitudeindicator = 0;
                gpsdata.speed = 0;
                gpsdata.course = 0;
                gpsdata.dateofposition = 0;
                gpsdata.magneticvariation = 0;
                gpsdata.magneticvariationdirection = 0;
                gpsdata.modeindicator = 0;
                gpsdata.positionindic = 0;
                gpsdata.noofsatellite = 0;
                gpsdata.horizontalprecision = 0;
                gpsdata.antennaheight = 0;
                gpsdata.geodialheight = 0;
                gpsdata.dgps = 0;
                gpsdata.station = 0;
                gpsdata.checksum = 0;
                gpsdata.errorbyte = 0;
}
/**
**  decide gprmc or gpgga format is topical
** GPRMC =0
** GPRGA =1
**/
int NMEAParse::wichformat(char c)
{
      switch(m_counter){
                case FIRST_CHARACTER_OF_GPRMC_OR_GPGGA :
                         if( c == 'G'){
                            m_counter++;
                         }
                         break;

                case SECOUND_CHARACTER_OF_GPRMC_OR_GPGGA :
                         if( c == 'P'){
                            m_counter++;
                         }
                         break;

                case THIRD_CHARACTER_OF_GPRMC :

                         if( c == 'R'){
                            m_counter++;
                         }else if( c == 'G'){
                            m_counter +=3;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case FOURTH_CHARACTER_OF_GPRMC:
                         if( c == 'M'){
                            m_counter++;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case FIFTH_CHARACTER_OF_GPRMC:
                         if( c == 'C'){

                            return GPS_FORMAT_GPRMC;

                         }else{
                            //m_counter = 0;
                         }
                         break;
                case THIRD_AND_FOURTH_CHARACTER_OF_GPGGA :
                         if( c == 'G'){
                                m_counter++;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case FIFTH_CHARACTER_OF_GPGGA :
                         if( c == 'A'){

                            return GPS_FORMAT_GPGGA;
                         }else{
                            //m_counter = 0;
                         }
                         break;
      }
return -1;
}
/**
*  search current byte by idx and return with
**/
/*
uint8_t NMEAParse::get_binpacked(uint8_t idx)
{
    int bine = 0;
    switch(idx){

            case 0:

                   int utc;
                   utc = gpsdata.utc;
                   bine = get_fourthbine(utc) ;
                   break;

            case 1:

                   int utc1;
                   utc1 = gpsdata.utc;
                   bine = get_thirdbine(utc1);
                   break;

            case 2:

                   int utc2;
                   utc2 = gpsdata.utc;
                   bine = get_secondbine(utc2);
                   break;
            case 3:

                   int utc3;
                   utc3 = gpsdata.utc;
                   bine = get_firstbine(utc3);
                   break;

            case 4:

                   int latitude ;
                   latitude = gpsdata.latitude;
                   bine = get_fourthbine(latitude) ;
                   break;

            case 5:

                   int latitude1 ;
                   latitude1 = gpsdata.latitude;
                   bine = get_thirdbine(latitude1);
                   break;

            case 6:

                   int latitude2 ;
                   latitude2 = gpsdata.latitude;
                   bine = get_secondbine(latitude2);
                   break;

            case 7:

                   int latitude3 ;
                   latitude3 = gpsdata.latitude;
                   bine = get_firstbine(latitude3);
                   break;

            case 8:

                   int longnitude;
                   longnitude = gpsdata.longnitude;
                   bine = get_fourthbine(longnitude);
                   break;

            case 9:

                   int longnitude1;
                   longnitude1 = gpsdata.longnitude;
                   bine =  get_thirdbine(longnitude1);
                   break;

            case 10:

                   int longnitude2;
                   longnitude2 = gpsdata.longnitude;
                   bine =  get_secondbine(longnitude2);
                   break;

            case 11:

                   int longnitude3;
                   longnitude3 = gpsdata.longnitude;
                   bine =  get_firstbine(longnitude3);
                   break;

            case 12:

                   int speed;
                   speed = gpsdata.speed;
                   bine = get_thirdbine(speed);
                   break;

            case 13:

                   int speed1;
                   speed1 = gpsdata.speed;;
                   bine = get_secondbine(speed1);
                   break;

            case 14:

                   int speed2;
                   speed2 = gpsdata.speed;;
                   bine = get_firstbine(speed2);
                   break;

            case 15:

                   int antennaheight;
                   antennaheight = gpsdata.antennaheight;
                   bine = get_fourthbine(antennaheight);
                   break;

            case 16:

                   int antennaheight1;
                   antennaheight1 = gpsdata.antennaheight;
                   bine = get_thirdbine(antennaheight1);
                   break;

            case 17:

                   int antennaheight2;
                   antennaheight2 = gpsdata.antennaheight;
                   bine = get_secondbine(antennaheight2);
                   break;


            case 18:

                   int antennaheight3;
                   antennaheight3 = gpsdata.antennaheight;
                   bine = get_firstbine(antennaheight3);
                   break;


            case 19:

                   int horizontalprecision;
                   horizontalprecision = gpsdata.horizontalprecision;
                   bine = get_secondbine(horizontalprecision);
                   break;

            case 20:

                   int horizontalprecision1;
                   horizontalprecision1 = gpsdata.horizontalprecision;
                   bine = get_firstbine(horizontalprecision1);
                   break;
            case 21:
                return get_fourthbine( gpsdata.geodialheight );
            case 22:
                return get_thirdbine( gpsdata.geodialheight );
            case 23:
                return get_secondbine( gpsdata.geodialheight );
            case 24:
                return get_firstbine( gpsdata.geodialheight );

    }
    return bine;
}
*/

void NMEAParse::printbinaryarray(){

   int counter= 0;
   for(counter = 0; counter < 21; counter++){
        printf("%d.bin value =%d\n",counter,binary_array[counter]);
   }
}

void NMEAParse::writeToStruct()
{
            initiation();///set null all data in gpsdata
            gpsdata.utc = getvaluefrombinaryformat(4,0);
            gpsdata.latitude = getvaluefrombinaryformat(4,4);
            gpsdata.longnitude = getvaluefrombinaryformat(4,8);
            gpsdata.speed = getvaluefrombinaryformat(3,12);
            gpsdata.antennaheight = getvaluefrombinaryformat(4,15);
            gpsdata.horizontalprecision = getvaluefrombinaryformat(2,19);
}

int NMEAParse::getvaluefrombinaryformat(char howmanybyte,char idx)
{
        int value = 0;

           for(; howmanybyte !=0 ;howmanybyte--){
                int number = binary_array[(int)idx] ;
                number <<= ( 8* ( howmanybyte - 1 ) ) ;
                value |= number ;
                idx++;
           }
        return value;
}

void NMEAParse::getData( char* dest )
{
    Math::getBytes(gpsdata.latitude, (uint8_t*)dest, 4);
    Math::getBytes(gpsdata.longnitude, (uint8_t*)(&(dest[4])), 4);
    Math::getBytes(gpsdata.geodialheight, (uint8_t*)(&(dest[8])), 3);
    Math::getBytes(gpsdata.speed, (uint8_t*)(&(dest[11])), 2);

/*
    dest[0] = get_fourthbine( gpsdata.latitude );         //latitude 4. byte
    dest[1] = get_thirdbine( gpsdata.latitude );          //latitude 3. byte
    dest[2] = get_secondbine( gpsdata.latitude );         //latitude 2. byte
    dest[3] = get_firstbine( gpsdata.latitude );          //latitude 1. byte

    dest[4] = get_fourthbine( gpsdata.longnitude );       //longnitude 4. byte
    dest[5] = get_thirdbine( gpsdata.longnitude );        //longnitude 3. byte
    dest[6] = get_secondbine( gpsdata.longnitude );       //longnitude 2. byte
    dest[7] = get_firstbine( gpsdata.longnitude );        //longnitude 1. byte

    dest[8] = get_thirdbine( gpsdata.geodialheight );    //geodial height 1. byte
    dest[9] = get_secondbine( gpsdata.geodialheight );   //geodial height 2. byte
    dest[10] = get_firstbine( gpsdata.geodialheight );    //geodial height 3. byte

    dest[11] = get_secondbine( gpsdata.speed );            //speed high [knot]
    dest[12] = get_firstbine( gpsdata.speed );             //speed low [knot]
*/
    //N=0,S=1
    if( gpsdata.latitudeindicator == 'S' )
    {
        dest[0] |= 128;
    };

    //E=0,W=1
    if( gpsdata.longnitudeindicator == 'W' )
    {
        dest[4] |= 128;
    }
    //0 = Valid
    //1 = Invalid
    if(gpsdata.status == 'V')
    {
        dest[8] &= 127;
    }
    else
    {
        dest[8] |= 128;
    }
/*
    Logger::logf( LOG_MSG, _T("NMEAParse::getData() - longnitude : %u"), gpsdata.longnitude );

    uint32_t result  = ( get_fourthbine( gpsdata.longnitude ) << 24 ) + ( get_thirdbine( gpsdata.longnitude ) << 16) +
                        ( get_secondbine( gpsdata.longnitude ) << 8 ) + get_firstbine( gpsdata.longnitude ) ;

    int32_t result2 = ( (uint8_t)dest[4] << 24 ) + ( (uint8_t)dest[5] << 16 ) + ( (uint8_t)dest[6] << 8 ) + ( (uint8_t)dest[7] );

    //int tmp = 141;
    Logger::logf( LOG_MSG, _T("NMEAParse::getData() - test : %u"), result );
    Logger::logf( LOG_MSG, _T("NMEAParse::getData() - test : %u"), result2 );
*/
}


