#ifndef IMAGELOADER_H
#define IMAGELOADER_H

#include "Observable.h"
#include "common/ProcessBase.h"


class ImageLoader: public ProcessBase, public Observable
{
    public:
        ImageLoader(int id = -1);
        virtual ~ImageLoader();

        void Load(const wxString& url, long type = wxBITMAP_TYPE_PNG);
        wxImage GetImage() { return m_image; };

        virtual bool process();
        virtual void reset() {};

        int GetLastError() { return m_error; }
        int GetState() { return m_state; }


        enum ImageLoaderStates
        {
            IDLE = 0,
            LOADING
        };

        enum ImageLoaderErrors
        {
            NONE = 0,
            WRONG_URL,
            SERVER_NOT_RESPONDING
        };


        wxString GetLastURL() { return m_url; };

    private:

        wxString    m_url;
        long        m_imType;

        wxImage     m_image;

        int         m_state;
        int         m_error;

        int         m_id;

        virtual void finished() {};

};

#endif // IMAGELOADER_H
