// #include <iostream>
// #include "..\VemsGauge\vemsgauge.h"
// #include "gaugeframe.h"

#include <math.h>
#include "MGraphics.h"

#include <wx/dcclient.h>
#include <wx/brush.h>

#include <wx/image.h>

#include "../logger.h"


//-----------------------------------------------------------------------
int Round(double x)
  {
    int X;

    X = (int)floor(x);

    if(0.5 <= (x - X))
       X++;

    return X;
  }//int Round()

/**
//-----------------------------------------------------------------------
int Sign(double x)
  {
    int s = 1;

    if(x < 0)
      s = -1;

    return s;
  }//Sign()
**/

//-----------------------------------------------------------------------
void ChangePoint(TDPoint *P1, TDPoint *P2)
  {
    TDPoint P;
    P = *P2;
    *P2 = *P1;
    *P1 = P;
  }//ChangePoint()

//-----------------------------------------------------------------------
void InsertItem(TSegChain **Root, TSegChain *Item)
  {
    TSegChain   *Chain, *pNext;

    if(*Root == NULL)
      {
        *Root = Item;
        Item->Prev = NULL;
      }
    else
      {
        if(Item->Pos < (*Root)->Pos)
          {
            Item->Next = *Root;
            *Root = Item;
          }
        else
          {
            Chain = (*Root);
            pNext = Chain->Next;

            while((pNext != NULL) && (Item->Next == NULL))
              {
                if(Item->Pos < pNext->Pos)
                  {
                    Chain->Next = Item;
                    Item->Prev = Chain;
                    Item->Next = pNext;
                    pNext->Prev = Item;
                  }
                else
                  {
                    Chain = pNext;
                    pNext = Chain->Next;
                  }
              }

            if(Item->Next == NULL)
              {
                Chain->Next = Item;
                Item->Prev = Chain;
              }
          }
      }
  }//InsertItem()

//-----------------------------------------------------------------------
void Clear(TSegChain *Root)
  {
    TSegChain *Chain, *pNext;

    pNext = Root;
    while(pNext != NULL)
      {
        Chain = pNext;
        pNext = Chain->Next;
        delete Chain;
      }
  }//Clear()

//-----------------------------------------------------------------------
// Unfortunately, there is a problem with close the polygons
//
bool SearchBound(TSegChain *Root, int *From, int *To)
  {
    TSegChain *pNext;

    *From = *To = -1;

    if(Root != NULL)
      {
        pNext = Root;

        while((pNext != NULL) && (*To == -1))
          {
            *From = pNext->Pos;
            pNext = pNext->Next;

            if(pNext != NULL)
              {
                if((*From + 1) < pNext->Pos)
                  *To = pNext->Pos;
              }
          }
      }
    return (*From != -1);
  }//SearchBound()
