#ifndef MTCONFIGHELPER_H
#define MTCONFIGHELPER_H

#include "mtconfigdata.h"

extern const wxEventType FILE_PARSED_EVENT;
extern const wxEventType PROPER_INIFILE_NOT_FOUND;

class ObserverBase;
class FirmwareInfo;
class FirmwareVersion;

class MTConfigHelper
{
    public:
        static MTConfigData* createMTConfigData();
        static MTConfigData* getMTConfigData();
        static void setObserver(ObserverBase *observer = NULL){ m_observer = observer; }
        static void setEventHandler( wxEvtHandler* pEventHandler ) { s_eventHandler = pEventHandler; }
        static bool parseMTConfigData(const FirmwareInfo& fwInfo, MTConfigData* mtConfigData = NULL, bool _sendEvent = true );

        static bool parseMTConfigDataV2(const FirmwareInfo& fwInfo, MTConfigData* mtConfigData = NULL, bool _sendEvent = true );

        static void parseMTConfigDataByRound();
        static bool parseFirmwareHeader( const FirmwareInfo& fwInfo, MTConfigData* mtConfigData = NULL );
        static wxString getDefaultConfigFile();

        static bool parseAIMConfig(MTConfigData* mtConfigData = NULL);

        static void cleanup();
#ifdef COMM_MODEL_WITH_GUI
        static wxArrayString    m_commodelAddresses;
#endif

    private:
        static MTConfigData*    s_mtConfigData;
        static wxString         s_filename;
        static wxEvtHandler*    s_eventHandler;
        static FirmwareVersion* s_firmwareVersion;
        static ObserverBase*    m_observer;
        static wxString         m_defaultConfigFile;

        static void sendEvent();
        static void commonParse(BoolHash* bh,MTConfigData* mtConfigData, const wxString& iniFileName);
        static void fillGraph(SymbolMgr& symbolMgr);
};


#endif // MTCONFIGHELPER_H
