#ifndef OBSERVABLE_H
#define OBSERVABLE_H

#include "ObserverBase.h"

#include <wx/dynarray.h>
#include "common/types/wxVariantHash.h"

WX_DEFINE_ARRAY(ObserverBase *, ObserverBaseA);

#include "common/typedef.h"

class Observable
{
    public:
        Observable();
        virtual ~Observable();

        void registerObserver(ObserverBase * o){
            m_observerBaseA.Add(o);
        }

        void unRegisterObserver(ObserverBase * o){
            if ( m_observerBaseA.Index( o ) != wxNOT_FOUND )
                m_observerBaseA.Remove(o);
        }

        void observerInit(const wxString& caption, const wxString& str, const int pagesNum )
        {
            for(uint32_t i =0; i < m_observerBaseA.GetCount(); i++){
                ObserverBase *o = m_observerBaseA.Item(i);
                o->Init(caption, str, pagesNum);
            }
        }
        void observerNotify(int a, int b){
            for(uint32_t i =0; i < m_observerBaseA.GetCount(); i++){
                ObserverBase *o = m_observerBaseA.Item(i);
                o->notify(a, b);
            }
        }

        void observerNotify(const wxString& str){
            for(uint32_t i =0; i < m_observerBaseA.GetCount(); i++){
                ObserverBase *o = m_observerBaseA.Item(i);
                o->notify(str);
            }
        }

        void observerNotify( int value )
        {
            for( uint32_t i =0; i < m_observerBaseA.GetCount(); i++ )
            {
                ObserverBase *o = m_observerBaseA.Item(i);
                o->notify( value );
            }
        }

        void observerNotify( int j, void* classType )
        {
            for( uint32_t i =0; i < m_observerBaseA.GetCount(); i++ )
            {
                ObserverBase *o = m_observerBaseA.Item(i);
                o->notify( j, classType );
            }
        }

        void observerNotify( wxVariantHash& hash )
        {
            for( uint32_t i =0; i < m_observerBaseA.GetCount(); i++ )
            {
                ObserverBase *o = m_observerBaseA.Item(i);
                o->notify( hash );
            }
        }

    protected:
    private:
        ObserverBaseA m_observerBaseA;
};



#endif // OBSERVABLE_H
