#include "ProgressBarObserver.h"

#include "Observable.h"

#include "logger.h"

ProgressBarObserver::ProgressBarObserver()
{
    //ctor
}

ProgressBarObserver::~ProgressBarObserver()
{
    //dtor
}

void ProgressBarObserver::setWindow(wxWindow* parent)
{
    m_wxWindowParent  = parent;
}

void ProgressBarObserver::Init(const wxString& name, const wxString& msg, const int max)
{

    m_progressMsg = msg;
    m_progressDialog  = new  wxProgressDialog(name,
                            wxT(""),
                            max, // range
                            m_wxWindowParent, // parent
                            wxPD_CAN_ABORT |
                            wxPD_APP_MODAL |
                            wxPD_AUTO_HIDE |
                            wxPD_ELAPSED_TIME | wxPD_SMOOTH |
                            wxPD_ESTIMATED_TIME |
                            wxPD_REMAINING_TIME);


}


void ProgressBarObserver::InitPulse( const wxString& title, const wxString& message )
{
    m_message = message;
    m_progressDialog  = new wxProgressDialog( title
                                             , message
                                             , 1000
                                             , NULL
                                             , wxPD_AUTO_HIDE | wxPD_APP_MODAL | wxPD_CAN_ABORT );
}


/*
void Helper::progressErasingPages(int i, int idx)
{

     bool cont = true;
     wxString tmp;
     tmp.Printf(_T("Erasing all pages!"));
     cont = progressDialog->Update(i, tmp);

}
*/
void ProgressBarObserver::notify(int i, int idx)
{

     bool cont = true;
     wxString tmp;
     //tmp.Printf(_T("Page index: %d"), idx);
     tmp += m_progressMsg;
     tmp += wxString::Format(_T(" %d"), idx);
     cont = m_progressDialog->Update(i, tmp);


}

void ProgressBarObserver::notify(const wxString & str){
    bool b = m_progressDialog->Pulse( str );
    if ( !b ) { observerNotify( 0 ); }
}

void ProgressBarObserver::notify( int i )
{
    wxString message = wxString::Format( m_message + _T("%d"), i );
    bool b = m_progressDialog->Pulse( message );

    if ( !b ) { observerNotify( 0 ); }
}


void ProgressBarObserver::Close()
{

    m_progressDialog->Resume();
    m_progressDialog->Close();
    //delete progressDialog;
}

void ProgressBarObserver::Destroy()
{
    delete m_progressDialog;
}
