#include "RTDataManagerMainFrame.h"
#include "rtdatamanager/RTDataMgrFacade.h"
#include "rtdatamanager/RTDataInputSIPR.h"
#include "fileparser/V3iniParser2.h"
#include "fileparser/V3IniSections.h"
#include "fileparser/SymbolParser.h"
#include "SymbolMgr.h"
#include "DirHelper.h"
#include "logger.h"


//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

///// menuitems
//int idMenuECUConfig         = wxNewId();
//int idMenuFirmwareVerify    = wxNewId();
//int idMenuFirmwareUpload    = wxNewId();
//int idMenuConfigDownload    = wxNewId();
//int idMenuSDCardV3          = wxNewId();
//int idMenuSDCardOpenImage   = wxNewId();
//int idMenuReadPage          = wxNewId();
//int idMenuSDCardStart       = wxNewId();
//int idMenuSDCardStop        = wxNewId();
//int idMenuSDCardErase       = wxNewId();
//int idMenuTriggerLog        = wxNewId();
//
///// toolbar items
//int idButtonDevice              = wxNewId();
//int idButtonDeviceMode          = wxNewId();
//int idComboBoxBaudrates         = wxNewId();

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
//
//    /// MenuItemEvents
//    EVT_MENU( idMenuFirmwareVerify, MyFrame::onFirmwareVerify )
//    EVT_MENU( idMenuFirmwareUpload, MyFrame::onFirmwareUpload )
//    EVT_MENU( idMenuConfigDownload, MyFrame::onConfigDownload )
//    EVT_MENU( idMenuSDCardV3, MyFrame::onSDCardSave )
//    EVT_MENU( idMenuSDCardOpenImage, MyFrame::onSDCardSave )
//    EVT_MENU ( idMenuECUConfig, MyFrame::onECUConfig )
//    EVT_MENU ( idMenuReadPage, MyFrame::onReadPage )
//    EVT_MENU( idMenuSDCardStart, MyFrame::onSDAction )
//    EVT_MENU( idMenuSDCardStop, MyFrame::onSDAction )
//    EVT_MENU( idMenuSDCardErase, MyFrame::onSDAction )
//    EVT_MENU( idMenuTriggerLog, MyFrame::onTriggerLog )
//
//    /// Toolbar item events
//    EVT_BUTTON( idButtonDevice, MyFrame::onDeviceButton )
//    EVT_COMBOBOX( idComboBoxBaudrates, MyFrame::onBaudrateComboBox )
//
//    /// CommunicationEvent
//    EVT_COMMUNICATION( CommunicationEvent::CANNOT_OPEN_PORT, MyFrame::onCannotOpenPort )
//    EVT_COMMUNICATION( CommunicationEvent::COMMUNICATION_ERROR, MyFrame::onCommunicationError )
//
//    /// VemsDeviceControllerEvents
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_DEVICE_FOUND, MyFrame::onDeviceFound )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_DEVICE_NOT_FOUND, MyFrame::onDeviceNotFound )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_DEVICE_CONNECTED, MyFrame::onDeviceConnected )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_DEVICE_DISCONNECTED, MyFrame::onDeviceDisconnected )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_STARTED, MyFrame::onDeviceControllerStarted )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_STOPPED, MyFrame::onDeviceControllerStopped )
//    EVT_VEMS_DEVICE_CONTROLLER( VDC_EVENT_DEVICE_BAUDRATE_CHANGED, MyFrame::onDeviceBaudRateChanged )
//
//    /// InputEvents
//    //EVT_INPUT( wxID_ANY, MyFrame::onInputEvent )

END_EVENT_TABLE()

MyFrame::MyFrame(wxFrame *frame, const wxString& title)
    : wxFrame(frame, -1, title)
{
//#if wxUSE_MENUS
//    // create a menu bar
//    wxMenuBar* mbar = new wxMenuBar();
//
//    ///-----Preferences menu
//    wxMenu* settingsMenu = new wxMenu(_(""));
//	settingsMenu->Append( idMenuECUConfig, _("E&CU Communication\t"), _("ECU Communication"));
//    mbar->Append(settingsMenu, _("&Preferences"));
//
//    ///-----Firmware menu
//    wxMenu* firmwareMenu = new wxMenu ( _T("") );
//	firmwareMenu->Append( idMenuFirmwareVerify, _T("Firmware Verify"), _T("Firmware Verify") );
//	firmwareMenu->Append( idMenuFirmwareUpload, _T("Firmware Upload"), _T("Firmware Upload") );
//	firmwareMenu->AppendSeparator();
//	firmwareMenu->Append( idMenuConfigDownload, _T("Config Download"), _T("Config Download") );
//    mbar->Append( firmwareMenu, _T("Firmware") );
//
//    ///-----Firmware menu
//    wxMenu* sdcardmenu = new wxMenu( _T("") );
//    sdcardmenu->Append( idMenuSDCardV3, _T("Search SD files"), _T("Search SD files") );
//    sdcardmenu->Append( idMenuSDCardOpenImage, _T("Open image file"), _T("Open image file") );
//    sdcardmenu->Append( idMenuSDCardStart, _T("Start log"), _T("Start log") );
//    sdcardmenu->Append( idMenuSDCardStop, _T("Stop log"), _T("Stop log") );
//    sdcardmenu->Append( idMenuSDCardErase, _T("Erase SD Card"), _T("Erase SD Card") );
//    mbar->Append( sdcardmenu, _T("SD Card") );
//
//    ///-----Firmware menu
//    wxMenu* triggerLogMenu = new wxMenu( _T("") );
//    triggerLogMenu->Append( idMenuTriggerLog, _T("TriggerLog"), _T("TriggerLog") );
//    mbar->Append( triggerLogMenu, _T("TriggerLog") );
//
//    wxMenu* testMenu = new wxMenu(_T(""));
//    testMenu->Append( idMenuReadPage, _T("Read Page 1\tF2"), _T("Read Page 1"));
//    mbar->Append(testMenu, _("&Test"));
//
//    SetMenuBar(mbar);
//
//    enableFirmwareMenu( false );
//
//    int firmwareMenuIdx = mbar->FindMenu( _T("Firmware") );
//    mbar->EnableTop( firmwareMenuIdx, false );
//#endif // wxUSE_MENUS
//
//#if wxUSE_STATUSBAR
//    CreateStatusBar(3);
//    resetStatusBar();
//#endif // wxUSE_STATUSBAR
//
//    wxPanel* mainPanel = new wxPanel( this );
//    mainPanel->SetSizer( new wxBoxSizer( wxVERTICAL ) );
//
//    ///toolbar
//    wxButton* deviceButton = new wxButton( mainPanel, idButtonDevice, _T("N/A") );
//    deviceButton->Enable( false );
//
//    wxButton* deviceModeButton = new wxButton( mainPanel, idButtonDeviceMode, _T("N/A") );
//    deviceModeButton->Enable( false );
//
//    wxArrayString baudrates;
//    baudrates.Add( _T("9600") );
//    baudrates.Add( _T("19200") );
//    baudrates.Add( _T("38400") );
//    baudrates.Add( _T("57600") );
//    baudrates.Add( _T("115200") );
//
//    wxComboBox* baudrateComboBox = new wxComboBox(  mainPanel,
//                                                    idComboBoxBaudrates,
//                                                    _T("19200"),
//                                                    wxDefaultPosition,
//                                                    wxDefaultSize,
//                                                    baudrates,
//                                                    wxCB_READONLY );
//    baudrateComboBox->Enable( false );
//
//
//
//    wxBoxSizer* toolbar = new wxBoxSizer( wxHORIZONTAL );
//    toolbar->Add( deviceButton, 0, wxRIGHT, 5 );
//    toolbar->Add( deviceModeButton, 0, 0, 0 );
//    toolbar->Add( baudrateComboBox, 0, wxLEFT | wxALIGN_CENTRE_VERTICAL, 5 );
//    mainPanel->GetSizer()->Add( toolbar, 0, wxEXPAND | wxALL, 5 );
//
//    ///log window
//    UserLogWindow* logWindow = new UserLogWindow( mainPanel, wxID_ANY );
//    mainPanel->GetSizer()->Add( logWindow, 1, wxEXPAND );
//    UserLog::Init( logWindow );
//
//    ///device controller
//    VemsDeviceControllerConfig deviceControllerConfig;
//    ConfigBase* cfg = ConfigHelper2::getConfig(ConfigHelper2::CONFIG_MAIN);
//    ConfigMgrVemsDeviceController cfgMgr(cfg);
//    cfgMgr.load(&deviceControllerConfig);
//
//	MTConfigData* mtConfig = MTConfigHelper::getMTConfigData();
//    SymbolTable& symbolTbl = mtConfig->getSymbolTable();
//    SIPRDescriptor* siprDesc = mtConfig->getSIPRDescriptor();
//
//	m_model = new STDataModelSerial( symbolTbl, siprDesc );
//
//	m_siprFileLogger = new SIPRFileLogger( 512 );
//
//	m_controller = new VemsDeviceController( deviceControllerConfig );
//	m_controller->addEventHandler( this );
//
////	m_controller->Connect( VDC_EVENT_DEVICE_CONNECTED, wxEVT_VEMS_DEVICE_CONTROLLER, VemsDeviceControllerEventHandler( MyFrame::onDeviceConnected ), NULL, this );
////	m_controller->Connect( VDC_EVENT_DEVICE_DISCONNECTED, wxEVT_VEMS_DEVICE_CONTROLLER, VemsDeviceControllerEventHandler( MyFrame::onDeviceDisconnected ), NULL, this );
//	m_controller->Connect( wxEVT_INPUT, InputEventHandler( MyFrame::onInputEvent ), NULL, this );
//
//    m_progressBarManager = new DeviceControllerProgressBarManager( this, m_controller );
//
//    m_controller->start();


	m_symbolManager = new SymbolMgr();
	m_rtDataMgr = new RTDataMgrFacade();

	//SymbolTable symbolTable;
	//SymbolMgr symbolManager;

    RTDataInputSIPR* inputSIPR = new RTDataInputSIPR( m_symbolManager, &m_rtViewerModel );

    wxString iniFileName = _T("vemsTune-v3-1.1.77.ini");
    V3iniParser2 iniParser( (BoolHash*)NULL );
    iniParser.parse( DirHelper::GetPath(dCONFIG) + iniFileName );

    const StrToTokenizerPtrArrayHash& sections = iniParser.getSections();

    LOGP( wxString::Format( _T("sections.size() : %d"), sections.size() ) );

    StrToTokenizerPtrArrayHash::const_iterator sectionIt = sections.find( V3IniSections::CONSTANTS );

    if ( sectionIt != sections.end() ) {

        SymbolParser symbolParser( &sectionIt->second, m_symbolManager );
        symbolParser.parse();
    }


//
//    m_rtDataMgr->registerInput( inputSIPR );
//    m_rtDataMgr->selectInput( INPUT_TYPE_SIPR );
}

MyFrame::~MyFrame()
{
    delete m_symbolManager;
	delete m_rtDataMgr;
//	m_controller->stop();
//
//	delete m_progressBarManager;
//	delete m_controller;
//	delete m_model;
//	delete m_siprFileLogger;
}

//void MyFrame::startLogging()
//{
//    m_siprFileLogger->enableLog(true);
//
//    const FirmwareInfo& fwInfo = m_controller->getFirmwareInfo();
//
//    wxString baseFileName = fwInfo.getSerialNumber() + _T(".vemslog");
//    wxString logdir = DirHelper::GetPath(dLOG);
//    wxString fileName = DirHelper::CreateNewFileName(baseFileName,logdir,true,true);
//
//    wxString header = RawLogHelper::getVemslogHeader(fwInfo, 2);
//
//    m_siprFileLogger->setHeader(header);
//    m_siprFileLogger->setFile(fileName);
//
//    MTConfigData* mtConfig = MTConfigHelper::getMTConfigData();
//    SIPRDescriptor* siprDesc = mtConfig->getSIPRDescriptor();
//
//    STDataModelWriter::logPages( m_model, m_siprFileLogger, siprDesc );
//
//    LOGP( _T("header: ") + header );
//    LOGP( _T("fileName: ") + fileName );
//
//    UserLog::uLog( ULOG_OK, fileName );
//
//    wxArrayString lines = wxStringTokenize( header, _T("\n") );
//    for ( size_t i = 0; i < lines.GetCount(); ++i ){
//        UserLog::uLog( ULOG_OK, lines[i] );
//    }
//}
//
//void MyFrame::stopLogging()
//{
//    m_siprFileLogger->enableLog(false);
//}
//
//void MyFrame::refreshToolbar( const VemsDeviceControllerEvent& event )
//{
//    LOG
//
//    wxString deviceString = _T("N/A");
//    wxString deviceModeString = _T("N/A");
//
//    int eventId = event.GetId();
//
//    wxColor connectedColor( 0, 128, 0 );
//
//    switch ( eventId )
//    {
//        case VDC_EVENT_DEVICE_NOT_FOUND:
//        case VDC_EVENT_DEVICE_DISCONNECTED:
//        {
//            refreshToolbarButton( idButtonDevice, deviceString, *wxRED, true );
//            refreshToolbarButton( idButtonDeviceMode, deviceModeString, *wxRED, true );
//            refreshBaudrateComboBox( false, 0 );
//        } break;
//
//        case VDC_EVENT_DEVICE_CONNECTED:
//        {
//            deviceString = ECUInfo::getDeviceAsString( event.getDevice() );
//            deviceModeString = ECUInfo::getStateAsString( event.getDeviceMode() );
//
//            refreshToolbarButton( idButtonDevice, deviceString, connectedColor, true );
//            refreshToolbarButton( idButtonDeviceMode, deviceModeString, connectedColor, true );
//            refreshBaudrateComboBox( true, event.getBaudrate() );
//        } break;
//
//        case VDC_EVENT_STOPPED:
//        {
//            refreshToolbarButton( idButtonDevice, deviceString, *wxLIGHT_GREY, true );
//            refreshToolbarButton( idButtonDeviceMode, deviceModeString, *wxLIGHT_GREY, true );
//            refreshBaudrateComboBox( false, 0 );
//        } break;
//
//        default:
//            LOGP( wxString::Format( _T("Unhandled EventId - %d!"), eventId ) );
//            break;
//    }
//}
//
//void MyFrame::refreshToolbarButton( int buttonId, const wxString& label, const wxColour& color, bool isEnabled )
//{
//    wxButton* button = (wxButton*)wxWindow::FindWindowById( buttonId );
//
//    if ( !button ) {
//        LOGP( wxString::Format( _T("Button not found! - buttonId: %d"), buttonId ) );
//    }
//
//    button->SetForegroundColour( color );
//    button->Enable( true );
//    button->SetLabel( label );
//}
//
//void MyFrame::refreshBaudrateComboBox( bool isEnabled, size_t baudrate )
//{
//    wxComboBox* baudrateComboBox = (wxComboBox*)wxWindow::FindWindowById( idComboBoxBaudrates );
//    baudrateComboBox->Enable( isEnabled );
//    int itemIdx = baudrateComboBox->FindString( wxString::Format( _T("%d"), baudrate ) );
//    if ( itemIdx != wxNOT_FOUND ) {
//        baudrateComboBox->Select( itemIdx );
//    }
//}
//
//void MyFrame::resetStatusBar()
//{
//    wxString secl( _T("secl: N/A") );
//    wxString tps( _T("tps: N/A") );
//    wxString ups( _T("Update frequency: N/A") );
//
//    SetStatusText( secl, 0 );
//    SetStatusText( tps, 1 );
//    SetStatusText( ups, 2 );
//}
//
//void MyFrame::refreshStatusBar( const SIPRPacket& packet )
//{
//#if wxUSE_STATUSBAR
//    uint8_t* data = packet.data();
//
//    if ( !data ) {
//        LOGP( _T("data is NULL!") );
//        return;
//    }
//
//    switch ( packet.type() )
//    {
//        case SIPR_READ_SENSORS:
//        {
//            wxString secl( wxString::Format( _T("secl: %3d"), data[3] ) );
//            wxString tps( wxString::Format( _T("tps: %3d"), data[11] ) );
//
//            SetStatusText( secl, 0 );
//            SetStatusText( tps, 1 );
//        } break;
//
//        case SIPR_UPDATE_FREQUENCY:
//        {
//            int updateFrequency = Math::getNumber( data );
//            wxString ups( wxString::Format( _T("Update frequency: %3d"), updateFrequency ) );
//
//            SetStatusText( ups, 2 );
//        } break;
//
//        default:
//            break;
//    }
//#endif
//}
//
//void MyFrame::enableFirmwareMenu( bool isEnabled  )
//{
//    wxMenuBar* mbar = GetMenuBar();
//    int firmwareMenuIdx = mbar->FindMenu( _T("Firmware") );
//    mbar->EnableTop( firmwareMenuIdx, isEnabled );
//
//    // disable SD Card file search on v3 too :)
//    int item = mbar->FindMenuItem(_T("SD Card"), _T("Search SD files"));
//    mbar->FindItem(item)->Enable( isEnabled );
//}
//
//wxString MyFrame::getHexFile(FirmwareConfigItemArray* configItemA)
//{
//    FirmwareConfigItem* configItem;
//    for(uint16_t i = 0; i <configItemA->Count(); i++ ){
//        configItem = configItemA->Item(i);
//
//        if( configItem->type == _T("firmware") ){
//            return configItem->getAbsolutePath();
//        }
//    }
//    return wxEmptyString;
//}
//
//void MyFrame::onECUConfig( wxCommandEvent & event )
//{
//    ECUConfigPanel::findAndShow( this, m_controller );
//}
//
//void MyFrame::onFirmwareVerify( wxCommandEvent& event )
//{
//    ///TODO - check
//
//    SimpleFwDlg dlg( this, VERIFY );
//    FirmwareInfo fwInfo = m_controller->getFirmwareInfo();
//    dlg.Init( &fwInfo );
//
//    FirmwareConfigItemArray configItemA;
//
//    if (dlg.ShowModal() == wxID_OK){
//        dlg.getFirmwareConfigItemArray( configItemA );
//        //verifyUpdate(mode, &configItemA);
//        wxString hexFilePath = getHexFile(&configItemA);
//        IHexParser ihexp( m_controller->getDevice() );
//        if( ihexp.parse(hexFilePath) != 0){
//        //observerNotify(_T("Error: hex File does not exist!"));
//        //return FIRMWARE_FILE_NOT_FOUND_ERROR;
//        //return-1; //FIRMWARE_FILE_NOT_FOUND_ERROR;
//            LOGP( _T("Error: hex File does not exist!") );
//            return;
//        }
//
//		new  FirmwareVerifyDialog( this, m_controller, ihexp.getFirmwareData() );
//    }
//}
//
//void MyFrame::onFirmwareUpload( wxCommandEvent& event )
//{
//    SimpleFwDlg dlg( this, UPLOAD );
//    FirmwareInfo fwInfo = m_controller->getFirmwareInfo();
//    dlg.Init( &fwInfo );
//
//    FirmwareConfigItemArray configItemA;
//
//    if ( dlg.ShowModal() == wxID_OK ) {
//        dlg.getFirmwareConfigItemArray( configItemA );
//        wxString hexFilePath = getHexFile(&configItemA);
//        IHexParser ihexp( m_controller->getDevice() );
//        if( ihexp.parse(hexFilePath) != 0){
//            LOGP( _T("Error: hex File does not exist!") );
//            return;
//        }
//
//       new  FirmwareUploadDialog( this, m_controller, ihexp.getFirmwareData() );
//    }
//}
//
//void MyFrame::onConfigDownload( wxCommandEvent& event )
//{
//    m_controller->downloadDeviceConfig();
//}
//
//void MyFrame::onSDAction( wxCommandEvent& event )
//{
//    /// TODO
//}
//
//void MyFrame::onTriggerLog( wxCommandEvent& event )
//{
//    new TriggerLogEventManager( this, m_controller );
//}
//
//void MyFrame::onSDCardSave( wxCommandEvent& event )
//{
//    int id = event.GetId();
//
//    MTConfigData* mtConfig = MTConfigHelper::getMTConfigData();
//
//    FirmwareInfo fwinfo = m_controller->getFirmwareInfo();
//
//    SDCardDialog* dialog = NULL;
//
//    if ( id == idMenuSDCardV3 )
//    {
//        dialog = new SDCardDialog( this, &fwinfo, m_model, mtConfig, m_controller );
//    }
//    else if ( id == idMenuSDCardOpenImage )
//    {
//        wxFileDialog dlg( this, _T("Choose SD Card image file"), DirHelper::GetPath( dLOG ) );
//        if ( dlg.ShowModal() == wxID_OK )
//        {
//            wxString fname = dlg.GetPath();
//
//            SDImageHandler* handler = new SDImageHandler( fname );
//
//            dialog = new SDCardDialog( this, &fwinfo, m_model, mtConfig, handler );
//        }
//        else return;
//    }
//    else {
//        return;
//    }
//
//    dialog->ShowModal();
//}
//
//void MyFrame::onReadPage( wxCommandEvent& event )
//{
//    LOG
//    m_controller->request( new ReadPageCmd(5) );
//}
//
//void MyFrame::onDeviceButton( wxCommandEvent& event )
//{
//    LOG
//    wxButton* deviceButton = (wxButton*)wxWindow::FindWindowById( idButtonDevice );
//    deviceButton->Enable( false );
//
//    if ( m_controller->isWorking() ) {
//        m_controller->stop();
//    } else {
//        m_controller->start();
//    }
//}
//
//void MyFrame::onBaudrateComboBox( wxCommandEvent& event )
//{
//    LOG
//    refreshBaudrateComboBox( false, 0 );
//    unsigned long baudrate;
//    event.GetString().ToULong( &baudrate);
//    m_controller->changeBaudRate( baudrate );
//}
//
//void MyFrame::onCannotOpenPort( CommunicationEvent& event )
//{
//    UserLog::uLog( ULOG_ERROR, _T("Cannot Open Port!()") );
//}
//
//void MyFrame::onCommunicationError( CommunicationEvent& event )
//{
//    UserLog::uLog( ULOG_ERROR, _T("Communication Error!") );
//}
//
//void MyFrame::onDeviceFound( VemsDeviceControllerEvent& event )
//{
//    UserLog::uLog( ULOG_WARNING, _T("Device Found!") );
//}
//
//void MyFrame::onDeviceNotFound( VemsDeviceControllerEvent& event )
//{
//    UserLog::uLog( ULOG_WARNING, _T("Device Not Found!") );
//
//    refreshToolbar( event );
//}
//
//void MyFrame::onDeviceConnected( VemsDeviceControllerEvent& event )
//{
//    if ( event.isBootMode() ) {
//        BootModeDialog dlg(this);
//
//        switch ( dlg.ShowModal() )
//        {
//            case BootModeDialog::BMD_STAY:
//                UserLog::uLog( ULOG_OK, _T("Device is in Boot mode!") );
//                enableFirmwareMenu( true );
//                refreshToolbar( event );
//                break;
//
//            case BootModeDialog::BMD_LEAVE:
//                m_controller->leaveBootMode();
//                break;
//        }
//    } else {
//        UserLog::uLog( ULOG_OK, _T("Device Connected!") );
//        enableFirmwareMenu( true );
//        refreshToolbar( event );
//        startLogging();
//    }
//}
//
//void MyFrame::onDeviceDisconnected( VemsDeviceControllerEvent& event )
//{
//    UserLog::uLog( ULOG_WARNING, _T("Device Disconnected!") );
//
//    enableFirmwareMenu( false );
//
//    resetStatusBar();
//
//    refreshToolbar( event );
//
//    stopLogging();
//
//    event.Skip();
//}
//
//void MyFrame::onDeviceControllerStarted( VemsDeviceControllerEvent& event )
//{
//    UserLog::uLog( ULOG_WARNING, _T("DeviceController Started!") );
//
//}
//
//void MyFrame::onDeviceControllerStopped( VemsDeviceControllerEvent& event )
//{
//    UserLog::uLog( ULOG_WARNING, _T("DeviceController Stopped!") );
//
//    enableFirmwareMenu( false );
//
//    resetStatusBar();
//
//    refreshToolbar( event );
//
//    stopLogging();
//}
//
//void MyFrame::onDeviceBaudRateChanged( VemsDeviceControllerEvent& event )
//{
//    refreshBaudrateComboBox( true, event.getBaudrate() );
//}
//
//void MyFrame::onInputEvent( InputEvent& event )
//{
//    const SIPRPacket& packet = event.getPacket();
//
//    if ( m_controller->isConnected() ) {
//        m_siprFileLogger->process( packet );
//    }
//
//    switch ( packet.type() )
//    {
//        case SIPR_READ_SENSORS:
//        case SIPR_UPDATE_FREQUENCY:
//            refreshStatusBar( packet );
//            break;
//
//        case SIPR_GET_TABLEDATA:
//        case SIPR_GET_CONFIG_1:
//        case SIPR_GET_CONFIG_2:
//            m_model->process( packet );
//            break;
//    }
//}
//
///**
//    V3GUI - CommunicationModel common/conflicted files
//
//        ECUConfigPanel - ECUConfigPanel2
//        VemsCommand - VemsCommand2
//*/
///** TODO
//    - !!!TESTING 1.1.27!!!
//
//    - !!!TESTING!!!
//        - handle if detect bad rt length // because short timeout or interwrite delay
//             - set timeout and interwritedelay
//
//
//
//        - 1.1.27 - fetching wrong firmware info because pMan give wrong answer
//
//    - !!!VS compile!!!
//
//    - !!!set MegatuneSyncer to sync pages!!!
//    - !!!FwDesc::cleanup() memory leak!!!
//    - !!!MegatuneSyncer error when detect realtimelength( need sync if too many crcerror)!!!
//    - !!!VemsDeviceController->isRunning() doesn't work in DetectingState because thread isn't running!!!
//
//    - ECU ConfigPanel
//
//    - show crc errors / rt errors
//
//    - Detecting
//        - try to detect ECU with the config params first
//
//    - make ECUConfig panel applies changes without restart app
//    - create, test SerialPortScannerClient
//
//    - FirmwareVerifier
//        - handle patch files
//        - handle comm error
//        - handle patches
//        - handle round
//
//    - FirmwareUploader
//        - handle patch files
//
//    - ModeSelector
//    - BaudRateSelector
//
//    - DETECTING
//        - handle previous port, baud, device
//
//    - handle preferred baudrate
//    - Scanning / ECUConfigPanel
//    - handle MAN/MEGTUNE/BOOT
//    - Config Panel
//    - timeout, interWriteDelay
//    - main gui
//    - ConfigDownloader send events
//*/
//
///**
//    VemsDeviceController->start();
//        cannot open port
//
//        started
//            show dialog
//                Detecting device...
//                    device not found / close
//
//                    device found /
//                        boot / Boot mode found / close
//
//                        other / Checking password protection / close (testing)
//
//
//                    communication error
//                        / close
//
//
//
//    VemsDeviceController::configPanel()
//        saveCurrentState()
//            m_firmwareInfo
//            m_device
//            m_deviceMode
//            m_port
//            m_baudrate
//
//            m_fsm->isConnected()
//
//        stop()
//
//        resume()
//
//
//
//    ECUConfigPanel( VemsDeviceController* )
//
//        CANNOT_OPEN_PORT
//
//            change params
//                port
//                    searches device on the selected port ???
//                        found
//                        not found
//
//            detect
//
//            save/close
//                resume()
//
//
//
//
//        DETECTING
//
//
//        CONNECTED
//
//
//        STOPPED
//
//
//*/
//
///**
//    stat
//        update per sec
//        received packets
//        crc errors
//        rt errors
//
//
//*/
//
//
///**
//    Layers
//
//        Basic
//            class CommunicationController
//
//
//            class DeviceDetector
//
//
//            class DeviceController( )
//                selectManMode()
//                selectBootMode()
//                selectMegatuneMode()
//
//                sendPageAddress( ... )
//                getPageChecksum( ... )
//
//
//            DeviceControllerEvent
//                Type
//                    MAN_MODE_SELECTED
//                    BOOT_MODE_SELECTED
//                    MEGATUNE_MODE_SELECTED
//
//
//        First
//            VemsDeviceController
//
//                FirmwareUpdater( DeviceController )
//                {
//                    start()
//                       DeviceController
//                           selectBootMode()
//                           sendPageAddres( ... )
//                           getPageCheckSum( ... )
//
//                    OnDeviceControllerEvent
//                        BOOT_MODE_SELECTED
//                        PAGE_ADDRESS_OK
//                        PAGE_ADDRESS_BAD
//                        PAGE_CHECKSUM
//
//                        TIMEDOUT
//
//                    FirmwareUpdaterEvent
//                }
//
//        Second //GUI
//            DeviceController
//            FirmwareUpdater( DeviceController )
//
//            OnFirmwareUpdaterEvent
//
//
//*/
//
///**
//    //CommunicationClient???( id, )
//    CommunicationClient->register( CommunicationClient )
//
//    write()
//        m_client->write()
//
//    read()
//        m_client->read()
//
//    handleEvent( event )
//
//        meth = m_hash[id][event];
//
//        if ( meth ) {
//            meth();
//        }
//
//        switch ( event )
//        {
//            EVENT_1:
//                switch ( client->id )
//                {
//                    ID_1:
//                        //removeClient();
//                        registerClient( );
//                }
//
//            default:
//                break;
//        }
//
//    DeviceSelector( parent )
//        // addEventHandler( event, obj, meth )
//        parent->handleEvent( )
//
//
//    SelectManMode( parent )
//        write()
//            send
//
//
//
//
//*/
