#include "StatusBarObserver.h"

#include "logger.h"
#include "FirmwareInfo.h"

StatusBarObserver::StatusBarObserver(wxStatusBar* statusBar, wxEvtHandler* vemsController, FirmwareInfo* fwInfo)
{
    //m_vemsController = vemsController;
    //ctor
    vemsController->Connect( wxEVT_ECU, ECUEventHandler( StatusBarObserver::OnECUEvent ),NULL, this);
    m_statusBar = statusBar;
    m_fwInfo = fwInfo;
}

StatusBarObserver::~StatusBarObserver()
{
    //dtor
}

void StatusBarObserver::OnECUEvent(ECUEvent& event)
{
     wxString str;
    if( event.state == ECUEvent::CONNECTED ){
        str = _T("Firmware version: ") + m_fwInfo->getFirmwareVersionAsString();
    }else{
        str = event.getStateAsString();
        //Logger::logf( LOG_MSG, _T("StatusBarObserver::OnECUEvent() - ") + str );
    }

    m_statusBar->SetStatusText(str, 1);
    event.Skip();
}



