#include "SystemInfoPacker.h"

#include <wx/filename.h>

#include "wxSystemHelper.h"
#include "version.h"

#include "app.h"

wxString SystemInfoPacker::GetPack()
{
    wxString pack;

// overall
    wxDateTime now = wxDateTime::Now();
    pack += _T("Created=")+now.FormatISODate()+_T(" ")+now.FormatISOTime()+_T("\n");
    pack += wxString::Format(_T("CreatedRaw=%i\n"), now.GetTicks());

// adding infos about vemstune
    pack += _T("[VemsTune]\n");

    pack += _T("Version=")+ AutoVersion::getVersion() +_T("\n");
    pack += _T("Date=")+ AutoVersion::getDateTime() +_T("\n");

    size_t memusage = wxSystemHelper::GetMemoryUsage();

    pack += _T("CurrentMemoryUsage=")+wxFileName::GetHumanReadableSize(wxULongLong(0,memusage))+_T("\n");
    pack += wxString::Format(_T("CurrentMemoryUsageRaw=%i\n"),memusage);

    MyApp& app = wxGetApp();
    size_t time = app.GetRunningTimeMs();
    wxTimeSpan tspan = wxTimeSpan::Milliseconds(time);
    pack += _T("RunningTime=")+tspan.Format()+_T("\n");
    pack += wxString::Format(_T("RunningTimeRawMs=%i\n"),time);

// adding system informations
    Int2StringHash data;
    wxSystemHelper::GetSystemSummary(data);

    pack += _T("[System]\n");

    for(Int2StringHash::iterator it = data.begin(); it != data.end(); it++ ) {
        pack += wxSystemHelper::GetSysPropString(it->first) + _T("=") + it->second + _T("\n");
    }

    return pack;
}

