#ifndef THREADSTATUS_H
#define THREADSTATUS_H

#include <wx/thread.h>

enum ThreadState{
    TS_EXIT,
    TS_RUN
};

class ThreadStatusListener
{
    public:
        ThreadStatusListener() {};
        virtual ~ThreadStatusListener() {};

        virtual void TSNotify(ThreadState state) = 0;

    protected:

    private:

};

class ThreadStatusSender: public wxThread
{

    public:
        ThreadStatusSender() { m_threadStatusListener = NULL; };
        virtual ~ThreadStatusSender() {};

        void SetThreadStatus(ThreadStatusListener *tstat) { m_threadStatusListener = tstat; };

        bool SendThreadStatusFlag(ThreadState state) {
            if(m_threadStatusListener == NULL) return false;
            m_threadStatusListener->TSNotify(state);
            return true;
        }

    protected:

    private:

        ThreadStatusListener    *m_threadStatusListener;

};

#endif // THREADSTATUS_H
