#include "UserLogWindow.h"

#include "logger.h"
#include "DirHelper.h"
#include "vemsdialog/UserDialogBase.h"

UserLogWindow::UserLogWindow(wxWindow * parent, int id)
{
    //ctor
    m_userDialog = NULL;
    Create( parent, id, wxDefaultPosition, wxDefaultSize, wxBORDER_SUNKEN | wxHW_DEFAULT_STYLE);

   //SetPage(_T("<html><head><link rel='stylesheet' href='") + DirHelper::GetPath() + _T("test.css' type='text/css'></head><body>\n"));

    m_winStartStr = _T("<html><body><table cellspacing=2 cellpadding=2>\n");

    m_logStr = m_winStartStr;

    Init();

    SetBorders(0);


}

UserLogWindow::~UserLogWindow()
{
    //dtor
}

void UserLogWindow::Init()
{                               // r, g, b
    m_fontColor[ULOG_DOWN] = wxColor(193,71,194);
    m_fontColor[ULOG_ERROR] = wxColor(255,0,0);
    m_fontColor[ULOG_INFO] = wxColor(0,0,255);
    m_fontColor[ULOG_OK] = wxColor(0,100,0);
    m_fontColor[ULOG_STOP] = wxColor(255,0,0);
    m_fontColor[ULOG_UP] = wxColor(39,122,123);
    m_fontColor[ULOG_WARNING] = wxColor(156,110,1);

    m_fontSize[ULOGLS_SMALL] = 1;
    m_fontSize[ULOGLS_MEDIUM] = 3;
    m_fontSize[ULOGLS_LARGE] = 5;
    m_fontSize[ULOGLS_XLARGE] = 7;
    m_fontSize[ULOGLS_XXLARGE] = 7;

    m_iconFiles[ULOGLS_SMALL][ULOG_DOWN] = DirHelper::GetPath(dICON) + _T("ul-down-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_ERROR] = DirHelper::GetPath(dICON) + _T("ul-error-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_INFO] = DirHelper::GetPath(dICON) + _T("ul-info-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_OK] = DirHelper::GetPath(dICON) + _T("ul-ok-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_STOP] = DirHelper::GetPath(dICON) + _T("ul-stop-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_UP] = DirHelper::GetPath(dICON) + _T("ul-up-s.png");
    m_iconFiles[ULOGLS_SMALL][ULOG_WARNING] = DirHelper::GetPath(dICON) + _T("ul-warning-s.png");

    m_iconFiles[ULOGLS_MEDIUM][ULOG_DOWN] = DirHelper::GetPath(dICON) + _T("ul-down-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_ERROR] = DirHelper::GetPath(dICON) + _T("ul-error-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_INFO] = DirHelper::GetPath(dICON) + _T("ul-info-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_OK] = DirHelper::GetPath(dICON) + _T("ul-ok-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_STOP] = DirHelper::GetPath(dICON) + _T("ul-stop-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_UP] = DirHelper::GetPath(dICON) + _T("ul-up-m.png");
    m_iconFiles[ULOGLS_MEDIUM][ULOG_WARNING] = DirHelper::GetPath(dICON) + _T("ul-warning-m.png");

    m_iconFiles[ULOGLS_LARGE][ULOG_DOWN] = DirHelper::GetPath(dICON) + _T("ul-down-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_ERROR] = DirHelper::GetPath(dICON) + _T("ul-error-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_INFO] = DirHelper::GetPath(dICON) + _T("ul-info-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_OK] = DirHelper::GetPath(dICON) + _T("ul-ok-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_STOP] = DirHelper::GetPath(dICON) + _T("ul-stop-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_UP] = DirHelper::GetPath(dICON) + _T("ul-up-l.png");
    m_iconFiles[ULOGLS_LARGE][ULOG_WARNING] = DirHelper::GetPath(dICON) + _T("ul-warning-l.png");

    m_iconFiles[ULOGLS_XLARGE][ULOG_DOWN] = DirHelper::GetPath(dICON) + _T("ul-down-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_ERROR] = DirHelper::GetPath(dICON) + _T("ul-error-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_INFO] = DirHelper::GetPath(dICON) + _T("ul-info-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_OK] = DirHelper::GetPath(dICON) + _T("ul-ok-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_STOP] = DirHelper::GetPath(dICON) + _T("ul-stop-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_UP] = DirHelper::GetPath(dICON) + _T("ul-up-xl.png");
    m_iconFiles[ULOGLS_XLARGE][ULOG_WARNING] = DirHelper::GetPath(dICON) + _T("ul-warning-xl.png");

    m_iconFiles[ULOGLS_XXLARGE][ULOG_DOWN] = DirHelper::GetPath(dICON) + _T("ul-down-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_ERROR] = DirHelper::GetPath(dICON) + _T("ul-error-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_INFO] = DirHelper::GetPath(dICON) + _T("ul-info-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_OK] = DirHelper::GetPath(dICON) + _T("ul-ok-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_STOP] = DirHelper::GetPath(dICON) + _T("ul-stop-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_UP] = DirHelper::GetPath(dICON) + _T("ul-up-xxl.png");
    m_iconFiles[ULOGLS_XXLARGE][ULOG_WARNING] = DirHelper::GetPath(dICON) + _T("ul-warning-xxl.png");

}
void UserLogWindow::setUserDialog(UserDialogBase* userDialog){
    m_userDialog = userDialog;
}

void UserLogWindow::PutLog(UserLogType type, const wxString& str, UserLogLineSize size, ShowPolicy policy)
{
    wxDateTime now = wxDateTime::Now();

    wxString line = _T("</td><td align=\"center\" valign=\"top\"><img src=\"") + m_iconFiles[size][type] + _T("\"></td><td valign=\"center\"><font size=\"")
                    + wxString::Format(_T("%i"),m_fontSize[size]) + _T("\" color=\"") + m_fontColor[type].GetAsString(wxC2S_HTML_SYNTAX)
                    + _T("\">") + str + _T("</font></td></tr>\n");

    if( policy == SPC_NO_DUPLICATE_LINES && m_lastLine == line )
        return;

    m_lastLine = line;

    m_logStr += _T("<tr><td valign=\"top\">") + now.FormatISOTime() + line;

    SetPage( m_logStr + _T("</table></body></html>") );

    int x=0, y=0,u1,u2;

    GetVirtualSize(&x,&y);
    GetScrollPixelsPerUnit(&u1,&u2);

    Scroll( -1, y/u2);

    //Logger::logf(LOG_MSG,_T("x=%i,y=%i,u1=%i,u1=%i"),x,y,u1,u2);

}

void UserLogWindow::PutRawLog(const wxString& str)
{
    AppendToPage( str );
}
/*
bool UserLogWindow::OnCellClicked(wxHtmlCell *cell, wxCoord x, wxCoord y, const wxMouseEvent& event)
{
    Logger::logf(LOG_MSG,_T("x=%i,y=%i,t=")+ cell->GetId(),x,y);

}
*/
void UserLogWindow::OnLinkClicked(const wxHtmlLinkInfo& link)
{
    Logger::logf(LOG_MSG,_T("link=")+link.GetHref());

    //wxString menuName = _T("constants");
    if(m_userDialog){
        //Logger::logf(LOG_MSG,_T("Test l") );
        //m_userDialog->showDialog(menuName);
        m_userDialog->showDialog(link.GetHref(),link.GetTarget());
    }
}

void UserLogWindow::ClearWin()
{
    m_logStr = m_winStartStr;

    SetPage( _T("<html></html>") );
}

void UserLogWindow::notify( int i )
{
}

void UserLogWindow::notify(int i, int idx)
{
}

void UserLogWindow::notify(const wxString & str)
{
    PutLog( ULOG_INFO, str );
}
