#include "VemsAuiManager.h"

#include "logger.h"

/// AuiPaneToolBar
#include "AuiPaneToolBar.h"

VemsAuiManager::VemsAuiManager(wxWindow* managed_wnd, unsigned int flags)
              :wxAuiManager(managed_wnd,flags)
{
    //ctor
}

VemsAuiManager::~VemsAuiManager()
{
    //dtor
}

bool VemsAuiManager::AddPane1(AuiPaneToolBar *panetoolbar)
{
    AddPane((wxWindow*)panetoolbar->GetToolBar(),panetoolbar->GetAuiPaneInfo());
    return 0;
}

bool VemsAuiManager::ProcessDockResult(wxAuiPaneInfo& target, const wxAuiPaneInfo& new_pos)
{
    //LOG
    bool allowed = false;

    switch (new_pos.dock_direction)
    {
        case wxAUI_DOCK_TOP:    allowed = target.IsTopDockable();    break;
        case wxAUI_DOCK_BOTTOM: allowed = target.IsBottomDockable(); break;
        case wxAUI_DOCK_LEFT:   allowed = target.IsLeftDockable();   break;
        case wxAUI_DOCK_RIGHT:  allowed = target.IsRightDockable();  break;
    }

    if(allowed) target = new_pos;

    //Logger::logf(LOG_MSG,_T("VemsAuiManager::ProcessDockResult END allowed=%i"),allowed);

    return allowed;
}
