
#include "VemsInitialScreen.h"
#include "DisplayHelper.h"

#include <wx/dcbuffer.h>

#include "ProgressBarObserverWidget.h"
#include "VemsFlagConfigHelper.h"

#include "logger.h"
#include "DirHelper.h"

/*
DEFINE_EVENT_TYPE(wxEVT_VEMS_CONTROL)
IMPLEMENT_DYNAMIC_CLASS(VemsControlEvent, wxEvent)
*/

BEGIN_EVENT_TABLE(VemsInitialScreen, wxFrame)

    EVT_PAINT(VemsInitialScreen::OnPaint)

END_EVENT_TABLE()

VemsInitialScreen::VemsInitialScreen(wxWindow* parent, wxWindowID id,const wxString& title, const wxPoint& pos, const wxSize& size, long style)
                : wxFrame(parent, id, title, pos, size, style)
                , m_loader (NULL)

{
    //ctor
    SetBackgroundColour(wxColour(30,0,0));

    m_progressText = new wxStaticText(this, wxID_ANY, _T("Loading..."), wxPoint(5,(DisplayHelper::GetDisplaySize().y)-90));


    m_progressText->SetForegroundColour(wxColor(255,255,255));


    m_progressBar = new ProgressBarObserverWidget(this,wxID_ANY, wxPoint(10,(DisplayHelper::GetDisplaySize().y)-60), wxSize((DisplayHelper::GetDisplaySize().x)-20,20));
    m_progressBar->SetValueLimits(0.0, 100.0, 2.0);
    m_progressBar->SetWindowStyleFlag(wxBORDER_SUNKEN);
    m_progressBar->SetProgressStyle(PB_PERCENTTEXT_INNER);
    m_progressBar->Update(0);

    m_loader = new ConfigLoaderThread();

    m_logoBMP = wxBitmap( DirHelper::GetPath(dGRAPHICS) + _T("VemsLogo.png") , wxBITMAP_TYPE_PNG);

}

VemsInitialScreen::~VemsInitialScreen()
{
    //dtor
}

void VemsInitialScreen::SetInitText(const wxString& text)
{

    m_progressText->SetLabel(text);
	m_progressText->Update();

}

bool VemsInitialScreen::ConfigInit()
{
//    SetInitText(_T("Loading: ") + MTConfigHelper::GetFilename() + _T(" ..."));


    if( m_loader->Create() != wxTHREAD_NO_ERROR) return false;

   // Logger::log(LOG_MSG,_T("VemsInitialScreen::ConfigInit() thread ok"));

    m_loader->SetObserver(m_progressBar);
    m_loader->SetThreadStatus(m_threadStatusListener);
	m_loader->SetPriority(WXTHREAD_DEFAULT_PRIORITY);
    m_loader->Run();


    return true;
}

void VemsInitialScreen::OnPaint(wxPaintEvent& event)
{

    wxBufferedPaintDC dc(this);

    dc.SetBackground( *wxBLACK_BRUSH );
    dc.Clear();

    dc.DrawBitmap(m_logoBMP, 5, 20, 1);

}


void* ConfigLoaderThread::Entry()
{
//    Logger::logf(LOG_MSG,_T("ConfigLoaderThread::Entry() START"));
    Sleep(250);


   // MTConfigHelper::parseMTConfigData(NULL,m_observer);



    if(m_dest != NULL) {

    //    Logger::logf(LOG_MSG,_T("ConfigLoaderThread::Entry() SendEvent"));

        VemsControlEvent event;
        event.SetEventObject(m_dest);

        wxPostEvent(m_dest, event);

    }


    //Logger::log(LOG_MSG,_T("ConfigLoaderThread::Entry() SEND: TS_EXIT"));
    //SendThreadStatusFlag(TS_EXIT);
 //   Logger::logf(LOG_MSG,_T("ConfigLoaderThread::Entry() END"));

	return NULL;
}

