#ifndef WINDOWHELPER_H
#define WINDOWHELPER_H
#include <wx/wx.h>

class WindowTipper;
class GaugeGroupManager;

class WindowHelper
{
    public:
        WindowHelper(wxWindow * win, WindowTipper * winTip = NULL);
        virtual ~WindowHelper();

        int Action(wxKeyEvent &evt);
        bool GroupAction(GaugeGroupManager* groupmgr, int lastActionResult, const wxString& grpName, bool isDropToCarrier = true);

        void SetSideRatioRestriction(double s) { m_sideRatioRestriction = s; };

    protected:

        void MoveTarget(int xdiff, int ydiff);
        void SetSizeTarget(int xdiff, int ydiff);

    private:

        WindowTipper*   m_winTip;
        wxWindow*       m_targetWin;

        wxPoint         m_startPos;
        wxSize          m_startSize;

        double          m_sideRatioRestriction;

        wxKeyEvent*     m_evt;
};

#endif // WINDOWHELPER_H
