#ifndef AGGHELPER_H
#define AGGHELPER_H

#include "agg_color_rgba.h"
#include <wx/wx.h>
#include <exception>

namespace Agg {

    agg::rgba
    convertToRGBA( const wxColour& c );

    wxColor
    convertToColor( const agg::rgba& c );
};

class wxAggObject : public wxObject   {
    public:
        wxAggObject() {}
        virtual ~wxAggObject() {}
};

WX_DEFINE_ARRAY( wxAggObject*, wxAggObjArray );

class wxAggObjectStackException : std::exception
{
    public:
        virtual const char* what() { return "wxAggObjectStack: Stack is empty!"; }
        virtual const wxString error() { return _T("wxAggObjectStack: Stack is empty!"); }
};

class wxAggObjectStack {
    public:
        wxAggObjectStack();
        ~wxAggObjectStack();

        void            push( wxAggObject* object );
        wxAggObject*    pop() throw (wxAggObjectStackException);
        wxAggObject*    top() throw (wxAggObjectStackException);
        bool            isEmpty() const;
        void            clear();
    private:

        wxAggObjArray   m_stack;
};

#endif // AGGHELPER_H
