#ifndef WXAGGFONT_H
#define WXAGGFONT_H

#include "agg_font_freetype.h"

#include "aggHelper.h"

typedef agg::font_engine_freetype_int32             font_engine_type;
typedef agg::font_cache_manager<font_engine_type>   font_manager_type;

class wxAggFont : public wxAggObject
{
    public:
        wxAggFont();
        wxAggFont( const wxAggFont& font );

        wxAggFont& operator = ( const wxAggFont& font );

        bool                loadFont( const wxString& fontFileName, double height, double weight, double width = 0 );
        bool                reloadFont();
        void                setFont( const wxAggFont& font );

        bool                isOk() const { return m_fontOk; }

        double              getHeight() const;
        void                setHeight( double h );
        double              getWidth() const;
        void                setWidth( double w );

        double              getFontWeight() const;

        font_engine_type&   getFontEngine();

    protected:

    private:
        wxString            m_fontfilename;
        font_engine_type    m_font_engine;
        double              m_font_weight;
        double              m_font_height;
        double              m_font_width;
        bool                m_fontOk;

        DECLARE_DYNAMIC_CLASS( wxAggFont )
};

#endif // WXAGGFONT_H
