#include "PolygonHelper.h"

bool PolygonHelper::PtInPolygon( wxPoint *rgpts, unsigned int numpts, const wxPoint& pointToTest, wxRect* boundrect )
{
    if ( PtInPolyRect( rgpts, numpts, pointToTest, boundrect ) == false )
        return false;

    wxRect r;

    wxPoint pt1, pt2;
    wxPoint* ppt = rgpts;
    unsigned int wnumintsct = 0;

    pt1 = pt2 = pointToTest;
    pt2.x = r.GetRight() + 50;

    for ( unsigned int i = 0 ; i < numpts - 1 ; ++i )
    {
        if ( Intersect( pointToTest, pt2, *ppt, *(ppt+1) ) )
            wnumintsct++;

        ppt++;
    }

    if ( Intersect( pointToTest, pt2, *ppt, *rgpts ) )
        wnumintsct++;

    return ( wnumintsct & 1 );
}

bool PolygonHelper::PtInPolyRect( wxPoint* rgpts, unsigned int ptnum, const wxPoint& pointToTest, wxRect* boundrect )
{
    wxRect r;

    if ( boundrect )
        r = *boundrect;
    else
    {
        int xmin, xmax, ymin, ymax;

        wxPoint pt;

        xmin = ymin = INT_MAX ;
        xmax = ymax = -INT_MAX ;

        for ( unsigned i = 0; i < ptnum; ++i )
        {
            pt = rgpts[i];

            if ( pt.x < xmin )
                xmin = pt.x;

            if ( pt.x > xmax )
                xmax = pt.x;

            if ( pt.y < ymin )
                ymin = pt.y;

            if ( pt.y > ymax )
                ymax = pt.y;
        }

        r.SetTopLeft( wxPoint( xmin, ymin ) );
        r.SetBottomRight( wxPoint( xmax, ymax ) );
   }

   return ( r.Contains( pointToTest ) );
}

/* static */
bool PolygonHelper::Intersect( const wxPoint& p1, const wxPoint& p2, const wxPoint& p3, const wxPoint& p4 )
{
       return ( ( ( CCW( p1, p2, p3 ) * CCW( p1, p2, p4 ) ) <= 0 ) && ( ( CCW( p3, p4, p1 ) * CCW( p3, p4, p2 )  <= 0) ) ) ;
}

/* static */
int PolygonHelper::CCW( const wxPoint& p0, const wxPoint& p1, const wxPoint& p2 )
{
   long dx1, dx2;
   long dy1, dy2;

   dx1 = p1.x - p0.x ; dx2 = p2.x - p0.x ;
   dy1 = p1.y - p0.y ; dy2 = p2.y - p0.y ;

   return ( ( dx1 * dy2 > dy1 * dx2 ) ? 1 : -1) ;
}
