#ifndef BCPROGRESSDIALOG_H
#define BCPROGRESSDIALOG_H

#include <wx/progdlg.h>

#include "bcParentDialog.h"

class bcLabel;
class bcButton;
class bcProgressBar;

class bcProgressDialog: public bcParentDialog
{
    public:
        bcProgressDialog(const wxString& title, const wxString& message, int maximum = 100, wxWindow * parent = NULL, int style = wxPD_AUTO_HIDE | wxPD_APP_MODAL);
        virtual ~bcProgressDialog();

        virtual bool Update(int value, const wxString& newmsg = wxEmptyString, bool *skip = NULL);

        virtual bool Pulse(const wxString& newmsg = wxEmptyString, bool *skip = NULL);

        void UpdateMessage(const wxString& msg);
        virtual bool Show( bool show = true );
    protected:

        void BuildGUI();

        void OnButton(wxCommandEvent& event);

        void UpdateTimes();

        wxString FormatTime(long millisescs);

        void OnTimer(wxTimerEvent& evt);
        void ReenableOtherWindows();
    private:

        enum bcProgressDialogIds {
            idButtonSkip,
            idButtonAbort,
            idTimer
        };

        bool m_finished;
        long m_style;
        long m_value;
        long m_max;
        wxString m_msg;

        wxWindow*       m_parentTop;

        bcProgressBar*  m_bar;
        bcLabel*        m_elapsedLabel;
        bcLabel*        m_estimatedLabel;
        bcLabel*        m_remainingLabel;
        bcLabel*        m_msgLabel;

        bcButton*       m_abortButton;
        bcButton*       m_skipButton;

        bool            m_isSkipped;
        bool            m_isAborted;

        wxStopWatch     m_watch;


        wxTimer         m_timer;

        class WXDLLIMPEXP_FWD_CORE wxWindowDisabler *m_winDisabler; // for modal case

        DECLARE_EVENT_TABLE();

};

#endif // BCPROGRESSDIALOG_H
