#ifndef BCSLIDER_H
#define BCSLIDER_H

#include "BitmapCanvasWidgetBase.h"

class bcSlider: public BitmapCanvasWidgetBase
{
    DECLARE_DYNAMIC_CLASS(bcSlider);

    public:
        bcSlider() {}
        bcSlider(BitmapCanvasParentBase* parent, int id = wxID_ANY, int minValue = 0, int maxValue = 10, int currValue = 5, int style = 0, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
//        bcSlider(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);

        virtual void Create(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);

        virtual ~bcSlider();

        virtual void DrawWidget();

        void SetValue(int val);
        void ChangeValue(int val);
        void SetMinValue(int val);
        void SetMaxValue(int val);

        int GetValue() { return GetPropLong(BCS_CURRENT_VALUE); };

        enum bcSliderProperties {
            BCS_CURRENT_VALUE,
            BCS_MAX_VALUE,
            BCS_MIN_VALUE,
            BCS_CELL_SPACE,
            BCS_CELL_MIN_WIDTH_REF,
            BCS_ACTIVE_COLOR,
            BCS_INACTIVE_COLOR
        };

    protected:

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeave(wxMouseEvent& evt);
        void OnEnter(wxMouseEvent& evt);
        void OnMouseMove(wxMouseEvent& evt);

        int GetValue(const wxPoint& mousePos);

    private:

        DECLARE_EVENT_TABLE();

        wxVariant m_hlValue;

};

#endif // BCSLIDER_H
