#ifndef BCTEXTCTRL_H
#define BCTEXTCTRL_H

#include "BitmapCanvasWidgetBase.h"
#include "../TextValidator.h"


class bcTextCtrl: public BitmapCanvasWidgetBase
{
    public:
        bcTextCtrl(BitmapCanvasParentBase* parent, int id, const wxString& text = wxEmptyString, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxALIGN_CENTER_HORIZONTAL, const wxValidator& validator = wxDefaultValidator );
        virtual ~bcTextCtrl();

        virtual void Create(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);

        virtual void DrawWidget();

        void SetValue(const wxString& text);
        wxString GetValue() { return m_text; };

        long XYToPosition(int x, int y);
        long XYToPosition(const wxPoint& pos) { return XYToPosition(pos.x,pos.y); };

    protected:

        void OnKeyDown(wxKeyEvent& evt);

        void OnEnter(wxMouseEvent& evt);
        void OnLeave(wxMouseEvent& evt);
        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);
        void OnMouseMove(wxMouseEvent& evt);
        void OnProcessorTextEnter(wxCommandEvent& evt);

        void OnProcessorSetFocus(wxFocusEvent& evt);
        void OnProcessorKillFocus(wxFocusEvent& evt);

        void OnSetFocus(wxFocusEvent& evt);
        void OnKillFocus(wxFocusEvent& evt);

        void OnProcessorUpdated(wxCommandEvent& evt);

        void OnTimer(wxTimerEvent& evt);
        void OnProcessocTimer(wxTimerEvent& evt);


    private:



        enum bcTextCtrlStates {
            BCTC_NORMAL,
            BCTC_HIGHLIGHTED
        };

        enum {
            idTimer,
            idProcTimer
        };

        enum ProcessorCursorStates {
            CHG_NO      = 0x00,
            CHG_INSPT   = 0x01,
            CHG_SELFROM = 0x02,
            CHG_SELTO   = 0x04
        };

        wxString        m_text;
        long            m_style;
        long            m_state;
        TextValidator   m_validator;

        wxTextCtrl*     m_processor;

        wxTimer         m_cursorTimer;
        wxTimer         m_processorChechker;

        int             m_cursorFlashTime;
        bool            m_isCursor;


        int             m_procSelFromIdx;
        int             m_procSelToIdx;
        int             m_procInsertIdx;

        long            m_procState;
        long            m_lastProcState;

        long            m_startMouseSelPos;

        DECLARE_EVENT_TABLE();
};

#endif // BCTEXTCTRL_H
