#ifndef BCTOOLTIP_H
#define BCTOOLTIP_H

#include "bcLabel.h"

class bcToolTip: public bcLabel
{
    public:
        bcToolTip(BitmapCanvasParentBase* parent, const wxString& text = wxEmptyString);
        virtual ~bcToolTip();

        void SetTipMessage(const wxString& msg);

        void ShowTip(const wxPoint& pos, int showlenms = 5000, int delayedms = 500);
        void HideTip();

    protected:

        void OnTimer(wxTimerEvent& evt);
        void OnLeave(wxMouseEvent& evt);

        void DoShowTip();
        void DoHideTip();

    private:

        enum {
            idTimer
        };

        wxTimer     m_timer;
        int         m_showLen;
        bool        m_isDelayedShow;

        DECLARE_EVENT_TABLE();

};

#endif // BCTOOLTIP_H
