#ifndef LOG2CSVCONVERTER_H
#define LOG2CSVCONVERTER_H

#include <wx/textfile.h>

#include "../Observable.h"
#include "../common/types/Int2StringHash.h"
#include "../common/types/Int2IntHash.h"

class MTConfigData;
class SymbolMgr;
class STDataModelSerial;
class LogHistoryMgr;
class RTDataMgrFacade;
class STDataMgrFacade;
class RTDataInputSIPR;
class DoubleHash;
class SIPRPacket;


class Log2CsvConverter : public Observable
{
    public:
        Log2CsvConverter( const wxString& filename );

    public:
        void        convert();

    private:
        wxString            m_fileName;
        MTConfigData*       m_mtConfigData;
        SymbolMgr*          m_symbolMgr;

        DoubleHash*         m_rtViewerModel;
        RTDataMgrFacade*    m_rtMgr;
        RTDataInputSIPR*    m_inputSIPR;
        STDataMgrFacade*    m_stMgr;
        STDataModelSerial*  m_myModelSerial;
        STDataModelSerial*  m_deviceModel;
        LogHistoryMgr*      m_logHistoryMgr;

        wxTextFile          m_csvfile;
        wxString            m_csvfilename;
        Int2StringHash      m_variables;
        Int2IntHash         m_addr2index; // address to array index

    private:
        void                createCSVFile( const wxArrayString& addresses );
        void                writePackets( SIPRPacket** packets, unsigned int packetNo );
        void                closeCsvFile();
};

#endif // LOG2CSVCONVERTER_H
