#include "SimpleIniParser.h"

#include "../Symbol.h"

SimpleIniParser::SimpleIniParser( SymbolTable* table ) : m_symbolTable(table)
{
}

void SimpleIniParser::parseLine()
{
    if ( m_line.Find(_T("=")) == wxNOT_FOUND )
        return;

    wxString symName, expr;

    symName = m_line.BeforeFirst('='); symName.Trim(); symName.Trim( false );
    expr = m_line.AfterFirst('=');

    int bb = expr.Find(_T("{")), be = expr.Find(_T("}") );
    if ( bb != wxNOT_FOUND && be != wxNOT_FOUND )
    {
        expr = expr.Mid( bb + 1, ( be - bb -1 ) );
    }

    expr.Trim(); expr.Trim( false );

    Symbol* sym = new Symbol;
    sym->setExpr( symName, expr );
    sym->setName( symName );

    SymbolTable::iterator it = m_symbolTable->find( symName );

    if ( it == m_symbolTable->end() )
    {
        (*m_symbolTable)[symName] = sym;
    }
}
