#include "KeyBinderDialog.h"


#include <wx/keybinder.h>
#include <wx/wx.h>

BEGIN_EVENT_TABLE(KeyBinderDialog, wxDialog)
	EVT_BUTTON(wxID_APPLY, KeyBinderDialog::OnApply)
END_EVENT_TABLE()

KeyBinderDialog::KeyBinderDialog(wxKeyProfileArray &prof,
    wxWindow *parent, const wxString &title, int mode)
:wxDialog(parent, -1, title, wxDefaultPosition, wxDefaultSize,
    wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER)
{
    // we can do our task in two ways:
	// 1) we can use wxKeyConfigPanel::ImportMenuBarCmd which gives
	//    better appearances (for me, at least, :-))
	// 2) we can use wxKeyConfigPanel::ImportKeyBinderCmd

	// STEP #1: create a simple wxKeyConfigPanel
	m_p = new wxKeyConfigPanel(this, wxID_ANY, wxDefaultPosition,
                               wxDefaultSize, wxTAB_TRAVERSAL|mode);

	// STEP #2: add a profile array to the wxKeyConfigPanel
	m_p->AddProfiles(prof);

	// STEP #3: populate the wxTreeCtrl widget of the panel
	m_p->ImportMenuBarCmd(((wxFrame*)parent)->GetMenuBar());

	// and embed it in a little sizer
	wxBoxSizer *main = new wxBoxSizer(wxVERTICAL);
	main->Add(m_p, 1, wxGROW);
	SetSizer(main);
	main->SetSizeHints(this);

	// this is a little modification to make dlg look nicer
	wxSize sz(GetSizer()->GetMinSize());
	SetSize(-1, -1, (int)(sz.GetWidth()*1.3), (int)(sz.GetHeight()*1.1));
	CenterOnScreen();
}

KeyBinderDialog::~KeyBinderDialog()
{
    //dtor
}

void KeyBinderDialog::OnApply(wxCommandEvent &)
{ EndModal(wxID_OK); }
