#ifndef ORDEREDSTRINGHASH_H
#define ORDEREDSTRINGHASH_H
#include <wx/wx.h>

#include "types/StringHash.h"

/** \class OrderedStringHash
  * \brief This is a container class represent an ordered map with minimal functionality
 */
class OrderedStringHash
{
    public:
        OrderedStringHash() {}
        virtual ~OrderedStringHash() {}

        void add( const wxString& key, const wxString& value );
        void remove( const wxString& key );
        void clear();

        const wxArrayString& getArray() const { return m_array; }
        const StringHash& getHashMap() const { return m_hashmap; }
    protected:
    private:
        wxArrayString   m_array;
        StringHash      m_hashmap;
};

#endif // ORDEREDSTRINGHASH_H
