#ifndef PROCESSBASE_H
#define PROCESSBASE_H


#include  <wx/object.h>
#include <wx/wx.h>

class CommunicationThread;

class ProcessBase : public wxObject
{
    public:
        ProcessBase();
        virtual ~ProcessBase();
        virtual bool process() = 0;
        //virtual bool ProcessEvent(wxEvent& event ) = 0;
        virtual void start(int priority = WXTHREAD_DEFAULT_PRIORITY);
        virtual void stop();
        virtual void reset() = 0;
        virtual bool isRunning();
        void    pause();
        void    resume();

        void setDisabled(bool state){
                m_isDisabled = state;
        }
        bool    isDisabled(){ return m_isDisabled; }

        virtual void kill();

        int GetPID();

    protected:
        bool m_isDisabled;
    private:

        CommunicationThread* m_pThread;
        wxCriticalSection m_pThreadCS;    // protects the m_pThread pointer
        static int s_threadCount;
        friend class CommunicationThread;
        /// destructor of the thread will invoke this
        virtual void finished() = 0;



};

#endif // PROCESSBASE_H
