#ifndef SDCARDFILESUMMARY_H
#define SDCARDFILESUMMARY_H

#include <wx/wx.h>
#include "../CommunicationControllerClient.h"
#include "../../common/MMCFilesDesc.h"
#include "../../Interruptable.h"

class SDCardFileSummary : public CommunicationControllerClient, public Interruptable
{
    public:
        SDCardFileSummary( const MMCFilesDesc& desc, wxEvtHandler* evthandler );
        virtual ~SDCardFileSummary();

        void    write( uint8_t* buffer, int& size );
        void    read( uint8_t* buffer, int size );
        bool    isFinished();
        void    finish();

        void    Abort();

    protected:

    private:
        enum { TIMEOUT_VAL = 1000, MAX_MSG_COUNT = 5 };

        enum State {
            TIMEOUT,
            GET_SECTOR,
            CHECK_SECTOR,

            GET_STATUS,
            CHECK_STATUS,
            STATUS_FAILED,

            FINISHED,
            ABORTED
        };

        void                getSector( uint8_t* buffer, int& size );
        void                checkSector( uint8_t* buffer, int size );

        void                getStatus( uint8_t* buffer, int& size );
        void                checkStatus( uint8_t* buffer, int size );

        bool                m_nextBlock;
        bool                m_firstBlock;

        unsigned char       m_timeoutCounter;

        unsigned char*      m_buffer;
        size_t              m_buflen;

        State               m_state;

        uint32_t            m_startIdx;
        uint32_t            m_blockIdx;
        uint32_t            m_endIdx;
        uint32_t            m_inc;
        uint32_t            m_realSampleCnt;
        unsigned char       m_errorCnt;

        size_t              m_msscounter;
        size_t              m_msgcounter;

        wxEvtHandler*       m_evtHandler;
        wxVariantHash*      m_dhash;
};

#endif // SDCARDFILESUMMARY_H
