#ifndef CONFIGHELPER_H
#define CONFIGHELPER_H

#include "serialconfig.h"
#include "wxRealRect.h"
#include "common/types/wxVariantHash.h"
#include <wx/config.h>
#include <wx/wx.h>
#include <wx/wfstream.h>



enum{
    CONFIG_TYPE_GUI = 0,
    CONFIG_TYPE_LAYOUT = 1,
    CONFIG_TYPE_KEYBINDER = 2
};

class ConfigHelper
{
    public:
        virtual ~ConfigHelper();

        static void initConfig(char mode = CONFIG_TYPE_GUI);
		static void cleanup();
        static wxString getConfigFile(char mode = CONFIG_TYPE_GUI);
        static wxConfig* getConfig(char mode = CONFIG_TYPE_GUI);
        static void save(char mode = CONFIG_TYPE_GUI);

//        static wxString GetDialogPath(const wxString &dialogname, const wxString &defpath = wxEmptyString );
//        static void SaveDialogPath(const wxString &dialogname, const wxString &path);



    protected:
    private:

        ConfigHelper();
        static void checkAndCreateFile(const wxString& file);
        static wxString CFG_PORT_NAME;
        static wxString CFG_AUTO_RAW_LOG;
        static SerialConfig* m_serialConfig;
        static SerialConfig* m_serialConfigGPS;

        static wxConfig* globalConfig;
        static wxString* guiConfigFile;

        static wxConfig* m_guiLayoutConfig;
        static wxString* guiLayoutConfigFile;

        static wxConfig*    s_keyBindingsCfg;
        static wxString* s_keyBindingsFile;

//        static void ParseGaugesDBFile(const wxString& str);

//        static wxSize m_refDisplaySize;

		static wxFileInputStream* globalFileInputStream;
		static wxFileInputStream* keybindingsFileInputStream;
		static wxFileInputStream* layoutFileInputStream;

		static wxFileInputStream* defaultLayoutFileInputStream;
		static wxFileInputStream* v3LayoutFileInputStream;
		static wxFileInputStream* roundLayoutFileInputStream;

};

#endif // CONFIGHELPER_H

