#include "ConfigMgrAudio.h"


#include "../ConfigBase.h"
#include "AudioConfig.h"
#include "../logger.h"

ConfigMgrAudio::ConfigMgrAudio(ConfigBase* configBase)
:ConfigMgrBase(configBase)
{
    //ctor
}

ConfigMgrAudio::~ConfigMgrAudio()
{
    //dtor
}

void ConfigMgrAudio::load(wxObject* obj)
{
    Logger::log(LOG_MSG,_T("ConfigMgrAudio::load START 10"));
    AudioConfig* audioConfig = dynamic_cast<AudioConfig*>( obj );
    if(!audioConfig){
         Logger::log(LOG_MSG,_T("ConfigMgrAudio::load START 20 cast failed"));
        return;
    }
    Logger::log(LOG_MSG,_T("ConfigMgrAudio::load START 30"));
    getConfig(*audioConfig);
}

void ConfigMgrAudio::save(wxObject* obj)
{
    AudioConfig* audioConfig = dynamic_cast<AudioConfig*>( obj );
    if(!audioConfig) return;

    m_configBase->setPath( _T("/audio") );
    m_configBase->write( _T("inputDevice"), wxString::Format(_T("%i"), audioConfig->m_inputDevice) );
    m_configBase->write( _T("outputDevice"), wxString::Format(_T("%i"), audioConfig->m_outputDevice ) );
    m_configBase->write( _T("sampleRate"), wxString::Format(_T("%i"), audioConfig->m_sampleRate ) );

    m_configBase->setPath( _T("/") );
    m_configBase->flush();
    m_configBase->save();
}

void ConfigMgrAudio::getConfig(AudioConfig& bean)
{

    m_configBase->setPath(_T("/audio"));
    m_configBase->read(_T("inputDevice"), &bean.m_inputDevice, 0 );
    m_configBase->read(_T("outputDevice"), &bean.m_outputDevice, 0 );
    m_configBase->read(_T("sampleRate"), &bean.m_sampleRate, 44100 );

/*
    wxString path = ;
    wxString idStr = m_configBase->getValue(path, _T("inputDevice"), _T("1") );
    wxString odStr = m_configBase->getValue(path, _T("outputDevice"), _T("1") );

	long id = wxAtoi(idStr);
    bean.m_inputDevice = id;

    long od = wxAtoi(odStr);
    bean.m_outputDevice = od;
*/
	Logger::logf(LOG_MSG, _T("ConfigMgrAudio::getConfig(): extension: inputdevice: %i"), bean.m_inputDevice );
	Logger::logf(LOG_MSG, _T("ConfigMgrAudio::getConfig(): autoclose: outputdevice: %i"), bean.m_outputDevice );

}
