#include "ConfigMgrLogConverter.h"

#include "../ConfigBase.h"
#include "CSVConfig.h"
#include "../logger.h"

ConfigMgrLogConverter::ConfigMgrLogConverter(ConfigBase* configBase)
:ConfigMgrBase(configBase)
{
    //ctor
}

ConfigMgrLogConverter::~ConfigMgrLogConverter()
{
    //dtor
}

void ConfigMgrLogConverter::load(wxObject* obj)
{
    Logger::log(LOG_MSG,_T("ConfigMgrLogConverter::load START 10"));
    CSVConfig* csvConfig = dynamic_cast<CSVConfig*>( obj );
    if(!csvConfig){
         Logger::log(LOG_MSG,_T("ConfigMgrLogConverter::load START 20 cast failed"));
        return;
    }
    Logger::log(LOG_MSG,_T("ConfigMgrLogConverter::load START 30"));
    getConfig(*csvConfig);
}

void ConfigMgrLogConverter::save(wxObject* obj)
{
    CSVConfig* csvConfig = dynamic_cast<CSVConfig*>( obj );
    if(!csvConfig) return;

    m_configBase->setPath( _T("/vemslog_converter") );
    m_configBase->write( _T("extension"), csvConfig->m_extension );
    m_configBase->write( _T("autoclose"), wxString::Format(_T("%i"), csvConfig->m_autoClose ) );
    m_configBase->setPath( _T("/") );
    m_configBase->flush();
    m_configBase->save();
}

void ConfigMgrLogConverter::getConfig(CSVConfig& bean)
{
    wxString path = _T("/vemslog_converter");
    wxString extension = m_configBase->getValue(path, _T("extension"), _T("csv") );
    wxString autoCloseStr = m_configBase->getValue(path, _T("autoclose"), _T("1") );

    bean.m_extension = extension;

	long autoClose = wxAtoi(autoCloseStr);
    bean.m_autoClose = autoClose!=0?true:false;

	Logger::logf(LOG_MSG, _T("ConfigMgrLogConverter::getConfig(): extension: ")+ extension);
	Logger::logf(LOG_MSG, _T("ConfigMgrLogConverter::getConfig(): autoclose: %i"), autoClose);

}
