#include "LogSearchHistoryHelper.h"

#include <wx/tokenzr.h>

#include "../ConfigBase.h"

bool LogSearchHistoryHelper::Load(const wxString& path, wxArrayString& hist, ConfigBase* config)
{
    if(!config) return false;

    config->setPath(path);

//    long entries = config->getNumberOfEntries();
//
//    for(long a=0; a < entries; ) {
//        wxString entry;
//        config->getNextEntry(entry,a);
//        hist.Add(entry);
//    }

    wxString histstr;
    config->read(_T("history"),&histstr);

    hist = wxStringTokenize(histstr, _T(";"));

    if(hist.GetCount() < 1) return false;

    return true;
}

bool LogSearchHistoryHelper::Save(const wxString& path, const wxArrayString& hist, ConfigBase* config)
{
    if(!config) return false;

    config->setPath(path);

    wxString histstr;

    for(size_t a=0; a<hist.GetCount();a++) histstr += hist[a] + _T(";");

    histstr.RemoveLast();

    if(histstr == wxEmptyString) return false;

    config->write(_T("history"),histstr);

    config->save();

    return true;
}
