#include "AggToolTipFrame.h"

#include <wx/dcbuffer.h>

//#include "../logger.h"

BEGIN_EVENT_TABLE( AggToolTipFrame, wxFrame )
    EVT_PAINT( AggToolTipFrame::OnPaint )
    EVT_SET_FOCUS( AggToolTipFrame::OnFocus )
END_EVENT_TABLE()

#define ATTPROFILE_CURRVAL _T("currvalue")

AggToolTipFrame::AggToolTipFrame( wxWindow* parent, const wxPoint& pos, const wxSize& size) :
    wxFrame( parent, wxID_ANY, _T(""), pos, size, wxFRAME_FLOAT_ON_PARENT | wxFRAME_NO_TASKBAR | wxBORDER_NONE | wxFRAME_SHAPED )
{
    m_toolTip = new AggToolTip();

    wxVariantIntHash props;

    props[ ATT_ARROW_ALIGMENT ] = (long)ATT_AA_TOP;
    props[ ATT_TEXT_ALIGN ] = (long)ATT_TA_LEFT;
    props[ ATT_ROUND_TYPE ] = (long)ATT_RT_ARC;
    props[ ATT_ARROW_REFPOSITION ] = 0.0;
    props[ ATT_BORDER_WIDTH ] = 0.0;
    props[ ATT_TEXT_HEIGHT ] = 8.0;
    props[ ATT_ROUND_RADIUS ] = 3.5;
    props[ ATT_BACKGROUNDCOLOR ] << wxColor(255,255,255,255);
    props[ ATT_BORDER_WIDTH ] = 1.0;
    props[ ATT_BORDER_COLOR ] << wxColor(10,10,10,255);
    props[ ATT_TEXT_COLOR ] << wxColor(10,10,10,255);

    m_toolTip->SetProperties( props );

    m_toolTip->SetCurrentProfile(ATTPROFILE_CURRVAL);
    m_toolTip->InitProfile(ATTPROFILE_CURRVAL);
    props[ ATT_BORDER_WIDTH ] = 1.5;
    props[ ATT_BACKGROUNDCOLOR ] << wxColor(255,255,255,255);
    m_toolTip->SetProperties( props );
}

AggToolTipFrame::~AggToolTipFrame()
{
    delete m_toolTip;
}

void AggToolTipFrame::OnPaint( wxPaintEvent& event )
{
    wxBufferedPaintDC dc( this );
    dc.Clear();
    m_toolTip->SetProperty( ATT_TEXT_CONTENT, m_tipText );
    wxBitmap* ttip = m_toolTip->DrawBox();

    dc.DrawBitmap( *ttip, 0, 0, 1 );

    wxRegion reg( *ttip, wxColor( 0, 0, 0, 0 ), 5 );

    delete ttip;

    SetShape( reg );
}

void AggToolTipFrame::SetToolTipText( const wxString& str )
{
    m_tipText = str;
    Refresh( false );
}

void AggToolTipFrame::OnFocus( wxFocusEvent& event )
{
    wxWindow* win = event.GetWindow();
    if ( win )
        win->SetFocus();
}
