#ifndef CONTROLCOLORCONTENTVALIDATOR_H
#define CONTROLCOLORCONTENTVALIDATOR_H

#include <wx/wx.h>

class ControlColorContentValidator
{

    public:
        ControlColorContentValidator() { m_targetWin = NULL; }
        ControlColorContentValidator(wxWindow * targetwin, const wxString& value = wxEmptyString, const wxString& nullstr = _T("NULL"), bool isPending = false);
        virtual ~ControlColorContentValidator();

        void CreateValidator(wxWindow * targetwin, const wxString& value = wxEmptyString, const wxString& nullstr = _T("NULL"), bool isPending = false);

        wxString GetNullStr() { return m_nullStr; };

        bool IsNull();

        void ChangeValueEx(const wxString& val, bool isStyle = true);

        void ResetChange(bool updateStyle = true);
        bool IsChanged() { return m_isChanged; }

        void ChangeToNull();

    protected:

        void DoOnUpdated(bool updateStyle = true);
        void DoSetFocus();
        void DoKillFocus();

        void CCCV_SetValue(const wxString& val);
        void CCCV_ChangeValue(const wxString& val);

        wxString CCCV_GetValue();

        void SetStyleEx();

        wxColor     m_normalColor;
        wxFont      m_normalFont;

        wxColor     m_nullColor;
        wxFont      m_nullFont;

        wxColor     m_changedColor;

        wxString    m_nullStr;

        bool        m_isPending;

        bool        m_isChanged;

    private:

        wxWindow*   m_targetWin;

};

#endif // CONTROLCOLORCONTENTVALIDATOR_H
