#include "InfoPanel.h"

#include "../logger.h"

BEGIN_EVENT_TABLE(InfoPanel, wxFrame)

    EVT_ENTER_WINDOW(InfoPanel::OnEnter)
    EVT_LEAVE_WINDOW(InfoPanel::OnLeave)

    EVT_COMMAND_SCROLL_THUMBTRACK(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_THUMBRELEASE(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_TOP(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_BOTTOM(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_LINEUP(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_LINEDOWN(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_PAGEUP(idSlider,InfoPanel::OnSlider)
    EVT_COMMAND_SCROLL_PAGEDOWN(idSlider,InfoPanel::OnSlider)

END_EVENT_TABLE()

InfoPanel::InfoPanel(wxWindow * parent, const wxString& text, const wxString& title, int id, const wxPoint& pinpoint, bool expand)
{
    //ctor
    Create(parent, id, title,m_pinPoint, wxDefaultSize, wxCAPTION | wxFRAME_FLOAT_ON_PARENT );
    SetIcon(wxIcon(_T("vemsLogoIcon2")));
    m_pinPoint = pinpoint;

    m_win= new wxHtmlWindow(this, -1, wxDefaultPosition, wxDefaultSize, wxHW_SCROLLBAR_AUTO /*| wxHW_NO_SELECTION*/);

    m_win->SetBorders(2);
    m_win->SetPage(text);

    SetVirtualSizeHints(wxDefaultSize,wxDefaultSize);

    wxBoxSizer * mainsizer =  new wxBoxSizer(wxVERTICAL);

    mainsizer->Add(m_win,1,wxEXPAND);

    SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));
    m_win->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));

    //m_btn = new wxButton(this,idBtnToggle,expand?_T("Open"):_T("Close"));

    //mainsizer->Add(m_btn,0,wxEXPAND|wxALIGN_CENTER_HORIZONTAL);

    SetSizer(mainsizer);
	//mainsizer->SetSizeHints(this);

    int x,y;
    m_win->GetVirtualSize(&x,&y);

    mainsizer->SetItemMinSize(m_win,x+20,y+5);
//    mainsizer->RecalcSizes();
    mainsizer->Layout();
	//mainsizer->SetSizeHints(this);

    m_hideSizeDist = y + 3;

//    SetWindowStyle(wxBORDER_RAISED);
    Refresh();

    m_win->Connect(wxEVT_ENTER_WINDOW,wxMouseEventHandler(InfoPanel::OnEnter),NULL,this);
    m_win->Connect(wxEVT_LEAVE_WINDOW,wxMouseEventHandler(InfoPanel::OnLeave),NULL,this);


    wxSlider * slider = new wxSlider(this,idSlider, 180, 0, 255 );


    mainsizer->Add(slider,0,wxEXPAND|wxALL, 5);
    mainsizer->Layout();
//	mainsizer->SetSizeHints(this);
}

InfoPanel::~InfoPanel()
{
    //dtor
}

void InfoPanel::OnEnter(wxMouseEvent& evt)
{
    SetTransparent(255);
}

void InfoPanel::OnLeave(wxMouseEvent& evt)
{
    SetTransparent(m_defAlpha);
}

void InfoPanel::SetPinPoint(const wxPoint& pt)
{
    m_pinPoint = pt;
    Move(pt);
}

void InfoPanel::OnButton(wxCommandEvent& evt)
{
    wxPoint pt = GetPosition();
    if( pt == m_pinPoint ) {
        Move( pt.x, pt.y-m_hideSizeDist );
        m_btn->SetLabel(_T("Open"));
    } else {
        Move( m_pinPoint );
        m_btn->SetLabel(_T("Close"));
    }
}

void InfoPanel::OnSlider(wxScrollEvent& evt)
{
    m_defAlpha = evt.GetInt();
    SetTransparent(m_defAlpha);
}
