#ifndef INFOWINDOW_H
#define INFOWINDOW_H

#include <wx/wx.h>
#include <list>
#include <algorithm>

enum { IW_FADE_IN = 1, IW_MOVE = 2, IW_ERROR = 32, IW_WARNING = 64, IW_MESSAGE = 128, IW_DEFAULT = IW_FADE_IN | IW_MOVE | IW_MESSAGE };

class Stacker;

class InfoWindow : public wxFrame
{
    public:
        static void Display(wxWindow* parent,const wxString& title, const wxString& message, int flags = IW_DEFAULT,
                unsigned int delay = 5000, unsigned int fadein_time = 1 );

    private:

        int             m_scrollmillis;
        int             m_alpha;

        bool            m_fadein;
        bool            m_moving;
        wxString        m_iconname;

        wxTimer         m_timer;
        wxColor         m_titleBackground;
        wxColor         m_textBackground;
        wxColor         m_textColor;


        int             m_left, m_top, m_hMin, m_pos;
        unsigned int    m_status;
        unsigned int    m_delay;
        unsigned int    m_fadeout;

        static Stacker  m_stacker;
        static int      m_screenWidth;
        static int      m_screenHeight;

        std::list<wxString>::iterator m_it;
        static std::list<wxString> m_active_messages;


        InfoWindow ( wxWindow* parent, const wxString& title, const wxString& message, int flags, unsigned int delay,
                unsigned int fadein_time );

        virtual ~InfoWindow();

        void        OnTimer( wxTimerEvent& event );
        void        OnMove( wxMouseEvent& event );
        void        OnClick( wxMouseEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif
