#include "InfoWindowHelper.h"
#include <wx/dcbuffer.h>

BEGIN_EVENT_TABLE( OwnStaticText, wxStaticText )
    EVT_MOUSE_EVENTS(OwnStaticText::OnEvent )
END_EVENT_TABLE()

BEGIN_EVENT_TABLE( IconBitmap, wxControl )
    EVT_PAINT( IconBitmap::OnPaint )
END_EVENT_TABLE()

IconBitmap::IconBitmap( wxWindow* parent, wxWindowID id, const wxPoint& position, const wxSize& size, wxString iconname )
    : wxControl( parent, id, position, size, wxBORDER_NONE )
{
    m_name = iconname;
}

void IconBitmap::OnPaint( wxPaintEvent& event )
{
    wxSize size = GetSize();
    wxBufferedPaintDC dc( this );
    dc.SetBrush( m_tc );
    dc.SetPen( m_tc );
    dc.DrawRectangle( 0, 0, size.x, size.y / 2 + 2);
    dc.SetBrush( m_bc );
    dc.SetPen( m_bc );
    dc.DrawRectangle( 0, size.y/2 + 2, size.x, size.y / 2 -2 );

    wxBitmap bmp( m_name, wxBITMAP_TYPE_PNG );

    wxMemoryDC temp_dc;
    temp_dc.SelectObject( bmp );

    dc.Blit( 0, 0, bmp.GetWidth(), bmp.GetHeight(), &temp_dc, 0, 0 );
    temp_dc.SelectObject ( wxNullBitmap );
}
