#ifndef INFOWINDOWHELPER_H
#define INFOWINDOWHELPER_H

#include <wx/wx.h>
#include <list>
#include <algorithm>

class Stacker
{
    std::list<int> widths;

    public:

    int StackMe(int mySize)
    {
        mySize += 3;
        int pos = 0;

        if(!widths.empty())
            pos = *(std::max_element(widths.begin(), widths.end()));

        widths.push_back(pos + mySize);
        return pos + mySize;
    }

    void ReleaseMe(int myPos)
    {
        std::list<int>::iterator it = std::find(widths.begin(), widths.end(), myPos);
        if(it != widths.end())
            widths.erase(it);
    }
};


class IconBitmap : public wxControl
{
    public:
        IconBitmap( wxWindow* parent, wxWindowID id, const wxPoint& position, const wxSize& size, wxString iconname );
        void SetColors( wxColor titleColor, wxColor textBColor ) { m_tc = titleColor; m_bc = textBColor; }

    private:
        wxString    m_name;
        wxColor     m_tc;
        wxColor     m_bc;

        void    OnPaint( wxPaintEvent& event );

        DECLARE_EVENT_TABLE()
};

class OwnStaticText : public wxStaticText
{
    public:
        OwnStaticText( wxWindow* parent, wxWindowID id, const wxString& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0 )
            : wxStaticText(parent, id, label, pos, size, style) { }

    private:
        void OnEvent( wxMouseEvent& e ){ e.ResumePropagation(10); e.Skip();}

        DECLARE_EVENT_TABLE()
};

#endif // INFOWINDOWHELPER_H
