#ifndef SYMBOLCHOOSERPANEL_H
#define SYMBOLCHOOSERPANEL_H

#include <wx/wx.h>

#include "../common/types/Int2StringHash.h"
#include "wxPanelWithCtrlExBase.h"

class GaugeDescManager;

class SymbolChooserPanel: public wxPanelWithCtrlExBase
{
    DECLARE_DYNAMIC_CLASS(SymbolChooserPanel);

    public:
        SymbolChooserPanel() {}
        SymbolChooserPanel(wxWindow* parent, GaugeDescManager* mgr);
        virtual ~SymbolChooserPanel();

        virtual void SetSymbolName(const wxString& name, bool isDropEvt = true);

        wxString GetSymbolName() { return m_currentName; };

        virtual void SetValue(const wxVariant& value);
        virtual wxVariant GetValue();

        void SetUpdateSizeTarget(wxWindow* win) { m_updateSizeTarget = win; }

    protected:

        void UpdateSize(bool isSend = false);

        void OnButton(wxCommandEvent& evt);
        void OnSize(wxSizeEvent& evt);

        void OnPopupMenuSelectSymbol(wxCommandEvent& evt);


        enum {
            idSelectButton
        };

        GaugeDescManager*   m_mgr;

        wxStaticText*       m_label;

        wxMenu*             m_selectMenu;

        Int2StringHash      m_menuId2symbolname;

        wxString            m_currentName;

        wxWindow*           m_updateSizeTarget;

        DECLARE_EVENT_TABLE();

};

#endif // SYMBOLCHOOSERPANEL_H
