#ifndef WXEVENTCATCHER_H
#define WXEVENTCATCHER_H


template <class T>
class wxEventCatcher: public wxEvtHandler
{
    public:
        wxEventCatcher(wxEvtHandler* evtParent, T* handler){
            if(evtParent) {
                evtParent->Connect( wxEVT_LEFT_DOWN, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_LEFT_UP, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_MIDDLE_DOWN, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_MIDDLE_UP, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_RIGHT_DOWN, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_RIGHT_UP, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_MOTION, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_ENTER_WINDOW, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_LEAVE_WINDOW, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_LEFT_DCLICK, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_MIDDLE_DCLICK, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_RIGHT_DCLICK, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_CHILD_FOCUS, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );
                evtParent->Connect( wxEVT_MOUSEWHEEL, wxMouseEventHandler(wxEventCatcher::OnMouse), NULL, this );

                evtParent->Connect( wxEVT_KEY_DOWN, wxKeyEventHandler(wxEventCatcher::OnKey), NULL, this );
                evtParent->Connect( wxEVT_KEY_UP, wxKeyEventHandler(wxEventCatcher::OnKey), NULL, this );
                evtParent->Connect( wxEVT_CHAR, wxKeyEventHandler(wxEventCatcher::OnKey), NULL, this );
            }
            m_handler = handler;
        }

    private:

        void OnKey(wxKeyEvent& evt){
            m_handler->OnEvent(evt);
        };

        void OnMouse(wxMouseEvent& evt){
            m_handler->OnEvent(evt);
        };

        T*  m_handler;

};

#endif // WXEVENTCATCHER_H
