#ifndef NODE_H
#define NODE_H

#include <wx/string.h>

#define PORDER_UNKNOWN -1
#define NOW_READY -2
#include "GraphNodeSet.h"

class GraphNode
{
    public:
        GraphNode();
        virtual ~GraphNode();

        void insertNode(GraphNode* ptr);
        bool hasDepending();
        void setPorder(int porder);
        bool isAlledgeKnown(int porder_now);
        int  getPorder();
        GraphNodeSet getDependNodeSet();
        void setName( const wxString& name ) { m_name = name; }
        wxString    getName() const { return m_name; }
    protected:
        wxString        m_name;
    private:
        int             m_porder;   // partial order, 0 is lowest (no edge into). PORDER_UNKNOWN means yet unknown
        GraphNodeSet    m_nodeSet;  // hash of edges
};


WX_DEFINE_ARRAY(GraphNode *,NodeArray);
#endif // NODE_H
