#ifndef DIRHELPER_H
#define DIRHELPER_H

#include <wx/string.h>
#include <wx/hashmap.h>

enum DirHelperTypes
{
    dCACHE,
    dLOG,
    dGRAPHICS,
    dCONFIG,
    dICON,
    dPROJECTS,
    dPROGRAMROOT,
    dWEBCACHE,
    dCONFIGLETS,
    dCONFIGFILTERS,
    dHOTKEYS,
    dDEFAULTCONFIGS,
    dWORKINGDIR,
    dDEBUGLOG,
    dHELP,
    dDEFAULTSTATEMENTS,
    dGPSMAPSCACHE,
    dGPSMAPTILESCACHE,
    dFONTS
};

WX_DECLARE_HASH_MAP(DirHelperTypes, wxString, wxIntegerHash, wxIntegerEqual, wxPathStringsHashMap);

class DirHelper
{
    public:
        DirHelper();
        virtual ~DirHelper();
        static wxString Separ();

        static void SetProgramRootDir(const wxString &dir = wxEmptyString);

        static wxString GetPath(DirHelperTypes type = dPROGRAMROOT, bool WithPathSeparatorOnEnd = true);
        static wxString CreateNewFileName(const wxString &defaultFileName, const wxString &path, bool isTimeStamp, bool isDateStamp);
        static void SetPath(DirHelperTypes tye, wxString path);
        static void setLogdirPath(long id, const wxString& name);
        static void setLogdirPath( const wxString& id, const wxString& name );

        static void CheckDir(const wxString& dirpath);

        static bool MkDir(const wxString& path, int perm = 0777);

    protected:

        static void CheckDirs();

    private:

        static wxPathStringsHashMap m_paths;

        static wxString m_OSPathSeparator;


};



#endif // DIRHELPER_H
