#include "eval.h"




Eval::Eval()
{
    curr_tok = PRINT;
    result =0.0;
    //ctor
}

Eval::~Eval()
{
    //dtor
}


double Eval::evaluate(const wxString s)
{

    is = new wxStringInputStream(s);

    while ( ! is->Eof() )
    {
        //int off =
        is->TellI();
        get_token();
        if (curr_tok == END) break;
        if (curr_tok == PRINT) continue;
        result = expr(false);
    }

    return result;
}


Eval::Token_value Eval::get_token()
{

    char ch;

    do
    {
        ch = is->GetC();
        if(is->LastRead() == 0) return curr_tok = END;
    }
    while (ch != '\n' && isspace(ch));

/*
    do
    {
        if (!is->get(ch)) return curr_tok = END;
    }
    while (ch != '\n' && isspace(ch));
*/
    switch (ch)
    {
    case ';':
    case '\n':
        return curr_tok = PRINT;
    case '*':
    case '/':
    case '+':
    case '-':
    case '(':
    case ')':
    case '=':
        return curr_tok = Token_value(ch);
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case '.':
        is->Ungetch(ch);
        number_value = getDouble();
        //*is>>number_value;  //TODO: getNumber();!!!!!
        return curr_tok = NUMBER;
    default:
        if (isalpha(ch))
        {
            is->Ungetch(ch);
            variableName = getVariable();

         /*   variableName = wxString::Format(_T("%c"), ch);

            while (input->get(ch) && isalnum(ch))
                string_value.push_back(ch);
            input->putback(ch);
           */ return curr_tok = NAME;
        }
        wxString tmp =  _T("Bad token!");
        throw SyntaxError( tmp);
        return PRINT;
    }
}

double Eval::expr(bool get)
{
    double left  = term(get);

    for (;;)
    {
        switch (curr_tok)
        {
        case PLUS:
            left += term(true);
            break;
        case MINUS:
            left -= term(true);
            break;
        default:
            return left;
        }
    }
}

double Eval::term(bool get)
{
    double left = prim(get);

    for (;;)
    {
        switch (curr_tok)
        {
        case MUL:
            left *= prim(true);
            break;
        case DIV:
            if (double d = prim(true))
            {
                left /= d;
                break;
            }
            throw ZeroDivideException();
        default:
            return left;
        }
    }
}

double Eval::prim(bool get)
{
    if (get) get_token();

    switch (curr_tok)
    {
    case NUMBER:
    {
        double v = number_value;
        get_token();
        return v;
    }
    case NAME:
    {
        double v;
        if(constTable.find(variableName) != constTable.end() ){
            v = constTable[variableName];
            if (get_token() == ASSIGN) v = expr(true);
            return v;
        }else{
            wxString tmp = _T("Symbol not found: ") +variableName +_T("\n");
            throw SyntaxError(tmp);
        }
    }
    case MINUS:
        return -prim(true);
    case FUNCTION: //found: fvName(a,2*(b+2),c)

        /*

        if(functionTable.find(functionName) != functionTable.end() ){
            *fvBase = functionName[functionName];
            while(curr_tok != RP){
                double value = expr(true);
                // At this pont curr_tok shold be COMMA or RP
                fvBase->addparam(value);
            }
            //fvBase->setValues(params);
            double v = fvBase->execute();
            return v;
        }else{
            wxString tmp = _T("Function not found: ") +functionName +_T("\n");
            throw SyntaxError(tmp);
        }
            */
        return 0;
    case LP: // (x+y*z)
    {
        double e = expr(true);
        if (curr_tok != RP){
                wxString tmp = _T("')' expected!\n");
             throw SyntaxError(tmp);
        }
        get_token();
        return e;
    }
    default:
         wxString tmp = _T("Primary symbol expected!\n");
        throw SyntaxError(tmp);
    }
}

bool Eval::isDigit(char ch)
{
    switch(ch){
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
        case '.':
          return true;
        default:
          return false;
    }
}

double Eval::getDouble()
{
    double value;
    wxString valueStr;

    char ch;

    ch = is->GetC();
    while( (is->LastRead() != 0) && isDigit(ch) ){
        valueStr += ch;
        ch = is->GetC();
    }
    if( is->LastRead() != 0 ) is->Ungetch(ch); //put back
    valueStr.ToDouble(&value);
    return value;
}

wxString Eval::getVariable()
{
    wxString name;
    char ch;

    ch = is->GetC();
    while( (is->LastRead() != 0) && isalnum(ch) ){
        name += ch;
        ch = is->GetC();
    }
    if( is->LastRead() != 0 ) is->Ungetch(ch); //put back
    return name;
}

void Eval::test()
{

    constTable[_T("pi")] = 3.14;
    constTable[_T("e")] = 2.71;
    //Eval calc;

    wxArrayString testA;
    testA.Add(_T("2+2")); //4
    testA.Add(_T("(2*(5+2))/8")); // 14/8 = 1.75
    testA.Add(_T("(2* (5 +  2 )) / 8 * (15 + pi )")); // 1.75 * (15 + 3.14)= 31.745
    testA.Add(_T("2*pi"));          //6.28
    testA.Add(_T("2*pip"));         // Symbol not found error
    testA.Add( _T("12.45/(3.14-pi)") ); // Zero division error

    //testA.Add( _T("12.45 * fv1( 2 * (1+pi) )") ); //TODO: fv1 parse
    //testA.Add( _T("12.45 * fv2( 2 * (1+pi), \"xyz\" )") ); //TODO: fv2 parse, 2 param


 /*       for(uint16_t i = 0; i < testA.Count(); i++){
            try{
                double  result = evaluate(testA[i]);
                cout<<"Test "<<i<<" Result = "<<result<<'\n';

            }catch(ZeroDivideException){
                cout<<"Test "<<i<<" Zero division";
            }catch(SyntaxError e){
                cout<<"Test "<<i<<" Syntax error: " << e.get();
            }
        }*/

}
