#ifndef ECUEVENT_H
#define ECUEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_ECU;    /// without this MinGW gives undifened referenced linker error

#define EVT_ECU(id, func) \
    wx__DECLARE_EVT1(wxEVT_ECU, id, ECUEventHandler(func))

class ECUEvent : public wxEvent
{
    public:
        enum State { NOT_CONNECTED = 0, CONNECTED = 1, BOOT_MODE, AIM_MODE };
        ECUEvent(int id = 0);
        virtual wxEvent *Clone() const { return new ECUEvent(*this); }
        State state;
        wxString getStateAsString();
        DECLARE_DYNAMIC_CLASS(ECUEvent)
};

typedef void (wxEvtHandler::*ECUEventFunction)(ECUEvent&);

#define ECUEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(ECUEventFunction, &func)


#endif // ECUEVENT_H
