#ifndef FIRMWAREUPLOADEVENT_H
#define FIRMWAREUPLOADEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_FIRMWARE_UPLOAD;    /// without this MinGW gives undifened referenced linker error

#define EVT_FIRMWARE_UPLOAD(id, func) \
    wx__DECLARE_EVT1(wxEVT_FIRMWARE_UPLOAD, id, FirmwareUploadEventHandler(func))

class FirmwareUploadEvent : public wxEvent
{
    public:
        enum {  ERASING_PAGES_STARTED,
                ERASING_PAGES,
                ERASING_PAGES_SUCCEEDED,
                ERASING_PAGES_FAILED,
                UPLOADING_PAGES_STARTED,
                PAGE_UPLOADED,
                UPLOADING_PAGES_SUCCEEDED,
                UPLOADING_PAGES_FAILED };

    public:
        FirmwareUploadEvent( int id = 0 ) : wxEvent( id, wxEVT_FIRMWARE_UPLOAD ) {}
        virtual wxEvent *Clone() const { return new FirmwareUploadEvent(*this); }
        DECLARE_DYNAMIC_CLASS(FirmwareUploadEvent)

        void setFirmwarePageCount( size_t pageCount ) { m_firmwarePageCount = pageCount; }
        void setFirmwarePageIdx( size_t pageIdx ) { m_firmwarePageIdx = pageIdx; }

        size_t getFirmwarePageCount() const { return m_firmwarePageCount; }
        size_t getFirmwarePageIdx() const { return m_firmwarePageIdx; }

    private:
        size_t m_firmwarePageCount;
        size_t m_firmwarePageIdx;
};

typedef void (wxEvtHandler::*FirmwareUploadEventFunction)(FirmwareUploadEvent&);

#define FirmwareUploadEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(FirmwareUploadEventFunction, &func)

#endif // FIRMWAREUPLOADEVENT_H
