#ifndef FIRMWAREVERIFYEVENT_H
#define FIRMWAREVERIFYEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_FIRMWARE_VERIFY;    /// without this MinGW gives undifened referenced linker error

#define EVT_FIRMWARE_VERIFY(id, func) \
    wx__DECLARE_EVT1(wxEVT_FIMRWARE_VERIFY, id, FirmwareVerifyEventHandler(func))

class FirmwareVerifyEvent : public wxEvent
{
    public:
        enum { PAGE_VERIFIED, PAGE_VERIFIED_AND_PATCHED, FAILED, SUCCEEDED };

    public:
        FirmwareVerifyEvent( int id = 0 ) : wxEvent( id, wxEVT_FIRMWARE_VERIFY ) { m_patchFilename = _T(""); }
        virtual wxEvent *Clone() const { return new FirmwareVerifyEvent(*this); }
        DECLARE_DYNAMIC_CLASS(FirmwareVerifyEvent)

        void setFirmwarePageCount( size_t pageCount ) { m_firmwarePageCount = pageCount; }
        void setFirmwarePageIdx( size_t pageIdx ) { m_firmwarePageIdx = pageIdx; }
        void setPatchFileName( const wxString& fname ) { m_patchFilename = fname; }

        size_t      getFirmwarePageCount() const { return m_firmwarePageCount; }
        size_t      getFirmwarePageIdx() const { return m_firmwarePageIdx; }
        wxString    getPatchFileName() const { return m_patchFilename; }

    private:
        size_t          m_firmwarePageCount;
        size_t          m_firmwarePageIdx;
        wxString        m_patchFilename;

};

typedef void (wxEvtHandler::*FimwareVerifyEventFunction)(FirmwareVerifyEvent&);

#define FirmwareVerifyEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(FimwareVerifyEventFunction, &func)


#endif // FIRMWAREVERIFYEVENT_H
