#ifndef GPSCOMMEVENT_H
#define GPSCOMMEVENT_H

#include <wx/event.h>

#include "../GPSInfo.h"

extern const wxEventType wxEVT_GPS_COMM;    /// without this MinGW gives undifened referenced linker error

#define EVT_GPS_COMM(id, func) \
    wx__DECLARE_EVT1(wxEVT_GPS_COMM, id, GPSCommEventHandler(func))

class GPSCommEvent : public wxEvent
{
    public:
        GPSCommEvent(int id = 0);
        virtual wxEvent *Clone() const { return new GPSCommEvent(*this); }
        GPSInfo::CommState state;
    public:
        DECLARE_DYNAMIC_CLASS(GPSCommEvent)
};

typedef void (wxEvtHandler::*GPSCommEventFunction)(GPSCommEvent&);

#define GPSCommEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(GPSCommEventFunction, &func)

#endif // GPSCOMMEVENT_H
