#ifndef UPDATEVIEWEREVENT_H
#define UPDATEVIEWEREVENT_H

#include <wx/wx.h>
#include "../common/types/wxVariantHash.h"

extern const wxEventType EVT_UPDATE_VIEWER;    /// without this MinGW gives undifened referenced linker error

#define EVT_UPDATE_VIEWER_EVENT(id, func) \
    wx__DECLARE_EVT1(EVT_UPDATE_VIEWER, id, UpdateViewerEventHandler(func))

class UpdateViewerEvent : public wxEvent
{
    public:
        UpdateViewerEvent( int id = 0);
        virtual wxEvent *Clone() const { return new UpdateViewerEvent(*this); }

        DECLARE_DYNAMIC_CLASS(UpdateViewerEvent)

        wxVariantHash   m_userData;
    protected:
    private:
};

typedef void (wxEvtHandler::*UpdateViewerEventFunction)(UpdateViewerEvent&);

#define UpdateViewerEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(UpdateViewerEventFunction, &func)



#endif // UPDATEVIEWEREVENT_H
