#ifndef EXPRESSIONFVLT_H
#define EXPRESSIONFVLT_H

#include "ExpressionBase.h"

class ExpressionFvLT : public ExpressionBase
{
    public:
        ExpressionFvLT()
        {
            setPrec( 110 );
            setAssoc( ASSOC_RIGHT );
            setType( OPERATOR );
        }
        virtual ~ExpressionFvLT();

        void interpret( RPNStack& rpnStack )
        {
            RPNStackItem* b = rpnStack.pop();
            RPNStackItem* a = rpnStack.pop();

            if( a->getType() == RPNStackItem::NUMBER && b->getType() == RPNStackItem::NUMBER )
            {
                int result = a->getNumber() > b->getNumber();

                RPNStackItem* item = new RPNStackItem();
                item->setNumber( (double) result );
                rpnStack.push( item );
            }
            delete a;
            delete b;

        }
        wxString toString() { return _T(">"); }
    protected:
    private:
};



#endif // EXPRESSIONFVLT_H
