#ifndef EXPRESSIONFVNEGATE_H
#define EXPRESSIONFVNEGATE_H

#include "ExpressionBase.h"

#include "../logger.h"

class ExpressionFvNegate : public ExpressionBase
{
    public:
        ExpressionFvNegate()
        {
            setPrec( 160 );
            setAssoc( ASSOC_RIGHT );
            setType( OPERATOR );
        }
        virtual ~ExpressionFvNegate();

        void interpret( RPNStack& rpnStack )
        {
            RPNStackItem * a = rpnStack.pop();
            if(a->getType() == RPNStackItem::NUMBER )
            {
                int number = (int) a->getNumber();

                number = ~number;

                RPNStackItem* item = new RPNStackItem();
                item->setNumber( (double) number );
                rpnStack.push( item );
            }else{
                    // throw
            }
            delete a;
        }
        wxString toString() { return _T("~"); }
    protected:
    private:
};



#endif // EXPRESSIONFVNEGATE_H
