#ifndef EXPRESSIONFVOR_H
#define EXPRESSIONFVOR_H

#include "ExpressionBase.h"

class ExpressionFvOr : public ExpressionBase
{
    public:
        ExpressionFvOr()
        {
            setPrec( 70 );
            setAssoc( ASSOC_LEFT );
            setType( OPERATOR );
        }
        virtual ~ExpressionFvOr();

        void interpret( RPNStack& rpnStack )
        {
            RPNStackItem* a = rpnStack.pop();
            RPNStackItem* b = rpnStack.pop();
            if(a->getType() == RPNStackItem::NUMBER && b->getType() == RPNStackItem::NUMBER)
            {
                int number1 = (int) a->getNumber();
                int number2 = (int) b->getNumber();
                number2 = number1 | number2 ;
                RPNStackItem* item = new RPNStackItem();
                item->setNumber( (double) number2 );
                rpnStack.push( item );
            }
            delete a;
            delete b;
        }
        wxString toString() { return _T("|"); }
    protected:
    private:
};



#endif // EXPRESSIONFVOR_H
