#include "ExpressionVariable.h"
#include "VariableData.h"
#include "../logger.h"

ExpressionVariable::ExpressionVariable(const wxString& name, VariableData* data )
{
    m_name = name;
    m_data = data;
    setType( VARIABLE );
}

ExpressionVariable::~ExpressionVariable()
{

}

void ExpressionVariable::interpret( RPNStack& rpnStack )
{
    double number = 0.0;

    if( !m_data->getValue( m_name, &number ) )
    {
        throw ExpError::VariableException( _T("variable not found : ") + m_name );
    }

    RPNStackItem* item = new RPNStackItem();
    item->setNumber( number );
    rpnStack.push( item );
}

wxString ExpressionVariable::toString()
{
    return m_name;
}
