#include "InfixTester.h"

#include "InfixTokenizer.h"
#include "../logger.h"
#include "InfixToken.h"
#include "InfixOperator.h"

#include "ExpressionBase.h"
//#include "ShuntingYard.h"
#include "RPNParser.h"

InfixTester::InfixTester()
{
    //ctor
}

InfixTester::~InfixTester()
{
    //dtor
}

void InfixTester::test()
{
    Logger::logf(LOG_WARNING, _T("InfixTokenizer test(): START") );

    wxArrayString exprTestA;

    //exprTestA.Add( _T("3 + 2 * 4") );
    //exprTestA.Add( _T("3 * 2  + 4") );
    //exprTestA.Add( _T("3 * 2 * 4 + 5") );
    //exprTestA.Add( _T("3 + 2 + 4 * 5") );
    //exprTestA.Add( _T("(3 + 2) * 4") );
    //exprTestA.Add( _T("( 3.1 - 2 * -5.2 ) * ( 4 + alma )") );
    exprTestA.Add( _T("( 3.1 - 2 * -5.2 ) * ( 4 + 5 )") );

    for( uint32_t i = 0; i < exprTestA.GetCount(); i++ )
    {
        InfixTokenizer  ifTokenizer;
        InfixTokenA     ifTokenA;

        //wxString to InfixTokenA
        //ifTokenizer.parse( exprTestA[i], ifTokenA );

        ExpressionA    exprA;
      //  ShuntingYard    sy;

        //InfixTokenA to ExpressionA
        //sy.toRpn( ifTokenA, exprA );

        //evaluate rpn
        RPNParser rpn;

        DoubleHash varH;

        varH[_T("alma")] = 12;
        varH[_T("barack")] = 16;

        rpn.setVariableHash( &varH );

        rpn.parseShuntingYard( exprTestA[i] );
        double result = rpn.evaluate();

        //printing result
        Logger::logf( LOG_WARNING, _T("<-- ") );
        Logger::logf( LOG_WARNING, _T("Input String : ") + exprTestA.Item(i) );

        //tokens
        wxString tokenStr = wxEmptyString;

        for(uint32_t j = 0; j < ifTokenA.GetCount(); j++)
        {
            tokenStr += ifTokenA.Item( j )->getValue() + _T(" ");
        }

        Logger::logf( LOG_WARNING, _T("Infix tokens: ") + tokenStr );

        //tokens for rpn
        wxString exprStr = wxEmptyString;

        for(uint32_t j = 0; j < exprA.GetCount(); j++ )
        {
            ExpressionBase* eb = exprA.Item(j);
//            exprStr += eb->toString() + _T(" ");
            //wxString msg = eb->toString();
            //Logger::logf( LOG_WARNING, _T("InfixTester::test %i ") +msg, j );
        }

        Logger::logf( LOG_WARNING, _T("RPN input : ") + exprStr );

        Logger::logf( LOG_WARNING, _T("Result : %f "), result );
    }

    Logger::logf(LOG_WARNING, _T("InfixTokenizer test(): END") );
}

