#ifndef INFIXTOKEN_H
#define INFIXTOKEN_H

#include <wx/dynarray.h>
#include <wx/string.h>

#include "../common/typedef.h"

class InfixToken
{
    public:
        enum TokenType { NUMBER = 0, OPERATOR, STRING, VARIABLE, FUNCTION, UNKNOWN };

        InfixToken();
        virtual ~InfixToken();

        void setType( TokenType type_in ) { m_type = type_in; }
        void setNumber( double number_in ) { m_number = number_in; }
        void setValue( const wxString& value_in ) { m_value = value_in; }
        void setPrec( uint32_t prec_in ) { m_prec = prec_in; };

        TokenType       getType() { return m_type; }
        double          getNumber() { return m_number; }
        wxString        getValue() { return m_value; }
        uint32_t        getPrec() { return m_prec; };
    protected:
    private:
        TokenType       m_type;
        double          m_number;
        wxString        m_value;
        uint32_t        m_prec;
};

//WX_DEFINE_ARRAY( InfixToken*, InfixTokenA );

#endif // INFIXTOKEN_H
