#include "VariableData.h"
#include "../common/types/DoubleHash.h"
#include "../logger.h"


VariableData::VariableData()
{
    //ctor
}

VariableData::~VariableData()
{
    //dtor
}


VariableDataDH::VariableDataDH()
{
    m_variables = new DoubleHash();
    m_isInternal = true;
}


VariableDataDH::VariableDataDH( DoubleHash* dh )
{
    m_variables = dh;
    m_isInternal = false;
}

VariableDataDH::~VariableDataDH()
{
    //dtor
    if(m_isInternal){
        delete m_variables;
    }
}


void VariableDataDH::addValue( const wxString& name, double value )
{
    (*m_variables)[name] =value;
}

bool VariableDataDH::getValue( const wxString& name, double* value, IntSet* dirty )
{
    if( m_variables->find( name ) != m_variables->end() )
    {
        *value = (*m_variables)[ name ];
        return true;
    }

    return false;
}

DoubleHash* VariableDataDH::getDoubleHash()
{
    return m_variables;
}

size_t VariableDataDH::size()
{
    return m_variables->size();
}

bool VariableDataDH::getValue( const wxString& name, VemsMatrix<double>& data )
{
    Logger::logf( LOG_MSG, _T("VariableDataDH::getValue() - ") + name );
    return false;
}
