#ifndef CONFIGPARSERMSQ_H
#define CONFIGPARSERMSQ_H

#include "parserbase.h"

class FirmwareConfigData;

class ConfigParserMSQ : public ParserBase
{
    public:
        ConfigParserMSQ(FirmwareConfigData* fcData, bool isHighBoost );
        virtual ~ConfigParserMSQ();
        void     parseLine();

    protected:
    private:
        FirmwareConfigData* m_ptrFcData;
        bool m_isHighBoost;
        enum state {
            FIND_TABLE,
            TABLE_DATA,
            X_AXIS_DATA,
            Y_AXIS_DATA,
            END
        };

        int m_tableState;
        bool m_inConstant;
        int m_tableRowIdx;
        wxArrayString m_tmpAxisToken;

        bool isEndOfConstant();
        bool isStartOfConstant();
        void parseTableData();
        void parseAxis(const wxString& axisName);
        wxString getTableName();
        wxString convertX(const wxString& str);
        wxString convertY(const wxString& str);

};

#endif // CONFIGPARSERMSQ_H
