        #ifndef FIRMWARECONFIGPARSER_H
#define FIRMWARECONFIGPARSER_H

#include "parserbase.h"

class FirmwareConfigData;


/** \class FirmwareConfigParser
 *  \~english
 *  \brief Parse firmware config files ( config.txt, tables.txt, ... )
 */
class FirmwareConfigParser : public ParserBase
{
    public:
                            FirmwareConfigParser( FirmwareConfigData* fcData );
        virtual             ~FirmwareConfigParser() {}

        /*virtual*/void     parseLine();
        void                parseFiles( const wxArrayString& files );
        void                parseHeaderOnly( const wxString& fileName );
    private:
        FirmwareConfigData* m_ptrFcData;

        void            parseHeader();
        void            parseConfigLine( const wxString& key, const wxString& value );
        void            parseTableLine();
        wxString        getSymbolName( const wxString& key );
};

#endif // FIRMWARECONFIGPARSER_H
