#include "MyMakeParser.h"

#include <wx/regex.h>
#include "../logger.h"

void MyMakeParser::parseLine()
{
    // comment
    if ( m_line.StartsWith(_T("#") ) )
        return;

    wxRegEx re( _T("^\\s*MY_CONF\\s*\\+=\\s*\\-D\\s([A-Za-z0-9_=]*)"), wxRE_ADVANCED );

    if ( re.Matches( m_line ) )
    {
        wxString define = re.GetMatch( m_line, 1 );

        if ( define.Find( _T("=") ) != wxNOT_FOUND )
        {
            wxString defineName = define.BeforeFirst( '=' );
            wxString defValue = define.AfterFirst( '=' );
            long val = -1;

            defValue.ToLong( &val );

            m_defines[defineName] = val;
        }
        else
        {
            m_defines[define] = -1;
        }
    }
}
