#ifndef TOKENIZER_H
#define TOKENIZER_H

#include <wx/string.h>
#include <wx/dynarray.h>

#include "../common/typedef.h"

enum type { T_DIR, T_ID, T_NUM, T_STR, T_BLK, T_EXP, T_COL, T_GARBAGE };

class Token
{
    public:
        wxString    str;
        type        typ;
        double      num;

        Token(wxString s, type t, double d=0.0);
        ~Token();
};

WX_DEFINE_ARRAY( Token*, TokenArray );
//WX_DECLARE_OBJARRAY(Token, TokenArray);


class Tokenizer
{
    public:
        Tokenizer();
        Tokenizer( const Tokenizer& tokenizer );
        virtual ~Tokenizer();

        size_t      tokenize(const wxString& s);
        wxString    operator[](size_t i) const { return i<getSize()?m_tokens[i]->str:_T(""); }
        type         getType(size_t i) const { return i<getSize() ? m_tokens[i]->typ : T_GARBAGE; }
        double      getDouble(size_t i) const { return i<getSize() ? m_tokens[i]->num : 0.0; }
        int         getInt(size_t i) const { return (int)(i<getSize() ? m_tokens[i]->num : 0); }
        size_t    getSize() const { return m_tokens.GetCount(); }
    protected:
    private:
        TokenArray m_tokens;
};

WX_DEFINE_ARRAY( Tokenizer*, TokenizerPtrArray );

#endif // TOKENIZER_H
