
#ifndef PARSERBASE_H
#define PARSERBASE_H

#include <wx/string.h>
#include <wx/textfile.h>

#include "../Observable.h"
#include "../Interruptable.h"

class ParserBase: public Observable, public Interruptable
{
    public:
        ParserBase();
        virtual ~ParserBase();
        /* sequencial parse  (non batch mode) */
        bool parseNextLine();
        /* parse at once (batch) or line by line (non batch)*/
        int parse(const wxString& strFile, bool batch = true);
        int parseDir(const wxString& dirname, const wxString& filespec);

        void parseOneLine(const wxString& line);
        virtual void parseLine() =0;
        void Abort() { m_aborted = true; }

    protected:
        int m_lineNumber;
        int m_totalLineNumber;
        wxString m_line;
        wxArrayString * m_files;

        int openFile(const wxString& strFile);
        int closeFile();

        wxString m_fileName;

    private:
        wxTextFile m_file;
        bool m_batch;
        bool m_firstline;
};



#endif // PARSERBASE_H
