#include "triggertestpanel.h"

//(*InternalHeaders(TriggerTest)
#include <wx/bitmap.h>
#include <wx/font.h>
#include <wx/fontenum.h>
#include <wx/fontmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>
//*)
#include "../logger.h"

//#include "trigger.h"

const int  ID_OK     = 1234;
//const long TriggerTest::ID_OK = wxNewId();

BEGIN_EVENT_TABLE(TriggerTestPanel,wxPanel)
	//(*EventTable(TriggerTest)
	//*)
	EVT_BUTTON    (ID_OK,        TriggerTestPanel::OnComboButtons)
END_EVENT_TABLE()

TriggerTestPanel::TriggerTestPanel(wxWindow* parent,wxWindowID id)
{
    Logger::log(LOG_MSG, _T("TriggerTestPanel::TriggerTestPanel 1"));
	//(*Initialize(TriggerTestPanel)
	Create(parent,id,wxDefaultPosition,wxDefaultSize,wxTAB_TRAVERSAL,_T("id"));

	topBoxStatic = new wxStaticBoxSizer(wxVERTICAL,this,_("Parameters"));
	configBox = new wxBoxSizer(wxHORIZONTAL);
	configBoxStatic = new wxStaticBoxSizer(wxVERTICAL,this,_("Config"));
	engineBoxStatic = new wxStaticBoxSizer(wxVERTICAL,this,_("Engine"));
    //wxStaticBoxSizer * StaticBoxSizer3 = new wxStaticBoxSizer(wxVERTICAL,this,_("Engine Config"));

    FlexGridSizer1 = new wxFlexGridSizer(0,4,0,0);
    FlexGridSizer2 = new wxFlexGridSizer(0,4,0,0);
    Logger::log(LOG_MSG, _T("TriggerTestPanel::TriggerTestPanel 2"));
    configBoxStatic->Add(FlexGridSizer1,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);
    engineBoxStatic->Add(FlexGridSizer2,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);

	configBox->Add(configBoxStatic,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);
	configBox->Add(engineBoxStatic,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);

	topBoxStatic->Add(configBox,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);

	//StaticBoxSizer1->Add(StaticBoxSizer3,1,wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);
	SetSizer(topBoxStatic);


	//*)
	//const long  ID_OK = wxNewId();
    m_button = new wxButton( this, ID_OK, _T("&Ok"), wxDefaultPosition,wxDefaultSize );
    configBox->Add(m_button);

	m_text = new wxTextCtrl(this, wxID_ANY, _T("This is the log window.\n"),
                            wxPoint(0, 250), wxSize(100, 50), wxTE_MULTILINE);
      Logger::log(LOG_MSG, _T("TriggerTestPanel::TriggerTestPanel 3"));
    m_logTargetOld = wxLog::SetActiveTarget(new wxLogTextCtrl(m_text));

    topBoxStatic->Add(m_text, wxSizerFlags(1).Border().Expand());
      Logger::log(LOG_MSG, _T("TriggerTestPanel::TriggerTestPanel 4"));
    topBoxStatic->Fit(this);
	topBoxStatic->SetSizeHints(this);

    currGrid = FlexGridSizer1;

    initTiggerMap();
}


void TriggerTestPanel::selectBox(const wxString& name)
{
    if(name == _T("Config"))
    {
        currGrid = FlexGridSizer1;
    }else{
        currGrid = FlexGridSizer2;
    }
}

void TriggerTestPanel::addMappingCab(TriggerMap &tmap, wxString &key, wxString &label, double a, double b, double c )
{
        tmap.mapHash[key] = label;
        tmap.doubleAHash[key] = a;
        tmap.doubleBHash[key] = b;
        tmap.doubleCHash[key] = c;
}
void TriggerTestPanel::initTiggerMap()
{
        TriggerMap tmap = TriggerMap();

        wxString key =  _T("adv: ");
        wxString value = _T("crankdeg: ");
        addMappingCab(tmap, key,  value, 4.0, 256.0, 0.0 );

        key =_T("RPM: ");
        value = _T("rpm_period: ");
        addMappingCab(tmap, key, value, 1.0, 0.0, 7500000.0 );  // c=30000000/4 cyl

        setTiggerMap(tmap);
}

void TriggerTestPanel::setTiggerMap(const TriggerMap& tmap)
{
     this->tmap = tmap;
}

void TriggerTestPanel::addLine(const wxString& label, const wxString& defValue,  const wxArrayString& choices )
{

    const long ID1 = wxNewId();
    const long ID2 = wxNewId();
    //comboIdArray.Add(ID1);
    comboIdArray.Add(ID2);
    wxString l = label + wxString::Format(_T(" (%d)"), comboIdArray.Count()-1 );
    wxStaticText * StaticText = new wxStaticText(this,ID1,l,wxDefaultPosition,wxDefaultSize,0,_T("") );
	currGrid->Add(StaticText,1,wxALL|wxALIGN_LEFT,1);
	wxComboBox * ComboBox = new wxComboBox(this,ID2,defValue,wxDefaultPosition,wxDefaultSize,choices,0,wxDefaultValidator,_T(""));
	currGrid->Add(ComboBox,1,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);

    wxString mapNameLabel = tmap.mapHash[label];
    if( ! mapNameLabel.IsEmpty() ){
        const long ID3 = wxNewId();
        const long ID4 = wxNewId();
        Logger::log(LOG_MSG, _T("TriggerTestPanel::addLine() mapNameLabel: ")+ mapNameLabel);
        //wxString mapNameLabel =_T("");
        wxString mapValueLabel = _T("");

        wxStaticText * mapName = new wxStaticText(this,ID3,mapNameLabel,wxDefaultPosition,wxDefaultSize,0,_T("") );
        currGrid->Add(mapName,1,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);

        wxStaticText * nameValue = new wxStaticText(this,ID4,mapValueLabel,wxDefaultPosition,wxDefaultSize,0,_T("") );
        currGrid->Add(nameValue,1,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,1);
        comboWindowID2TextID[ID2] = ID4;
        comboWindowID2Label[ID2] = label;
    }else{
        currGrid->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
        currGrid->Add(0,0,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);
    }

	topBoxStatic->Fit(this);
	topBoxStatic->SetSizeHints(this);

}

double TriggerTestPanel::calcMapValue(const wxString& label, double x)
{

    //wxString mapNameLabel = tmap.mapHash[label];
    //if( ! mapNameLabel.IsEmpty() ){

    double a;
    double b;
    double c;
    double value;


    if( tmap.doubleAHash.find(label) != tmap.doubleAHash.end() ){ a = tmap.doubleAHash[label]; }
    else{a = 1;}
    if( tmap.doubleBHash.find(label) != tmap.doubleBHash.end() ){ b = tmap.doubleBHash[label]; }
    else{b = 0;}
    if( tmap.doubleCHash.find(label) != tmap.doubleCHash.end() ){ c = tmap.doubleCHash[label]; }
    else{c = 0;}

    Logger::log(LOG_MSG,wxString::Format(_T("TriggerTestPanel::calcMapValue A: %f B: %f C: %f"), a,b,c) );
    if(c != 0){
        value = c/(a*x+b);
    }else{
        value = a*x + b;
    }

    return value;
}

void TriggerTestPanel::setStaticMapValue(long wID, double value)
{
    long mappedWID = comboWindowID2TextID[wID];
    wxWindow * w = FindWindow(mappedWID);
    bool iswxStaticText = w->IsKindOf(CLASSINFO(wxStaticText));
    if(iswxStaticText){
        ((wxStaticText*) w)->SetLabel(wxString::Format(_T("%f"), value) );
    }
}

void TriggerTestPanel::OnComboButtons( wxCommandEvent &event )
{
//    long id_ok = ID_OK;
    FirmwareTriggerConfig config;
    Engine engine;

    switch ( event.GetId() )
    {
        case ID_OK:
            {
                    wxLogMessage(_T("OnComboButtons:") );
                    int size = comboIdArray.Count();
                    for(int i=0; i< size; i++)
                    {
                        long wID = comboIdArray.Item(i);

                        //wxLogMessage(_T("Window ID:%d"), wID);

                        wxWindow * w = FindWindow(wID);
                        //wxString windowName = w->GetName();
                        bool iswxComboBox = w->IsKindOf(CLASSINFO(wxComboBox));
                        if(iswxComboBox){
                            wxString value = ((wxComboBox*) w)->GetValue();

                            wxString label = comboWindowID2Label[wID];
                            if(!label.IsEmpty()){
                                Logger::log(LOG_MSG, _T("Label: ") + label);
                                double valueD;
                                value.ToDouble(&valueD);
                                double mappedValueD = calcMapValue(label,  valueD);
                                setStaticMapValue(wID, mappedValueD);
                                value = wxString::Format(_T("%f"), mappedValueD);
                            }

                            wxLogMessage(_T("(wid: %d) index: %d value: %s"), wID, i, value.c_str());
                            switch(i)
                            {
                                case 0:
                                    value.ToLong((long*)&config.adv);
                                    break;
                                case 1:
                                    value.ToLong((long*)&config.config11);
                                    break;
                                case 2:
                                    value.ToLong((long*)&config.ign_tdcdelay);
                                    break;
                                case 3:
                                    value.ToLong((long*)&config.trigger_tooth);
                                    break;
                                case 4:
                                    value.ToLong((long*)&config.toothw16);
                                    break;
                                case 5:
                                    value.ToLong((long*)&config.tooth_wheel);
                                    break;
                                case 6:
                                    value.ToLong((long*)&config.another_trigger_tooth);
                                    break;
                                case 7:
                                    value.ToLong((long*)&config.primary_trigger);
                                    break;
                                case 8:
                                    value.ToLong((long*)&config.secondary_trigger);
                                    break;
                                    ///////////////////////////////ENGINE
                                case 9:
                                    value.ToLong((long*)&engine.rpm_period);
                                    break;
                                case 10:
                                    value.ToLong((long*)&engine.ignum);
                                case 11:
                                    value.ToLong((long*)&engine.dwell);
                                  break;
                            }
        /*
        uint16_t adv;

        uint8_t config11;     // c11, bit7-4:ncyl-1 bit3:TBI bit2:2stroke bit0:0=mpx4115/1=mpx4250
        uint16_t ign_tdcdelay;
        uint8_t trigger_tooth;
        uint16_t toothw16;
        uint8_t tooth_wheel;          // tooth wheel, number of teeth on the wheel
        uint8_t another_trigger_tooth;
        uint8_t primary_trigger;
        uint8_t secondary_trigger;

        //////////ENGINE///////////
         uint32_t rpm_period;
    uint8_t ignum;	// http://tiki.vems.hu/tiki/tiki-index.php?page=IgnitionTiming
	uint16_t dwell;		// in 4 usec resolution. (This could be 64 usec resolution and uint8_t?)
	uint16_t trig2spark;	// time from trigger to spark [4 usec] (NOT rpm_period * trig2spark / 4096 !)
	uint16_t proposed_trig2spark; // 4 usec (not angle "factor" like earlier)
	uint8_t spark_phase;	// actually toothcnt relative to the reference tooth for given cyl
	uint8_t proposed_spark_phase;
	uint8_t dwell_phase;
	uint8_t proposed_dwell_phase;
	uint16_t trig2dwell;	// time from trigger to dwell [4 usec]
	uint16_t proposed_trig2dwell;  // 4 usec
        */
                        }

                    }
                Trigger trigger = Trigger();
                trigger.triggertooth(config.adv, config, engine);
                //wxLogMessage(_T("Result: %d value: %s"), config.);
                // TODO: print rpm_period or tooth_width
                wxLogMessage(_T("Result: engine.proposed_spark_phase: %d"), engine.proposed_spark_phase );
                wxLogMessage(_T("Result: engine.proposed_trig2spark: %d"), engine.proposed_trig2spark );
                wxLogMessage(_T("Result: engine.dwell: %d"), engine.dwell );
                wxLogMessage(_T("Result: engine.proposed_dwell_phase: %d"), engine.proposed_dwell_phase );
                wxLogMessage(_T("Result: engine.proposed_trig2dwell: %d"), engine.proposed_trig2dwell );
                break;
            }

    }
}

TriggerTestPanel::~TriggerTestPanel()
{

    int size = comboIdArray.Count();
    for(int i=0; i< size; i++)
    {
        long wID = comboIdArray.Item(i);
        wxLogMessage(_T("Delete Window ID:%d"), wID);

        wxWindow * w = FindWindow(wID);
        delete w;
    }

//    delete topBoxStatic;
//    delete FlexGridSizer1;
//    delete m_text;
//    delete m_logTargetOld;
}

