#ifndef TRIGGERTESTPANEL_H
#define TRIGGERTESTPANEL_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

//(*Headers(TriggerTestPanel)
#include <wx/button.h>
#include <wx/combobox.h>
#include <wx/panel.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
//*)

#include "../common/types/IntArray.h"
#include "../common/types/Long2LongHash.h"
#include "../common/types/Long2StringHash.h"
#include "trigger.h"

#include <wx/wx.h>

class TriggerTestPanel: public wxPanel
{
	public:

		TriggerTestPanel(wxWindow* parent,wxWindowID id = -1);
		virtual ~TriggerTestPanel();

        void addLine(const wxString& label, const wxString& defValue, const wxArrayString& choices);
        void selectBox(const wxString& name);
        void setTiggerMap(const TriggerMap& tmap);
	protected:
        void addMappingCab(TriggerMap &tmap, wxString &key, wxString &label, double a, double b, double c );

		//(*Handlers(TriggerTestPanel)
		//*)

		//(*Declarations(TriggerTestPanel)
		wxStaticBoxSizer* topBoxStatic;
		wxBoxSizer* configBox;
		wxStaticBoxSizer * configBoxStatic;
		wxStaticBoxSizer * engineBoxStatic;
		wxFlexGridSizer* FlexGridSizer1;
		wxFlexGridSizer* FlexGridSizer2;
		wxFlexGridSizer* currGrid;
         wxButton* m_button;
		//*)
        wxTextCtrl    *m_text;
        wxLog *m_logTargetOld;
        //static const long ID_OK;
        void initTiggerMap();
        void OnComboButtons( wxCommandEvent &event );
        double calcMapValue(const wxString& label, double x);
        void setStaticMapValue(long wID, double value);
        IntArray comboIdArray;
        TriggerMap tmap;

        Long2LongHash comboWindowID2TextID;
        Long2StringHash comboWindowID2Label;

	private:

		DECLARE_EVENT_TABLE()
};

#endif
