#include "ConfigCriteria.h"

ConfigCriteria::ConfigCriteria( const wxString& name, const wxString& errorMsg, const wxString& warningMsg,
ConfigCriteriaType type, wxArrayString vars )
{
    m_rangeTypeFound = CCR_TYPE_INVALID;
    m_name      = name;
    m_errorMsg = errorMsg;
    m_warningMsg = warningMsg;
    m_type = type;
    m_ruleIdx = -1;
    m_vars = vars;
}

wxString ConfigCriteria::getErrorMsg() const
{
    if(m_ruleIdx == -1){
         return m_errorMsg;
    }
    ConfigCriteriaRange* range = m_rangeArray.Item(m_ruleIdx);
    wxString msg = range->getMsg();
    if(msg == wxEmptyString){
        return m_errorMsg;
    }
    return m_errorMsg + msg;
}

void ConfigCriteria::setHtmlErrorMsg(const wxString msg)
{
    m_htmlErrorMsg = msg;
}

wxString ConfigCriteria::getHtmlErrorMsg() const
{
    return m_htmlErrorMsg;
}
