#ifndef CONFIGSAVER_H
#define CONFIGSAVER_H

#include <wx/wfstream.h>
#include <wx/progdlg.h>

#include "../common/typedef.h"
#include "../vemsprotocol/CommunicationClientBase.h"


class SIPRPacket;


class ConfigSaver : public CommunicationClientBase
{
    public:
        ConfigSaver( CommunicationController* controller, CommunicationDispatcher* dispatcher );
        virtual             ~ConfigSaver();

        bool                init( const wxString& file, const wxString& header, bool showProgress );
        void                close();

        // CommunicationClientBase virtual
        void                process();
        void                OnSIPR( InputEvent& event );

        void SetEventHandler(wxEvtHandler* handler) { m_handler = handler; };

    private:
        wxFileOutputStream* m_pOutputStream;
        wxProgressDialog*   m_pProgressDialog;
        wxFile*             m_pFile;
        wxString            m_strFileName;
        wxString            m_strHeader;
        bool                m_bShowProgress;
        int                 m_iLineCount;

    private:
        void                write( uint8_t* data, uint8_t size );

        wxEvtHandler*       m_handler;
};

#endif // CONFIGSAVER_H
