#ifndef FIRMWARECONFIGITEM_H
#define FIRMWARECONFIGITEM_H


#include <wx/wx.h>

class FirmwareConfigItem
{
    public:
        enum FirmwareConfigItemStatus {

            FWIS_NEW = 0,
            FWIS_VIRGIN = 1,
            FWIS_REMOVED = 2,
            FWIS_MODIFIED = 3

        };

        FirmwareConfigItem();
        virtual ~FirmwareConfigItem();

        wxString getPath();
        wxString getAbsolutePath();
        wxString getListDir();
        bool IsRelative();
        wxString getRelativeTo();
        void toString();
        //
        wxString name;
        wxString value;
        wxString type;
        bool isFile;  //:   isFile, isDir, none
        FirmwareConfigItem * parent;
        wxString parentName; // only used in load
        bool active; //: true, false;
        bool validate; //: true, false;
        bool mandatory; // the base dir, and the header is mandatory any others are not


        wxString    grpName;
        bool        lastInPanel;

        int status;


    protected:
    private:
};

WX_DEFINE_ARRAY(FirmwareConfigItem *, FirmwareConfigItemArray);

#endif // FIRMWARECONFIGITEM_H
