#ifndef GUIDESCGUIITEM_H
#define GUIDESCGUIITEM_H

#include <wx/wx.h>
#include "../common/types/wxVariantHash.h"

class GUIDescGUIItem
{
    public:
        GUIDescGUIItem() {};
        GUIDescGUIItem(const wxString& name, int type, wxWindow* ctrl, wxButton* dialogButton = NULL);
        virtual ~GUIDescGUIItem() {};

        wxVariant GetValue(wxVariant& defval = wxNullVariant);
        void SetValue(wxVariant& val);
        bool IsNull();

        void ResetChange();
        bool IsChanged();


        wxWindow*   Ctrl;
        wxButton*   DialogButton;
        int         Type;
        wxString    Name;

        wxVariantHash ExtraProperties;

};

WX_DECLARE_OBJARRAY(GUIDescGUIItem, GUIDescGUIItemArray);
WX_DECLARE_STRING_HASH_MAP(GUIDescGUIItemArray, GUIDescGUIItemArrayStrHash);
WX_DECLARE_HASH_MAP(int, GUIDescGUIItemArray, wxIntegerHash, wxIntegerEqual, GUIDescGUIItemArrayIntHash);


#endif // GUIDESCGUIITEM_H
