#ifndef GAUGEDESCMANAGERSQL_H
#define GAUGEDESCMANAGERSQL_H

#include "GaugeDescHelper.h"
#include "GaugeDescManager.h"
#include <wx/wxsqlite3.h>

class VEMSGaugeDescArray;
class wxSQLite3Exception;

class GaugeDescManagerSQL: public GaugeDescManager
{
    public:
        GaugeDescManagerSQL(MTConfigData* mtConfigData);
        virtual ~GaugeDescManagerSQL();

        virtual bool LoadDescriptors(const wxString &filename);
        virtual bool SaveGaugeDescriptors(const wxString &filename);
        virtual bool SaveGaugeDescriptor(VEMSGaugeDesc * desc);
        virtual bool AddGaugeDescriptor(VEMSGaugeDesc * desc);
        virtual short ManageColoredArea( short command, ColoredArea * ca, int desc_id = -1 );

        virtual void GetTypeList(wxArrayString &arr);
        virtual void GetSymbolGroupList(wxArrayString &arr);
        virtual bool AddSymbolDesc(const wxString &name, const wxString &type, const wxString &title, const wxString &grpname);
        virtual wxVariant GetGaugeDescFieldByAnyField( const wxString &fieldname, const wxVariant& value, const wxString &resultfieldname );
        virtual wxVariant GetGaugeDescFieldBySymbolName( const wxString &symbolname, const wxString &fieldname );
        virtual wxVariant GetSymbolFieldBySymbolName( const wxString &symbolname, const wxString &fieldname );

        virtual bool GetColoredAreasBySymbolName( const wxString &symbolname, ColoredAreaRefArray& result);
        virtual bool GetColoredAreaByAnyField( const wxString &fieldname, const wxVariant& value, ColoredAreaRefArray& result);

        virtual wxString GetType() { return _T("SQL"); };

        virtual int GetGaugeSettings(const wxString gaugeType, int gauge_id, wxVariantHash &datas);
        virtual int SaveGaugeSettings(const wxString gaugeType, int gauge_id, wxVariantHash &datas);

    protected:

        void SetLastError(wxSQLite3Exception& e);

    private:

        bool CreateGSTable(wxSQLite3Database *db, const wxString &tablename, wxVariantHash &fields);

        wxString    m_dbFilename;

        wxSQLite3Database m_db;
        wxSQLite3Database m_gsdb;



};

#endif // GAUGEDESCMANAGERSQL_H
