#include "GaugeGroupDesc.h"

GaugeGroupDesc::GaugeGroupDesc(long id, const wxString& groupname)
{
    //ctor
    Properties[_T("id")] = id;
    Properties[_T("name")] = groupname;
}

GaugeGroupDesc::~GaugeGroupDesc()
{
    //dtor
}

wxVariant GaugeGroupDesc::GetProperty(const wxString& name, const wxVariant& defval) const
{
    const wxVariantHash::const_iterator it = Properties.find(name);

    if(it == Properties.end())
        return defval;
    else {
        return it->second;
    }
}

long GaugeGroupDesc::GetId() const
{
    return GetProperty(_T("id"),-1).GetLong();
}

long GaugeGroupDesc::GetFocusedGauge() const
{
    return GetProperty(_T("settofocus_gaugeid"),-1).GetLong();
}

wxString GaugeGroupDesc::GetName() const
{
    return GetProperty(_T("name"),wxEmptyString).GetString();
}

wxString GaugeGroupDesc::GetShortName() const
{
    return GetProperty(_T("short_name"),wxEmptyString).GetString();
}

wxString GaugeGroupDesc::GetHotKey() const
{
    return GetProperty(_T("hotkey"),wxEmptyString).GetString();
}

wxString GaugeGroupDesc::GetTheme() const
{
    return GetProperty(_T("theme"),wxEmptyString).GetString();
}

ShowOnStartupFlags GaugeGroupDesc::GetStartupInfo() const
{
    if(GetProperty(_T("show_on_startup"),false).GetBool())
        return SOSF_OFFLINE_LOG;

    if(GetProperty(_T("show_on_startup_online"),false).GetBool())
        return SOSF_ONLINE;

    if(GetProperty(_T("show_on_startup_offline_cfg"),false).GetBool())
        return SOSF_OFFLINE_CONFIG;

    return SOSF_NONE;
}

bool GaugeGroupDesc::IsSticked() const
{
    return GetProperty(_T("sticked"),false).GetBool();
}

bool GaugeGroupDesc::IsFloated() const
{
    return GetProperty(_T("floated"),false).GetBool();
}
