#ifndef GAUGEGROUPDESC_H
#define GAUGEGROUPDESC_H

#include "../common/types/wxVariantHash.h"

enum ShowOnStartupFlags {
    SOSF_NONE,
    SOSF_ONLINE,
    SOSF_OFFLINE_LOG,
    SOSF_OFFLINE_CONFIG
};

class GaugeGroupDesc
{
    public:
        GaugeGroupDesc() {};
        GaugeGroupDesc(long id, const wxString& groupname);
        virtual ~GaugeGroupDesc();

        long                GetId() const;
        long                GetFocusedGauge() const;
        wxString            GetName() const;
        wxString            GetShortName() const;
        wxString            GetHotKey() const;
        wxString            GetTheme() const;
        ShowOnStartupFlags  GetStartupInfo() const;
        bool                IsSticked() const;
        bool                IsFloated() const;

        wxVariant           GetProperty(const wxString& name, const wxVariant& defval) const;


        wxVariantHash       Properties;
};

#endif // GAUGEGROUPDESC_H
