#ifndef MULTIGRAPHTHEME_H
#define MULTIGRAPHTHEME_H

#include "../common/types/wxVariantHash.h"

class MultiGraphTheme
{
    public:
        MultiGraphTheme() { IsChanged = false; };
        MultiGraphTheme(MultiGraphTheme& m);
        virtual ~MultiGraphTheme();

        wxColor     GetColor(const wxString& key, const wxColor& defval = wxNullColour);
        double      GetDouble(const wxString& key, double defval = -1.0);
        int         GetInt(const wxString& key, int defval = -1);
        wxString    GetString(const wxString& key, const wxString& defval = wxEmptyString);

        wxString    MakeString(const wxString& key);
        void        SetByString(const wxString& key, const wxString& value);

        wxVariantHash   Properties;
        bool            IsChanged;

    protected:
    private:

};

class MultiGraphThemeProperty
{
    public:
        MultiGraphThemeProperty() { Id = -1; };
        MultiGraphThemeProperty(int id, const wxString& name, const wxString& title){
            Id = id;
            Name = name;
            Title = title;
        };

        int         Id;
        wxString    Name;
        wxString    Title;

        //MultiGraphThemeProperty& operator=( const MultiGraphThemeProperty& ) {        }

};

WX_DECLARE_STRING_HASH_MAP( MultiGraphThemeProperty, MultiGraphThemePropertyHash );
WX_DECLARE_OBJARRAY(MultiGraphThemeProperty, MultiGraphThemePropertyArray);
WX_DECLARE_HASH_MAP( int, MultiGraphTheme*, wxIntegerHash, wxIntegerEqual, MultiGraphThemeHash);

#endif // MULTIGRAPHTHEME_H
