#include "gaugevalueselector.h"

//(*InternalHeaders(GaugeValueSelector)
#include <wx/bitmap.h>
#include <wx/font.h>
#include <wx/fontenum.h>
#include <wx/fontmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>
//*)
#include "rtdatamanager/RTDataViewerBase.h"

#include "logger.h"

const long GaugeValueSelector::ID_LISTBOX1 = wxNewId();
const long GaugeValueSelector::ID_BUTTON1 = wxNewId();
const long GaugeValueSelector::ID_BUTTON2 = wxNewId();

BEGIN_EVENT_TABLE(GaugeValueSelector,wxFrame)

	EVT_BUTTON(ID_BUTTON1, GaugeValueSelector::OnButtonOK)
	EVT_BUTTON(ID_BUTTON2, GaugeValueSelector::OnButtonCN)
	EVT_LISTBOX(ID_LISTBOX1, GaugeValueSelector::OnListBoxClick)

END_EVENT_TABLE()



GaugeValueSelector::GaugeValueSelector(wxWindow* parent,wxWindowID id)
: m_RTDataViewerBase (NULL)
{
    int x,y;
	wxDisplaySize(&x,&y);

    wxSize fSize = wxSize(x-50,y-50);

	Create(parent,id,_T("Gauge Value Selector"),wxPoint(x/2-fSize.x/2,y/2-fSize.y/2),fSize,wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX | wxCLIP_CHILDREN | wxSTAY_ON_TOP);
	BoxSizer1 = new wxBoxSizer(wxVERTICAL);
	ListBox1 = new wxListBox(this,ID_LISTBOX1,wxDefaultPosition,wxSize(fSize.x-10,fSize.y-40),0,0,0,wxDefaultValidator,_T("ID_LISTBOX1"));
	BoxSizer1->Add(ListBox1,1,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxEXPAND,5);
	BoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
	Button1 = new wxButton(this,ID_BUTTON1,_("OK"),wxDefaultPosition,wxSize(60,20),0,wxDefaultValidator,_T("ID_BUTTON1"));
	BoxSizer2->Add(Button1,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);
	Button2 = new wxButton(this,ID_BUTTON2,_("Cancel"),wxDefaultPosition,wxSize(60,20),0,wxDefaultValidator,_T("ID_BUTTON2"));
	BoxSizer2->Add(Button2,1,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,5);
	BoxSizer1->Add(BoxSizer2,0,wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0);

	SetSizer(BoxSizer1);
	//BoxSizer1->Fit(this);
	//BoxSizer1->SetSizeHints(this);

	//SetTransparent(200);

}

GaugeValueSelector::~GaugeValueSelector()
{

}

void GaugeValueSelector::ResizeAndShow(bool show)
{
    ///wxDisplayChangedEvent ???

    int x,y;
	wxDisplaySize(&x,&y);

    wxSize fSize = wxSize(x-50,y-50);
    wxPoint fPoint = wxPoint(x/2-fSize.x/2,y/2-fSize.y/2);

    SetSize(fSize);
    Move(fPoint);

    Show(show);
}

void GaugeValueSelector::SetRTDataViewer(RTDataViewerBase* rtdV)
{
    m_RTDataViewerBase =  rtdV;
}

void GaugeValueSelector::OnButtonOK(wxCommandEvent& WXUNUSED(event))
{

    if (m_RTDataViewerBase != NULL){
        m_RTDataViewerBase->SetValueIdx(ListBox1->GetSelection() );
    }
    Show(0);
}

void GaugeValueSelector::OnButtonCN(wxCommandEvent& WXUNUSED(event))
{
    Show(0);
}

void GaugeValueSelector::OnListBoxClick(wxCommandEvent& WXUNUSED(event))
{

    if (m_RTDataViewerBase != NULL){
        m_RTDataViewerBase->SetValueIdx(ListBox1->GetSelection() );
    }
    Show(0);

}

void GaugeValueSelector::Clear()
{
    ListBox1->Clear();
}

void GaugeValueSelector::AddItems(wxArrayString choices)
{
    ListBox1->InsertItems(choices,0);
}
