#ifndef GPSCONFIGDIALOG2_H
#define GPSCONFIGDIALOG2_H

#include <wx/wx.h>

#include "GPSCommunicationEvent.h"

#include "../serialconfig.h"

#include <wx/richtext/richtextctrl.h>

class VemsTuneController;
class GPSCommunicationController;
class ProcessBase;
class ProgressBar;

class GPSConfigDialog2 : public wxDialog
{
    public:
        /// vtc needed to stop the threads
        GPSConfigDialog2( wxWindow* parent, VemsTuneController* vtc );
        ~GPSConfigDialog2();

    public:
        bool        process();

    private:
        VemsTuneController*         m_vtc;
        GPSCommunicationController* m_gpscommcontroller;

        wxComboBox*                 m_comports;
        wxComboBox*                 m_baudRate;
        wxComboBox*                 m_enabled;

        SerialConfig                m_serialConfig;

        ProgressBar*                m_progressbar;

        wxStaticText*               m_txtDetect;

        wxArrayString               m_baudRateS;

        wxButton                    *m_testButton, *m_detectButton, *m_saveButton;
        wxButton                    *m_closeButton, *m_cancelButton;

        wxStaticBitmap*             m_statBmp;
        wxRichTextCtrl*             m_result;
        wxBitmap                    m_bmp;
        bool                        m_found;
        bool                        m_saved;
        bool                        m_wasECUOnline;

        ProcessBase*                m_contentLoader;
        double                      m_gpslat, m_gpslong;

    private:

        void                        buildGUI();

        void                        OnSave( wxCommandEvent& event );
        void                        OnTest( wxCommandEvent& event );
        void                        OnDetect( wxCommandEvent& event );
        void                        OnClose( wxCommandEvent& event );
        void                        OnCancelButton( wxCommandEvent& event );

        void                        OnGPSEnabledCombo( wxCommandEvent& event );

        void                        enableButtons( bool enable = true );

        // GPSCommController will send events
        void                        OnGPSEvent( GPSCommunicationEvent& event );

        static int                  sortFunction( const wxString& first, const wxString& second );

        void                        parseResponse( const wxString& respstr, int Type = 0 );

    private:

        DECLARE_EVENT_TABLE()
};

#endif // GPSCONFIGDIALOG2_H
