#ifndef CONFIGDOWNLOADDIRECTOR_H
#define CONFIGDOWNLOADDIRECTOR_H


class ConfigDownloadController;
class VemsDeviceControllerBase;
class ConfigSaver2;

class InputEvent;
class CommunicationEvent;


extern const wxEventType ConfigDownloadDirectorEvent;


class ConfigDownloadDirector : public wxEvtHandler
{
    public:
        ConfigDownloadDirector( wxWindow* parent, VemsDeviceControllerBase* deviceController );
        virtual ~ConfigDownloadDirector();

        void saveDeviceConfig( bool showDialog );

    private:
        VemsDeviceControllerBase*   m_deviceController;
        ConfigDownloadController*   m_configDownloadController;
        ConfigSaver2*               m_configSaver;
        wxWindow*                   m_parent;
        wxString                    m_fileName;

        bool isConfigDownloadEnabled() const;
        void showErrorMessage() const;
        void showFileDialog( wxString& path );

        void onInputEvent( InputEvent& event );
        void onCommunicationEvent( CommunicationEvent& event );

        void connectCommunicationEventHandler();
        void disconnectCommunicationEventHandler();
};

#endif // CONFIGDOWNLOADDIRECTOR_H
