#ifndef ECUCONFIGPANEL_H
#define ECUCONFIGPANEL_H

#include <wx/wx.h>
#include <wx/progdlg.h>
#include "../ProgressBar.h"


class VemsTuneController;
class SerialPortScanner;
class SerialPortScannerEvent;

enum DetectState { D_UNDEFINED, D_NOT_FOUND, D_FOUND };

class ECUConfigPanel : public wxDialog
{
    public:
        ECUConfigPanel(wxWindow* parent, VemsTuneController* vemscontroller);
        virtual ~ECUConfigPanel();
        static void findAndShow(wxWindow* parent, VemsTuneController* controller);
    protected:

        void Detect();

    private:

        // Communication vars
        wxRadioButton*  m_serial;
        wxRadioButton * m_tcp;
        wxTextCtrl*     m_com_timeout;
        wxTextCtrl*     m_rt_error_count;
        wxTextCtrl*     m_rtInterWriteDelay;
        wxComboBox*     m_comport;
        wxComboBox*     m_preferredBaudrateComboBox;
        wxComboBox*     m_fwuploadBrComboBox;
        wxComboBox*     m_sdcard_b;
        wxTextCtrl*     m_ipport;
        wxTextCtrl*     m_tcp_timeout;

        wxPanel*        m_CommunicationPanel;
        wxPanel*        m_serialPanel;
        wxPanel*        m_tcpPanel;

        wxButton*       m_detectButton;
        wxButton*       m_SaveButton;

        //VemsTuneController* m_controller;
        VemsTuneController* m_controller;
        ProgressBar*    m_progressbar;
        wxStaticText*   m_txtDetect;

        bool            m_detecting;
        bool            m_restartControllerAfterClose;

        SerialPortScanner* m_portScanner;

        void saveValues();
        void enablePanels(bool enabled = true);

        void buildGUI(wxWindow* parent);
        void connectKeyDownEvent( wxWindow* window );

        void OnClose(wxCloseEvent& event);
        void OnButton(wxCommandEvent& event);
        void OnCOMChange(wxCommandEvent& event);
        void OnChangeBaudrate(wxCommandEvent& event);
        void OnSelectCommMode(wxCommandEvent& event);
        void OnKeyDown( wxKeyEvent& event );

        void OnDeviceFound( SerialPortScannerEvent& event );
        void OnDeviceNotFound( SerialPortScannerEvent& event );
        void OnCannotOpenPort( SerialPortScannerEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // ECUCONFIGPANEL_H
