#ifndef ECUCONFIGPANEL_H
#define ECUCONFIGPANEL_H

#include <wx/wx.h>
#include <wx/progdlg.h>
#include "../ProgressBar.h"


class VemsDeviceController;
class VemsDeviceControllerEvent;

enum DetectState { D_UNDEFINED, D_NOT_FOUND, D_FOUND };

class ECUConfigPanel : public wxFrame
{
    public:
        ECUConfigPanel(wxWindow* parent, VemsDeviceController* vemscontroller);
        virtual ~ECUConfigPanel();
        static void findAndShow(wxWindow* parent, VemsDeviceController* controller);

    private:

        // Communication vars
        wxRadioButton*  m_serial;
        wxRadioButton * m_tcp;
        wxStaticText*   m_ctext1;
        wxStaticText*   m_ctext2;
        wxStaticText*   m_ctext3;
        wxStaticText*   m_ctext4;
        wxStaticText*   m_ctext5;
        wxStaticText*   m_rtErrorText;
        wxStaticText*   m_currentBaudrateLabel;
        wxStaticText*   m_preferredBaudrateLabel;
        wxStaticText*   m_interWriteDelayText;
        wxTextCtrl*     m_com_timeout;
        wxTextCtrl*     m_rt_error_count;
        wxTextCtrl*     m_rtInterWriteDelay;
        wxComboBox*     m_comport;
        wxTextCtrl*     m_currentBaudrateTextCtrl;
        wxComboBox*     m_preferredBaudrateComboBox;
        wxComboBox*     m_sdcard_b;
        wxTextCtrl*     m_ip;
        wxTextCtrl*     m_tcp_timeout;
        // Protocol vars
        wxComboBox*     m_defprot;
        wxComboBox*     m_defreadc;

        wxPanel*        m_ProtocolPanel;
        wxPanel*        m_CommunicationPanel;

        wxButton*       m_detectButton;
        wxButton*       m_SaveButton;

        VemsDeviceController* m_deviceController;
//        DetectState     m_detectState;
        ProgressBar*    m_progressbar;
        wxStaticText*   m_txtDetect;

        bool            m_detecting, m_connecting;
        int             m_actualPort;

        //size_t          m_portIdx;
        size_t          m_tryCount;
        size_t          m_maxTryCount;

        void saveConfig();
        void enablePanels(bool enabled = true);

        void buildGUI(wxWindow* parent);
        void setEnabledSerialSettings( bool enable );
        void setEnabledTCPSettings( bool enable );

        void OnClose(wxCloseEvent& event);
        void OnDetectButton(wxCommandEvent& event);
        void OnSaveButton(wxCommandEvent& event);

        void OnCOMChange(wxCommandEvent& event);
        void OnChangeBaudrate(wxCommandEvent& event);
        void OnChangeCommunicationMode( wxCommandEvent& event );

        void OnVemsDeviceControllerEvent( VemsDeviceControllerEvent& event );


        DECLARE_EVENT_TABLE()
};

#endif // ECUCONFIGPANEL_H
