#include "FileSearchDlg.h"

BEGIN_EVENT_TABLE( FileDialogSearchDialog, wxDialog )
    EVT_CLOSE( FileDialogSearchDialog::OnClose )
END_EVENT_TABLE();

FileDialogSearchDialog::FileDialogSearchDialog( wxWindow* parent )
{
    Create( parent, wxID_ANY, _T("Search") );

    wxFlexGridSizer* mainsizer = new wxFlexGridSizer( 2 );

    int id;

    wxTextValidator validator(wxFILTER_NUMERIC);

    // header
    wxBoxSizer* s = new wxBoxSizer( wxHORIZONTAL );
    mainsizer->Add( 30, 20 );
    wxStaticText* h1 = new wxStaticText( this, -1, _T("Min value"), wxDefaultPosition, wxSize(120,20) );
    s->Add( h1, 0, wxALL | wxEXPAND, 5 );
    h1 = new wxStaticText( this, -1, _T("Max value") );
    s->Add( h1, 0, wxALL | wxEXPAND, 5 );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // size
    s = new wxBoxSizer( wxHORIZONTAL );
    wxStaticText* txt1 = new wxStaticText( this, -1, _T("Size of file (in bytes)") );
    m_sizeMin = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    m_sizeMax = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    id = wxNewId(); wxButton* eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_sizeMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_sizeMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // date
    s = new wxBoxSizer( wxHORIZONTAL );
    txt1 = new wxStaticText( this, -1, _T("Modification date") );
    // unix startDate
    wxDateTime beginDt((time_t)0), endDt = wxDateTime::Now();
    m_dateMin = new wxDatePickerCtrl( this, -1, beginDt, wxDefaultPosition, wxDefaultSize,
        wxDP_DROPDOWN | wxDP_SHOWCENTURY );
    m_dateMax = new wxDatePickerCtrl( this, -1, endDt, wxDefaultPosition, wxDefaultSize,
        wxDP_DROPDOWN | wxDP_SHOWCENTURY );
    m_dateMin->SetRange( beginDt, endDt ); m_dateMax->SetRange( beginDt, endDt );

    id = wxNewId(); eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_dateMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_dateMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // FW
    s = new wxBoxSizer( wxHORIZONTAL );
    txt1 = new wxStaticText( this, -1, _T("Firmware (don't use dots, eg. 1.0.73 = 1073)") );
    m_fwMin = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    m_fwMax = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    id = wxNewId(); eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_fwMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_fwMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // rpm
    s = new wxBoxSizer( wxHORIZONTAL );
    txt1 = new wxStaticText( this, -1, _T("RPM") );
    m_rpmMin = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    m_rpmMax = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    id = wxNewId();  eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_rpmMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_rpmMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // map
    s = new wxBoxSizer( wxHORIZONTAL );
    txt1 = new wxStaticText( this, -1, _T("MAP") );
    m_mapMin = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    m_mapMax = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    id = wxNewId(); eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_mapMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_mapMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // trigerr
    s = new wxBoxSizer( wxHORIZONTAL );
    txt1 = new wxStaticText( this, -1, _T("# of trigger errors") );
    m_teMin = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    m_teMax = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, 0, validator );
    id = wxNewId(); eq = new wxButton( this, id, _T("=") ); m_ButtonIds.Add( id );
    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 ); s->Add( m_teMin, 0, wxEXPAND | wxALL, 5);
    s->Add( m_teMax, 0, wxEXPAND | wxALL, 5); s->Add( eq, 0, wxALL, 5 );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 1, wxEXPAND | wxALL, 3 );

    // gps
    txt1 = new wxStaticText( this, -1, _T("GPS data") );
    wxArrayString arr; arr.Add( _T("?") ); arr.Add( _T("No")); arr.Add( _T("Yes") );
    m_hasGPS = new wxChoice( this, -1, wxDefaultPosition, wxDefaultSize, arr );
    m_hasGPS->SetSelection( 0 );

    mainsizer->Add( txt1, 0, wxEXPAND | wxALL, 5 );
    mainsizer->Add( m_hasGPS, 0, wxALL, 5 );

    s = new wxBoxSizer( wxHORIZONTAL );
    id = wxNewId();
    wxButton* b = new wxButton( this, id, _T("Search") );
    s->Add( b, 0, wxALL, 5 ); m_ButtonIds.Add( id );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    id = wxNewId(); b = new wxButton( this, id, _T("Close") );
    s->Add( b, 0, wxALL, 5 ); m_ButtonIds.Add( id );
    Connect( id, wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( FileDialogSearchDialog::OnButton ), 0, this );
    mainsizer->Add( s, 0, wxALL, 5 );
    mainsizer->AddSpacer( 5 );
    //
    SetSizer( mainsizer );
    mainsizer->SetSizeHints( this );
    mainsizer->Fit( this );
}

void FileDialogSearchDialog::OnClose( wxCloseEvent& event )
{
    EndModal( -1 );
}

void FileDialogSearchDialog::OnButton( wxCommandEvent& event )
{
    int id = event.GetId();

    int bNo = m_ButtonIds.Index( id );

    if ( bNo == wxNOT_FOUND )
    {
        event.Skip();
        return;
    }

    if ( bNo == (int)(m_ButtonIds.GetCount()) - 1 )
    {
        EndModal( -1 );
        return;
    }
    if ( bNo == (int)(m_ButtonIds.GetCount()) - 2 )
    {
        searchFiles();
        EndModal( 1 );
        return;
    }

    switch ( bNo )
    {
        case 0:
            if ( m_sizeMin->GetValue().IsEmpty() && !m_sizeMax->GetValue().IsEmpty() )
                m_sizeMin->SetValue( m_sizeMax->GetValue() );
            else if ( m_sizeMax->GetValue().IsEmpty() && !m_sizeMin->GetValue().IsEmpty() )
                m_sizeMax->SetValue( m_sizeMin->GetValue() );
            else if ( !m_sizeMax->GetValue().IsEmpty() && !m_sizeMin->GetValue().IsEmpty() )
                m_sizeMax->SetValue( m_sizeMin->GetValue() );
            break;
        case 1:
            m_dateMin->SetValue( m_dateMax->GetValue() );
            break;
        case 2:
            if ( m_fwMin->GetValue().IsEmpty() && !m_fwMax->GetValue().IsEmpty() )
                m_fwMin->SetValue( m_fwMax->GetValue() );
            else if ( m_fwMax->GetValue().IsEmpty() && !m_fwMin->GetValue().IsEmpty() )
                m_fwMax->SetValue( m_fwMin->GetValue() );
            else if ( !m_fwMax->GetValue().IsEmpty() && !m_fwMin->GetValue().IsEmpty() )
                m_fwMax->SetValue( m_fwMin->GetValue() );
            break;
        case 3:
            if ( m_rpmMin->GetValue().IsEmpty() && !m_rpmMax->GetValue().IsEmpty() )
                m_rpmMin->SetValue( m_rpmMax->GetValue() );
            else if ( m_rpmMax->GetValue().IsEmpty() && !m_rpmMin->GetValue().IsEmpty() )
                m_rpmMax->SetValue( m_rpmMin->GetValue() );
            else if ( !m_rpmMax->GetValue().IsEmpty() && !m_rpmMin->GetValue().IsEmpty() )
                m_rpmMax->SetValue( m_rpmMin->GetValue() );
            break;
        case 4:
            if ( m_mapMin->GetValue().IsEmpty() && !m_mapMax->GetValue().IsEmpty() )
                m_mapMin->SetValue( m_mapMax->GetValue() );
            else if ( m_mapMax->GetValue().IsEmpty() && !m_mapMin->GetValue().IsEmpty() )
                m_mapMax->SetValue( m_mapMin->GetValue() );
            else if ( !m_mapMax->GetValue().IsEmpty() && !m_mapMin->GetValue().IsEmpty() )
                m_mapMax->SetValue( m_mapMin->GetValue() );
            break;
        case 5:
            if ( m_teMin->GetValue().IsEmpty() && !m_teMax->GetValue().IsEmpty() )
                m_teMin->SetValue( m_teMax->GetValue() );
            else if ( m_teMax->GetValue().IsEmpty() && !m_teMin->GetValue().IsEmpty() )
                m_teMax->SetValue( m_teMin->GetValue() );
            else if ( !m_teMax->GetValue().IsEmpty() && !m_teMin->GetValue().IsEmpty() )
                m_teMax->SetValue( m_teMin->GetValue() );
            break;
        default: break;
    }
}

void FileDialogSearchDialog::searchFiles()
{
    SDHash searchH;
    if ( ! m_sizeMin->GetValue().IsEmpty() || !m_sizeMax->GetValue().IsEmpty() )
    {
        SearchDescr* sd = new SearchDescr;
        if ( !m_sizeMin->GetValue().IsEmpty() ) m_sizeMin->GetValue().ToLong( &sd->minval );
        if ( !m_sizeMax->GetValue().IsEmpty() ) m_sizeMax->GetValue().ToLong( &sd->maxval );
        searchH[_T("fsize")] = sd;
    }
    if ( ! m_fwMin->GetValue().IsEmpty() || !m_fwMax->GetValue().IsEmpty() )
    {
        SearchDescr* sd = new SearchDescr;
        if ( !m_fwMin->GetValue().IsEmpty() ) m_fwMin->GetValue().ToLong( &sd->minval );
        if ( !m_fwMax->GetValue().IsEmpty() ) m_fwMax->GetValue().ToLong( &sd->maxval );
        searchH[_T("firmware")] = sd;
    }
    if ( ! m_rpmMin->GetValue().IsEmpty() || !m_rpmMax->GetValue().IsEmpty() )
    {
        SearchDescr* sd = new SearchDescr;
        if ( !m_rpmMin->GetValue().IsEmpty() ) m_rpmMin->GetValue().ToLong( &sd->minval );
        if ( !m_rpmMax->GetValue().IsEmpty() ) m_rpmMax->GetValue().ToLong( &sd->maxval );
        searchH[_T("rpmmax")] = sd;
    }
    if ( ! m_mapMin->GetValue().IsEmpty() || !m_mapMax->GetValue().IsEmpty() )
    {
        SearchDescr* sd = new SearchDescr;
        if ( !m_mapMin->GetValue().IsEmpty() ) m_mapMin->GetValue().ToLong( &sd->minval );
        if ( !m_mapMax->GetValue().IsEmpty() ) m_mapMax->GetValue().ToLong( &sd->maxval );
        searchH[_T("mapmax")] = sd;
    }
    if ( ! m_teMin->GetValue().IsEmpty() || !m_teMax->GetValue().IsEmpty() )
    {
        SearchDescr* sd = new SearchDescr;
        if ( !m_teMin->GetValue().IsEmpty() ) m_teMin->GetValue().ToLong( &sd->minval );
        if ( !m_teMax->GetValue().IsEmpty() ) m_teMax->GetValue().ToLong( &sd->maxval );
        searchH[_T("trigerr")] = sd;
    }
    // gps
    int gps = m_hasGPS->GetSelection() - 1;
    SearchDescr* sd = new SearchDescr;
    sd->minval = sd->maxval = gps;
    searchH[_T("hasGPS")] = sd;

    // date
    sd = new SearchDescr;
    wxDateTime dtS = m_dateMin->GetValue(), dtE = m_dateMax->GetValue();
    sd->minval = dtS.GetTicks(); sd->maxval = dtE.GetTicks() + 86400;
    searchH[_T("fdate")] = sd;

    m_fileinfo = FileOpenSQL::searchFiles( searchH );

    WX_CLEAR_HASH_MAP( SDHash, searchH );
}

FileInfoA FileDialogSearchDialog::getFiles()
{
    return m_fileinfo;
}
