#ifndef FIRMWAREVERIFYDIALOG_H
#define FIRMWAREVERIFYDIALOG_H


#include "wx/progdlg.h"


class VemsDeviceControllerBase;
class FirmwareVerifyController;
class FirmwareData;
class VemsDeviceControllerEvent;
class FirmwareVerifyEvent;
class CommunicationEvent;


class FirmwareVerifyDialog : public wxProgressDialog
{
    DECLARE_DYNAMIC_CLASS( FirmwareVerifyDialog )

    public:
        FirmwareVerifyDialog(   wxWindow* parent,
                                VemsDeviceControllerBase* deviceController,
                                FirmwareData* firmwareData );

        virtual ~FirmwareVerifyDialog();

    private:
        VemsDeviceControllerBase*   m_deviceController;
        FirmwareVerifyController*   m_firmwareVerifyController;
        wxString                    m_message;
        size_t                      m_pagesCount;

    private:
        /// stop VerifyController, disconnects EventHandlers
        void cleanup();

        /// FirmwareVerifyEvent handlers
        void onFirmwarePageVerified( FirmwareVerifyEvent& event );
        void onFirmwareVerifingSucceeded( FirmwareVerifyEvent& event );
        void onFirmwareVerifingFailed( FirmwareVerifyEvent& event );

        /// VemsDeviceControllerEvent handlers
        void onDeviceDisconnected( VemsDeviceControllerEvent& event );

        void onCommunicationEvent( CommunicationEvent& event );
};

#endif // FIRMWAREVERIFYDIALOG_H
