#include "OpenVemsCfgDialog.h"
#include <wx/statline.h>
#include <wx/artprov.h>


BEGIN_EVENT_TABLE( OpenVemsCfgDialog, wxDialog )
    EVT_BUTTON( ID_CONFIG_UPLOAD, OpenVemsCfgDialog::OnButton )
    EVT_BUTTON( ID_CONFIG_SWITCH_UPLOAD, OpenVemsCfgDialog::OnButton )
    EVT_BUTTON( ID_CONFIG_VERIFY, OpenVemsCfgDialog::OnButton )
    EVT_BUTTON( ID_GO_OFFLINE, OpenVemsCfgDialog::OnButton )
    EVT_BUTTON( ID_CANCEL, OpenVemsCfgDialog::OnButton )
END_EVENT_TABLE()


OpenVemsCfgDialog::OpenVemsCfgDialog(   wxWindow* parent,
                                        wxWindowID id,
                                        const wxString& title,
                                        long buttons,
                                        const wxPoint& pos,
                                        const wxSize& size,
                                        long style,
                                        const wxString& name )
{
    Create( parent, id, _T("Open VemsCfg"), pos, size, style, name );

    SetSizer( new wxBoxSizer( wxVERTICAL ) );


    wxBoxSizer* pButtonLineSizer = new wxBoxSizer( wxHORIZONTAL );

    if(buttons & OVCDB_OPEN) {
        wxButton* pOpenButton   = new wxButton( this, ID_CONFIG_UPLOAD, _T("Config upload") );
        pButtonLineSizer->Add( pOpenButton, 0, wxALL, 5 );
    }
    if(buttons & OVCDB_OPENADV) {
        wxButton* pOpenCSButton = new wxButton( this, ID_CONFIG_SWITCH_UPLOAD, _T("Config Upload Advanced") );
        pButtonLineSizer->Add( pOpenCSButton, 0, wxALL, 5 );
    }
    if(buttons & OVCDB_OPENADV) {
        wxButton* pVerifyButton = new wxButton( this, ID_CONFIG_VERIFY, _T("Config Verify") );
        pButtonLineSizer->Add( pVerifyButton, 0, wxALL, 5 );
    }
    if(buttons & OVCDB_GOOFFLINE) {
        wxButton* pSelectButton = new wxButton( this, ID_GO_OFFLINE, _T("Go offline") );
        pButtonLineSizer->Add( pSelectButton, 0, wxALL, 5 );
    }
    if(buttons & OVCDB_CANCEL) {
        wxButton* pCancelButton = new wxButton( this, ID_CANCEL, _T("Cancel") );
        pButtonLineSizer->AddStretchSpacer();
        pButtonLineSizer->Add( pCancelButton, 0, wxALL, 5 );
    }

    wxBoxSizer* pMsgLineSizer = new wxBoxSizer( wxHORIZONTAL );

    wxBitmap bitmap = wxArtProvider::GetIcon(wxART_WARNING, wxART_MESSAGE_BOX);
    wxStaticBitmap *icon = new wxStaticBitmap(this, wxID_ANY, bitmap);
    pMsgLineSizer->Add( icon, 0, wxALIGN_CENTER | wxALL , 5 );
    //pMsgLineSizer->AddStretchSpacer();

    wxStaticText* text = new wxStaticText( this, wxID_ANY, _T("ECU is connected. Please, choose an option.") );
    wxFont font = text->GetFont();
    font.SetPointSize( 12 );
    font.SetWeight( wxFONTWEIGHT_BOLD );
    text->SetFont( font );

    pMsgLineSizer->Add( text, 1, wxALIGN_CENTER | wxALL, 5 );

    GetSizer()->Add( pMsgLineSizer, 0, 0, 0 );
    GetSizer()->Add( new wxStaticLine( this ), 0, wxEXPAND | wxALL, 5 );
    GetSizer()->Add( pButtonLineSizer, 0, wxEXPAND, 0 );

    SetInitialSize();
}

void OpenVemsCfgDialog::OnButton( wxCommandEvent& event )
{
    EndModal( event.GetId() );
}
