#ifndef HASHCOMPARE_H
#define HASHCOMPARE_H

#include "common/types/String2Uint32Hash.h"
#include "common/types/StringHash.h"

#include <wx/wx.h>

enum{
        COMPARE_EQUAL = 0,
        COMPARE_DIFF,
        COMPARE_NEAR
};

class CompareResult
{
    public:
        int size;
        void addMissingKey(const wxString& key)
        {
                missingKey.Add(key);
        }
        void addDiffValueKey(const wxString& key)
        {
                diffValueKey.Add(key);
        }

        wxArrayString& getDiffValueKey(){
            return diffValueKey;
        }

        wxArrayString& getMissingKey(){
            return missingKey;
        }

        bool isIdentical(){
            if( missingKey.Count() == 0 && diffValueKey.Count() ==0 ){ return true;}
            return false;
        }

        wxString toString()
        {
            return wxString::Format( _T("Number of missing keys: %d\n Number of different values: %d\n"), missingKey.Count(), diffValueKey.Count());
        }

    protected:
        wxArrayString missingKey;
        wxArrayString diffValueKey;


};

class HashCompare
{
    public:
        HashCompare();
        virtual ~HashCompare();


        static CompareResult * compare(String2Uint32Hash& h1, String2Uint32Hash& h2, uint32_t mask);
        static CompareResult * compare(StringHash& h1, StringHash& h2);
    protected:
        static int compareValue(const wxString& key, const wxString& v1, const wxString& v2);
        static int compareValue(const wxString& key, uint32_t v1, uint32_t v2);
        static uint8_t norm(uint32_t v1);
    private:
};



#endif // HASHCOMPARE_H
