#include "wxHotKeyProfileManager.h"

#include <wx/wxsqlite3.h>

#include "wxHotKeyManagerGUI.h"


#include "../logger.h"
#include "../UserLog.h"
#include "../DirHelper.h"


wxHotKeyProfileManager::wxHotKeyProfileManager(wxWindow *win, wxMenu * parentmenu)
{
    m_dbfile = DirHelper::GetPath(dHOTKEYS) + _T("profiles.db");
    m_dbtfile = DirHelper::GetPath(dHOTKEYS) + _T("targets.db");
    m_menu = parentmenu;
    m_parent = win;
    m_parent->PushEventHandler( this );
    //ctor
    Init();
}

wxHotKeyProfileManager::~wxHotKeyProfileManager()
{
    //dtor
}

void wxHotKeyProfileManager::Init()
{
    wxSQLite3Database db;

    wxMenu * menu = new wxMenu();

    try {
        db.Open(m_dbfile);
    } catch(wxSQLite3Exception &ex) {
        UserLog::uLog(ULOG_ERROR, ex.GetMessage());
        return;
    }

    db.ExecuteQuery(wxString::Format(_T("attach database \"%s\" as targetdb;"),m_dbtfile.c_str()));

    wxSQLite3ResultSet res = db.ExecuteQuery(_T("select * from targets order by title asc;"));

    while(res.NextRow()) {
/*
        wxMenu * subm = new wxMenu();

        wxSQLite3ResultSet subres = db.ExecuteQuery(wxString::Format(_T("select * from profiles where target_id=%i order by title asc;"),res.GetInt(_T("id"))));

        while(subres.NextRow()) {
            int id = wxNewId();
            subm->AppendRadioItem(id,subres.GetString(_T("title")));
            if(subres.GetInt(_T("isuse")) == 1)
                subm->Check(id,true);

            Connect(id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler(wxHotKeyProfileManager::OnMenu));
            Logger::logf(LOG_MSG,_T("wxHotKeyProfileManager::Init() id=%i"),id);
        }

        menu->AppendSubMenu(subm,res.GetString(_T("title")));
        */

        int id = wxNewId();
        menu->Append(id,res.GetString(_T("title")));
        Connect(id, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler(wxHotKeyProfileManager::OnMenu));
    }

    m_menu->AppendSubMenu(menu,_T("Hotkey config"));
}

void wxHotKeyProfileManager::OnMenu(wxCommandEvent &evt)
{
    wxString str = m_menu->GetLabelText(evt.GetId());

    Logger::logf(LOG_MSG,_T("wxHotKeyProfileManager::OnMenu str=")+str);

    wxHotKeyManagerGUI * gui = new wxHotKeyManagerGUI(m_parent);

    gui->Show(1);

    gui->LoadTarget( str );

/*
    wxSQLite3Database db;

    db.Open(m_dbfile);

    wxSQLite3ResultSet res = db.ExecuteQuery(wxString::Format(_T("select target_id from profiles where title='%s';"),str.c_str()));

    db.ExecuteUpdate( wxString::Format(_T("update profiles set isuse=0 where target_id=%i;"),res.GetInt(0)) );
    db.ExecuteUpdate( wxString::Format(_T("update profiles set isuse=1 where title='%s' and target_id=%i;"),str.c_str(),res.GetInt(0)) );
    */
}
