#ifndef GPSHELPER_H
#define GPSHELPER_H

#include <wx/dynarray.h>

#include "../rtdatamanager/RTDataViewerBase.h"

class GPSData {
    public:
        double  latitude;
        double  longitude;
        double  height;
        double  speed;
        double  distance;
};

WX_DECLARE_OBJARRAY( GPSData, GPSDataA );

class SIPR2GPSConverter : public RTDataViewerBase {
    public:
        SIPR2GPSConverter() { m_isregistered = false; m_minLat = 90; m_maxLat = -90; m_minLon = 180; m_maxLon = -180; }
        void        SetValue(double value) {}
        void        refresh(DoubleHash* table);
        void        require();
        void        unregisterSymbols();
        void        SetValueIdx(int idx) { }
        void        getBounds( double* minLat, double* maxLat, double* minLon, double* maxLon );
        GPSDataA    getData();

    private:
        bool        m_isregistered;
        double      m_minLon, m_minLat, m_maxLon, m_maxLat;
        GPSDataA    m_data;
};

class GPSHelper
{
    public:
        void                analyzeGPS( const wxString& filename, int exportType );

        static void         calculateGPSData();
        static GPSDataA     getGPSData();
        static void         exportToKML( const wxString& filename, const wxString& name = wxEmptyString,
                                    const wxString& descr = wxEmptyString );
        static void         exportToGPX( const wxString& filename, const wxString& name = wxEmptyString,
                                    const wxString& descr = wxEmptyString );

        static void         getBounds( double* minLat, double* maxLat, double* minLon, double* maxLon );

        static void         sketchRoute( const wxString& filename );

    protected:
    private:
        static GPSDataA     m_gpsdata;
        static double       m_minLon, m_minLat, m_maxLon, m_maxLat;
};

#endif // GPSHELPER_H
