#include "LogHistoryBase.h"
#include "../logger.h"

LogHistoryBase::LogHistoryBase( RTDataMgrBase* rtMgr, STDataMgrBase* stMgr, SymbolMgr* symbolMgr )
{
     //ctor
    m_rtMgr = rtMgr;
    m_stMgr = stMgr;
    m_symbolMgr = symbolMgr;
    m_rt_idx = -1;
    m_rt_time = -1;
    m_isStopProcessFlag = false;
}

LogHistoryBase::~LogHistoryBase()
{
    //dtor
}

DoubleHash* LogHistoryBase::getData(size_t idx)
{
    DoubleHashArray viewerData;

    getHistory(idx,idx,viewerData);

    DoubleHash* dh = NULL;

    if( viewerData.GetCount() > 0 )
    {
        dh = new DoubleHash( *(viewerData[0]) );
        WX_CLEAR_ARRAY( viewerData );
    }

    return dh;
}

void LogHistoryBase::registerLogFilter( LogFilter* logfilter )
{
    m_logfilterA.Add( logfilter );
    Logger::logf(LOG_MSG, _T("LogHistoryBase::registerLogFilter()"));
}


void LogHistoryBase::unregisterLogFilter( LogFilter* logfilter )
{
    m_logfilterA.Remove( logfilter );
    Logger::logf(LOG_MSG, _T("LogHistoryBase::unregisterLogFilter()"));
}

