#include "LogHistoryProcessFilterThread.h"


#include "../logger.h"
#include "LogHistoryBase.h"

LogHistoryProcessFilterThread::LogHistoryProcessFilterThread(LogHistoryBase* mgr, size_t idxfrom, size_t idxto)
                :m_historyMgr(mgr)
                ,m_from(idxfrom)
                ,m_to(idxto)
                ,m_run(false)
{

}

void LogHistoryProcessFilterThread::start()
{
    if(!m_from && !m_to){
        m_to = m_historyMgr->getHistoryCount();
    }

    setDisabled(false);
    this->ProcessBase::start();
}

void LogHistoryProcessFilterThread::stop()
{
    setDisabled(true);
    this->ProcessBase::stop();
    m_run = false;
}

void LogHistoryProcessFilterThread::reset()
{

}

void LogHistoryProcessFilterThread::finished()
{
    // Logger::logf( LOG_MSG, _T("Finished") );
    m_from  = 0;
    m_to    = 0;
    //observerNotify(_T("rtdatastatHelperfinished"));
    setDisabled(true);
    m_run = false;

    observerNotify(_T("LogHistoryProcessFilterThreadFinished"));
}

bool LogHistoryProcessFilterThread::process()
{
    if ( m_isDisabled )
        return false;

    if ( m_run )
        return false;

    Logger::logf( LOG_MSG, _T("LogHistoryProcessFilterThread::process() start") );

    m_historyMgr->processFilter(m_from, m_to);

    Logger::logf(LOG_MSG,_T("LogHistoryProcessFilterThread::process() ended. History loaded"));

    m_run = true;

    return false;
}
