#include "LogHistorySearch.h"

#include <wx/arrimpl.cpp>

#include "../logger.h"
#include "../common/types/DoubleHash.h"

WX_DEFINE_OBJARRAY( SectionArray );

Section DefaultSection = Section(-1,-1);

LogHistorySearch::LogHistorySearch( const wxString& filter, size_t endIdx, SectionArray* externalArr )
    : LogFilter( filter )
{
    m_startIdx = -1;
    m_endIdx = -1;

    m_searchEndIdx = endIdx;

    m_externalIndicesArr = externalArr;
}

void LogHistorySearch::processData( const DoubleHash& data, bool passedfilter )
{
    DoubleHash dh = data;

    size_t rtidx = (size_t)ceil(dh[_T("rtidx")]);

    if ( passedfilter )
    {
        if ( m_startIdx == -1 )
        {
            m_startIdx = rtidx;

        } else if( rtidx == m_searchEndIdx) {

            if(m_externalIndicesArr)
                m_externalIndicesArr->Add( Section(m_startIdx, m_searchEndIdx) );
            else
                m_indices.Add( Section(m_startIdx, m_searchEndIdx) );

        }
    }
    else
    {
        if ( m_startIdx != -1 )
        {
            m_endIdx = rtidx;

            if(m_externalIndicesArr)
                m_externalIndicesArr->Add( Section(m_startIdx, m_endIdx) );
            else
                m_indices.Add( Section(m_startIdx, m_endIdx) );

            m_startIdx = m_endIdx = -1;
        }
    }
}
