#ifndef QUICKANALYZE_H
#define QUICKANALYZE_H

#include "LogHistoryMgr.h"

#include "../Observable.h"
#include "../logger.h"

#include "../common/ProcessBase.h"
#include "../common/types/DoubleHashArray.h"

#include "../rtdatamanager/RTDataAnalyzer.h"


class QuickAnalyze : public ProcessBase, public Observable
{
    public:
        QuickAnalyze( LogHistoryMgr* loghistory, wxString filename );
        ~QuickAnalyze();

        void set(LogHistoryMgr* loghistory, wxString filename);

        void start();
        bool process();
        void stop();
        void reset();
        bool isrunning() { return m_isRunning; }

        static bool isAnalyzed( const wxString& filename );

        enum { QA_FINISHED = 0, QA_CANCELLED };

    protected:
    private:
        wxString        m_filename;
        DoubleHashArray m_datas;

        LogHistoryMgr*  m_loghistory;
        RTDataAnalyzer* m_analyzer;

        size_t          m_rpmMax;
        size_t          m_mapMax;
        size_t          m_triggerError;
        bool            m_hasGPSdata;

        bool            m_isTriggerError;

        bool            m_isCancelled;
        bool            m_isRunning;

        void finished();
};

#endif // QUICKANALYZE_H
