#include "NoProjectDialog.h"

#include <wx/statline.h>
#include <wx/artprov.h>

BEGIN_EVENT_TABLE( NoProjectDialog, wxDialog )
    EVT_BUTTON( ID_OPEN_PROJECT, NoProjectDialog::OnButton )
    EVT_BUTTON( ID_SELECT_PROJECT, NoProjectDialog::OnButton )
    EVT_BUTTON( ID_CANCEL_PROJECT, NoProjectDialog::OnButton )
END_EVENT_TABLE()

NoProjectDialog::NoProjectDialog(   wxWindow* parent,
                                    wxWindowID id,
                                    const wxString& title,
                                    const wxPoint& pos,
                                    const wxSize& size,
                                    long style,
                                    const wxString& name )
{
    Create( parent, id, _T("No project selected!"), pos, size, style, name );
    SetIcon(wxIcon(_T("vemsLogoIcon2")));
    //wxDialog*  dialog = new wxDialog( this, wxID_ANY, _T("No project selected"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("dialogBox") );
    SetSizer( new wxBoxSizer( wxVERTICAL ) );

    wxButton* pOpenButton   = new wxButton( this, ID_OPEN_PROJECT, _T("Open project...") );
    wxButton* pSelectButton = new wxButton( this, ID_SELECT_PROJECT, _T("Select recent project...") );
    wxButton* pCancelButton = new wxButton( this, ID_CANCEL_PROJECT, _T("Cancel") );

    wxBoxSizer* pButtonLineSizer = new wxBoxSizer( wxHORIZONTAL );
    pButtonLineSizer->Add( pOpenButton, 0, wxALL, 5 );
    pButtonLineSizer->Add( pSelectButton, 0, wxALL, 5 );
    pButtonLineSizer->AddStretchSpacer();
    pButtonLineSizer->Add( pCancelButton, 0, wxALL, 5 );

    wxBoxSizer* pMsgLineSizer = new wxBoxSizer( wxHORIZONTAL );

    wxBitmap bitmap = wxArtProvider::GetIcon(wxART_WARNING, wxART_MESSAGE_BOX);
    wxStaticBitmap *icon = new wxStaticBitmap(this, wxID_ANY, bitmap);
    pMsgLineSizer->Add( icon, 0, wxCENTER | wxALL , 5 );
    pMsgLineSizer->AddStretchSpacer();
    pMsgLineSizer->Add( new wxStaticText( this, wxID_ANY, _T("No project selected!") ), 1, wxALIGN_CENTER | wxALL, 5 );

    GetSizer()->Add( pMsgLineSizer, 0, 0, 0 );
    GetSizer()->Add( new wxStaticLine( this ), 0, wxEXPAND | wxALL, 5 );
    GetSizer()->Add( pButtonLineSizer, 0, wxEXPAND, 0 );
    //wxIcon icon( wxICON_WARNING );

    SetInitialSize();
}

NoProjectDialog::~NoProjectDialog()
{
    //dtor
}

void NoProjectDialog::OnButton( wxCommandEvent& event )
{
    EndModal( event.GetId() );
}
