#ifndef PROJECTCHOOSERFRAME_H
#define PROJECTCHOOSERFRAME_H

#include <wx/wx.h>
#include <wx/listctrl.h>
#include <wx/xml/xml.h>

class Project;
class ProjectManager;

class ProjectChooserFrame: public wxDialog
{
    public:
        enum {
            idOkButton,
            idAddButton,
            idCancelButton
        };

        ProjectChooserFrame(ProjectManager *prjmgr, wxWindow* parent = NULL, wxWindowID id = wxID_ANY, const wxString& title = _T("Select a project"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = _T("frame"));
        virtual ~ProjectChooserFrame();

        Project * GetProject() { return m_selectedPrj; };

        bool IsEmpty();

    protected:

        void LoadRecents();

        void AddLineToList(const wxString& name, const wxString& path);
        void InitList();



        bool SelectLine(long id, bool select=true);

        void OnButton(wxCommandEvent &evt);
        void OnListAcitvated(wxListEvent &evt);


        void SelectProject();


        void OnKeyDown(wxKeyEvent &evt);

    private:

      //  wxListBox *     m_projectList;
        wxListCtrl *    m_projectList;

        ProjectManager *m_PrjMgr;

        Project *       m_selectedPrj;



        DECLARE_EVENT_TABLE();
};



#endif // PROJECTCHOOSERFRAME_H
