#include "ProjectConfigHelper.h"
#include "../logger.h"
#include "../common/types/StringHash.h"
#include "../configmanager/ConfigHelper2.h"

void ProjectConfigHelper::getProjectParams(BoolHash* bHash, const wxString& path)
{
    StringHash vHash;

    ConfigHelper2::getEntryHash(path, vHash);

    StringHash::iterator it;
    for(it = vHash.begin(); it != vHash.end(); it++){
        wxString key = it->first;
        wxString valueStr = it->second;
        if(valueStr == _T("0")){
             (*bHash)[key] = false;
        }else{
             (*bHash)[key] = true;
        }
        Logger::logf(LOG_MSG, _T("Helper::getProjectParams() ")+ key +_T(" = %d"), (*bHash)[key]);
    }

    // include additional ini
    #ifdef COMM_MODEL_WITH_GUI
    (*bHash)[_T("COM_MODEL")] = true;
    #endif
}

void ProjectConfigHelper::getProjectParams(BoolHash* bHash)
{
    wxString path = _T("/sessions/params/");    //default
    getProjectParams(bHash, path);
}
