#include "CommunicationThread.h"

#include <wx/wx.h>
#include "../common/ProcessBase.h"
#include "../logger.h"

const wxEventType wxEVT_THREAD = wxNewEventType();

CommunicationThread::CommunicationThread( ProcessBase* commController )
{
    //ctor
    m_controller = commController;
    //m_state = ECUInfo::UNKNOWN;
    m_isSync = true;

    //Logger::logf(LOG_MSG,_T("CommunicationThread Ctor pid=%i"),GetCurrentId());

}

CommunicationThread::~CommunicationThread()
{
    //dtor
    {
        wxCriticalSectionLocker enter(m_controller->m_pThreadCS);

        m_controller->m_pThread = NULL;
        m_controller->s_threadCount--;
        Logger::logf(LOG_MSG,_T("CommunicationThread dtor THREAD COUNT=%i"),m_controller->s_threadCount);
        m_controller->finished();
    }

    //Logger::logf(LOG_MSG,_T("CommunicationThread Dtor pid=%i"),GetCurrentId());


}

void* CommunicationThread::Entry()
{
    m_controller->s_threadCount++;
    Logger::logf(LOG_MSG,_T("CommunicationThread Entry THREAD COUNT=%i"),m_controller->s_threadCount);
    bool res = true;
    while ( !this->TestDestroy() && res )
    {
//        waitEnable();
        res = m_controller->process();
    }
    //wxCommandEvent event( wxEVT_THREAD, wxID_ANY );
    //m_controller->ProcessEvent( event );
    return 0;
}
