#include "FileProducerThread.h"

#include "../logger.h"
//#include "../rtdatamanager/RTDataMgrFacade.h"
#include "../events/InputEvent.h"
#include "../vemsprotocol/VemsLogReader.h"
#include "../vemsprotocol/SIPRTypes.h"

FileProducerThread::FileProducerThread(VemsLogReader* vemsLogReader, wxEvtHandler* eventHandler)
{
    //ctor
    //m_rtDataMgr = rtDataMgr;
    m_vemsLogReader = vemsLogReader;
    m_eventHandler = eventHandler;
    m_disabled = true;
}

FileProducerThread::~FileProducerThread()
{
    //dtor
}

void* FileProducerThread::Entry()
{
    SIPRPacket siprPacket;

    //Logger::logf(LOG_MSG, _T("RingBufferWriterThread::Entry() start"));
    while ( true )
    {
        waitEnable();
        int result = m_vemsLogReader->getNext(siprPacket);
        if( result == -2 ){
            Logger::logf(LOG_MSG, _T("FileProducerThread::Entry::SendThreadStatusFlag"));
            //SendThreadStatusFlag(TS_EXIT);
            //Logger::logf(LOG_MSG, _T("RawToHighLogConverter::Entry: SendThreadStatusFlag2 \n"));
            //m_threadStatus->TSNotify(TS_EXIT);
        }
        if(result < 0){
            Logger::logf(LOG_MSG, _T("FileProducerThread::Entry: before exit"));
            ///m_DataLogWriter->flushBuffers();
            m_vemsLogReader->start();
            //Exit();
            //Logger::logf(LOG_MSG, _T("RawToHighLogConverter::Entry: after exit \n"));

        }else{
            //Logger::logf(   LOG_MSG, _T("FileProducerThread::Entry() - send event - packet type:%d, size: %d"),
             //               siprPacket.type(), siprPacket.size() );
            sendEvent(siprPacket, SIPR_EVENT_TYPE_INPUT);
        }

        //Logger::logf(LOG_MSG, _T("FileProducerThread::Entry() loop"));
        //m_rtDataMgr->updateInputModel(INPUT_TYPE_RINGBUFFER_RAWFILE);
        //Logger::logf(LOG_MSG, _T("FileProducerThread::Entry() start 2"));
        if( siprPacket.type() == SIPR_READ_SENSORS){
            wxThread::Sleep(80);
        }else{
            wxThread::Sleep(10);
        }
        //wxThread::Sleep(1000);
    }
}

void FileProducerThread::sendEvent( const SIPRPacket& packet, int eventType )
{
    InputEvent e;
    e.setPacket( packet );
    e.setType( eventType );
    m_eventHandler->AddPendingEvent( e );
}
