#include "RingBufferReaderThread.h"

#include "../logger.h"
#include "../rtdatamanager/RTDataMgrFacade.h"

RingBufferReaderThread::RingBufferReaderThread()
    :m_ringBuffer (NULL)
    ,m_tc (NULL)
    ,m_mgrBase (NULL)
{
    //ctor
}

RingBufferReaderThread::~RingBufferReaderThread()
{
    //dtor
}

void* RingBufferReaderThread::Entry()
{
    //Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() start"));
     if(m_mgrBase == NULL || m_ringBuffer == NULL || m_tc == NULL){
        Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() NOT INITIALIZED CORECTLY"));
        return false;
    }
    while ( true )
    {

        waitRingBufferNotEmpty();
        waitInputSource();
        waitViewers();

        readRingBuffer();
        //Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() m_isNotFull->Signal()"));
        m_tc->m_isNotFull->Broadcast();
        //Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() m_isNotFull->Signal() 1"));


    }
}

void  RingBufferReaderThread::waitViewers()
{
    while (m_mgrBase->getRegisteredCount() == 0){
   //     Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() waitViewers"));
        m_tc->m_Viewers->Wait();
    }
}

void RingBufferReaderThread::waitRingBufferNotEmpty()
{
     while( m_ringBuffer->isEmpty()  )
        {
    //        Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() isEmpty() "));
            m_tc->m_isNotEmpty->Wait(); // signaled by writer;
      //      Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() isEmpty() released"));
        }
}

void RingBufferReaderThread::waitInputSource()
{
     while( ((RTDataMgrFacade*)m_mgrBase)->getInputType() != INPUT_TYPE_RINGBUFFER )
        {
 //           Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() isNotRingbuffer() "));
            m_tc->m_isRingBuffer->Wait(); // signaled by writer;
   //         Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() m_isRingBuffer() released"));
        }
}

bool RingBufferReaderThread::readRingBuffer()
{
    //Logger::logMilli(LOG_MSG,_T("RingBufferReaderThread::readRingBuffer() START"));
    m_mgrBase->updateViewers();
    //Logger::logMilli(LOG_MSG,_T("RingBufferReaderThread::readRingBuffer() END"));
    /*
    wxThread::Sleep(1500);
    char * desc;
    m_ringBuffer->Read(desc);
    */
    return true;
}

 void RingBufferReaderThread::setRTDataMgrBase(RTDataMgrBase *mgr)
 {
    m_mgrBase = mgr;
 }


void RingBufferReaderThread::setRingBuffer(RingBuffer *rb)
{
    m_ringBuffer = rb;
}


void RingBufferReaderThread::setThreadConditionBase(ThreadConditionBase *cb)
{
    m_tc = cb;
}

