#ifndef RINGBUFFERSYNC_H
#define RINGBUFFERSYNC_H

class wxThread;
class wxCondition;

class RingBuffer;
class SyncObj;

class RingBufferSync
{
    public:
        RingBufferSync(RingBuffer* rb, SyncObj* syncObj);
        RingBufferSync(int bufferCount, int bufferSize);
        virtual ~RingBufferSync();
        /// Producer will use it.
        void waitRingBufferNotFull();
        void nextHeadAndBroadcast();

        //////////////////////////

        /// Consumer will use it.
        void waitRingBufferNotEmpty();
        void nextTailAndBroadcast();

        /// Sync objects
        wxCondition* m_isNotFull;
        wxCondition* m_isNotEmpty;
        RingBuffer* m_ringBuffer;
    protected:
    private:
        SyncObj* m_syncObj;
};
#endif // RINGBUFFERSYNC_H
