#include "SignalProducerThread.h"

#include "RingBuffer.h"
#include "../signalgen/signalgen.h"
#include "../logger.h"

SignalProducerThread::SignalProducerThread(RingBuffer* outputData, SyncObj* syncObj, SignalGen* signalGen)
:RBProducerBase(outputData, syncObj)
{
    //ctor;
    m_signalGen = signalGen;
}

SignalProducerThread::~SignalProducerThread()
{
    //dtor
}

void* SignalProducerThread::Entry()
{

    while(!m_isStoped)
    {
        //Logger::logf(LOG_ERROR, _T("SignalProducerThread! Entry()"));
        waitEnable();
        if(m_ringBuffer->isFull() ){
            //Logger::logf(LOG_ERROR, _T("SignalProducerThread! ringbuffer is full()!"));
        }
        waitRingBufferNotFull();
        if(m_isStoped){
            Logger::logf(LOG_ERROR, _T("SignalProducerThread::Entry() stopped 1!"));
            return 0;
        }

        char* buff = m_ringBuffer->getHeadPointer();

        m_signalGen->generateBlock( (int16_t*) buff, m_ringBuffer->getBufferSize()/4);
        m_ringBuffer->nextHead();
        m_isNotEmpty->Broadcast();


    }
    Logger::logf(LOG_ERROR, _T("SignalProducerThread::Entry() stopped 2!"));
    return 0;
}


