#ifndef THREADBASE_H
#define THREADBASE_H

#include <wx/thread.h>

//class RingBuffer;
class wxCondition;

class ThreadBase:  public wxThread
{
    public:
        ThreadBase();
        virtual ~ThreadBase();
        virtual void* Entry() = 0;
        void setEnable(bool enable, bool isBlocking = false);
        bool isEnable();
        virtual void stop();
     protected:
        void setEnableBlocking(bool enable);
        void waitEnable();

        wxMutex      m_enabledMutex;
        wxMutex      m_waitDisabledMutex;
        wxCondition* m_isNotDisabled;
        wxCondition* m_waitToDisabled;

        bool m_disabled;
        bool m_isWaiting;
        bool m_isStoped;
    private:

};



#endif // RBTHREADBASE_H
