#ifndef RTDATAINPUTGPS_H
#define RTDATAINPUTGPS_H

#include "RTDataInputBase.h"
#include "../GPSInfo.h"
#include <wx/wfstream.h>

class CommunicationBase;
class GpsProtocol;

class RTDataInputGPS: public RTDataInputBase
{
    public:
        RTDataInputGPS(CommunicationBase* commBase, GpsProtocol* pb);
        virtual ~RTDataInputGPS();

        int updateViewerModel(){ return 0; }
        int updateInputModel();
        double getValue(const wxString& symbolname){ return -1;}
        bool isExist(const wxString& symbolname){ return true;}
        bool isValid(){ return true; }
        RTDataInputType getType(){ return INPUT_TYPE_GPS; }
        void reset(){};

        void enableLog( bool enable );
    protected:
    private:
        CommunicationBase*  m_commBase;
        GpsProtocol* m_gps;
        wxFileOutputStream* m_fileOutputStream;
        GPSInfo::State      m_state;
        uint8_t     m_buff;

        char*       m_gpsDataBuffer;        //raw gps data line
        int         m_gpsDataIdx;           //line idx
        bool        m_recording;            //nmea line making started
        bool        m_isLog;

        GPSInfo::State getGPSData();
        GPSInfo::State processGPSData();
};

#endif // RTDATAINPUTGPS_H
