#include "RTDataInputRingBuffer.h"

#include "../logger.h"
#include "../SymbolMgr.h"

RTDataInputRingBuffer::RTDataInputRingBuffer(RingBuffer * rb, SymbolMgr * mt, DoubleHash* viewerModel )
:RTDataRawInputBase( mt, viewerModel )
{
    //ctor
    m_ringBuffer = rb;
}

RTDataInputRingBuffer::~RTDataInputRingBuffer()
{
    //dtor
}


/** @brief isExist
  *
  * @todo: document this function, implement this function ;)
  */
bool RTDataInputRingBuffer::isExist(const wxString& symbolname)
{
    return true;
}

bool RTDataInputRingBuffer::isValid()
{
    return !m_ringBuffer->isFull();
}

/** @brief refresh
  *
  * @todo: invoked only when ringbuffer is not empty
  */
int RTDataInputRingBuffer::updateViewerModel()
{
    Logger::logf(LOG_MSG,_T("RTDataInputRingBuffer::updateViewerModel()"));

    setRTDataBuffer((uint8_t*)m_ringBuffer->getTailPointer(), m_ringBuffer->getBufferSize() );
    fillSymbolValues();
    m_ringBuffer->nextTail();
    return 0; //OK
}


