#ifndef RTDATAINPUTRINGBUFFERRAWFILE_H
#define RTDATAINPUTRINGBUFFERRAWFILE_H

#include "RTDataInputRingBufferSync.h"
#include <wx/file.h>

#include "../Observable.h"

#define HEADERBLOCKSIZE 512

class RTDataInputRingBufferRawFile: public RTDataInputRingBufferSync //, public Observable
{
    public:
        RTDataInputRingBufferRawFile(RingBuffer * rb, SymbolMgr * mt, SyncObj* syncObj, DoubleHash* viewerModel = NULL );
        virtual ~RTDataInputRingBufferRawFile();

        bool SetInputFile(const wxString &filename);
        int ParseHeader();

        RTDataInputType getType();
        int updateInputModel();
        bool isExist(const wxString& symbolname);
        bool isValid();

        unsigned int GetFilePos();
        unsigned int GetFileSize();
        void SetFilePos(double percent);

        void reset();
        wxString getHeaderValue(const wxString& key) const;
    protected:
    private:
        StringHash  m_headerHash;
        wxFile      m_rawFile;
        wxString    m_fileName;

        char m_headerBuffer[HEADERBLOCKSIZE];
        char* m_blockBuffer;
        uint8_t* m_dataBuffer; //realtime data + gps data

        long m_datalen;
        long m_gpsDataLength;
        int  m_gpsBlockIdx;
        long m_blocksize;

        int m_blockIdx;

        bool m_isValid;

        uint32_t m_prevFilePos;

        uint32_t m_seekIdx;
        bool isSettedSeek;

};



#endif // RTDATAINPUTRINGBUFFERRAWFILE_H
