#include "RTDataInputRingBufferSync.h"

#include "../logger.h"

#include "../ringbuffer/SyncObj.h"

RTDataInputRingBufferSync::RTDataInputRingBufferSync(RingBuffer * rb, SymbolMgr * mt, SyncObj* syncObj, DoubleHash* viewerModel )
: RTDataInputRingBuffer( rb, mt, viewerModel )
{
    //ctor
    m_isNotEmpty = syncObj->m_isNotEmpty;
    m_isNotFull =  syncObj->m_isNotFull;

}

RTDataInputRingBufferSync::~RTDataInputRingBufferSync()
{
    //dtor
}

void RTDataInputRingBufferSync::waitRingBufferNotEmpty()
{
    //Logger::logf(LOG_MSG, _T("RTDataInputRingBufferSync::waitRingBufferNotEmpty()"));
    while( m_ringBuffer->isEmpty()  )
    {
        //Logger::logf(LOG_MSG, _T("RTDataInputRingBufferSync::waitRingBufferNotEmpty() isEmpty() "));
        //Logger::logf(LOG_MSG, _T("RingBufferWriterThread::Entry() isEmpty() %p, type=%d"), m_isNotEmpty, getType() );
        m_isNotEmpty->Wait(); // signaled by writer;
        //Logger::logf(LOG_MSG, _T("RingBufferReaderThread::Entry() isEmpty() released"));
        if( !isActive() ) return;
    }
}

void RTDataInputRingBufferSync::waitRingBufferNotFull()
{
    //Logger::logf(LOG_MSG, _T("RTDataInputRingBufferSync::waitRingBufferNotFull()"));
     while( m_ringBuffer->isFull()  )
        {
            //Logger::logf(LOG_MSG, _T("RingBufferWriterThread::Entry() isFull() %p, type=%d"), m_isNotFull, getType() );
            m_isNotFull->Wait(); // signaled by reader;

      //      Logger::logf(LOG_MSG, _T("RingBufferWriterThread::Entry() isFull() released"));
        }
}

/** @brief refresh
  *
  * @todo: invoked only when ringbuffer is not empty
  */
int RTDataInputRingBufferSync::updateViewerModel()
{
    //Logger::logf(LOG_MSG,_T("RTDataInputRingBufferSync::updateViewerModel() START"));
    waitRingBufferNotEmpty();
     if( !isActive() ) return 0;
    //Logger::logf(LOG_MSG,_T("RTDataInputRingBufferSync::updateViewerModel()"));

    setRTDataBuffer((uint8_t*) m_ringBuffer->getTailPointer(), m_ringBuffer->getBufferSize() );
    fillSymbolValues();
    m_ringBuffer->nextTail();

    m_isNotFull->Broadcast();

    return 0; //OK
}
