#ifndef RTDATAINPUTSIGNALGEN_H
#define RTDATAINPUTSIGNALGEN_H

#include "RTDataInputBase.h"
#include "RTDataInputRingBufferSync.h"
#include "../vemsprotocol/Sipr.h"


class SignalProcessThread;

class RTDataInputSignalgen : public RTDataInputRingBufferSync
{
    public:
        RTDataInputSignalgen(RingBuffer* rb, SymbolMgr* mt, SyncObj* syncObj );
        virtual ~RTDataInputSignalgen();

        //void setDataSource( SignalProcessThread * signalprocess ); // hack
        int refresh();

        //int updateViewerModel();
        int updateInputModel();
        double getValue(const wxString& symbolname);
        bool isExist(const wxString&  symbolname);
        bool isValid();
        RTDataInputType getType();
        void reset();
        void setTriggerType(const wxString& type);
        void processPulseTrainPacket(SIPRPacket &pulsePacket);
        void initSignalProcess();

    protected:
        void fillSymbolValues();
    private:
        // double m_mockData;
        SignalProcessThread * m_signalProcess;
};



#endif // RTDATAINPUTSIGNALGEN_H
