#include "RealtimeDataChecker.h"

const size_t MAX_ERROR_COUNT = 5;

RealtimeDataChecker::RealtimeDataChecker( wxEvtHandler* pEventHandler )
{
    m_symbolName    = _T("secl");
    m_previousValue = 0;
    m_errorCount    = 0;
    m_isEnabled     = true;
    m_pEventHandler = pEventHandler;
}


RealtimeDataChecker::~RealtimeDataChecker()
{
}


void RealtimeDataChecker::require()
{
    //m_rtDataMgr->registerSymbol( m_symbolName );
}


void RealtimeDataChecker::unregisterSymbols()
{
    m_rtDataMgr->unregisterSymbol( m_symbolName );
}


void RealtimeDataChecker::refresh( DoubleHash* table )
{
    if( table->find( m_symbolName ) == table->end() ) { return; }

    uint8_t currentValue = (uint8_t)(*table)[m_symbolName];

    //printf( "%d, %d\r", currentValue, m_previousValue );

    if ( ( currentValue == m_previousValue ) || ( currentValue == ( m_previousValue + 1 ) ) )
    {
        m_errorCount = 0;
        //printf( "%d, %d\r", currentValue, m_previousValue );
    }
    else
    {
        ++m_errorCount;

        if ( m_errorCount >= MAX_ERROR_COUNT )
        {
            //send message
            // m_isEnabled = false;
        }
    }
    m_previousValue = currentValue;
}
