#ifndef RTCELLINFO_H
#define RTCELLINFO_H

#include <wx/wx.h>

#include "RTDataStatDistributionWin.h"
#include "../common/types/DoubleArray.h"

class RTCellInfo : public wxPanel
{
    public:
        RTCellInfo(wxWindow* parent, wxWindowID id, wxPoint pos, wxSize size);
        virtual ~RTCellInfo();

        void        setCellInfo(int count, int filteredOut, int outliers, double minval, double maxval, double mean, double variance);
        void        setCellInfo(int count, int filteredOut, int outliers, double minval, double maxval, double ve_mean, double vecorr_mean, double variance);
        void        setUnfilteredInfo( int count, double minval, double maxval, double mean, double sd );
        void        setCellBgColor( wxColor color );
        void        setCellTextColor( wxColor color );
        void        setHistogram( double minval, double maxval, const DoubleArray& data = DoubleArray() );
        void        setChecked( bool isChecked ) { m_checked = isChecked; }

        void        drawGraphs();
        void        showHistogramWindow();

    protected:
    private:
        bool            m_checked;
        int             m_count;
        int             m_filteredOut;
        int             m_outliers;
        double          m_min;
        double          m_max;
        double          m_mean;
        double          m_mean2;
        double          m_variance;

        int             m_unf_count;
        double          m_unf_min;
        double          m_unf_max;
        double          m_unf_mean;
        double          m_unf_variance;

        wxColor         m_cellbgcolor;
        wxColor         m_celltextcolor;
        wxSize          m_size;

        wxWindow*       m_parent;

        RTDataStatDistributionWin*  m_distr_win;

        void            OnPaint( wxPaintEvent& evt );
        void            OnRightClick( wxMouseEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // RTCELLINFO_H
