#ifndef MMCLOGGERMANAGER_H
#define MMCLOGGERMANAGER_H

#include <wx/wx.h>
#include "../common/typedef.h"
#include "../common/ProcessBase.h"
#include "SdImage.h"
#include "../Observable.h"
#include "../ObserverBase.h"
#include "MMCLoggerViewerBase.h"

#include "MMCLoggerExtOverviewFrame.h"


class VemsTuneController;
class CommunicationBase;
class MMCLogger;
class MTConfigData;

class MMCLoggerManager : public ProcessBase, public Observable
{
    public:
        MMCLoggerManager( VemsTuneController * vtc, CommunicationBase* commBase, MTConfigData* mtConfigData, SdImage* source = NULL );
        virtual ~MMCLoggerManager();

        //bool Save(uint32_t startIdx,uint32_t stopIdx,bool needLock=true);
        bool Save(const MMCFilesDesc& mmcFileDesc,  bool needLock = true);

        void StartLog();
        void StopLog();
        int EraseLog(wxWindow * parent);

        void OverViewOld(wxWindow * parent);
        void Summary( MMCFilesDesc *desc, ObserverBase* observerBase, Observable* observable);
        void OverView(wxWindow * parent);
        void OverViewEnd();

        // process
        void    start(const MMCFilesDesc& mmcFileDesc, bool needLock);
        bool    process();
        void    reset();
        void    stop();

    protected:

        void Update(int logtype=1);

        bool StartSession();
        bool EndSession();

    private:
        //bool                wasECUOnline;

        VemsTuneController* m_vemsTuneController;
        SdImage*            m_source;
        MTConfigData*       m_mtConfigData;

        MMCLogger*          m_mmcLog;
        ObserverBase*       m_observer;

        // process
        MMCFilesDesc        m_mmcFileDesc;
        bool                m_needLock;

        void    finished();
        bool    m_run;

};

#endif // MMCLOGGERMANAGER_H
