#ifndef MMCLOGGERV3_H
#define MMCLOGGERV3_H

#include "MMCLogger.h"

class CommunicationBase;
class SymbolMgr;

class MMCLoggerV3 : public MMCLogger
{
    public:
        MMCLoggerV3(CommunicationBase* commBase);
        virtual ~MMCLoggerV3();

        void        start();
        void        stop();

        void        erase();
        bool        getStatus();
        bool        needsUpdate();
        void        flushBuffer();
        bool        getMMCBlock(uint32_t blockIdx, uint8_t* data, int len );

        void        ResetBaudrate();
        void        SetBaudrate();

    protected:
        uint16_t    getCRC(uint8_t* data, int len);

        //bool        isDataValid( uint8_t* data, int len);
        bool        isCRCValid( uint8_t* data, int len);

    private:
        CommunicationBase* m_commBase;
        bool getMMCBlock_priv(uint32_t blockIdx, uint8_t* data, int len );
};

#endif // MMCLOGGERV3_H
