#include <wx/txtstrm.h>
#include "SDProcess.h"
#include "SDCardSaveDialog.h"

SDProcess::SDProcess( SDCardSaveDialog* parent, bool parentClose ) :
    wxProcess( parent ), m_parent( parent ), m_parentClose( parentClose )
{
    Redirect();
}

void SDProcess::OnTerminate( int pid, int status )
{

    // show the rest of the output
    while ( HasInput() )
        ;

    m_parent->OnProcessTerminated( this );

    delete this;
}

bool SDProcess::HasInput()
{
    bool hasInput = false;

    if ( IsInputAvailable() )
    {
        wxTextInputStream tis( *GetInputStream() );
        m_parent->Notify( tis.ReadLine() );

        hasInput = true;
    }

    if ( IsErrorAvailable() )
    {
        wxTextInputStream tis( *GetErrorStream() );

        m_parent->Notify( tis.ReadLine() );

        hasInput = true;
    }

    return hasInput;
}
