#ifndef SERIALHELPER_H
#define SERIALHELPER_H

#include <wx/wx.h>
//#include "serialporthandler.h"

class CommunicationBase;
class SerialConfig;

class SerialHelper
{
    public:
        SerialHelper();
        virtual ~SerialHelper();
        static CommunicationBase* getECUComm();
        static CommunicationBase * getECUCommCTB();

        static void setECUPort(const wxString& comPort);
        static SerialConfig* getECUConfig(){ return m_serialConfigECU; };

        static CommunicationBase* getGPSComm();
        static void setGPSPort(const wxString& comPort);
        static SerialConfig* getGPSConfig(){ return m_serialConfigGPS; };


        static wxArrayString getSerialBaudrates();

    protected:
    private:
        //static wxString PATH_ROUND;
        //static wxString PATH_SMART;
        static SerialConfig* m_serialConfigECU;
        static SerialConfig* m_serialConfigGPS;
        static CommunicationBase* m_ECUComm;
        static CommunicationBase* m_GPSComm;
};

#endif // SERIALHELPER_H

