#ifndef AUDIOPANEL_H
#define AUDIOPANEL_H

#include <wx/wx.h>
#include <wx/bookctrl.h>
#include <wx/tglbtn.h>

class AudioController;
class RpmFromFile;
class Main_Pulse_train;
class SIPRPacket;

class AudioPanel : public wxPanel
{
    public:
        AudioPanel( wxWindow* parent );
        virtual ~AudioPanel();
        AudioController* getAudioController();
        void setRpmSlider(int value){m_rpmSlider->SetValue(value);}
        void processPulseTrainPacket(SIPRPacket &pulsePacket);

    protected:
    private:
        RpmFromFile*    m_rpmFromFile;
        AudioController* m_audioController;
        wxBookCtrl*     m_book;
        wxComboBox*     m_triggerTypeCombo;
        wxComboBox*     m_inputDeviceCombo;
        wxComboBox*     m_outputDeviceCombo;

        wxToggleButton* m_mutePrimSignalButton;
        wxToggleButton* m_muteSecSignalButton;

        wxSlider*       m_volumeSlider;
        wxSlider*       m_rpmSlider;
        wxSlider*       m_deltaMaxClimbSlider;
        wxSlider*       m_SecTrigSlider;

        wxSlider*       m_fluctuatingSlider;

        wxComboBox*     m_sampleRateCombo;
        Main_Pulse_train* m_pulse_train;

        //int m_selectedOutputDevice;

        void initAudioController();
        void initStream();

        void createPlaybackPanel();
        void createAuidoIOPanel();

        void OnComboBoxSelected( wxCommandEvent& event );
        void OnSampleRateSelected( wxCommandEvent& event );
        void OnRpmSliderScroll( wxScrollEvent& event );
        void OnVolumeSliderScroll( wxScrollEvent& event );
        void OnDeltaMaxClimberSliderScroll( wxScrollEvent& event );
        void OnSecTrigSliderScroll( wxScrollEvent& event );
        void OnPlayButton( wxCommandEvent& event );
        void OnFilePlayButton( wxCommandEvent& event );
        void OnPulseTrainButton( wxCommandEvent& event );
        void OnStopButton( wxCommandEvent& event );
        void OnAudioOutputSelected( wxCommandEvent &event );
        void OnAudioInputSelected( wxCommandEvent &event );
        void OnMuteButtons( wxCommandEvent& event );
        void OnFluctuatingScroll( wxScrollEvent& event );
        DECLARE_EVENT_TABLE()
};

#endif // AUDIOPANEL_H
