#ifndef AUDIOTHREAD_H
#define AUDIOTHREAD_H

#include <wx/thread.h>
// #include "../ringbuffer/RingBuffer.h"

#include "../rtdatamanager/RTDataMgrFacade.h"

class RingBuffer;
class SineTest;
class SyncObj;

/**
 * Producer for RingBuffer m_ringBuffer:
 * Records (and in future likely play as well) audio blocks
 * TODO: call FullDuplexTest::fullDuplexTest()  // preferrably do NOT add sound processing directly into this (Thread) class
 */
class AudioThread : public wxThread
{
    public:
        AudioThread( RingBuffer *rbp, SyncObj* syncObj );
        virtual ~AudioThread();
        void* Entry();  // thread essential entry point
        void setRecordFlag(uint8_t flag); // for, true, we will start recording into rbp
        void setRTDataMgrBase( RTDataMgrBase *rtDataMgr);
        void setAudioDevice(int audioDevice);
    protected:
        void startRecording();
        void sineTest();
    private:
            RingBuffer* m_ringBuffer;
            SyncObj*    m_syncObj;
            RTDataMgrBase *m_rtDataMgr;
            uint8_t m_recordFlag;

            SineTest * m_sineTest;
            int m_audioDevice;
};

#endif // AUDIOTHREAD_H
