#ifndef FULLDUPLEXTEST_H
#define FULLDUPLEXTEST_H

//#include <portaudiocpp/System.hxx>

#define RECORD_SECONDS (90)
#define SAMPLE_RATE  (96000)
#define FRAMES_PER_BUFFER (1024)
#define NUM_CHANNELS    (2)
#define PA_SAMPLE_TYPE    portaudio::INT16
//#define PA_SAMPLE_TYPE  paInt16
#define SAMPLE_SILENCE  (0)

#include <math.h>
#include "../common/typedef.h"

#ifndef M_PI
#define M_PI  (3.14159265)
#endif

class SyncObj;
class RingBuffer;

class SineTest
{
    public:
        SineTest(size_t bufferSize, int sampleRate){

            m_bufferSize = bufferSize;
            m_sampleRate = sampleRate;
            m_phase = 0.0;
            m_buff  = new int16_t[m_bufferSize * 2]; // 2 channel

        }

    void setFrequency(double freq){ // in Hz
        m_freq = freq;
    }

    int16_t * generate()
    {

        double sampleCount = (double) m_sampleRate / (double) m_freq;
        double dPhase = 2 * M_PI /sampleCount;

        for(uint32_t i = 0; i < m_bufferSize; i++){
           m_phase += dPhase;
           m_buff[2*i] = (uint16_t) ( 32760.0 * sin(m_phase));
           m_buff[2*i+1] = m_buff[2*i];
        }

        return m_buff;
    }

    private:
        int16_t * m_buff;
        size_t m_bufferSize;
        int m_sampleRate;

        double m_phase;
        double m_freq;
};


class FullDuplexTest
{
    public:
        FullDuplexTest( RingBuffer* rbp, int audioDevice, SyncObj* syncObj);
        virtual ~FullDuplexTest();
        void init();
        void initBuffer();
        void ShowDevices();
        void fullDuplexTest();
    protected:
    private:
         void serialErrorMsgDialog(const char * msg);
         void getAvarage( short * m_sampleBlock,int i);
        // short * m_sampleBlock;
        //MyFrame *m_frame;
        int m_avgLeft;
        int m_avgRight;
        RingBuffer* m_ringBuffer;
        SineTest* m_sineTest;
        int m_audioDevice;
        SyncObj* m_syncObj;

};


#endif // FULLDUPLEXTEST_H
