#ifndef SHOWSPARKPWIDGET_H
#define SHOWSPARKPWIDGET_H
#include "RTSignalViewerBase.h"
#include <wx/dcbuffer.h>
#include <wx/dcmemory.h>
//#include <stdlib.h>
#include <wx/string.h>
#include <wx/font.h>
#include <wx/wx.h>


#define IDX 150 //the long of the "screen"

#define REFRESHTIME 1000 //millisec  (1 millsec - 500000millisec)
#define MISSINGDATACNT 50
#include <wx/control.h>

class UpdateViewerEvent;

class DoubleHash;

struct   statisticsdata_t{
        uint16_t min;
        uint16_t max;
        uint16_t cnt;
};

class ShowSparkPhaseWidget: public wxControl, public RTSignalViewerBase
{
    public:

        ShowSparkPhaseWidget(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = wxPanelNameStr);
        virtual ~ShowSparkPhaseWidget();
        virtual void refresh(DoubleHash* table);
        int updateInputModel();
        void sendInputEvent(int type, int inputEvent);
        bool   isExist(const wxString& symbolname);

    protected:

        int updateViewerModel();
        double getValue(const wxString& symbolname);
        DECLARE_EVENT_TABLE();

        void CopyStData(const statisticsdata_t &from, statisticsdata_t &to);

    private:

        void OnPaint(wxPaintEvent &event);
        void OnWindowCreate(wxWindowCreateEvent& event);
        void OnUpdateValue( UpdateViewerEvent& event );
        void PaintBackGround();
        void getminmax(void);

        uint8_t m_missingRatio;
        uint8_t m_missingRatio2;
        uint8_t m_missingRatio_prev;
        uint8_t m_missingRatio_prev2;
        uint8_t m_missingdata[MISSINGDATACNT];//store data for missingratio calculation
        uint8_t m_missingdata2[MISSINGDATACNT];//store data for missingratio calculation
        uint16_t m_missingPointer;//shows the last data in m_missingdata[]

        uint16_t m_idx;
        uint16_t m_dataidx;
        uint16_t m_changerefresh;
        bool        bgsem;

        uint16_t m_missing_prev;
        uint16_t m_missing_prev2;
        uint16_t m_missing_curr;
        uint16_t m_missing_curr2;

        struct statisticsdata_t m_prevPw;
        struct statisticsdata_t m_prevPw2;
        struct statisticsdata_t m_prevSpark;
        struct statisticsdata_t m_prevSpark2;
        struct statisticsdata_t m_prevDphase;
        struct statisticsdata_t m_prevDphase2;
        struct statisticsdata_t m_prevRpm;
        struct statisticsdata_t m_prevDwell;
        struct statisticsdata_t m_prevDwell2;

        struct statisticsdata_t m_currPw;
        struct statisticsdata_t m_currPw2;
        struct statisticsdata_t m_currSpark;
        struct statisticsdata_t m_currSpark2;
        struct statisticsdata_t m_currDphase;
        struct statisticsdata_t m_currDphase2;
        struct statisticsdata_t m_currRpm;
        struct statisticsdata_t m_currDwell;
        struct statisticsdata_t m_currDwell2;

        bool        m_newDatas;

        wxImage     m_coordsImg;

        wxBitmap    *m_backGround;
        wxDateTime  m_lastTime;
        wxTimeSpan  m_refreshInterval;

        void storeminmax(uint16_t value,struct statisticsdata_t &data);

        wxDateTime m_time;//last paint time
        wxCheckBox* m_checkbox_rpm;
        wxCheckBox* m_checkbox_dwell1;
        wxCheckBox* m_checkbox_spark1;
        wxCheckBox* m_checkbox_missing1;
        wxCheckBox* m_checkbox_dwell2;
        wxCheckBox* m_checkbox_spark2;
        wxCheckBox* m_checkbox_missing2;
        wxCheckBox* m_checkbox_pw1;
        wxCheckBox* m_checkbox_pw2;
        wxCheckBox* m_checkbox_dwellphase1;
        wxCheckBox* m_checkbox_dwellphase2;

};



#endif // SHOWSPARKPWIDGET_H
