#include "SparkTesterWidgetFactory.h"

#include "RTSignalViewerBase.h"

#include "../../rtdatamanager/RTDataMgrBase.h"
#include "../../vemsgauge/vemsgaugedesc.h"

#include "Vems2DHistogramWidget.h"
#include "VemsSignalGridWidget.h"
#include "ShowSparkPWidget.h"
#include "GridByTime.h"
#include "WriteInFileByTime.h"


SparkTesterWidgetFactory::SparkTesterWidgetFactory(wxWindow* parent, RTDataMgrBase* m_rtMgr)
{
    //ctor
    m_parent = parent;
    m_signalProcessMgr = m_rtMgr;

    initGaugeDesc();
}

SparkTesterWidgetFactory::~SparkTesterWidgetFactory()
{
    //dtor
}


void SparkTesterWidgetFactory::ShowWidget(int id)
{

    RTSignalViewerBase* widget;
    wxFrame *tmpframe;

    switch(id){
    case SPARKW_HISTOGRAM_2D:
        tmpframe = new wxFrame(m_parent, wxID_ANY, _T("new widget test"), wxPoint(50,50), wxSize(800,300));

        widget = new Vems2DHistogramWidget(tmpframe, wxID_ANY);
        //m_rtDataMgr2 = m_vemsTuneController->
        widget->SetDataMgr( m_signalProcessMgr );
        widget->RegisterViewer();

        tmpframe->Show(1);
        Logger::logf(LOG_MSG,_T("RegisterSignalViewer = %p"),widget);
        break;
    case SPARKW_GRID:
        widget = new VemsSignalGridWidget(m_parent, wxID_ANY, _T("VemsSignalGridWidget"));
        widget->SetDataMgr(m_signalProcessMgr);
        widget->RegisterViewer();
        Logger::logf(LOG_MSG,_T("RegisterSignalViewer = %p"),widget);
        break;
    case SPARKW_PHASE:
        tmpframe = new wxFrame(m_parent, wxID_ANY, _T("new widget test"), wxPoint(50,50), wxSize(900,800));
        widget = new ShowSparkPhaseWidget(tmpframe, wxID_ANY);
        widget->SetDataMgr( m_signalProcessMgr );
        widget->RegisterViewer();

        tmpframe->Show(1);
        Logger::logf(LOG_MSG,_T("RegisterSignalViewer = %p"),widget);
        break;
    case SPARKW_GRID_BY_TIME:
        widget = new GridByTime(m_parent,wxID_ANY,_T("GridByTime"));
        widget->SetDataMgr( m_signalProcessMgr );
        widget->RegisterViewer();
        break;
    case SPARKW_GAUGE:/*
        GaugeFrame *gaugeFrame;
        gaugeFrame = new GaugeFrame( m_parent, wxID_ANY,_T("title"),wxPoint(0,0), wxSize(200,200),_T("rpm"), m_vemsGaugeDescA );
        //(_T("lambda"));
        Logger::logf(LOG_MSG,_T("SparkMyFrame::OnGaugeTest(wxCommandEvent& event)0"));
//        m_signalProcessMgr->RegisterViewer(gaugeFrame->GetGauge());
        gaugeFrame->GetGauge()->SetDataMgr(m_signalProcessMgr);
        gaugeFrame->Show(true);*/
    case SPARKW_FILE:
        //gaugeFrame = new GaugeFrame( m_parent, wxID_ANY,_T("title"),wxPoint(0,0), wxSize(200,200),_T("rpm"), m_vemsGaugeDescA );
        //WriteInFileByTime* widget_tmp = new WriteInFileByTime();
        widget = new WriteInFileByTime();
        widget->SetDataMgr( m_signalProcessMgr );
        widget->RegisterViewer();
        //(_T("lambda"));
        //Logger::logf(LOG_MSG,_T("SparkMyFrame::OnGaugeTest(wxCommandEvent& event)0"));
//        m_signalProcessMgr->RegisterViewer(gaugeFrame->GetGauge());
        //gaugeFrame->GetGauge()->SetDataMgr(m_signalProcessMgr);
    }


}

void SparkTesterWidgetFactory::initGaugeDesc()
{
        m_vemsGaugeDescA = new VEMSGaugeDescArray();
        VEMSGaugeDesc *gaugeDesc = new VEMSGaugeDesc();

        gaugeDesc = new VEMSGaugeDesc();
        gaugeDesc->SetName(_T("rpm"));
        gaugeDesc->SetSymbolName(_T("rpm"));  //VAR
        gaugeDesc->SetUnit(_T(""));     //units
        gaugeDesc->SetGaugeNumberFormat(_T("%4.3f")); //?? vd  ld -- %4.3f- --
        gaugeDesc->SetTitle(_T("RPM"));
        gaugeDesc->SetMaxValue(11000);
        gaugeDesc->SetLDecimals(0);
        m_vemsGaugeDescA->Add(gaugeDesc);

        gaugeDesc = new VEMSGaugeDesc();
        gaugeDesc->SetName(_T("SparkPhase"));
        gaugeDesc->SetSymbolName(_T("phase"));  //VAR
        gaugeDesc->SetUnit(_T(""));     //units
        gaugeDesc->SetGaugeNumberFormat(_T("%4.3f")); //?? vd  ld -- %4.3f- --
        gaugeDesc->SetTitle(_T("SparkPhase"));
        gaugeDesc->SetMaxValue(720);
        gaugeDesc->SetLDecimals(0);
        //gaugeDesc->SetVDecimals(3);
        //gaugeDesc->SetLDecimals(0);
        m_vemsGaugeDescA->Add(gaugeDesc);

        gaugeDesc = new VEMSGaugeDesc();
        gaugeDesc->SetName(_T("Dwelll"));
        gaugeDesc->SetSymbolName(_T("dwell"));  //VAR
        gaugeDesc->SetUnit(_T(""));     //units
        gaugeDesc->SetGaugeNumberFormat(_T("%4.3f")); //?? vd  ld -- %4.3f- --
        gaugeDesc->SetTitle(_T("Dwelll"));
        gaugeDesc->SetMaxValue(10000);
        gaugeDesc->SetLDecimals(0);
        //gaugeDesc->SetVDecimals(3);
        //gaugeDesc->SetLDecimals(0);
        m_vemsGaugeDescA->Add(gaugeDesc);
}
