#ifndef VEMSSIGNALGRIDWIDGET_H
#define VEMSSIGNALGRIDWIDGET_H

#include "RTSignalViewerBase.h"
#include <wx/wx.h>
#include <wx/grid.h>

class UpdateViewerEvent;

class VemsSignalGridWidget: public wxFrame, public RTSignalViewerBase
{
    public:
        VemsSignalGridWidget(wxWindow* parent, wxWindowID id,const wxString &title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxPanelNameStr);
        virtual ~VemsSignalGridWidget();

        virtual void refresh(DoubleHash* table);

        int updateInputModel();
        void sendInputEvent(int type, int inputEvent);
        bool   isExist(const wxString& symbolname);

    protected:
        int updateViewerModel();
        double getValue(const wxString& symbolname);

    private:
        void addIntValueToCell(int row, int col, int value);
        void addwxStringValueToCell(int row, int col, wxString& value);
        wxString linkwxString(wxString& s1,wxString& s2);
        void OnUpdateValue( UpdateViewerEvent& event );

        wxGrid      *m_grid;

        DECLARE_EVENT_TABLE();
};



#endif // VEMSSIGNALGRIDWIDGET_H
