#include "signalgen.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include "../logger.h"
#define M_PI		3.14159265358979323846


/**
PLEASE NOTE: I've tested this code quite thoroughly and determined that it
does not work as documented. RPM changes cause the trigger spacing to jump.
The cam sync signal does not occur in the correct places for the coil type
and there are other bugs. If you are planning to use this code you may wish
to look at utilities/signalgen for a cleaner implementation.
Michael (hackish@gmail.com)

IMPORTANT Warning !!!
Please do NOT recommit the STL patch to signalgen.cpp
before permission from Marcell or Pacsa, make a branch instead.
We only use STL where the same functionality is not available within wx.
*/

SignalGen::SignalGen()
{
    //ctor
    //filename = new char[FILENAMEMAXLEN];
    //TEST
    //filename = "c:\\tmp\\test.wav";
    //openWavFile();
    //fwrite(&wavheader, sizeof(wavheader), 1, wavout);

/*
    m_triggerTypesChar = new char* [17];

    m_triggerTypesChar[0] = "sine";
    m_triggerTypesChar[1] = "c004";
    m_triggerTypesChar[2] = "c008";
    m_triggerTypesChar[3] =  "c270";
    m_triggerTypesChar[4] =  "m582";
    m_triggerTypesChar[5] =  "m351";
    m_triggerTypesChar[6] =  "f000";
    m_triggerTypesChar[7] =  "e324";
    m_triggerTypesChar[8] =  "s060";
    m_triggerTypesChar[9] =  "m031";
    m_triggerTypesChar[10] =  "m631";
    m_triggerTypesChar[11] =  "c001";
    m_triggerTypesChar[12] =  "m111";
    m_triggerTypesChar[13] =  "c010";
    m_triggerTypesChar[14] =  "l008";
    m_triggerTypesChar[15] =  "c024";
    m_triggerTypesChar[16] =  "m171";
    */
    m_sampleRate = 44100;


    m_secTriggerAngle = 15;
    m_prim_mute = false;
    m_sec_mute = false;
    m_fluctuatingScaler = 0;
    m_oldcamsample = 0;
}

SignalGen::~SignalGen()
{
    //dtor
    //fclose(wavout);
}


/*
gcc  -v
Reading specs from /usr/lib/gcc/i486-linux/3.4.4/specs
Configured with: ../src/configure -v --enable-languages=c,c++,java,f77,pascal,objc,ada,treelang --prefix=/usr --libexecdir=/usr/lib --with-gxx-include-dir=/usr/include/c++/3.4 --enable-shared --with-system-zlib --enable-nls --without-included-gettext --program-suffix=-3.4 --enable-__cxa_atexit --enable-libstdcxx-allocator=mt --enable-clocale=gnu --enable-libstdcxx-debug --enable-java-gc=boehm --enable-java-awt=gtk --disable-werror i486-linux
Thread model: posix
gcc version 3.4.4 20050314 (prerelease) (Debian 3.4.3-12)

but gcc 4.0 seems to show the same problem too
*/

// ==========================================
// returns non-zero if error
// TODO: use strsep or similar instead of strtok
uint8_t SignalGen::parse_tokens( struct tokens_t *token_ptr, char *rpm_str, char *delim)
{
	int i=0;
    int rpm_int;
    char *rpm;

	do{
		rpm = strtok(rpm_str, delim);
		rpm_str = NULL;

		if( rpm == NULL ){
			// fprintf(stdout, "Break");
			break;
		}

		if(sscanf( rpm, "%d", &rpm_int) != 1 ){
   			fprintf (stdout, "bad RPM: %s\n", rpm);
			return 7;
	     	}

		//fprintf(stdout,"rpm_uint: %d", rpm_uint);

		token_ptr->arr[i] = (uint16_t)rpm_int;

		fprintf(stdout, "i: %d => value: %s\n", i, rpm);
		i++;
	} while (i < ARR_MAX_LEN);

	if( i == ARR_MAX_LEN ){
		fprintf( stdout, "WARNING: ARRAY LENGTH MAXIMUM is %d\n", ARR_MAX_LEN );
	}

	fprintf(stdout, "array length (check your compiler or try -O2 if bad): %d\n", i);

	token_ptr->len = i;

	if( i == 0 ){
		fprintf(stdout, "parse_tokens: could NOT parse tokens\n");
		return 9;
	}

	return 0;
}

/* Wrapper to make sure minimum 2 entries always exist
 * this allows easier processing.
 */
uint8_t SignalGen::parse_tokens_min2entries( struct tokens_t *token_ptr, char *str, char *delim )
{
	uint8_t t8;
	uint16_t len;

	fprintf(stdout, "parse_tokens_min2entries, str=%s\n", str );
	t8 = parse_tokens( token_ptr, str, delim );
	//if only 1 entry is given: 400 => 400-400

	fprintf(stdout, "parse_tokens_min2entries, token_ptr=%p\n", token_ptr);
	len = token_ptr->len;
	if( len == 1 ){
		fprintf(stdout,"NO SWEEP (1 parameter)\n");
		token_ptr->len = 2;
	}

	if( len > ARR_MAX_LEN ){
		fprintf( stdout, "WARNING: ARRAY LENGTH MAXIMUM is %d\n", ARR_MAX_LEN );
	}

	// fill in the entry  last (shouldn't be needed theoretically? but won't hurt)
	token_ptr->arr[ len ] = token_ptr->arr[ len - 1 ];

	fprintf(stdout,"end of: parse_tokens_min2entries\n");
	return t8;
}

// positive and negative peaks
#define PEAKPOS 32767
#define PEAKMID 0
#define PEAKNEG	-32767

/*
 * input is 0..65535
 * Output is -32768 or +32767
 * used for missing tooth, and high toothcount coiltype signals
 */
int16_t SignalGen::onetooth(uint16_t phase)
{
#define TRAPEZ 0
// 0 is clean squarewave
// #define TRAPEZ 0x4000
// was original, but that limited RPM with high count toothwheel and 44100 samples/sec
	if( phase < 0x8000 - TRAPEZ ){
		return PEAKNEG;
	}

	if( phase >= 0x8000 + TRAPEZ ){
		return PEAKPOS;
	}

	// TODO: fix if using TRAPEZ != 0 or 0x4000
	return (phase - 0x4000) * 2 ;
}

/*
* elise
* toothcnt = 32
* missing = 4
* normaltooth_amplitude is 0.0 .. 1.0 relative to missing tooth amplitude
*/
int16_t SignalGen::trigger_lotus_elise(struct wheel_param_t *wheel, uint16_t angle, double normaltooth_amplitude)
{
	uint16_t tooth_period;
	uint8_t t8, tooth;
	uint32_t t32;
	uint16_t phase;
	int16_t i16;

	t8 = wheel->toothcnt + wheel->missing;
	tooth_period = 0x8000 / t8;

	// period is 360 crankdeg, not 720:
	angle &= 0x7FFF;

	// decide current tooth:
	tooth = angle / tooth_period;

	if( tooth == 0 || tooth == 14 || tooth == 17 || tooth == 32 ){ // missing tooth
		return PEAKNEG;
	}

	phase = angle % tooth_period;

	t32 = 65535 * phase;
	i16 = onetooth( t32 / tooth_period );
	// normal tooth is faded !!!
	if( tooth != 0 ){
		i16 = (int16_t)( (double)i16 * normaltooth_amplitude);
	}

	return i16;
}

int16_t SignalGen::trigger_missing_tooth( struct wheel_param_t *wheel, uint16_t angle, double normaltooth_amplitude )
{
	uint16_t tooth_period;
	uint8_t t8, tooth;

	t8 = wheel->toothcnt + wheel->missing;
	tooth_period = 0x8000 / t8;

	// period is 360 crankdeg, not 720:
	angle &= 0x7FFF;

	// decide current tooth:
	tooth = angle / tooth_period;

 //   Logger::logf(LOG_MSG, _T("SignalGen::trigger_missing_tooth angle= %d"),angle);
    double scaler=cos (4* M_PI/ (t8) * tooth    );
    angle+=(tooth_period*m_fluctuatingScaler/100 *scaler);
    //Logger::logf(LOG_MSG, _T("SignalGen::trigger_missing_tooth angle2= %d"),angle);

	if( tooth < wheel->toothcnt ){ // normal tooth
		uint32_t t32;
		uint16_t phase = angle % tooth_period;
		int16_t i16;

		t32 = 65535 * phase;
		i16 = onetooth( t32 / tooth_period );
		// normal tooth is faded !!!
		if( tooth != 0 ){
			i16 = (int16_t)( (double)i16 * normaltooth_amplitude);
		}
		return i16;
	} else { // missing tooth
		return PEAKNEG;
	}
}

/*
 * SIMPLE coil type trigger
 */
int16_t SignalGen::trigger_coil( struct wheel_param_t *wheel, uint16_t angle )
{
	// concatenate "missing" so 27,0 becomes 270:
    uint16_t toothcnt = 10 * wheel->toothcnt + wheel->missing;

    if( toothcnt == 0 || toothcnt > 24 ){
        return onetooth( angle * toothcnt );
    }

    uint16_t modulus = conv_degree_angle(720) / toothcnt;
    // low toothcount pulsetrain, use 00000+-00000 pattern
	return trigger_oneshot( modulus == 0 ? angle : angle % modulus, 0 );
}

/* *******************************************************
 input:
	0..65535 is engine phase from 0..720 crankdegrees

	actually, period is 180 degrees, avoid input= 360..720 degrees for now
 output: signal 0..65535 triangle waveform
+60 + 90 + 30 = 180 deg toothwidth
so 0, 60, 150, 180 deg positions

  http://www.vems.hu/wiki/index.php?page=MembersPage%2FFiatStilo
 *****************************************/
int16_t SignalGen::trigger_fiat_stilo( uint16_t angle )
{
	int16_t ret;

	// period is 180 degrees:
	if( angle >= conv_degree_angle(180)){
		angle -= conv_degree_angle(180);
	}

	if( angle >= conv_degree_angle(180)){
		angle %= conv_degree_angle(180);
	}

	ret = trigger_oneshot( angle, 0 );
	if( ret == PEAKMID ) ret = trigger_oneshot( angle, conv_degree_angle(60)); // another chance
    if( ret == PEAKMID ) ret = trigger_oneshot( angle, conv_degree_angle(150)); // third chance

	return ret;
}

int16_t SignalGen::trigger_subaru36222_cam ( uint16_t angle, uint16_t cam_start_pos )
{
	int16_t ret;
	ret = trigger_oneshot( angle, cam_start_pos + conv_degree_angle(690) ); //720-45deg + 15deg(for tdc==first cam trigger tooth meaning)
	if( ret == PEAKMID ) ret = trigger_oneshot( angle, cam_start_pos + conv_degree_angle(150)); // 135 + 15deg another chance
    // if( ret == PEAKMID ) ret = PEAKPOS;
	return ret;
}

int16_t SignalGen::trigger_subaru36222_crank( uint16_t angle )
{
    int16_t i16;
    angle -= conv_degree_angle(4);//cam pulse has 6 deg offset (1+5 see the 5 below)
    angle &= 0x7FFF;
    uint16_t a = angle;
    /* 3 + 12 + 3,   + 15 + 3 */
    if( a>=conv_degree_angle(130) && a <conv_degree_angle(150)
        || a>=conv_degree_angle(310) && a <conv_degree_angle(330)
        || a>=conv_degree_angle(340) && a <conv_degree_angle(360)
        ) return PEAKPOS;

    a = angle % conv_degree_angle(10); // 0..
    double rad = a * 2 * PI / conv_degree_angle(10);  // radian
    // if( a < conv_degree_angle(5)) ...;
    return PEAKPOS * cos ( rad );
    /*
	for (int i=0; i<360; i+=10) {
        if ( (i != 130) && (i != 140) && (i != 310) && (i != 320) && (i != 340) && (i != 350) ) i16 = trigger_oneshot( angle, conv_degree_angle(i) );
        if( i16 != PEAKMID ) return i16;
	}	return i16; */
}

/* VR-like pulse like this: 00000+-00000 */
int16_t SignalGen::trigger_oneshot( uint16_t angle, uint16_t cam_start_pos )
{
	int16_t i16;
        if( angle < (conv_degree_angle(0)+ cam_start_pos)
            || angle > (conv_degree_angle(12) + cam_start_pos) ){
                i16 = PEAKMID;
        }else if (angle < (conv_degree_angle(6)+ cam_start_pos) ){
            i16 = PEAKPOS;
        }else{
            i16 = PEAKNEG;
        }

	return i16;
}

/*
 * HALL signal, 1 pulse per cam-revolution
 * amplitude is 0.0 .. 1.0
 */
int16_t SignalGen::trigger_simple_cam( uint16_t angle, uint16_t cam_start_pos )
{
	int16_t i16;
	// 50% duty in any case
	// non-50% duty can cause difficulties in the analog-signal chain, eg. when
	// simple NPN inverter is used to produce a HALL-type signal,
	// and with 360 crankdegrees length the edge is at the SAME position (relative to primary trigger)
	// regardless of the (often unknown) signal polarity.
	/*
	if( (angle >= cam_start_pos )
		&& (angle < (conv_degree_angle(360) + cam_start_pos)) ){
		i16 = PEAKNEG;
	} else {
		i16 = PEAKPOS;
	}
    But for low toothcount, this is in general better: */
    i16 =  trigger_oneshot( angle, cam_start_pos );
	return i16;
}

/**
* Lancia, Cosworth (2 pulses per camrot, 90 camdegres==180crankdegrees apart)
*/
int16_t SignalGen::trigger_lancia_cam( uint16_t angle, uint16_t cam_start_pos )
{
	int16_t i16;
	i16 = trigger_oneshot( angle, /*conv_degree_angle(0)*/ + cam_start_pos );
	if( i16 == PEAKMID ) i16 = trigger_oneshot( angle, conv_degree_angle(180) + cam_start_pos ); // another chance

    return i16;
}

/*
 * Produce a sine wave scaled to PEAKNEG-PEAKPOS and a given width
 */
int16_t SignalGen::subaru_vr_signal( uint16_t base, uint16_t angle, uint16_t width )
 {

	int16_t i16;
	uint16_t value;
	double scaler;

	value = angle - base;
	scaler = (2.0f*PI) * (1.0f / ((double)width));

	i16 = (int16_t)((sin((double) value * scaler))*(double)PEAKPOS);

	return i16;
}

/*
 * Subaru EJ series VR crank trigger
 * (use same as fiatstilo ! Start from fiatstilo if you want something slightly different)
 * Pattern is | | | | | |
 * Timing is 83,115,170,263,295,350,443,475,530,623,655,710
 * Tooth width is 10 degrees
 * No multiple pulses
 * Period of 720 degrees equals 65535
 * So signals begin on 7555,10467,15474,23938,26851,31857,40322,43235,48241,56706,59619,64625
 * And last for 910

int16_t SignalGen::trigger_subaru_crank( uint16_t angle )
{
	int16_t i16;
	uint16_t teeth[12] = {7555,10467,15474,23938,26851,31857,40322,43235,48241,56706,59619,64625};
	const uint16_t width = 600; // 910;

	// set default value
	i16 = PEAKNEG;

	// iterate over trigger points and look for match
	for (int i=0; i<12; i++) {
		if ((angle >= teeth[i]) && (angle < teeth[i]+width)) {
			i16 = PEAKPOS; // subaru_vr_signal(teeth[i],angle,width);
			break;
		}
	}

	return i16;
}
*/
/*
 * Subaru EJ series VR cam trigger
 * Pattern is ||| | || |
 * Timing is 5,110,200,290,365,470,560,650 where 0 is TDC on cylinder 1
 * Tooth width is measured as 5 degrees of cam rotation, or 2.5 degrees of crank rotation
 * Spacing for multiple pulses is measured as 5 degrees, or 2.5 degrees of crank rotation

 * --So signals begin at 5,15,25,110,200,210,290,365,375,385,470,560,570,650--
 * --Period of 720 degrees equals 65535--
 * --So signals begin on 455,1365,2276,10012,18204,19114,26396,33223,34133,35043,42780,50972,51882,59164--
 * --And last for 455 --

 * BUT cam spins at half crankshaft speed, so cam angle will be half of crank angle and will never pass 360
 * And amplitude will be reduced relative to crank amplitude

 * --Therefore widths and spacings are also halved (amplitude should also be scaled down - halved or squared?)--
 * --So timing is 5,7.5,10,110,200,202.5,290--
 * --And signals begin on 455,683,910,10012,18204,18432,26396--
 * --With width and spacing of 228--
 *
 * TODO: Implement cam_start_pos factor
 */
int16_t SignalGen::trigger_subaru_cam ( uint16_t angle, uint16_t cam_start_pos )
{
	int16_t i16 = PEAKNEG;
	/*
	uint16_t teeth[7] = {455,683,910,10012,18204,18432,26396};
	const uint16_t width = 228;
	 */
	uint16_t teeth[7] = {455,1365,2276,10012,18204,19114,27396};
	// const uint16_t width = 455;
	// uint16_t cam_angle = angle/2;

	// iterate over trigger points and look for match
	for (int i=0; i<7; i++) {
        i16 = trigger_oneshot( angle, cam_start_pos + 2*teeth[i]);
        if( i16 != PEAKMID ) return i16;
	}

	return PEAKMID;
}


/*
 * Wrapper for cam trigger
 */
int16_t SignalGen::cam_trigger_sample( uint16_t angle, uint16_t cam_start_pos, double amplitude )
{
	int16_t i16;
	switch (prim_trig_type) {
		case 's':
            if ( ( wheel.toothcnt == 36 ) && ( wheel.missing == 2 ) ){//s362 (subaru 36-2-2)
                i16 = trigger_subaru36222_cam( angle, cam_start_pos );
            }else{//normal subaru
                i16 = trigger_subaru_cam( angle, cam_start_pos );
            }
			break;
		case 'l':
			i16 = trigger_lancia_cam( angle, cam_start_pos );
			break;
		default:
			i16 = trigger_simple_cam( angle, cam_start_pos );
	}

    // IIR filter to avoid extremely sharp corners:
    int finalcamsample = (int)((double)i16 * amplitude);
    int ocs = 3 * (int)m_oldcamsample + finalcamsample;
    ocs >>= 2;
    m_oldcamsample = ocs;
	return m_oldcamsample;
}

/*
 * setup default wav header
 * mono, 16bit, 44100 SPS
 * wavtools /usr/share/doc/wavtools/WavHeader.txt
 * http://en.wikipedia.org/wiki/WAV
 *
 * TODO: make it work on bigendian
 */
void SignalGen::wavheader_setup( struct wavheader_t *hdr, int length )
{
	int channels=2;
	unsigned char bytespersample = 2 * channels;
	int DataLength = length * bytespersample;
	int samplerate = (int)m_sampleRate;

	hdr->RiffTag[0]='R';
	hdr->RiffTag[1]='I';
	hdr->RiffTag[2]='F';
	hdr->RiffTag[3]='F';
	hdr->FormatTag[0]='W';
	hdr->FormatTag[1]='A';
	hdr->FormatTag[2]='V';
	hdr->FormatTag[3]='E';
	hdr->FormatTag[4]='f';
	hdr->FormatTag[5]='m';
	hdr->FormatTag[6]='t';
	hdr->FormatTag[7]=' ';

	hdr->FileLength = DataLength + 36 ;
	// WARNING!! bad docs suggested +32 :
	// DataLength(bytes) + 32(rest of header)
	// but comparison with good wavs showed that 36 is good

	hdr->FormatLength = 16;
	hdr->DataFormat = 1;
	hdr->NumChannels = channels;
	hdr->SampleRate = samplerate;
	hdr->BytesPerSecond = samplerate * bytespersample;
	hdr->BlockAlignment = bytespersample;
	hdr->SampleDepth = 16;
	hdr->DataLength = DataLength;

	// TODO:DataTag[3] must be wrong in the docs
	hdr->DataTag[0]='d';
	hdr->DataTag[1]='a';
	hdr->DataTag[2]='t';
	hdr->DataTag[3]='a';
}

/*
 * amplitude is 0.0 .. 1.0
 */
int16_t SignalGen::primary_trigger_sample( uint16_t angle, double amplitude, double normaltooth_amplitude )
{
	int16_t i16;

	switch( prim_trig_type ){
		case 'c':
		case 'l':
			i16 = trigger_coil( &wheel, angle );
			break;
		case 'f':
			i16 = trigger_fiat_stilo( angle );
			if( (wheel.toothcnt % 2) == 1){
				i16 = -i16;
			}
			break;
		case 'm':
			i16 = trigger_missing_tooth( &wheel, angle, normaltooth_amplitude );
			break;
		case 'e':
			i16 = trigger_lotus_elise( &wheel, angle, normaltooth_amplitude );
			break;
		case 's':
            if ( ( wheel.toothcnt == 36 ) && ( wheel.missing == 2 ) ){//s362 (subaru 36-2-2)
                i16 = trigger_subaru36222_crank( angle );
            }else{//normal subaru
                i16 = trigger_fiat_stilo( angle ); // trigger_subaru_crank( angle );
            }
			break;
		default:
			i16=0xdead;
	} // switch

	if( prim_trig_polarity ){
		// invert the signal:
		i16 = -i16;
	}

	i16 = (int16_t)((double)(i16) * amplitude);

	return i16;
}

// =======================
void SignalGen::usage(char *progname)
{
	fprintf (stdout, "usage- %s <type> <RPM> <seconds> <sectrig_position> <amplitude> <normal_tooth_relative_amplitude>\n", progname );
	fprintf (stdout, "	most parameters allow constant like 40 or continuous changes with 40-80-85-70 syntax\n" );
	fprintf (stdout, "	specify ALL parameters (amplitude=1000 is normal 100%%)\n" );

	fprintf (stdout, "	60-2 (58+2) at 180-1740 RPM, 60 sec length, sectrig rising edge=15..30crankdeg, amplitude=10%%..100%%, normaltooth=100%% .. 90%%-\n");
	fprintf (stdout, "	signalgen m582 180-1740 60 15-30 100-1000 1000-900\n");
	fprintf (stdout, "	Rev up from 140 to 3000 RPM in 4 steps, holding 200 RPM for a while, sweeping sectrig 20+-5 degree-\n");
	fprintf (stdout, "	signalgen m582 140-200-200-3000 60 15-25-20 1000 1000\n");
	fprintf (stdout, "	type-\n");
	fprintf (stdout, "	c004: coiltype with 4 cyl\n");
	fprintf (stdout, "	c008: coiltype with 8 cyl\n");
	fprintf (stdout, "	c270: auditrigger (1 sectrig pulse for every 270 primtrig pulse)\n");
	fprintf (stdout, "	m582: multitooth 60-2\n");
	fprintf (stdout, "	m351: multitooth 36-1\n");
	fprintf (stdout, "	f000: fiatstilo\n");
	fprintf (stdout, "	e324: Lotus Elise\n");
	fprintf (stdout, "	s060: Subaru EJ series\n");
	fprintf (stdout, "	l008: Lancia/Cosworth 4 crank + 2 cam\n");
	fprintf (stdout, "	capitals for reverse polarity; might be necessary depending on soundcard\n");
}

// --------------------
// like "c270"
void SignalGen::setTriggerType(const char * primstr)
{
    strcpy(type_str, primstr);

	prim_trig_type = type_str[0];

	// m631 means toothcnt=63 missing=1
	wheel.toothcnt=10*(type_str[1]-'0') + type_str[2]-'0';
	wheel.missing=type_str[3] - '0';
//	fprintf(stdout, "primstr=%s, toothcnt=%d, missing=%d\n", primstr, wheel.toothcnt, wheel.missing );

}

/*
void SignalGen::setTriggerType(TriggerType type)
{
	m_triggerType = type;
	if(type == SINE) return;

	const char * primstr = getTriggerTypeAsChar();
	setTriggerType(primstr);
}
*/

// ================
// returns non-0 for error
int SignalGen::process_param( int argc, char **argv )
{

	// argc == 7 is fine ( argv[6] is the last used param ...)
  	if (argc < 7) {
		fprintf(stdout, "NOT enough parameters: %d (min:7)\n", argc);
   		return 2;
   	}

	//type_str=argv[1];
	setTriggerType( argv[1] ); /// set type_str
  	rpm_str = argv[2];
	seconds_str=argv[3];
	campos_str = argv[4];	// same format as rpm_str
	amplitude_str = argv[5];// same format as rpm_str
	fading_str = argv[6];	// same format as rpm_str

#if defined(WIN32)
    _snprintf( filename, FILENAMEMAXLEN, "%s_%s_%s_%s_%s_%s.wav", type_str, rpm_str, seconds_str, campos_str, amplitude_str, fading_str);
#else
	snprintf( filename, FILENAMEMAXLEN, "%s_%s_%s_%s_%s_%s.wav", type_str, rpm_str, seconds_str, campos_str, amplitude_str, fading_str);
#endif


	// for capitals, invert the signal
	if( prim_trig_type <= 'Z' ){
		prim_trig_polarity = 0x80;
		prim_trig_type += 'a' - 'A';
	} else {
		prim_trig_polarity = 0;
	}
	fprintf(stdout, "rpm_str is: %s\n", rpm_str);
	if( parse_tokens_min2entries( &tokens, rpm_str, "-")){
		return 3;
	}

	if(sscanf( seconds_str, "%d", &wav_seconds) != 1 ){
   		fprintf (stdout, "bad length: %s\n", seconds_str );
		wav_seconds=120;
	}

  	fprintf(stdout, "The length of the wav file will be %i seconds\n", wav_seconds);

	fprintf(stdout, "cam_pos_str is: %s\n", campos_str);
	if( parse_tokens_min2entries( &cam_pos_tokens, campos_str, "-")){
      		return 4;
	}

	fprintf(stdout, "amplitude_str is: %s\n", amplitude_str);
	if( parse_tokens_min2entries( &amplitude_tokens, amplitude_str, "-")){
      		return 5;
	}

	fprintf(stdout, "fading_str is: %s\n", fading_str);
	if( parse_tokens_min2entries( &fading_tokens, fading_str, "-")){
      		return 6;
	}

	return 0;
}

/**
position: 0.0 .. 1.0
tokens_ptr : 2000,8000,1000,6000
Calculate the stream postions
*/
double SignalGen::lookup_and_weight( struct tokens_t *tokens_ptr, double position )
{
	uint16_t a1, a2, position_int;
	double position_fract, ret;

	position *= (tokens_ptr->len - 1); // with 3 elements, last indexes to be used are 1, 2 due to cam_position_int= 1.9999
	position_int=(int)position;	// eg 5.0
	position_fract=position - position_int ; // eg 0.8, will be used as weight

	// index checking against cam_pos_tokens.len
	if( position_int == tokens_ptr->len ){ // prevent overindexing
		position_int = tokens_ptr->len - 1;
		/* fprintf(stdout,"position_int adjusted to %d\n", position_int); */
		a1 = a2 = tokens_ptr->arr[position_int];
	} else {
		a1 = tokens_ptr->arr[position_int];
		a2 = tokens_ptr->arr[position_int + 1];
	}

	ret = position_fract * (double)(a2) + (1- position_fract) * (double)(a1);
	// fprintf( stdout, "position_int: %d, a1: %d, a2: %d, ret:%f\n", position_int, a1, a2, ret );
	return ret;
}

/** ===================================
 * (standard-) output is stereo, WAV_SPS SPS (like CD wav)
 * This function does a little too much, should be broken to parts.
 */
int SignalGen::generate_wav_output( void )
{
	double amplitude, normaltooth_amplitude;
	uint16_t i, start_rpm, end_rpm, rpm_now, angle;
  	uint32_t total_samplecount, rpmsweep_samplecount, s;
	double angle_precise, stretch;
	struct wavheader_t wavheader;
	uint16_t rpm_prev; // debugging: RPM goes up, stretch also

	// roughly 2 mins:
	total_samplecount = (uint32_t)(wav_seconds * m_sampleRate);
	rpmsweep_samplecount = total_samplecount / (tokens.len - 1);
	// calculate again, now precise:
	total_samplecount = rpmsweep_samplecount * (tokens.len - 1);
	wavheader_setup( &wavheader, total_samplecount );

	// TODO: mixing write with fprintf might blurp on some systems ?
	i = fwrite(&wavheader, sizeof(wavheader), 1, wavout);
	i = i * sizeof(wavheader);

	fprintf(stdout, "wavheader length=%d (ideally 44 ?)\n", i);
	if ( i < 38 ){
		 return 7;
	}

	rpm_prev = 0; // so we notice if increases (bad during debug)
	angle_precise = 0.0;

	for( i = 0; i < (tokens.len -1); i++){
		int16_t diff_rpm;

		start_rpm = tokens.arr[i];
		end_rpm = tokens.arr[i+1];
		//sectrig_start=cam_pos_tokens.arr[i];
		//sectrig_end=cam_pos_tokens.arr[i+1];

		fprintf (stdout, "start_rpm: %d end_rpm: end_rpm: %d \n", start_rpm, end_rpm);

		// note that it's signed:
		diff_rpm = end_rpm - start_rpm;
		// helper number for inner cycle
		// iterate over as many samples as necessary

		for( s=0 ; s < rpmsweep_samplecount ; s++){
			double position; // 0.0 .. 1.0
			uint16_t t16, fwritten, cam_start_pos;
			int16_t i16;
			// because of the >>8, result would fit in 32 bit (and t64 might be 32 bit actually?)
			double f = (double)(diff_rpm) * (double)(s) / (double)(rpmsweep_samplecount);
			rpm_now = start_rpm + (int)( f );

			// calculate cam_start_pos according to cam_pos_tokens and our position in the stream
			position = (double)(i * rpmsweep_samplecount + s);
			position /= total_samplecount; 	// 0.0 .. 1.0
			cam_start_pos = (uint16_t) conv_degree_angle(
			lookup_and_weight( &cam_pos_tokens, position));

			//We used this for debug
			//if( s==0 ){
			//	fprintf( stdout, "cam_position=%f cam_position_int=%d cam_position_fract=%f a1=%d a2=%d cam_start_pos=%d\n", cam_position, cam_position_int, cam_position_fract, a1, a2, cam_start_pos );
			//}

			// during 60 seconds (WAV_SPS*60 samples) we want to proceed RPM * 32768 angle units,
            // so during 1 sample:
#define MAGIC_CONST_HARD_TO_GET_RIGHT (32768 /60 / WAV_SPS)
			stretch = (double)(rpm_now) * 546.13 / (double)(m_sampleRate); // MAGIC_CONST_HARD_TO_GET_RIGHT;

			// only debugging:
			// if((rpm_now < rpm_prev )){
			// 	fprintf (stdout, "OOPS: stretch or rpm decreased.
			// 	 stretch:%f, rpm_prev:%d, rpm:%d, i:%d, s:%d, f:%f, rpmsweep_samplecount:%d\n"
			// 	, stretch, rpm_prev, rpm_now,     i,    s,    f,    rpmsweep_samplecount );
			// }
			rpm_prev = rpm_now;

			angle_precise += stretch ;
			angle = (int)(angle_precise);

			// fading 0..1000 => desired value ( 0.0 .. 1.0 )
			normaltooth_amplitude = lookup_and_weight( &fading_tokens, position) / 1000.0;

			// LEFT channel is primary trigger:

			// amplitude 0..1000 => desired value ( 0.0 .. 1.0 )
			amplitude = lookup_and_weight( &amplitude_tokens, position) / 1000.0;

			//fprintf(stdout, " %f", amplitude);
			i16 = (int16_t)(primary_trigger_sample( angle, amplitude, normaltooth_amplitude ) );

			fwritten = fwrite( &i16, sizeof(int16_t), 1, wavout);
			if( fwritten < 1 ){
				 fprintf (stdout, "fwrite error\n");
				 return 5;
			}

			// RIGHT channel is secondary trigger:
			// convert to signed format (add 32768)
			t16 = cam_trigger_sample( angle, cam_start_pos, amplitude );

			fwritten = fwrite( &t16, sizeof(uint16_t), 1, wavout);
			if( fwritten < 1 ){
				fprintf (stdout, "fwrite error\n");
			 	return 5;
			}
		}

	}

	if (wavout != stdout) {
		fclose(wavout);
	}

  return 0;
}

void SignalGen::generateFileName()
{
    generateFileName(NULL);
}

void SignalGen::generateFileName(const char * dir)
{
    if(dir != NULL){
        char * filename_clone = strdup(filename);
        //delete[] filename;
/*#if defined(WIN32)
        _snprintf( filename, FILENAMEMAXLEN, "%s%s", dir, filename_clone);
#else
        snprintf( filename, FILENAMEMAXLEN, "%s%s", dir, filename_clone);
#endif*/
		delete filename_clone;
    }
    fprintf(stdout, "Filename: %s\n", filename);
}

bool SignalGen::openWavFile()
{
    wavout = fopen(filename, "wb");
	if(wavout == NULL) {
		fprintf(stdout, "cannot open file %s for writing, reverting to stdout\n", filename);
		//wavout = stdout;
		return false;
	} else {
		fprintf(stdout, "writing to file: %s\n", filename);
		return true;
	}

}

/** ================ Used for generating one triggercycle

 * This started by ripping unneeded parts from a cloned generate_wav_output()
 * so it might be a little clumsy. Live with it.
 * buf: PREallocated buffer (caller's responsibility!)
 * samples: number of 4 byte samples to write to buf
 * rpm: 0..25500 RPM
 * Note that rpmsweep is ripped, which might mean sudden RPM jumps. Readd rpmsweep ?
 *
 * Variables that must be filled, just like before generate_wav_output() :
 * cam_pos_tokens (hint: "30")
 * fading_tokens (hint: "1000")
 * amplitude_tokens (hint: "1000")
 * returns 0 on success
 */
long SignalGen::generate_trigger_cycle( unsigned char *buf, uint32_t samples, uint16_t rpm, const char *type, const char *secondtrg, char* amplitudex )
{
	double amplitude, normaltooth_amplitude;
	uint16_t angle,cam_start_pos;
  	uint32_t i,total_samplecount, s;//, rpmsweep_samplecount;
	double angle_precise, stretch;
    struct wavheader_t wavheader;
	double position = 0.0; // 0.0 .. 1.0
	angle_precise = 0.0;
    FILE *dummy;
    char fading[10]; //fixed linux playback
    strcpy(fading,"1000");

	setTriggerType( (char*)type );

	// for capitals, invert the signal
	if( prim_trig_type <= 'Z' ){
		prim_trig_polarity = 0x80;
		prim_trig_type += 'a' - 'A';
	} else {
		prim_trig_polarity = 0;
	}
	/*fprintf(stdout, "rpm_str is: %s\n", rpm_str);
	if( parse_tokens_min2entries( &tokens, rpm_str, "-")){
		//return 3;
	}*/

	if( parse_tokens_min2entries( &cam_pos_tokens, (char*)secondtrg, "-")){
	//if( parse_tokens_min2entries( &cam_pos_tokens, test, "-")){
      		//return 4;
	}
	if( parse_tokens_min2entries( &amplitude_tokens, amplitudex, "-")){
	//if( parse_tokens_min2entries( &amplitude_tokens, test2, "-")){
      		//return 5;
	}
	if( parse_tokens_min2entries( &fading_tokens, fading, "-")){
      		//return 6;
	}
    //600 rpm = 10rps -> 720deg ->2/10s per cycle = 8820 samples * 2 channels
	total_samplecount = samples;
	wavheader_setup( &wavheader, total_samplecount );

    dummy = tmpfile();
    if(dummy == NULL) {
		fprintf(stdout, "cannot open file for writing\n");
		return 0;
	}
	i = fwrite(&wavheader, sizeof(wavheader), 1, dummy);
	i = i * sizeof(wavheader);
    fprintf(stdout,"\nWavheader %d,%s\n",i,&wavheader);

    rewind (dummy);
    fread (buf,1,i,dummy);

    fprintf(stdout,"Buffer %d,%s\n",i,buf);
    for(uint32_t x=0;x<i;x++)
    {
        fprintf(stdout,"0x%02X,",*buf++);
    }
    fprintf(stdout,"\n");
	fclose(dummy);


   /* FILE *test_file;
    char * filename = "test.wav";
    test_file = fopen(filename, "wb");
    if(test_file == NULL) {
        fprintf(stdout, "cannot open file for writing\n");
    }
    else*/
    {
        /*i = fwrite(&wavheader, sizeof(wavheader), 1, test_file);
        i = i * sizeof(wavheader);*/

        // position = 0.0 means that
        // fading of variables is ripped. Can be moved back inside the cycle later...
        // 0..1000 => desired value ( 0.0 .. 1.0 )
        normaltooth_amplitude = lookup_and_weight( &fading_tokens, position) / 1000.0;
        // amplitude 0..1000 => desired value ( 0.0 .. 1.0 )
        amplitude = lookup_and_weight( &amplitude_tokens, position) / 1000.0;
        cam_start_pos = (uint16_t) conv_degree_angle(lookup_and_weight( &cam_pos_tokens, position));

    #define MAGIC_CONST_HARD_TO_GET_RIGHT (32768 /60 / WAV_SPS)
        stretch = (double)(rpm) * 546.13 / (double)(m_sampleRate);
        for( s=0 ; s < samples ; s++){
            uint16_t t16;//, fwritten;
            int16_t i16;
            angle_precise += stretch ;
            angle = (int)(angle_precise);
            // LEFT channel is primary trigger:
            i16 = (int16_t)(primary_trigger_sample( angle, amplitude, normaltooth_amplitude ) );

            // RIGHT channel is secondary trigger:
            // convert to signed format (add 32768)
            t16 = cam_trigger_sample( angle, cam_start_pos, amplitude );

            // place the 2 samples in the buffer. TODO: byteorder
            *buf++ = i16 & 0xFF; // little endian; prim trigg(left) channel first
            *buf++ = i16 >> 8;
            *buf++ = t16 & 0xFF;
            *buf++ = t16 >> 8;
            i+=4;

            //backtrace
            /*fwritten = fwrite( &i16, sizeof(int16_t), 1, test_file);
            if( fwritten < 1 ){
                 fprintf (stdout, "fwrite error\n");
            }

            fwritten = fwrite( &t16, sizeof(uint16_t), 1, test_file);
            if( fwritten < 1 ){
                fprintf (stdout, "fwrite error\n");
            }*/

        }
        fprintf(stdout,"END generate_trigger_cycle, bytes: %d\n",i);

        //fclose(test_file);
    }
/*
    //Write buf to file for back debug

    FILE *test_file;
    char * filename = "test.wav";
    test_file = fopen(filename, "rb");
    if(test_file == NULL) {
        fprintf(stdout, "cannot open file for reading, reverting to stdout\n");
    } else {

        rewind (test_file);

        // copy the file into the buffer.
        fread (buf,1,i,test_file);

        // Close file
        fclose(test_file);
    }
*/
    /*for(long x=0;x<i;x++)
    {
        fprintf(stdout,"0x%02X,",buf[x]);
    }*/
	return 0; // success
}


void SignalGen::initBlock( uint16_t currentRpm, double currentAmplitude, int sampleRate )
{
    Logger::logf(LOG_MSG, _T("SignalGen::initBlock sampleRate= %d"),sampleRate);

    m_currentRpm        = currentRpm;
    m_currentAmplitude  = currentAmplitude;
    m_sampleRate = sampleRate;

    m_currentAngle      = 0;
    m_deltaMaxClimb     = (12000.0 / m_sampleRate );
    m_expRpm = (uint16_t)m_currentRpm;
    m_expAmp = m_currentAmplitude;

}

void SignalGen::setAmplitude(double endAmplitude)
{
    m_expAmp = endAmplitude;
}

void SignalGen::setRpm(int16_t expRpm)
{
    m_expRpm = expRpm;
}

/**
    generate a block (samples number of samples) into buf
*/
/*
long SignalGen::generateBlock( unsigned char *buf, uint32_t samples)
{
    //600 rpm = 10rps -> 720deg ->2/10s per cycle = 8820 samples * 2 channels
    // position = 0.0 means that
    // fading of variables is ripped. Can be moved back inside the cycle later...
    // 0..1000 => desired value ( 0.0 .. 1.0 )
    double normaltooth_amplitude = m_currentAmplitude;
    // amplitude 0..1000 => desired value ( 0.0 .. 1.0 )

    uint16_t cam_start_pos = 15;

    double deltaRpm = ( m_expRpm  - m_currentRpm ) / samples;

    uint32_t s;

    for( s=0 ; s < samples*4 ; s += 4){
        m_currentRpm += deltaRpm;
        #define MAGIC_CONST_HARD_TO_GET_RIGHT (32768 /60 / WAV_SPS)
        double deltaAngle = m_currentRpm * 546.13 / (double)(WAV_SPS);

        uint16_t t16;//, fwritten;
        int16_t i16;
        m_currentAngle += deltaAngle ;
        int angle = (int)(m_currentAngle);
        // LEFT channel is primary trigger:
        i16 = (int16_t)(primary_trigger_sample( angle, m_currentAmplitude, normaltooth_amplitude ) );

        // RIGHT channel is secondary trigger:
        // convert to signed format (add 32768)
        t16 = cam_trigger_sample( angle, cam_start_pos, m_currentAmplitude );

        // place the 2 samples in the buffer. TODO: byteorder
        buf[s]      = i16 & 0xFF; // little endian; prim trigg(left) channel first
        buf[s+1]    = i16 >> 8;
        buf[s+2]    = t16 & 0xFF;
        buf[s+3]    = t16 >> 8;
    }

	return 0; // success
}
*/

int16_t SignalGen::generateLeftChannel()
{
    //return (int16_t) (32760.0 * m_currentAmplitude * sin(m_currentAngle));

    if (strncmp ( type_str,"sine",4) == 0){
        return (int16_t) (32760.0 * m_currentAmplitude * sin(m_currentAngle));
    }

    int angle = (int) (m_currentAngle/PI_4 * 65535.0);
    return (int16_t)(primary_trigger_sample( angle, m_currentAmplitude, m_currentAmplitude ) );

}

int16_t SignalGen::generateRightChannel()
{
//     double shiftAngle = 15.0/360.0 * 2.0 * M_PI;
//    return (int16_t) (32760.0 * m_currentAmplitude * sin(m_currentAngle-shiftAngle));

     if (strncmp ( type_str,"sine",4) == 0){
        double shiftAngle = 15.0/360.0 * 2.0 * M_PI;
        return (int16_t) (32760.0 * m_currentAmplitude * sin(m_currentAngle-shiftAngle));
     }

    int angle = (int) (m_currentAngle/PI_4 * 65535.0);
    return (int16_t)(cam_trigger_sample( angle, (uint16_t)conv_degree_angle(m_secTriggerAngle), m_currentAmplitude ) );

}

void SignalGen::setdeltaMaxClimb(double deltaMaxClimb)
{
    m_deltaMaxClimb=deltaMaxClimb/m_sampleRate;
}

void SignalGen::setSecTrigAngle(double d)
{
    m_secTriggerAngle = 360-d;
    //Logger::logf(LOG_MSG,_T("SignalGen::setSecTrigAngle: m_secTriggerAngle=%f "), m_secTriggerAngle);
}

long SignalGen::generateBlock( int16_t *buf, uint32_t samples)
{
    double deltaRpm = (m_expRpm  - m_currentRpm ) / samples;
    //Logger::logf(LOG_MSG,_T("SignalGen::generateBlock: currAngle=%f, deltarpm=%f"),m_currentAngle, deltaRpm);

    if( deltaRpm > m_deltaMaxClimb ) deltaRpm = m_deltaMaxClimb ;
    else if( deltaRpm < -m_deltaMaxClimb ) deltaRpm = -m_deltaMaxClimb ;

    double deltaAmp = (m_expAmp  - m_currentAmplitude ) / samples;

    uint32_t s;
    for( s=0 ; s < samples; s++){

        m_currentRpm += deltaRpm;
        m_currentAmplitude+= deltaAmp;
        double freq = m_currentRpm / 60.0;
        double sampleCountPerPeriod = (double)(m_sampleRate) / freq;
        double deltaAngleRad = 2.0 * M_PI / sampleCountPerPeriod;
        m_currentAngle += deltaAngleRad ;
        if(m_currentAngle > PI_4){
            m_currentAngle = m_currentAngle - PI_4;
        }

        buf[2*s] = m_prim_mute ?  0 : generateLeftChannel();
        buf[2*s+1] = m_sec_mute ? 0 : generateRightChannel();

        wxINT16_SWAP_ALWAYS(buf[2*s]);
        wxINT16_SWAP_ALWAYS(buf[2*s+1]);

    }

    //fwrite(buf, sizeof(int16_t), 2*samples, wavout); // FOR Testing
	return 0; // success
}

/*
const char * SignalGen::getTriggerTypeAsChar()
{
    return m_triggerTypesChar[m_triggerType];
}
*/

/*
long SignalGen::generateBlock( int16_t *buf, uint32_t samples)
{

    double deltaRpm = ( m_expRpm  - m_currentRpm ) / samples;
    double shiftAngle = 15/360* 2 *M_PI;

    uint32_t s;
    for( s=0 ; s < samples*4 ; s += 4){
        m_currentRpm += deltaRpm;
        double freq = m_currentRpm / 60.0;
        double sampleCountPerPeriod = (double) WAV_SPS / (double) freq;
        double deltaAngleRad = 2 * M_PI / sampleCountPerPeriod;

        int16_t t16;//, fwritten;
        int16_t i16;
        m_currentAngle += deltaAngleRad ;
        i16 = (32767 * m_currentAmplitude * sin(m_currentAngle));
        t16 = (32767 * m_currentAmplitude * sin(m_currentAngle-shiftAngle));

        buf[s]      = i16 >> 8;
        buf[s+1]    = i16 & 0xFF;

        buf[s+2]    = t16 >> 8;
        buf[s+3]    = t16 & 0xFF;
    }

	return 0; // success
}
*/




