#include "wxSQLite3ExceptionMessageBox.h"

#include <wx/clipbrd.h>

#include "../bcWidgets/bcLabel.h"
#include "../bcWidgets/bcStaticBitmap.h"
#include "../bcWidgets/bcButton.h"
#include "../bcWidgets/bcWrapper.h"

#include "../DrawHelper.h"

BEGIN_EVENT_TABLE(wxSQLite3ExceptionMessageBox,bcParentDialog)


    EVT_BUTTON(idButtonAbort,wxSQLite3ExceptionMessageBox::OnButton)
    EVT_BUTTON(idButtonIgnore,wxSQLite3ExceptionMessageBox::OnButton)
    EVT_BUTTON(idButtonCopy,wxSQLite3ExceptionMessageBox::OnButton)


END_EVENT_TABLE()

wxSQLite3ExceptionMessageBox::wxSQLite3ExceptionMessageBox(wxWindow* parent, wxSQLite3Exception& e)
    :bcParentDialog(parent, wxID_ANY,_T("VemsTune"))
{
    //ctor
    bcStaticBitmap* icon = new bcStaticBitmap(this, wxID_ANY, DrawHelper::GetIconImg(_T("ul-warning-xxl.png")));

    m_msg = _T("Unhandled sqlite exception caught.\n\n");
    m_msg += _T("Error message: ")+e.GetMessage();
    m_msg += _T("\nDatabase: ")+e.GetDatabaseFilename();
    m_msg += _T("\nQuery: ")+e.GetQuery();

    bcLabel* label = new bcLabel(this, wxID_ANY, m_msg);

    bcButton* bAbort = new bcButton(this, idButtonAbort,_T("Abort"));
    bcButton* bIgnore = new bcButton(this, idButtonIgnore,_T("Ignore"));
    bcButton* bCopy = new bcButton(this, idButtonCopy,_T("Copy message to clipboard"));

    wxBoxSizer* mainsizer = new wxBoxSizer(wxVERTICAL);

    wxBoxSizer* headSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* buttonSizer = new wxBoxSizer(wxHORIZONTAL);

    headSizer->Add(new bcWrapper(icon),0, wxALL, 10 );
    headSizer->Add(new bcWrapper(label),0, wxALL, 10 );

    mainsizer->Add( headSizer );

    buttonSizer->Add(new bcWrapper(bAbort),0,wxALL, 5);
    buttonSizer->Add(new bcWrapper(bIgnore),0,wxALL, 5);
    buttonSizer->Add(new bcWrapper(bCopy),0,wxALL, 5);

    mainsizer->Add(buttonSizer, 0, wxALIGN_CENTER_HORIZONTAL);

    SetSizer(mainsizer);
    mainsizer->SetSizeHints(this);
}

wxSQLite3ExceptionMessageBox::~wxSQLite3ExceptionMessageBox()
{
    //dtor
}

void wxSQLite3ExceptionMessageBox::OnButton(wxCommandEvent& evt)
{
    switch(evt.GetId()){
        case idButtonAbort:
            EndModal(wxYES);
            break;
        case idButtonIgnore:
            EndModal(wxNO);
            break;
        case idButtonCopy:
            if(!wxTheClipboard->Open()) return;
            wxTheClipboard->SetData( new wxTextDataObject( m_msg ) );
            wxTheClipboard->Close();
            break;
    }
}
