#include "ModelFilter.h"

void ModelFilter::add( size_t page, size_t offset )
{
    m_filter[page].insert(offset);
}

void ModelFilter::remove( size_t page, size_t offset )
{
    IntToIntSetHash::iterator pageIt = m_filter.find( page );

    if ( pageIt == m_filter.end() ) return;

    pageIt->second.erase(offset);

    if ( pageIt->second.empty() ) { m_filter.erase( pageIt); }
}

void ModelFilter::clear()
{
    m_filter.clear();
}

void ModelFilter::clearPage( size_t page )
{
    m_filter.erase( page );
}

bool ModelFilter::isFiltered( size_t page, size_t offset ) const
{
    IntToIntSetHash::const_iterator pageIt = m_filter.find( page );

    if ( pageIt == m_filter.end() ) return false;
    //return ( m_filter[page].find(offset) != m_filter[page].end() );
    return (  pageIt->second.find(offset) != pageIt->second.end() );
}
