/**
  * \class STDataViewerHash
  *
  * \~english
  * \brief NON-GUI STDataViewer for connect ST and RT models through a DoubleHash
  * \detail
  *
  * \~hungary
  * \brief Nem grafikus statikus ... a RT s az ST modelek sszekapcsolshoz
  *
  */

#ifndef STDATAVIEWERHASH_H
#define STDATAVIEWERHASH_H

#include "STDataViewerBase.h"
#include "../Symbol.h"
#include "../common/typedef.h"
#include "../common/types/DoubleHash.h"

class STDataViewerHash : public STDataViewerBase
{
    public:
        STDataViewerHash( DoubleHash* rtViewerModel );
        virtual ~STDataViewerHash() {}

        /// STDataViewerBase virtual methods
        void update();

        void requestRead() {}
        void updateModel() {}
        void requestWrite() {}

        void setSymbol( const Symbol& symbol_in ) { m_symbol = symbol_in; }
        wxString toString();

    private:
        DoubleHash* m_rtViewerModel;
		uint32_t    getBitValue(uint32_t value);
		Symbol      m_symbol;
};

#endif // STDATAVIEWERHASH_H
