#include "wx/defs.h"
#include <wx/filename.h>

#include <iostream>
using namespace std;

#include "../../logger.h"
#include "../../DirHelper.h"

#include "../../expression/ExpressionFvGetGPSDistance.h"
#include "../../expression/ExpressionFvGetGPSCourse.h"


int main( int argc, char **argv )
{
    wxFileName tmp = wxFileName( wxString::FromAscii( argv[0] ) );
    DirHelper::SetProgramRootDir( tmp.GetPath() );

    double d  = ExpressionFvGetGPSDistance::calculateDistance( 56.0178, 12.19302, 56.017600, 12.193020 );
    double c  = ExpressionFvGetGPSCourse::getCourse( 56.017800, 12.193020, 56.017600, 12.193020 );
    Logger::logf( LOG_MSG, _T(" distance = %f, course = %f"), d, c );

    double lat1 = 0.0;
    double lon1 = 0.0;
    double lat2 = 0.0;
    double lon2 = 0.0;
    char ch = 'y';

    while( ch == 'y' )
    {
        cout << "Enter  lat1 :";
        cin >> lat1;
        cout << "Enter  lon1 :";
        cin >> lon1;
        cout <<"Enter  lat2 :";
        cin >>lat2;
        cout << "Enter  lon2 :";
        cin >> lon2;

        d  = ExpressionFvGetGPSDistance::calculateDistance( lat1, lon1, lat2, lon2 );
        c  = ExpressionFvGetGPSCourse::getCourse( lat1, lon1, lat2, lon2 );

        Logger::logf( LOG_MSG, _T(" distance = %f, course = %f"), d, c );
        printf( "new calculation? [ y / n ] :");

        getchar();
        ch = getchar();
    }

    return 0;
}

