#include "evalpanel.h"


int idSetTableButton = wxNewId();
int idRefreshButton = wxNewId();

BEGIN_EVENT_TABLE(EvalPanel, wxPanel)
    EVT_BUTTON(idSetTableButton, EvalPanel::OnSetTableButton)
    EVT_BUTTON(idRefreshButton, EvalPanel::OnRefreshButton)
END_EVENT_TABLE()

EvalPanel::EvalPanel(wxWindow* parent, wxWindowID id):wxPanel(parent,id)
{
    m_parser = NULL;
    buildGUI();
}

EvalPanel::~EvalPanel()
{
    //dtor
}

void EvalPanel::buildGUI()
{
    wxBoxSizer* top         = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* list        = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* controls    = new wxBoxSizer(wxHORIZONTAL);

    m_table  = new wxListCtrl(this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLC_REPORT);
    list->Add(m_table,1,wxEXPAND|wxALL,5);

    wxButton* setTableButton = new wxButton(this, idSetTableButton,_T("SetTable"),wxDefaultPosition,wxDefaultSize);
    controls->Add(setTableButton, 0, wxRIGHT, 5);

    wxButton* refreshButton = new wxButton(this, idRefreshButton,_T("Refresh"),wxDefaultPosition,wxDefaultSize);
    controls->Add(refreshButton, 0, wxRIGHT, 5);

    top->Add(list,1,wxEXPAND|wxALL,5);
    top->Add(controls,0,wxEXPAND|wxALL,5);

    SetSizer(top);
    top->Fit(this);
    top->SetSizeHints(this);
}


void EvalPanel::setTable()
{
    m_table->InsertColumn(m_table->GetColumnCount(), _T("Name"));
    m_table->InsertColumn(m_table->GetColumnCount(), _T("Type"));
    m_table->InsertColumn(m_table->GetColumnCount(), _T("Value"));

    SymbolTable& symbolTbl = m_parser->getMTConfigData()->getSymbolTable();

    for(SymbolTable::iterator it = symbolTbl.begin();it != symbolTbl.end(); it++){
        Symbol* sym = it->second;
        long idx = m_table->InsertItem(0,sym->getName());
        m_table->SetItem(idx, 1, sym->getType());
    }
}

void EvalPanel::OnSetTableButton(wxCommandEvent& event)
{
    wxMessageBox(wxString::Format(_T("Id : %d"), event.GetId()));
    setTable();
}

void EvalPanel::OnRefreshButton(wxCommandEvent& event)
{
//    wxMessageBox(_T("start refreshing"));
//    m_parser->getMTConfigData()->refresh();
}
