#include "TbTbLogRepeat.h"

#include "../loghistory/FilePlayCommander.h"
#include "../DirHelper.h"
#include "../logger.h"

enum ToolBitmapIds
{
    TBI_LOGREPEAT_INACTIVE,
    TBI_LOGREPEAT_ACTIVE
};

IMPLEMENT_DYNAMIC_CLASS( TbTbLogRepeat, VemsToolBarToolBase );

TbTbLogRepeat::TbTbLogRepeat( int id ) :
        VemsToolBarToolBase( id ),
        m_fpc ( NULL )
{
    m_bmpKeyListArray[TBI_LOGREPEAT_INACTIVE].Add( DirHelper::GetPath(dICON) + _T("tbRepeatInactive48.png"));
    m_bmpKeyListArray[TBI_LOGREPEAT_ACTIVE].Add( DirHelper::GetPath(dICON) + _T("tbRepeatActive48.png"));

    m_repeatOn = false;
}

TbTbLogRepeat::~TbTbLogRepeat()
{
    if ( m_fpc )
    {
        m_fpc->unregisterTool( this );
    }
}


void TbTbLogRepeat::OnTool( wxCommandEvent &event )
{
    if ( m_fpc )
    {
        if ( m_repeatOn )
        {
            SetToolBmp( m_bmpHash[TBI_LOGREPEAT_INACTIVE] );
            m_fpc->setRepeat( false );
            m_repeatOn = false;
        }
        else
        {
            SetToolBmp( m_bmpHash[TBI_LOGREPEAT_ACTIVE] );
            m_fpc->setRepeat( true );
            m_repeatOn = true;
        }
    }

    m_shortHelpString = _T("Repeat on/off");

    InitHelpStrings();
}

void TbTbLogRepeat::Init()
{
    InitBmpRes();

    m_defaultBitmap = m_bmpHash[TBI_LOGREPEAT_INACTIVE];
    m_inactiveBitmap = m_bmpHash[TBI_LOGREPEAT_INACTIVE];

    m_shortHelpString = _T("Repeat on/off");
    m_longHelpString  = _T("Repeat on/off");

    AddRequest( TN_FilePlayCommander );
}

void TbTbLogRepeat::OnToolR( wxCommandEvent &event )
{
}

bool TbTbLogRepeat::SendObject( int id, wxObject *object, const wxString &message )
{
    switch( id )
    {
        case TN_FilePlayCommander:
            m_fpc = dynamic_cast<FilePlayCommander*>(object);

            if ( !m_fpc )
            {
                LOGP(_T("Cannot cast to FilePlayCommander"))
                return false;
            }

            m_fpc->registerTool( _T("Repeat"), this );

            m_toolBar->EnableTool( m_toolID, false );

            SetToolBmp( m_bmpHash[ TBI_LOGREPEAT_INACTIVE ] );

            break;

        default:
            break;
    }

    return true;
}
