#include "TbTbStop.h"

#include "../DirHelper.h"

#include "../loghistory/FilePlayCommander.h"

#include "../logger.h"

/** \class TbTbStop
  *
  * \~english
  * \brief Stop the log replay
  * \details
  *
  *
  * \~hungarian
  * \brief Leállítja a log visszajátszást
  * \details
  *
  *
  */

enum ToolBitmapIds
{
    TBI_STOP_INACTIVE,
    TBI_STOP_ACTIVE
};

IMPLEMENT_DYNAMIC_CLASS(TbTbStop,VemsToolBarToolBase)

TbTbStop::TbTbStop(int id)
        :   VemsToolBarToolBase(id),
            m_fpc( NULL )

{
    //ctor
    m_bmpKeyListArray[TBI_STOP_ACTIVE].Add( DirHelper::GetPath(dICON) + _T("tbStopActive48.png"));
    m_bmpKeyListArray[TBI_STOP_INACTIVE].Add( DirHelper::GetPath(dICON) + _T("tbStopInactive48.png"));
}

TbTbStop::~TbTbStop()
{
    if ( m_fpc )
    {
        m_fpc->unregisterTool( this );
    }
}

void TbTbStop::OnTool(wxCommandEvent &event)
{
    if ( m_fpc )
    {
        m_fpc->Stop();
    }
}

void TbTbStop::Init()
{

    InitBmpRes();

    m_defaultBitmap = m_bmpHash[TBI_STOP_ACTIVE];

    m_inactiveBitmap = m_bmpHash[TBI_STOP_INACTIVE];

    m_shortHelpString = _T("Stop");
    m_longHelpString  = _T("Stop log");

    AddRequest(TN_FilePlayCommander);
}

bool TbTbStop::SendObject( int id, wxObject *object, const wxString &message )
{
    switch( id )
    {
        case TN_FilePlayCommander:
            m_fpc = dynamic_cast<FilePlayCommander*>(object);

            if ( !m_fpc )
{
                LOGP(_T("Cannot cast to FilePlayCommander"))
                return false;
            }

            m_fpc->registerTool(_T("Stop"), this);

            m_toolBar->EnableTool( m_toolID, false );
            break;

        default:
            break;
    }

    return true;
}
