#ifndef TRIGGERFRAMEFSM_H
#define TRIGGERFRAMEFSM_H


#include "../common/typedef.h"
#include "../common/types/IntArray.h"

class TriggerFrameBase
{
    public:
        TriggerFrameBase();
        virtual ~TriggerFrameBase();
        virtual bool parse(uint8_t data) = 0;
        virtual const IntArray& getFrame() const =0;
        virtual int getType() const = 0;
        virtual void intArrayToByte( uint8_t* desc ) = 0;
    protected:

};

class TriggerFrameFSM : public TriggerFrameBase
{
    public:
        TriggerFrameFSM();
        virtual ~TriggerFrameFSM();
        bool parse(uint8_t data);
        const IntArray& getFrame() const;
        int getType() const;
        void intArrayToByte( uint8_t* desc );

    protected:
        enum { FRAME_END, WAIT, RECEIVED_ESC};
        int m_state;
        void reset();
        IntArray m_frame;
};

class TriggerFrameFSMCRC : public TriggerFrameBase
{
    public:
        TriggerFrameFSMCRC();
        virtual ~TriggerFrameFSMCRC();
        bool parse(uint8_t data);
        const IntArray& getFrame() const;
        int getType() const;
        void intArrayToByte( uint8_t* desc );
    private:
        TriggerFrameFSM m_trFrameFSM;
        bool checkCRC(const IntArray& frame) const;

};

#endif // TRIGGERFRAMEFSM_H
