#ifndef TRIGGERLOGSAVEAUDIO_H
#define TRIGGERLOGSAVEAUDIO_H

#include "../common/types/DoubleArray.h"
#include "../Observable.h"
#include <wx/file.h>

class TriggerLogSaveAudio : public Observable
{
    public:
        TriggerLogSaveAudio( DoubleArray& primary, DoubleArray& secondary );

    public:
        bool saveToRaw( const wxString& filename );
        bool saveToWaw( const wxString& filename );

    private:
        wxFile          m_file;
        DoubleArray&    m_primary;
        DoubleArray&    m_secondary;

        unsigned int    m_samplerate;
        signed short    m_on, m_off;

        double          m_step;

        size_t          m_sampleNo;

    private:
        bool    createFile( const wxString& name );
        bool    writeHeader();
        bool    writeData();
        void    getSampleNo();

};

#endif // TRIGGERLOGSAVEAUDIO_H
