#include "TriggerLogSelector.h"

int idTLS_V3    = wxNewId();
int idTLS_File  = wxNewId();
// int idTLS_TailedFile  = wxNewId();

/// event table

BEGIN_EVENT_TABLE( TriggerLogSelector, wxDialog )

    EVT_BUTTON( idTLS_V3, TriggerLogSelector::OnButton )
    EVT_BUTTON( idTLS_File, TriggerLogSelector::OnButton )
    // EVT_BUTTON( idTLS_TailedFile, TriggerLogSelector::OnButton )

END_EVENT_TABLE()

///

TriggerLogSelector::TriggerLogSelector( wxWindow* parent ) :
    wxDialog( parent, -1, _T("Trigger log source"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE|wxFRAME_FLOAT_ON_PARENT )
{
    wxBoxSizer* mainsizer = new wxBoxSizer( wxVERTICAL );

    wxStaticBoxSizer* ssizer = new wxStaticBoxSizer( wxHORIZONTAL, this, _T("Select source for trigger log"));

    wxButton* b_v3 = new wxButton( this, idTLS_V3, _T("V3"));
    wxButton* b_file = new wxButton( this, idTLS_File, _T("Log file"));
    // wxButton* b_tailedFile = new wxButton( this, idTLS_TailedFile, _T("Tailed Log file"));

    ssizer->Add( b_v3, 0, wxEXPAND | wxALL, 5 );
    ssizer->Add( b_file, 0, wxEXPAND | wxALL, 5 );
    // ssizer->Add( b_tailedFile, 0, wxEXPAND | wxALL, 5 );

    wxSizer* bsizer = CreateButtonSizer( wxCANCEL );

    mainsizer->Add( ssizer, 0, wxALL | wxEXPAND | wxALIGN_CENTER, 0 );
    mainsizer->Add( bsizer, 0, wxALL | wxEXPAND, 5 );

    SetSizer( mainsizer );
    mainsizer->Fit( this );
    mainsizer->SetSizeHints( this );

    m_tlogsource = TLOG_CANCEL;
}

TriggerLogSelector::TLOG_SOURCE TriggerLogSelector::GetTriggerLogSource()
{
    return m_tlogsource;
}

/// event handlers

void TriggerLogSelector::OnButton( wxCommandEvent& evt )
{
    int id = evt.GetId();

    if ( id == idTLS_File ) m_tlogsource = TLOG_FILE;
    if ( id == idTLS_V3 ) m_tlogsource = TLOG_V3;
    // if ( id == idTLS_TailedFile ) m_tlogsource = TLOG_TAILED_FILE;

    EndModal( m_tlogsource );
}
