#ifndef TRIGGERLOGSETTINGSHELPER_H
#define TRIGGERLOGSETTINGSHELPER_H

#include <wx/wx.h>
#include "../common/types/Int2wxColorHash.h"
#include "../common/types/Int2StringHash.h"
#include "../common/types/IntArray.h"
#include "../common/types/Int2DoubleHash.h"

class TriggerLogSettingsHelper
{
    public:
        TriggerLogSettingsHelper();

        static  wxColor             tLog_bg;
        static  wxColor             tLog_scope;
        static  wxColor             tLog_text;

        static  Int2wxColorHash     tLogColors;
        static  Int2StringHash      tLogNames;
        static  IntArray            tLogEventsOrder; // order of events in setting dialog
        static  Int2DoubleHash      tLogVerticalOffsets;

        static  bool    saveSettings( const wxString& filename );
        static  void    loadSettings( const wxString& filename );

        static  void    setDefaults();
};

#endif // TRIGGERLOGSETTINGSHELPER_H
