#include "TriggerLogTail.h"

#include <wx/wfstream.h>
#include <wx/datetime.h>
#include <wx/filename.h>

#include "../logger.h"

TriggerLogTail::TriggerLogTail(const wxString& fileName, wxEvtHandler* evtHandler)
:TriggerLogEvt(evtHandler)
{
    //ctor

    m_name = fileName;
    m_fileName = new wxFileName(fileName);

    m_idx = 0;
    m_prevMod = NULL;
/*
    if ( !wxFileExists( fileName ) ){
        Logger::logf(LOG_MSG, _T("TriggerLogTail::TriggerLogTail() - file does not exist:") + fileName );
        return;
    }

    m_inputStream = new wxFFileInputStream(fileName);

*/




    Start(200, false);
}

TriggerLogTail::~TriggerLogTail()
{
    //dtor
    //delete m_inputStream;
}

void TriggerLogTail::start()
{
    Start(200, false);
}

void TriggerLogTail::stop()
{
    Stop();
}


void TriggerLogTail::read()
{

   // if ( !m_fileName->IsFileReadable() ){
   //     Logger::logf(LOG_MSG, _T("TriggerLogTail::TriggerLogTail() - file does not exist:") + fileName );
   //     return;
   // }

    wxInputStream* is = new wxFFileInputStream(m_name);

    is->SeekI(m_idx);
    //uint8_t data = 0;
    while( is->CanRead() ){

        uint8_t tmp = 0;
        is->Read( &tmp, 1);
        if( is->LastRead() ){
            parseTrigger(tmp);
            //Logger::logf(LOG_MSG, _T("TriggerLogTail::read() read: %i, %c"), tmp, tmp);
            //data = tmp;
        }
    }

    m_idx = is->TellI();
    //Logger::logf(LOG_MSG, _T("TriggerLogTail::read() finised: %i, %i, %c"),  m_idx, data, data);
    delete is;

}

void TriggerLogTail::Notify()
{

    if( !m_fileName->IsFileReadable() ) return;

    wxDateTime  currMod = m_fileName->GetModificationTime();
    if(m_prevMod == NULL){
        m_prevMod = new wxDateTime(currMod);
        read();
        return;
    }

    if( !m_prevMod->IsEarlierThan(currMod) ) return;

    /// file has been modified
    Logger::logf(LOG_MSG, _T("TriggerLogTail::Notify() new data found")  );
    read();
    *m_prevMod = currMod;
}
