#include "unidlg.h"

#include <wx/intl.h>
#include <wx/xrc/xmlres.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/filename.h>
#include <wx/stattext.h>

#include "helper.h"

#include "firmware.h" ///!!!
/*

Verify:

Base_dir:___:(dirselect)
Hexfile:__:(fileselect)
----------

MakeConfig:

Base dir:____: (exist/not) (dirselect)
exe:__		(e/n ) fileselect
Config:__:	(cfg) fileselect
global: string,
----------


MakeTable:


new UnivDlg("tile", ...);

UnivDlgList().AddRow("msg", default, type);
type= FILE_SELECT, DIR_SELECT, TXT_ENTRY, RO_ENTRY, SHOW_EXIST,


UniVDlg( dlgList() );

*/
//UniDlgItemStrHash UniDlg::itemHashStr;

UniDlg::UniDlg(wxWindow* parent,
        const wxString& title,
        const wxString& xrc,
         const wxString& xmlkey)
{
    wxString _C = _T("UniDlg ");
    wxString defCwd = wxFileName::GetCwd();

    Helper::log(LOG_MSG, _C+_T("dir: ") + defCwd);

    wxXmlResource::Get()->InitAllHandlers();
 //   wxXmlResource::Get()->Load(_T("wxsmith/edit_path.xrc"));
 //   wxXmlResource::Get()->LoadDialog(this, parent, _T("dlgEditPath"));

    //wxXmlResource::Get()->Load(_T("wxsmith/VerifyDialog.wxs"));
    //wxXmlResource::Get()->LoadDialog(this, parent, _T("VerifyDialog"));

    //wxXmlResource::Get()->Load(_T("wxsmith/MakeConfig.wxs"));

    wxXmlResource::Get()->Load(xrc);
    wxXmlResource::Get()->LoadDialog(this,parent, xmlkey);

     Helper::log(LOG_MSG, _C+_T("xrc: ") + xrc);
     Helper::log(LOG_MSG, _C+_T("xmlkey: ") + xrc);

#if defined(wxUSE_UNICODE) && wxUSE_UNICODE
    if(xmlkey.IsSameAs(_T("unidlg-4")))
    {
        XRCCTRL(*this, "unidlg-4", wxDialog)->SetTitle(title);
    }
    else if(xmlkey.IsSameAs(_T("unidlg-5")))
    {
        XRCCTRL(*this, "unidlg-5", wxDialog)->SetTitle(title);
    }
    else if(xmlkey.IsSameAs(_T("unidlg-2")))
    {
        XRCCTRL(*this, "unidlg-2", wxDialog)->SetTitle(title);
    }
    //XRCCTRL(*this, xmlkey, wxDialog)->SetTitle(title); //On Linux it gives: error: 'Lxmlkey' was not declared in this scope
#else
    XRCCTRL(*this, xmlkey, wxDialog)->SetTitle(title); //On Linux it gives: error: 'Lxmlkey' was not declared in this scope
#endif

	//ctor



/*
	XRCCTRL(*this, "dlgEditPath", wxDialog)->SetTitle(title);

    m_topSizer = (wxBoxSizer *) this->GetSizer();
*/
//    itemHash.clear();
//    m_idx =0;

    this->Connect( -1,
    wxEVT_UPDATE_UI, wxUpdateUIEventHandler(UniDlg::OnUpdateUI) );

    setUploadEvent();



    topSizer = (wxBoxSizer *) this->GetSizer();

}

UniDlg::~UniDlg()
{
    //dtor
}

/*
void UniDlg::AddItemRow(UniDlgRow& itemRow){

    fprintf(stderr, "UniDlg::AddItemRow START\n");

    wxBoxSizer * rowSizer = new wxBoxSizer(wxHORIZONTAL);

    //item.getMsg();
//    wxStaticText * txt = new wxStaticText(this, wxNewId(), label, wxDefaultPosition, wxDefaultSize,0);


    //rowSizer->Add(txt);
    //itemRow.getID();

    for(int i =0;i < itemRow.GetCount(); i++){
        UniDlgItem *item = itemRow.getItem(i);
        wxWindow *w = item->getWindowItem();
        //rowSizer->Add(w, *item->getSizerFlags() );
        rowSizer->Add(w, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

        fprintf(stderr, "UniDlg::AddItemRow count %i\n",i);
        if( item->isButton() ){
            fprintf(stderr, "UniDlg::AddItemRow  isButton OK\n");
            int id  = w->GetId();
            fprintf( stderr, "UniDlg::AddItemRow event id: %i\n", id);
            AddEvent(id);
            //unsigned int uid = (unsigned int) id
            itemHash[id] = item;
            //fprintf( stderr, "UniDlg::AddItemRow event id: %i\n", uid);

//            wxString tmp;
//            tmp.Printf("%i",i);
//            itemHashStr[tmp] = item;

        }
        bool isTextCtrl = w->IsKindOf(CLASSINFO(wxTextCtrl));
        if(isTextCtrl){
             fprintf( stderr, "UniDlg::AddItemRow isTextCtrl TRUE \n");
            wxString wName = ((wxTextCtrl*)w)->GetName();
            ((wxTextCtrl*)w)->SetValue(valueHash[wName]);
        }

    }

    m_topSizer->Insert(m_idx, rowSizer, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);
    m_topSizer->Fit(this);
	m_topSizer->SetSizeHints(this);
    m_idx++;
}
*/

int UniDlg::setUploadEvent()
{
    wxWindow* w =  FindWindowByName(_T("UploadButton"), this);
    if(!w) return -1;
    int id = w->GetId();
    this->Connect( id,
    wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(UniDlg::OnUpload) );
    return 0;
}

int UniDlg::Hide(const wxString& name)
{
    wxWindow* w =  FindWindowByName(name, this);
    if(!w) return -1;
    w->Show(false);
    return 0;
}

void UniDlg::AddEvent(int id){
    this->Connect( id,
    wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(UniDlg::OnBrowse) );
}

void UniDlg::setValue(const wxString & key, const wxString & value){
      valueHash[key] = value;
      dirHash[key] = false;
      fileHash[key] = false;

    wxString _C = _T("UniDlg ");
    wxString _F = _T("setValue ");
    Helper::log(LOG_MSG, _C+_F+_T("key: ") + key);

    wxWindow* w =  FindWindowByName(key, this);
    if(!w) return;

    bool isTextCtrl = w->IsKindOf(CLASSINFO(wxTextCtrl));
    if(isTextCtrl){
        fprintf( stderr, "UniDlg::AddItemRow isTextCtrl TRUE \n");
        ((wxTextCtrl*)w)->SetValue(value);
    }
    bool isStaticText = w->IsKindOf(CLASSINFO(wxStaticText));
    if(isStaticText){
        fprintf( stderr, "UniDlg::AddItemRow isStaticText TRUE \n");
        ((wxTextCtrl*)w)->SetLabel(value);
    }
    bool isButton = w->IsKindOf(CLASSINFO(wxButton));
    if(isButton){
        fprintf( stderr, "UniDlg::AddItemRow isButton TRUE \n");
        ((wxButton*)w)->SetLabel(value);
    }

    topSizer->Fit(this);
	topSizer->SetSizeHints(this);
}

wxString UniDlg::getValue(const wxString & key){
    return  valueHash[key];
}

bool UniDlg::isDirSelect(const wxString& key){
    return dirHash[key];
}

void UniDlg::setIsDirSelect(const wxString& key, bool b){
    dirHash[key] = b;
    //else dirHash[key] = 0;
    if(!b) return;

    wxWindow* w =  FindWindowByName(key, this);
    if(!w) return;
    fprintf(stderr, "UniDlg::setIsDirSelect: key FOUND\n");
    int id = w->GetId();
    fprintf(stderr, "UniDlg::setIsDirSelect: id: %i\n", id);
    AddEvent(id);
}

bool UniDlg::isFileSelect(const wxString& key){
    return fileHash[key];
}

void UniDlg::setIsFileSelect(const wxString& key, bool b){
    fileHash[key] = b;
    //else dirHash[key] = 0;
    if(!b) return;

    wxWindow* w =  FindWindowByName(key, this);
    if(!w) return;
    fprintf(stderr, "UniDlg::setIsDirSelect: key FOUND\n");
    int id = w->GetId();
    fprintf(stderr, "UniDlg::setIsDirSelect: id: %i\n", id);
    AddEvent(id);
}

void UniDlg::joinList(const wxString& key, const wxString& ctrl){
        joinListHash[key] = ctrl;
}

void UniDlg::join(const wxString& key, const wxString& ctrl){
        joinHash[key] = ctrl;

    //AddOnTextChangeEvent(ctrl)
    wxWindow* w =  FindWindowByName(ctrl, this);
    if(!w) return;

    int id = w->GetId();
    this->Connect( id,
    wxEVT_COMMAND_TEXT_UPDATED, wxCommandEventHandler(UniDlg::OnTextChange) );
}

wxString UniDlg::getJoin(const wxString& key){
    return joinHash[key];
}

void UniDlg::setFilter(const wxString& key, const wxString& filter){
    filterHash[key] = filter;
}

wxString UniDlg::getFilter(const wxString& key){
    return filterHash[key];
}

void UniDlg::OnTextChange(wxCommandEvent& event)
{
    int id  = event.GetId();

    wxWindow * w = FindWindow(id);
    wxString windowName = w->GetName();

    bool isTextCtrl = w->IsKindOf(CLASSINFO(wxTextCtrl));
    if(isTextCtrl){
        wxString value = ((wxTextCtrl*) w)->GetValue();
        wxString _C = _T("UniDlg ");
        wxString _F = _T("OnTextChange ");
        Helper::log(LOG_MSG, _C+_F+_T("windowName: ") + windowName +_T("value: ")+ value);

        valueHash[windowName] = value;
    }
}

void UniDlg::OnBrowse(wxCommandEvent& event)
{
    wxString _C = _T("UniDlg ");
    wxString _F = _T("OnBrowse ");

    int id  = event.GetId();
    fprintf( stderr, "UniDlg::OnBrowse event id: %i\n", id);
    wxWindow * w = FindWindow(id);

    //UniDlgItem * item = itemHash[id];
    if(!w){
        /*
        UniDlgItemHash::iterator it;
        for( it = itemHash.begin(); it != itemHash.end(); ++it )
        {
            int ikey = it->first;
             //UniDlgItem * item = it->second;
             fprintf( stderr, "UniDlg::OnBrowse key: %i\n", ikey);
        // do something useful with key and value
        }
        fprintf( stderr, "UniDlg::OnBrowse  NULL item hash size: %i\n", itemHash.size() );


        UniDlgItemStrHash::iterator its;
        for( its = itemHashStr.begin(); its != itemHashStr.end(); ++it )
        {
            wxString key = its->first;
             UniDlgItem * item = its->second;
             fprintf( stderr, "UniDlg::OnBrowse key: %s\n", key.c_str() );
        // do something useful with key and value
        }
        fprintf( stderr, "UniDlg::OnBrowse  NULL item hash size: %i\n", itemHashStr.size() );
        */
        return;
    }
    wxString baseDir = _T("");
    wxString wName = w->GetName();
    wxString message;

    wxString baseListName = joinListHash[wName];
    fprintf( stderr, "UniDlg::OnBrowse 130\n");
    wxWindow* w2 = FindWindowByName(baseListName, this);
    fprintf( stderr, "UniDlg::OnBrowse 140\n");
    if( w2 != NULL){
        bool isTextCtrl = w2->IsKindOf(CLASSINFO(wxTextCtrl));
        fprintf( stderr, "UniDlg::OnBrowse 150\n");
        if(isTextCtrl){
            baseDir = ((wxTextCtrl*) w2)->GetValue();
        }
    }else{
        baseDir = valueHash[baseListName];
        wxString msg = _T("UniDlg::OnBrowse Not a valid window item basedir: ") + baseDir;
        Helper::log(LOG_MSG, msg);
    }
    fprintf( stderr, "UniDlg::OnBrowse 160\n");

    wxString filter = getFilter(wName);

    if( isDirSelect(wName) ){
         message = _T("Directory select:");
         wxString path = Helper::ChooseDirectory(this, message, baseDir,
                baseDir, false, false);

        if (path.IsEmpty()){
            return;
        }
        //Populate the text control!!
        wxString jName = getJoin(wName);
        wxTextCtrl* tmpCtrl = (wxTextCtrl*) FindWindowByName(jName, this);
        //wxTextCtrl* tmpCtrl = (wxTextCtrl*) FindWindow(item->getPutValueID());
        tmpCtrl->SetValue(path);

        wxString windowName = tmpCtrl->GetName();
        valueHash[windowName] = path + wxFileName::GetPathSeparator();

    }    else if( isFileSelect(wName) )
    {
    //    item.GetMessage();
    //    item.getFilter();
    message = _T("File select:");
    wxString path =    v3FileDialog(message, baseDir, filter, 0);
    if(path.IsEmpty() ) return;

    Helper::log(LOG_MSG, _C+_F+_T("path: ") + path );

        //wxWindow::FindWindowByName();
        wxString jName = getJoin(wName);
        wxTextCtrl* tmpCtrl = (wxTextCtrl*) FindWindowByName(jName, this);
        if(!tmpCtrl) return;
    Helper::log(LOG_MSG, _C+_F+_T("wName: ") + wName +_T("jname: ") + jName);

        tmpCtrl->SetValue(path);

        wxFileName pathName = wxFileName::FileName(path);
        pathName.MakeRelativeTo(baseDir);
        tmpCtrl->SetValue(pathName.GetFullPath());

         fprintf(stderr, "UniDlg::OnBrowse path20:\n");
        wxString windowName = tmpCtrl->GetName();
        valueHash[windowName] = pathName.GetFullPath();
        wxString msg = _T("UniDlg::OnBrowse valueHash key: ") +windowName +_T(" value: ") + pathName.GetFullPath();
        Helper::log(LOG_MSG, msg);
    }




     //XRCCTRL(*this, "txtPath", wxTextCtrl)->SetValue(result);

}



wxString UniDlg::v3FileDialog(wxString & message, wxString& defaultDir, wxString & filter, bool multiSel){

wxFileDialog dlg(this, message, defaultDir,
                wxEmptyString, filter, wxCHANGE_DIR | (multiSel ? wxMULTIPLE : 0) );

wxString path = wxEmptyString;
//        PlaceWindow(&dlg);
        if (dlg.ShowModal() == wxID_OK)
        {
//           if (multiSel)
//                dlg.GetPaths(multiSel);
//            else
                path = dlg.GetPath();
        }
        return path;
}

void UniDlg::OnUpdateUI(wxUpdateUIEvent& event)
{
     //fprintf(stderr, "UniDlg::OnUpdateUI \n");
    wxButton* btn = (wxButton*)FindWindow(wxID_OK);
 //   if (btn)
 //       btn->Enable(! XRCCTRL(*this, "txtPath", wxTextCtrl)->GetValue().IsEmpty() );
}
/*
void UniDlg::OnUpload(wxCommandEvent& event)
{
    Helper::log(LOG_MSG, _T("UniDlg::OnUpload") );

        wxString baseDir = getValue(_T("baseDirCtrl"));
        wxString headerFile = getValue(_T("fileCtrl"));
        wxString configFile = getValue(_T("file2Ctrl"));
        wxString tableFile = getValue(_T("file3Ctrl"));

        ValueHash* vHash = Helper::getCurrValues();
        (*vHash)[_T("base_dir")] = baseDir ;
        (*vHash)[_T("header_txt")] = headerFile;
        (*vHash)[_T("config_txt")] = configFile;
        (*vHash)[_T("tables_txt")] = tableFile;

    Firmware* fv = new Firmware();
//    fv->configParseAndUpload(UPLOAD_TABLE|UPLOAD_CONFIG);
    delete fv;

}
*/
