#include "wx/defs.h"
#include <wx/filename.h>

#include "logger.h"
#include "DirHelper.h"
#include "MTConfigHelper.h"
#include "FirmwareInfo.h"
#include "Symbol.h"
#include "firmwareconfig/ConfigValidator.h"
#include "vemsprotocol/SIPRDescriptor.h"
#include "stdatamanager/STDataModelSerial.h"
	
#include <iostream> 

int main( int argc, char **argv )
{
    wxFileName exeFileName = wxFileName( wxString::FromAscii( argv[0] ) );
    DirHelper::SetProgramRootDir(exeFileName.GetPath());

	wxString logFileName = DirHelper::GetPath(dDEBUGLOG) + _T("v3_subprj_rpn_filelog.txt");
    Logger::initLog( logFileName );
	
	Logger::log( LOG_MSG, _T("Expression tester!") );

	MTConfigHelper::createMTConfigData();

	FirmwareInfo fwInfo;
	fwInfo.setFirmwareVersion(_T("1.1.86"));
	MTConfigHelper::parseMTConfigData( fwInfo );

	MTConfigData* configData = MTConfigHelper::getMTConfigData();
	SIPRDescriptor* siprDesc = configData->getSIPRDescriptor();
	SymbolTable& symbolTbl = configData->getSymbolTable();

	STDataModelSerial  deviceModel( symbolTbl, siprDesc );
	
	ConfigValidator cfgValidator;

	for ( size_t i = 0; i < 1000; ++i ){
		cfgValidator.validate( &deviceModel );
	}
	
	getchar();

	//char ch;

	//while ( ( ch = getchar() ) != 'x' ) {
	//	cfgValidator.validate( &deviceModel );
	//}

	MTConfigHelper::cleanup();

    return 0;
}
