#ifndef CHECKBOXMATRIXVIEWER_H
#define CHECKBOXMATRIXVIEWER_H

#include <wx/panel.h>
#include "StaticViewersController.h"
#include "../ObserverBase.h"


#include "../Symbol.h"
#include "../stdatamanager/STDataViewerBase.h"
#include "../common/types/IntArray.h"
#include "../common/types/wxObjectArray.h"


class STDataMgrBase;
class CheckBoxMatrix;
class EconosealPanel;
class STViewerCBMatrix;
class CommandRequestBase;

class CheckBoxMatrixDesc : public wxObject
{
    DECLARE_CLASS(CheckBoxMatrixDesc)
    public:
     CheckBoxMatrixDesc();
        virtual ~CheckBoxMatrixDesc();
        wxString m_maskHeaderName;
        wxString m_groupHeaderName;

        wxString m_title;
        wxString m_name;
        wxString m_help;
        wxString    m_SymbolName;
        wxArrayString m_groupNames; // row
        wxArrayString m_groupColors;

        wxArrayString   m_maskNames;
        IntArray        m_maskPinNumbers;
        IntArray        m_maskValues;
        //wxArrayString m_; // colors

};



class CheckBoxMatrixViewer : public wxPanel, public StaticViewersController, public ObserverBase
{
    public:
        CheckBoxMatrixViewer( CheckBoxMatrixDesc* desc,
                     STDataMgrBase* stController,
                     CommandRequestBase* requestMgr,
                     SymbolMgr* symbolmgr,
                     wxWindow* parent);

        virtual ~CheckBoxMatrixViewer();
        static CheckBoxMatrixDesc* getTestDesc();

        void setValue(size_t offset, int value);
        int getValue(int offset);

        void setOutputName( int row, const wxString& value, bool isConflicted, wxString conflicts = wxEmptyString );

        /// ObserverBase
        void notify( int i );
        void notify(int row, int col);
        void notify(const wxString& str);
        void Init(const wxString& name, const wxString& msg, const int max){};
        CheckBoxMatrix* getCBMatrix() { return m_checkBoxMatrixpanel;};

    protected:
    private:
        CheckBoxMatrixDesc* m_pDesc;
        CheckBoxMatrix* m_checkBoxMatrixpanel;
        EconosealPanel* m_econosealPanel;
        STViewerCBMatrix* m_stViewer;
        wxComboBox* m_testMode;
        bool m_isChecked;
        CommandRequestBase* m_requestMgr;
        SymbolMgr* m_symbolMgr;

        void buildGUI();

        void OnComboBox( wxCommandEvent& event );

        DECLARE_EVENT_TABLE()

};

class STViewerCBMatrix: public STDataViewerBase
{
    public:
        STViewerCBMatrix(const Symbol& s, CheckBoxMatrixViewer* cbViewer, SymbolTable* symTable );

        void update();
        void requestRead() {}
        void updateModel();
        void requestWrite();
        wxString toString();

    private:
        CheckBoxMatrixViewer*   m_cbViewer;
        Symbol                  m_symbol;
        SymbolTable*            m_symbols;
        wxObjectArray           m_dbnames;
};

#endif // CHECKBOXMATRIXVIEWER_H
