#ifndef DIFFERENTCONFIGDIALOG_H
#define DIFFERENTCONFIGDIALOG_H


#include <wx/wx.h>


#include "../bcWidgets/bcParentPanel.h"


class bcStaticBitmap;


enum DifferentConfigResponse{
    DCR_WRITE,
    DCR_REFRESH,
};


class DcHeadPanel: public bcParentPanel
{
    public:
        DcHeadPanel(wxWindow* parent, int id, int target = DCR_WRITE);
        virtual ~DcHeadPanel() {};

        void SetTarget(int target);

    protected:

    private:

        wxString GetTargetIconFile(int target);

        bcStaticBitmap* m_icon;

};

class DifferentConfigDialog: public wxDialog
{
    public:
        DifferentConfigDialog(wxWindow* parent, int id = wxID_ANY, const wxString& title = _T("Config") );

        virtual ~DifferentConfigDialog();

        void BuildGui();

        int GetChoosed();

    protected:

        void OnRadio(wxCommandEvent& evt);

    private:

        enum {
            idRbWrite = 2000,
            idRbRefresh,
        };

        wxRadioButton* m_rbWrite;
        wxRadioButton* m_rbRefresh;

        DcHeadPanel*    m_headPanel;

        DECLARE_EVENT_TABLE();
};



#endif // DIFFERENTCONFIGDIALOG_H
