#ifndef ECONOSEALPANEL_H
#define ECONOSEALPANEL_H

#include <wx/wx.h>
#include "../agg/wxAgg.h"

class EconosealPanel: public wxPanel
{
    public:
        EconosealPanel(wxWindow *parent, size_t pincount = 36, size_t linecnt = 3,int id = wxID_ANY, const wxPoint& pos = wxDefaultPosition);
        virtual ~EconosealPanel();

        void SetPinColor(size_t pin, const wxColor &color, bool refresh = true);
        void ClearPin(size_t pin);
        void ClearAllPin();

        void ShowPinNumbers(bool show);

    protected:

        void OnPaint(wxPaintEvent &evt);

        void Init();

    private:

        wxBitmap  *     m_backGround;
        wxBitmap  *     m_pinBmp;
        wxBitmap  *     m_pinNumbersBmp;
        wxAgg       *   m_aggCanvas;

        bool            m_showPinNumbers;

        size_t          m_pinCount;
        double          m_pinRadius;
        size_t          m_lineCount;
        double          m_pinDistance;
        RealPointArray  m_pinCenters;


        DECLARE_EVENT_TABLE();

};

#endif // ECONOSEALPANEL_H
