#ifndef SIZEPOSDIALOG_H
#define SIZEPOSDIALOG_H

#include <wx/wx.h>

class SizePosDialog: public wxDialog
{
    public:
        SizePosDialog(wxWindow * parent);
        virtual ~SizePosDialog();

        void SetValues( wxWindow * win ) { SetValues(win->GetPosition(), win->GetSize()); };

        void SetValues( const wxPoint &pos, const wxSize &size ) { SetValues(pos.x, pos.y, size.x, size.y); }

        void SetValues( int xpos, int ypos, int width, int height );

        void SetToWindow( wxWindow * win = NULL );

        wxPoint GetTargetPosition();
        wxSize GetTargetSize();

    protected:
    private:

        wxTextCtrl * m_xposCtrl;
        wxTextCtrl * m_yposCtrl;
        wxTextCtrl * m_widthCtrl;
        wxTextCtrl * m_heightCtrl;

};

#endif // SIZEPOSDIALOG_H
