#ifndef USERDIALOGBASE_H
#define USERDIALOGBASE_H
#include <wx/wx.h>

class UserDialogBase : public wxEvtHandler
{
    DECLARE_DYNAMIC_CLASS(UserDialogBase)

    public:
        UserDialogBase();
        virtual ~UserDialogBase();
        virtual void showDialog( const wxString& menuName, const wxString& symbolsToMark = wxEmptyString ) = 0;
        virtual void unActivate(int id) = 0;

        virtual void refreshMenu( wxMenuBar* menuBar ) = 0;

        virtual void changeToPreviousDialog( const wxString& dialogName ) = 0;
        virtual void changeToNextDialog( const wxString& dialogName ) = 0;

        wxWindow * GetDialogParent() { return m_window; };

        void setSymbolsToMark( const wxArrayString& symbols ) { m_symbolsToMark = symbols; }

    protected:
        wxWindow* m_window;
        wxArrayString m_symbolsToMark;

    private:
};

#endif // USERDIALOGBASE_H
