#include "UserDialogFrameBase.h"


#include "../common/FunctionMeter.h"
#include "UserDialogBase.h"
#include "StaticViewersController.h"
#include "StaticControlPanel.h"
#include "DialogsLayoutManager.h"
#include "../common/HelpUtil.h"



#include "../common/FileDropTarget.h"

#include "../logger.h"

int ID_STATIC_CONTROL_PANEL2 = wxNewId();

BEGIN_EVENT_TABLE(UserDialogFrameBase, wxFrame )
    EVT_CLOSE(UserDialogFrameBase::OnClose)
    EVT_ACTIVATE(UserDialogFrameBase::OnActivate)
END_EVENT_TABLE()
/*
UserDialogFrameBase::UserDialogFrameBase( wxWindow* parent, StaticViewersController* stViewersCtrl, const wxString& title)
    : wxFrame( parent, wxID_ANY, wxEmptyString,  wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE | wxFRAME_FLOAT_ON_PARENT )
{
    m_stViewersCtrl = stViewersCtrl;
    m_dlgLayoutMgr = NULL;
    m_ctrlPanel = NULL;

    this->SetSizer( new wxBoxSizer( wxVERTICAL ) );
    m_menuId = 0;
#ifndef __WINCE_STANDARDSDK__
    new FileDropTarget<UserDialogFrameBase>( this );
#endif

//    wxString title = desc->getTitle();
    addControlPanel( m_stViewersCtrl, StaticControlPanel::DEFAULT_IMPORT_BUTTONS );
    setLayout( title );
}
*/

UserDialogFrameBase::UserDialogFrameBase( wxWindow* parent, ConfigValidatorBase* validator, DialogsLayoutManager * dlglayoutmgr )
    : wxFrame( parent, wxID_ANY, wxEmptyString,  wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE | wxFRAME_FLOAT_ON_PARENT )
{
    m_stViewersCtrl = NULL;
    m_dlgLayoutMgr = dlglayoutmgr;
    m_ctrlPanel = NULL;
    m_validator = validator;

    this->SetSizer( new wxBoxSizer( wxVERTICAL ) );
    m_menuId = 0;
#ifndef __WINCE_STANDARDSDK__
    new FileDropTarget<UserDialogFrameBase>( this );
#endif
}

UserDialogFrameBase::~UserDialogFrameBase()
{
    if(m_dlgLayoutMgr){
        m_dlgLayoutMgr->SaveLayout( this );
    }
}

void UserDialogFrameBase::setMenuId(int id)
{
    m_menuId = id;
}
/*
void UserDialogFrameBase::addCtrl(StaticViewersController* stViewersCtrl, const wxString title)
{
    m_stViewersCtrl = stViewersCtrl;
    addControlPanel( m_stViewersCtrl, StaticControlPanel::DEFAULT_IMPORT_BUTTONS );
    setLayout( title );
}
*/
void UserDialogFrameBase::addControlPanel(StaticViewersController* stViewersCtrl, int buttons )
{
    LOG
    m_stViewersCtrl = stViewersCtrl;
    m_ctrlPanel = new StaticControlPanel( this, stViewersCtrl, buttons, ID_STATIC_CONTROL_PANEL2 );
    ///!!!!!!!!!!!!!!!stMgr->RegisterViewer( m_ctrlPanel );
    m_ctrlPanel->update();
    GetSizer()->Add( m_ctrlPanel, 0, wxEXPAND );
}


bool UserDialogFrameBase::loadLayout( const wxString& title )
{
    if ( !m_dlgLayoutMgr ) return false;

    wxPoint pos = wxDefaultPosition;
    wxSize size = wxDefaultSize;
    bool ismax  = false;

    if( !m_dlgLayoutMgr->LoadLayout( title, pos, size, ismax ) ) return false;

    Move( pos );
    SetInitialSize(wxSize(310,300));
    SetSize(size);
    Maximize(ismax);

    return true;
}

void UserDialogFrameBase::setLayout( const wxString& title )
{
    if( !loadLayout( title ) )
    {
        SetInitialSize();
        CenterOnScreen();
    }

    prepareAndShow( title );
}

void UserDialogFrameBase::prepareAndShow( const wxString& title )
{
    SetIcon(wxIcon(_T("vemsLogoIcon2")));
    SetTitle( title );
    connectKeyDownEvent( this );
    connectKeyUpEvent( this );

    Show();
}

void UserDialogFrameBase::connectKeyDownEvent( wxWindow* window )
{
    if( window )
    {
        window->Connect( wxID_ANY,
                         wxEVT_KEY_DOWN,
                         wxKeyEventHandler( UserDialogFrameBase::OnKeyDown ),
                         (wxObject*) NULL,
                         this );

        wxWindowListNode* node = window->GetChildren().GetFirst();

        while( node )
        {
            wxWindow* child = node->GetData();
            this->connectKeyDownEvent( child );

            node = node->GetNext();
        }
    }
}

void UserDialogFrameBase::connectKeyUpEvent( wxWindow* window )
{
    if( window )
    {
        window->Connect( wxID_ANY,
                         wxEVT_KEY_UP,
                         wxKeyEventHandler( UserDialogFrameBase::OnKeyUp ),
                         (wxObject*) NULL,
                         this );

        wxWindowListNode* node = window->GetChildren().GetFirst();

        while( node )
        {
            wxWindow* child = node->GetData();
            this->connectKeyUpEvent( child );

            node = node->GetNext();
        }
    }
}

void UserDialogFrameBase::setStaticViewersController( StaticViewersController* controller )
{
    m_stViewersCtrl = controller;
}


void UserDialogFrameBase::OnKeyDown( wxKeyEvent& event )
{
    int keyCode = event.GetKeyCode();

    switch( keyCode )
    {
        case WXK_ESCAPE :
        {
            GetParent()->SetFocus();
        }break;
        case 'R' :
        {
            if( event.AltDown() ) { m_stViewersCtrl->refreshData(); }
            else { event.Skip(); }

        }break;
        case 'W' :
        {
            if( event.AltDown() )
            {
                m_stViewersCtrl->writeData();
            }
            else { event.Skip(); }
        }break;
        case 'B' :
        {
            if( event.AltDown() )
            {
                m_stViewersCtrl->burnData();
            }
            else { event.Skip(); }
        }break;
        case 'C' :
        {
            if( event.AltDown() ) { Close(); }
            else { event.Skip(); }
        }break;
        case WXK_F1 :
        {
            m_stViewersCtrl->showHelp();
            event.Skip();
        }break;
        case 'G':
        {
            m_stViewersCtrl->showTable3D();
        } break;
        case WXK_PAGEDOWN:
        case WXK_PAGEUP:
            break;
        default :
        {
            event.Skip();
        }
    }


}

void UserDialogFrameBase::OnKeyUp( wxKeyEvent& event )
{
    int keyCode = event.GetKeyCode();

    switch( keyCode )
    {
        case WXK_PAGEUP:
        {
            m_stViewersCtrl->changeToPreviousDialog();
        } break;
        case WXK_PAGEDOWN:
        {
            m_stViewersCtrl->changeToNextDialog();
        } break;
        default :
        {
            event.Skip();
        }
    }
}

void UserDialogFrameBase::OnClose( wxCloseEvent& event )
{
    LOGP( wxString::Format( _T("m_stViewersCtrl: %p"), m_stViewersCtrl ) );
    //if( m_udManager ) m_udManager->unActivate(m_menuId);
    if( m_stViewersCtrl ){
        UserDialogBase* udMgr = m_stViewersCtrl->getUserDialogBase();

        LOGP( wxString::Format( _T("udMgr: %p"), udMgr ) );

        if(udMgr){ udMgr->unActivate(m_menuId);}
    }
    event.Skip();
}

bool UserDialogFrameBase::onDropFiles( const wxArrayString& filenames )
{
    if ( !m_stViewersCtrl )
    {
        Logger::logf( LOG_MSG, _T("UserDialogFrameBase::OnDropFiles() - m_stViewersCtrl is NULL") );
        return false;
    }

    return m_stViewersCtrl->onDropFiles( filenames );
}

void UserDialogFrameBase::OnActivate( wxActivateEvent& event )
{
    FunctionMeter fm(_T("OnActivate"));
    Logger::logf( LOG_MSG, _T("UserDialogFrameBase::OnActivate()") );

    event.Skip();
}

void UserDialogFrameBase::showHelp()
{
    if ( HelpUtil::isHelpShown() )
    {
        m_stViewersCtrl->showHelp();
    }
}


bool UserDialogFrameBase::Destroy()
{
    if ( m_stViewersCtrl ) {
        m_stViewersCtrl->unregisterViewers();
    }

    return wxFrame::Destroy();
}
