#ifndef USERDIALOGFRAMEBASE_H
#define USERDIALOGFRAMEBASE_H

#include <wx/wx.h>

class StaticViewersController;
class DialogsLayoutManager;
class StaticControlPanel;
class STDataMgrBase;
class ConfigValidatorBase;

class UserDialogFrameBase : public wxFrame
{
    public:
        //UserDialogFrameBase( wxWindow* parent, StaticViewersController* stViewersCtrl, const wxString& title);
        UserDialogFrameBase( wxWindow* parent, ConfigValidatorBase* validator = NULL, DialogsLayoutManager * dlglayoutmgr = NULL);
        virtual ~UserDialogFrameBase();

        void setMenuId(int id);
        //void addCtrl(StaticViewersController* stViewersCtrl, const wxString title);
        bool onDropFiles( const wxArrayString& filenames );

        void        setStaticViewersController( StaticViewersController* stViewersCtrl );
        void        addControlPanel(StaticViewersController* stViewersCtrl, int buttons );
        StaticControlPanel* getControlPanel() { return m_ctrlPanel; }
        void        setLayout( const wxString& title );

        void        showHelp();

        virtual bool Destroy();

    protected:
        ConfigValidatorBase*        m_validator;
        StaticViewersController*    m_stViewersCtrl;
        DialogsLayoutManager*       m_dlgLayoutMgr;
        //UserDialogBase*             m_udManager;
        int                         m_menuId;
        StaticControlPanel*         m_ctrlPanel; /// only for super curve editor


        bool        loadLayout( const wxString& title );

        void        prepareAndShow( const wxString& title );
        void        connectKeyDownEvent( wxWindow* pclComponent );
        void        connectKeyUpEvent( wxWindow* window );




        void        OnKeyDown( wxKeyEvent& event );
        void        OnKeyUp( wxKeyEvent& event );
        void        OnClose( wxCloseEvent& event );
        void        OnActivate( wxActivateEvent& event );

    private:

        DECLARE_EVENT_TABLE()
};

#endif // USERDIALOGFRAMEBASE_H
