#ifndef DIFFERENTIALGAUGE_H_INCLUDED
#define DIFFERENTIALGAUGE_H_INCLUDED

#include "VemsWidgetBase.h"
#include "../common/types/wxVariantHashHash.h"

#include "../gaugedesc/MultiSymbolGaugeDescMgr.h"
//#include "../gaugedesc/DiffGaugeDescManager.h"

class wxHotKeyManager;

class DifferentialGauge: public VemsWidgetBase
{
    DECLARE_DYNAMIC_CLASS(DifferentialGauge);

    public:
        DifferentialGauge() {};
        DifferentialGauge( wxWindow* parent, wxWindowID id, GaugeDescManager * gdmgr, GaugeProperties &prop );
        ~DifferentialGauge();

        wxRegion    GetShape();
        wxRegion    GetBorderRegion();
        void        UpdateSize() {}
        void        setSize(int x , int y) {}

        void        SetValue( double value ) { }
        void        SetNewTheme(WidgetThemeTable *theme);

        void        require();
        void        refresh(DoubleHash* table);

        void        setBoundaries(float r_min, float r_max) { m_rmin = r_min; m_rmax = r_max;  }

        void        GaugeRefresh();

        virtual void RedrawWidget();

        int         GetProfileID() { return m_profileID; };



    protected:

        void OnPaint(wxPaintEvent &evt);
        void OnKeyDown(wxKeyEvent &evt);
        void OnRightDown(wxMouseEvent& evt);
        void OnProfileMenu(wxCommandEvent& evt);
        void OnMenu(wxCommandEvent& evt);


        MultiSymbolGaugeDescMgr* GetMgr() { return m_gaugeDescMgr->GetDiffGaugeDescMgr(); };
        MultiSymbolGaugeDesc& GetDesc() { return GetMgr()->GetProfile(m_profileID); };

//        DiffGaugeDescManager* GetMgr() { return m_gaugeDescMgr->GetDiffGaugeDescMgr(); };
//        DiffGaugeDesc& GetDesc() { return GetMgr()->GetProfile(m_profileID); };

        void RegisterSymbols();
        void UnRegisterSymbols();

        void CreateProfileChooserMenu(wxMenu* menu);

        virtual void createWidgetMenu( wxMenu& popupMenu );

    private:

        enum {
            idMenuOpenDescEditor,
            idMenuOpenDescEditorProfile
        };



        bool            m_isRegistered;
        DoubleHash      m_hash;
        DoubleHash      m_PrevValueHash;

        wxVariantHashHash   m_customProps;

        Int2IntHash     m_menuId2ProfileId;

        bool            m_showRange;
        bool            m_valuesOntheLeft;
        bool            m_needRefresh;
        double          m_rmin, m_rmax;
        int             m_TickTextHeight;

        wxHotKeyManager*m_hotkeyMgr;
        wxTimer         m_timer;

        int             m_profileID;

        void OnTimer( wxTimerEvent&event );

        DECLARE_EVENT_TABLE();
};

#endif // DIFFERENTIALGAUGE_H_INCLUDED
