#ifndef GAUGECARRIERAUIMDICHILDFRAME_H
#define GAUGECARRIERAUIMDICHILDFRAME_H

#include "GaugeCarrierBase.h"
#include "../gaugedesc/GaugeProperties.h"

#include <wx/aui/tabmdi.h>
#include <wx/scrolwin.h>

#include "../FileDropTargetBase.h"

class FileDropManagerBase;

class GaugeCarrierAuiMDIChildFrame: public wxAuiMDIChildFrame, public GaugeCarrierBase, public wxScrollHelperNative, public FileDropTargetBase
{
    public:
        GaugeCarrierAuiMDIChildFrame(wxAuiMDIParentFrame * parent, int id = wxID_ANY, const wxString &pagetext = wxEmptyString, GaugeGroupManager* mgr = NULL);
        virtual ~GaugeCarrierAuiMDIChildFrame();

        virtual wxString GetTheme();


        virtual void connectKeyDownEvent( wxWindow* window );

        virtual void ShowCarrier(bool isShow);


        virtual void CloseCarrier();
        virtual void CloseGauge(int winid, bool eraseHash = true);

        virtual void SetFocusToItem(int id = -1);

        virtual void ResetMinMax();

        void SetEditMode(bool isedit);

        void ProcessWidgetCommand(wxVariantHash& cmdHash);

        bool onDropFiles( const wxArrayString& filenames );

        virtual bool AcceptDrop();
        virtual bool DropFiles( const wxArrayString& files );

    protected:

        void OnChar(wxKeyEvent& event);
        void HandleVemsControlBaseKeys( int keyCode );
        void OnRightClick(wxMouseEvent& evt);
        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);
        void OnMouseMove(wxMouseEvent& evt);
        void OnInfoPanelClose(wxCloseEvent& evt);
        void OnKeyDown(wxKeyEvent& evt);
        void OnLeave(wxMouseEvent& evt);
        void OnMenu(wxCommandEvent& evt);

        void OnPaint(wxPaintEvent& evt);
        void OnClose( wxCloseEvent& event );

        void createAddSubMenu(wxMenu* parent);
        void createExportSubMenu(wxMenu* parent);
        void createImportSubMenu(wxMenu* parent);
        void createCopyPasteMenu(wxMenu* parent);

        wxString GetHotKeyStr();

        void DropDeselectWidgetCommand();


        void DeleteSelectedItems(bool isConfirm = true);
        void SelectAllItems();

        void GetGaugesToExport(GaugePropertiesArray& arr, bool onlySelected);

        void CopySelectedGauges();
        void Paste();
        bool IsValidPaste();
        bool HasSelectedItem();
        void EndSelection();

    private:

        enum {
            idMenuExportAll,
            idMenuExportSelected,
            idMenuImport,
            idMenuCopy,
            idMenuPaste,
            idMenuSave,
            idMenuSelectAll,
            idMenuDelSelected,
            idMenuDelSelectedNoConfirm,
            idMenuEND
        };


        wxMenu*     m_popupMenu;

        wxString    m_groupName;

        wxPoint*    m_popupPos;

        wxPoint     m_selectBoxStart;


        FileDropManagerBase* m_dropmgr;


        DECLARE_EVENT_TABLE();

};

#endif // GAUGECARRIERAUIMDICHILDFRAME_H
