#include "GaugeCarrierBase.h"

//#include "../vemstoolicon/VemsToolIconBase.h"

#include "../WindowReg.h"

#include "../DirHelper.h"

//#include "../VemsStateWidget.h"
//#include "../VemsTaskBarIcon.h"

#include "../logger.h"

#if defined (__WINCE_STANDARDSDK__)
    //#include <shellsdk.h>		/// for WinAPI support
    #include <aygshell.h>		/// for WinAPI support
#endif

#include "GaugeCarrierBaseDesc.h"
#include "VemsControlBase.h"
#include "WidgetFactoryBase.h"




GaugeCarrierBase::GaugeCarrierBase(wxWindow * parent)

{
    m_desc = new GaugeCarrierBaseDesc();

    //ctor
    m_desc->m_frame = 0;
    m_desc->m_panel = 0;
    m_desc->m_window = 0;
    m_desc->m_floating = true;
    m_desc->m_onlyOneGauge = false;
//    m_orientation = 0;

    m_desc->m_wreg = NULL;
    m_TaskBarIconApp = NULL;
//    m_desc->m_CustomControlHash = NULL;
//    m_rtDataMgr = NULL;
//    m_stController = NULL;
    //m_themedObj = NULL;
    //m_gauge = NULL;
    //m_table = NULL;
    //m_rootdir = wxEmptyString;
    m_desc->m_graphQual = 0;
    m_groupMgr = NULL;
//    m_logHistory = NULL;



}

GaugeCarrierBase::~GaugeCarrierBase()
{
    //dtor
    delete m_desc;
}


/*************************************************/

void GaugeCarrierBase::InitWindow(wxFrame * frame)
{
    m_desc->m_frame = frame;
    m_desc->m_window = frame;
}

void GaugeCarrierBase::InitWindow(wxPanel * panel)
{
    m_desc->m_panel = panel;
    m_desc->m_window = panel;
}

#if !defined(__WINCE_STANDARDSDK__) && !defined(__POCKETPC__)
void GaugeCarrierBase::InitWindow(wxMDIChildFrame * frame)
{
    m_desc->m_frame = frame;
    m_desc->m_window = frame;
}
#endif

void GaugeCarrierBase::SetShaped(bool isShaped)
{
    m_desc->m_hasShape = isShaped;
}

void GaugeCarrierBase::SetGaugeShowInit( bool GaugeShowInit )
{
    m_desc->m_GaugeShowInit = GaugeShowInit;
}

bool GaugeCarrierBase::IsGaugeShowInit()
{
    return m_desc->m_GaugeShowInit;
}

void GaugeCarrierBase::OnlyOneGauge(bool is)
{
    m_desc->m_onlyOneGauge = is;
}

bool GaugeCarrierBase::IsOnlyOneGauge()
{
    return m_desc->m_onlyOneGauge;
}

int GaugeCarrierBase::getType()
{
    return m_desc->m_type;
}

void GaugeCarrierBase::SetBGColor( const wxColor& color)
{
    m_desc->m_window->SetBackgroundColour( color );
    m_desc->m_window->ClearBackground();
}

void GaugeCarrierBase::SetFloating( bool isfloat )
{
    m_desc->m_floating = isfloat;
}

bool GaugeCarrierBase::IsFloating()
{
    return m_desc->m_floating;
}

wxWindowHashInt& GaugeCarrierBase::GetIDControlHash()
{
    return m_desc->m_IDtoControls;
}

/*************************************************/
//
//void GaugeCarrierBase::SetDataMgrObj(RTDataMgrBase *rtDataMgr)
//{
//    m_rtDataMgr = rtDataMgr;
//}
//
//void GaugeCarrierBase::SetDataMgrObj(STDataMgrBase *stDataMgr)
//{
//    m_stController = stDataMgr;
//}
//
//RTDataMgrBase* GaugeCarrierBase::GetDataMgrObj(void)
//{
//    return m_rtDataMgr;
//}
/*
wxWindowHashInt* GaugeCarrierBase::GetControlHash()
{
    return NULL;//m_desc->m_CustomControlHash;
}

void GaugeCarrierBase::SetCustomControlHash( wxWindowHashInt *customControlHash)
{
    m_desc->m_CustomControlHash = customControlHash;
}
*/
void GaugeCarrierBase::ClearFrame(void)
{

    for(wxWindowHashInt::iterator it = m_desc->m_IDtoControls.begin(); it != m_desc->m_IDtoControls.end(); it++){
        Logger::logf(LOG_MSG,_T("itemName=%s, itemID=%i, itemPtr=%p"),it->second->GetName().c_str(),it->first, it->second);
        it->second->Destroy();
    }

    m_desc->m_IDtoControls.clear();

    ClearFrameShape();
}

void GaugeCarrierBase::ClearFrameShape()
{
    m_desc->m_region.Clear();
}


//void GaugeCarrierBase::RegIcon(int id, VemsToolIconBase *icon)
//{
//    if(icon != NULL) {
//        ///need to refactor
//        m_desc->m_IDtoControls[id] = icon;
//   //     if(m_desc->m_CustomControlHash != NULL) (*m_desc->m_CustomControlHash)[id] = icon;
//        icon->IconInit();
//    }
//}


wxWindow* GaugeCarrierBase::AddVemsTable( GaugeProperties &prop )
{

    if(m_widgetFactories.find(_T("TableEditorFactory")) == m_widgetFactories.end()) return NULL;

    WidgetFactoryBase* factory = m_widgetFactories[_T("TableEditorFactory")];

    if(!factory) return NULL;

    VemsControlBase* table = factory->CreateWidget(prop,m_desc);

    if(!table) return NULL;

    wxWindow* win = dynamic_cast<wxWindow*>(table);

    m_control = table;

    connectKeyDownEvent( m_desc->m_window );

    return win;

}

void GaugeCarrierBase::SetFactory(WidgetFactoryBase* factory)
{
    wxString className =  factory->GetClassInfo()->GetClassName();
    m_widgetFactories[className] = factory;
}

void GaugeCarrierBase::SetFactory(const wxString& type, WidgetFactoryBase* factory)
{
    m_widgetFactories[type] = factory;
}

void GaugeCarrierBase::SetFactory(WidgetFactoryBaseHash& factories)
{
    for(WidgetFactoryBaseHash::iterator it = factories.begin(); it != factories.end(); it++ ) {
        m_widgetFactories[it->first] = it->second;
    }
}

wxWindow* GaugeCarrierBase::AddGauge( GaugeProperties &prop )
{


    if(m_widgetFactories.find(_T("VemsWidgetBaseFactory")) == m_widgetFactories.end()) return NULL;

    WidgetFactoryBase* factory = m_widgetFactories[_T("VemsWidgetBaseFactory")];

    if(!factory) return NULL;

    VemsControlBase* gauge = factory->CreateWidget(prop,m_desc);

    if(!gauge) return NULL;

    wxWindow* vwbGauge = dynamic_cast<wxWindow*>(gauge);

    m_control = gauge;

    return vwbGauge;
}
//
//int GaugeCarrierBase::AddStateWidget(const wxString name, wxPoint pos, int size, bool isShow)
//{
//
//    int id = wxNewId();
//
//    VemsStateWidget *statew;
//
//    statew = new VemsStateWidget(m_desc->m_window,id, pos,wxSize(size,size/3),0,isShow);
//
//    m_desc->m_IDtoControls[id] = statew;
//    //if(m_desc->m_CustomControlHash != NULL) (*m_desc->m_CustomControlHash)[id] = statew;
//
//
//    return 0;
//}

void GaugeCarrierBase::FitInnerSizer()
{
    wxSizer* sizer = m_desc->m_window->GetSizer();

    if( !sizer ) return;

    sizer->Fit( m_desc->m_window );
    sizer->Layout();

}

void GaugeCarrierBase::unregisterViewer()
{
    //Logger::logf( LOG_MSG, _T("GaugeCarrierBase::unregisterViewer() m_desc->m_onlyOneGauge=%i , this=%p"),m_desc->m_onlyOneGauge, this );

    if( m_desc->m_onlyOneGauge )
    {

        m_control->b_UnRegisterViewer();

    }
//    else
//    {
//
//        for( uint32_t i = 0; i < m_viewers.GetCount(); ++i )
//        {
//            m_viewers.Item( i )->UnRegisterViewer();
//        }
//    }
//


//    if ( !m_desc->m_CustomControlHash ) { return; }
//
//    wxWindowHashInt::iterator it = m_desc->m_CustomControlHash->begin();
//
//    for( ; it != m_desc->m_CustomControlHash->end() ; ++it )
//    {
//        if( it->second->GetName() == _T("VemsWidgetBase") )
//        {
//            if( ( (VemsWidgetBase*)it->second )->IsRegistered() )
//            {
//                ( (VemsWidgetBase*)it->second )->UnRegisterViewer();
//            }
//        }
//        /*
//        else if( it->second->GetName() == _T("VemsFlagWidget") )
//        {
//            if( ( (VemsFlagWidget*)it->second )->IsRegistered() )
//            {
//                ( (VemsFlagWidget*)it->second )->UnRegisterViewer();
//            }
//        }*/
//    }

}


void GaugeCarrierBase::setTaskBarIcon(VemsTaskBarIcon *ptr)
{
    m_TaskBarIconApp = ptr;
}

//bool GaugeCarrierBase::isDefGaugeDesc()
//{
//    if(m_gauge)
//        return m_gauge->isDefaultGaugeDesc();
//    else
//        return true;
//}

//wxString GaugeCarrierBase::GetDesc()
//{
//    if(m_gauge)
//        return m_gauge->GetSelectedGaugeDesc();
//    else
//        return _T("defaultdesc");
//}

