#ifndef GAUGECARRIERFRAME_H
#define GAUGECARRIERFRAME_H

#include "GaugeCarrierBase.h"

class GaugeCarrierFrame: public wxFrame, public GaugeCarrierBase
{
    public:
        GaugeCarrierFrame(wxWindow* parent, wxWindowID id, const wxString& title,
                        const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize,
                        long style = wxDEFAULT_FRAME_STYLE);
        virtual ~GaugeCarrierFrame();

        virtual wxString GetTheme();

        virtual void connectKeyDownEvent( wxWindow* window );

        virtual void ShowCarrier(bool isShow);

        virtual void CloseCarrier() { Destroy(); };
        virtual void CloseGauge(int winid, bool eraseHash = true) {};

        virtual void ResetMinMax();

        virtual void SetFocusToItem(int id = -1);

        void ProcessWidgetCommand(wxVariantHash& cmdHash);

        bool IsUnregViewers;

    protected:

    private:


        void OnActivate(wxActivateEvent& evt);
        void OnLeftDown(wxMouseEvent& evt);
        void OnFrameClose(wxCloseEvent& event);
        void OnDoubleClick(wxMouseEvent& WXUNUSED(evt));

        void OnChar(wxKeyEvent& event);
        void OnMove( wxMoveEvent& event );


        DECLARE_EVENT_TABLE();
};

#endif // GAUGECARRIERFRAME_H
