#ifndef MVG_PROFILESEDITOR_H
#define MVG_PROFILESEDITOR_H

#include "../../common/types/String2IntHash.h"
#include "../../common/types/wxVariantHashArray.h"

class MultiValueGraph;
class GaugeDescManager;
class MultiGraphDescManager;

class MVG_ProfilesEditor: public wxFrame
{
    DECLARE_DYNAMIC_CLASS(MVG_ProfilesEditor);

    public:
        MVG_ProfilesEditor() {};
        MVG_ProfilesEditor(wxWindow* parent, GaugeDescManager * gdmgr);
        virtual ~MVG_ProfilesEditor();

        void SetMultiGraph(MultiValueGraph * mg) { m_mvg = mg; };

        void InitEditor();

        void RefreshDescList(int selectidx = -1);
        void RefreshThemeList(int selectidx = -1);

    protected:

        void FillList(wxComboBox* cb, wxVariantHashArray& source, String2IntHash& title2idhash);

        void OnButton(wxCommandEvent& evt);
        void OnCombo(wxCommandEvent& evt);

        void OpenThemeEditor();
        void OpenDescEditor();

        void DelTheme();
        void DelDesc();

        void SetThemeTitle();
        void SetDescTitle();



        bool DelConfirm();

    private:

        enum winids {
            idCBDescs,
            idCBThemes,
            idBtnSetDescTitle,
            idBtnSetThemeTitle,
            idBtnDelDesc,
            idBtnDelTheme,
            idBtnOpenDescEditor,
            idBtnOpenThemeEditor
        };

        MultiValueGraph*    m_mvg;

        GaugeDescManager*   m_gdMgr;

        MultiGraphDescManager * m_mvgDescMgr;

        wxComboBox  *   m_descProfiles;
        wxComboBox  *   m_themeProfiles;

        String2IntHash  m_descs;
        String2IntHash  m_themes;

        wxTextCtrl  *   m_descTitleCtrl;
        wxTextCtrl  *   m_themeTitleCtrl;

        wxButton * m_deldescbtn;
        wxButton * m_delthemebtn;

        DECLARE_EVENT_TABLE();
};

#endif // MVG_PROFILESEDITOR_H
