#include "MVG_SymbolChooserPanel.h"

#include "MVG_DescEditor.h"
#include "../../gaugedesc/GaugeDescManager.h"

IMPLEMENT_DYNAMIC_CLASS(MVG_SymbolChooserPanel,SymbolChooserPanel);

MVG_SymbolChooserPanel::MVG_SymbolChooserPanel(wxWindow* parent, GaugeDescManager* mgr)
    :SymbolChooserPanel(parent,mgr)
{

}

MVG_SymbolChooserPanel::~MVG_SymbolChooserPanel()
{
    //dtor
}

void MVG_SymbolChooserPanel::SetSymbol(wxVariantHash* desc)
{
    wxString title;
    wxString name = (*(desc))[_T("name")].GetString();

    if( desc->find(_T("type")) != desc->end() && (*(desc))[_T("type")].GetString() == _T("flag") ) {

        title = name;

    } else {

        title = m_mgr->GetGaugeSymbolTitle( name );

    }

    m_currentName = name;

    m_label->SetLabel( title );

    SetStyleEx();
}

void MVG_SymbolChooserPanel::SetSymbolName(const wxString& name, bool isDropEvt)
{
    wxWindow* win = GetParent();
    if(win){
        SymbolPanel * panel = wxDynamicCast(win,SymbolPanel);
        if(panel){
            bool res = panel->SetSymbolName(name);
            if(!res) return;
        }
    }

    m_currentName = name;

    wxString title = m_mgr->GetGaugeSymbolTitle( name );

    m_label->SetLabel( title == wxEmptyString ? name : title );

    if(isDropEvt)
        DoOnUpdated();
    else
        SetStyleEx();

}

