#ifndef MVG_SYMBOLDESCCHOOSERPANEL_H
#define MVG_SYMBOLDESCCHOOSERPANEL_H

#include <wx/wx.h>
#include "MVG_DescManager.h"
#include "../../common/types/Int2IntHash.h"
#include "../../customwidgets/wxPanelWithCtrlExBase.h"

//class VEMSGaugeDescArray

class MVG_SymbolDescChooserPanel: public wxPanelWithCtrlExBase
{
    DECLARE_DYNAMIC_CLASS(MVG_SymbolDescChooserPanel);

    public:

        MVG_SymbolDescChooserPanel() {}
        MVG_SymbolDescChooserPanel(wxWindow* parent, MVG_DescManager* mgr);
        virtual ~MVG_SymbolDescChooserPanel();


        void SetSymbol(wxVariantHash* desc);

        void SetDescId(int id);

        virtual void SetValue(const wxVariant& value);
        virtual wxVariant GetValue();

    protected:

        void OnButton(wxCommandEvent& evt);

        void OnPopupMenuSelectSymbol(wxCommandEvent& evt);

        wxString GetDescTitle(int desc_id);

        void OpenDescEditor();

    private:

        enum {
            idSelectButton,
            idEditButton
        };

        MVG_DescManager*    m_mgr;

        wxStaticText*       m_label;

        wxMenu*             m_selectMenu;

        Int2IntHash         m_menuId2symbolDescId;

        int                 m_currentSymbolDescID;

        wxVariantHash *     m_symbolDesc;

        VEMSGaugeDescArray* m_gaugeDescA;

        DECLARE_EVENT_TABLE();

};

#endif // MVG_SYMBOLDESCCHOOSERPANEL_H
