#ifndef MVG_THEMEEDITOR_H
#define MVG_THEMEEDITOR_H

#include "../../gaugedesc/MultiGraphTheme.h"


class MultiValueGraph;
class GaugeDescManager;
class wxTextCtrlNullEx;
class MultiGraphDescMgr;
class MultiGraphDescManager;


class ThemeLine
{
    public:
        ThemeLine() { Ctrl = NULL; };
        ThemeLine(MultiGraphThemeProperty prop, wxTextCtrlNullEx* ctrl) {
            Prop = prop;
            Ctrl = ctrl;
        }

        MultiGraphThemeProperty Prop;
        wxTextCtrlNullEx * Ctrl;

};

WX_DECLARE_OBJARRAY(ThemeLine, ThemeLineArray);
WX_DECLARE_HASH_MAP( int, ThemeLine, wxIntegerHash, wxIntegerEqual, ThemeLineHash);

class MVG_ThemeEditor: public wxFrame
{
    DECLARE_DYNAMIC_CLASS(MVG_ThemeEditor);

    public:
        MVG_ThemeEditor() {};
        MVG_ThemeEditor(wxWindow * parent, GaugeDescManager * gdmgr, int profileID);
        virtual ~MVG_ThemeEditor();

        void SetMultiGraph(MultiValueGraph * mg);

        void InitEditor();
        void RestoreTheme();
        void ProcessChange(int type);

        void Apply();
        void Save();

    protected:

        void OnButton(wxCommandEvent& evt);
        void OnMenu(wxCommandEvent& evt);
        void OnCDlgButton(wxCommandEvent& evt);
        void OnChange(wxCommandEvent& evt);

        void CreateBackup(MultiGraphTheme * sourceTheme);

    private:

        enum {
            idBtnRestore = 6300,
            idBtnSave,
            idBtnApply,
            idBtnSaveAs,
            idBtnClose,
            idMenuClose,
            idMenuFloat,
            idMenuStay,
            idMenuProfileTitle
        };

        MultiGraphDescManager*  m_mgMgr;
        MultiValueGraph*        m_multiGraph;
        GaugeDescManager*       m_gdMgr;

        MultiGraphTheme *       m_graphTheme;
        MultiGraphTheme *       m_graphThemeBck;

        wxButton *  m_restoreButton;
        wxButton *  m_saveButton;
        wxButton *  m_applyButton;

        wxString    m_editorCaption;

        bool    m_wasRestore;
        int     m_profileID;

        ThemeLineArray  m_themeLines;
        ThemeLineHash   m_colorDlgLines;

        wxVariantHash   m_settings;

        DECLARE_EVENT_TABLE();

};



#endif // MVG_THEMEEDITOR_H
