#include "SelectableWidgetBase.h"

#include "SelectableWidgetRendererBase.h"

#include "../logger.h"

SelectableWidgetBase::SelectableWidgetBase(SelectableWidgetRendererBase* renderer)
{
    //ctor
    m_isSelected = false;
    m_selectionBitmap = NULL;
    m_renderer = renderer;
}

SelectableWidgetBase::~SelectableWidgetBase()
{
    if ( m_selectionBitmap )
    {
        delete m_selectionBitmap;
        m_selectionBitmap = NULL;
    }
}

void SelectableWidgetBase::DrawSelectionBitmap(const wxRect& rect)
{
    //Logger::logf(LOG_MSG,_T("m_renderer=%p"),m_renderer);

    if(!m_renderer) return;

    wxBitmap* tmp = m_renderer->Render(rect);

    ptrdel(m_selectionBitmap);
    m_selectionBitmap = tmp;
}

void SelectableWidgetBase::DrawSelectionBitmap(wxWindow* win)
{
    DrawSelectionBitmap( win->GetRect() );
}

bool SelectableWidgetBase::IsSelected()
{
    return m_isSelected;
}

void SelectableWidgetBase::SetSelected(bool isSel)
{
    m_isSelected = isSel;
}
