#include "VemsTableDesc.h"

IMPLEMENT_DYNAMIC_CLASS(VemsTableDesc, wxObject)

VemsTableDesc::VemsTableDesc()
{
    useTableMapper = false;
    //ctor
}

VemsTableDesc::~VemsTableDesc()
{
    //dtor
}

wxString VemsTableDesc::toString()
{
    wxString desc;

    desc.Append( _T("name: ") + name + _T(";") );
    desc.Append( _T("title: ") + title + _T(";") );
    desc.Append( _T("xSTSymbol: ") + xSTSymbol + _T(";") );
    desc.Append( _T("xRTSymbol: ") + xRTSymbol + _T(";") );
    desc.Append( _T("ySTSymbol: ") + ySTSymbol + _T(";") );
    desc.Append( _T("yRTSymbol: ") + yRTSymbol + _T(";") );
    desc.Append( _T("zSTSymbol: ") + zSTSymbol + _T(";") );

    return desc;
}

/**********************************************************
*   VemsTableDescList
**********************************************************/

VemsTableDescList::VemsTableDescList()
{
    //ctor
}


VemsTableDescList::~VemsTableDescList()
{
    //dtor
}


void VemsTableDescList::add( const wxString& name, const wxString& title )
{
    m_vtds[ name ] = new VemsTableDesc();
    m_vtds[ name ]->name = name;
    m_vtds[ title]->title = title;
}


void VemsTableDescList::setX( const wxString& name, const wxString& xst, const wxString& xrt )
{
    m_vtds[ name ]->xSTSymbol = xst;
    m_vtds[ name ]->xRTSymbol = xrt;
}


void VemsTableDescList::setY( const wxString& name, const wxString& yst, const wxString& yrt )
{
    m_vtds[ name ]->xSTSymbol = yst;
    m_vtds[ name ]->xRTSymbol = yrt;
}


void VemsTableDescList::setZ( const wxString& name, const wxString& zst )
{
    m_vtds[ name ]->zSTSymbol = zst;
}

void VemsTableDescList::setNumberWidth( const wxString& name, int numberWidth )
{
    m_vtds[ name ]->numberWidth = numberWidth;
}

void VemsTableDescList::setNumberPrec( const wxString& name, int numberPrec )
{
    m_vtds[ name ]->numberPrec = numberPrec;
}

void VemsTableDescList::setSmallCellStep( const wxString& name, double step )
{
    m_vtds[ name ]->smallCellStep = step;
}

void VemsTableDescList::setLargeCellStep( const wxString& name, double step )
{
    m_vtds[ name ]->largeCellStep = step;
}
