#ifndef VEMSTEXTWIDGET_H
#define VEMSTEXTWIDGET_H

#include "VemsWidgetBase.h"
#include <wx/wx.h>

class wxStaticTextEx;

class VemsTextWidget: public VemsWidgetBase
{
    public:
        VemsTextWidget();
        VemsTextWidget(wxWindow* parent, wxWindowID id, GaugeDescManager * gdmgr, GaugeProperties &prop );
        virtual ~VemsTextWidget();

        virtual wxRegion GetShape();
        wxRegion GetBorderRegion() { return wxRegion(); };
        virtual void UpdateSize();
        virtual void SetValue(double value);
        virtual void setSize(int x , int y);
        void SetNewTheme(WidgetThemeTable *theme) {
            m_theme = theme;
            UpdateSize();
        };


    protected:

        void OnPaint(wxPaintEvent& evt);
        void DrawFace();

    private:

        void OnSize(wxSizeEvent &event);

        wxString m_prevValue;

        double   m_sideRatio;

        wxBitmap*   m_face;

        DECLARE_EVENT_TABLE();

};



#endif // VEMSTEXTWIDGET_H
