#ifndef VEMSGAUGEDESC_H
#define VEMSGAUGEDESC_H

#include <wx/colour.h>
#include "../ThemesHelper.h"
#include "../common/types/wxVariantHash.h"
#include "../common/types/IntArray.h"
/*
LD,LW, HW,HD
minValue - LD -> Danger -> Red
LD - LW -> Warning -> Yellow
HW - HD -> Warning -> Yellow
HD- maxValue -> Danger -> Red
*/
/*
VEMSGaugeDesc * vgd = new VEMSGaugeDesc();
	 vgd->SetSymbolName(_T("rpm"));
     vgd->SetUnit(_T("RPM"));
     vgd->SetMinValue(0);
     vgd->SetMaxValue(8000);
     vgd->SetMajorDivisions(8);
     vgd->SetMinorDivisions(10);
     vgd->SetUnitsScaleFactor(1000);
     vgd->SetGaugeNumberFormat(_T("%.0f"));
     vgd->coloredA.Add( new ColoredArea(0,800, new wxColor(43,1,210)) );
     vgd->coloredA.Add( new ColoredArea(6000,7000, new wxColor(210,210,43)) );
     vgd->coloredA.Add( new ColoredArea(7000,8000, new wxColor(210,1,43)) );
     */

#define DEFAULTDESC _T("defaultdesc")



class ColoredArea
{
    public:
        ColoredArea() {}
        ColoredArea( ColoredArea * ca ) {
            Set(ca);
        };

        ColoredArea(const wxColor &colorr, double minV , double maxV, int id = -1){
            minValue = minV;
            maxValue =maxV;
            color = colorr;
            itemID = id;
		}

        ColoredArea(double minV , double maxV, const wxString &colorname, int id = -1){
            minValue = minV;
            maxValue = maxV;
            ColorName = colorname;
            itemID = id;
		}

        int itemID;

        double minValue;
        double maxValue;
        wxColor color; /// deprecated!!!

        wxString ColorName;

        wxString toString(){
            return wxString::Format(_T("min value : %f; ")
                                    _T("max value : %f; ")
                                    ,minValue,maxValue);
        }

        void Set( ColoredArea * ca );

};

WX_DEFINE_ARRAY(ColoredArea *, ColoredAreaArray);
WX_DECLARE_OBJARRAY(ColoredArea, ColoredAreaRefArray);


class VEMSGaugeDesc
{
    public:
        VEMSGaugeDesc();
        VEMSGaugeDesc( VEMSGaugeDesc * vgd );
        virtual ~VEMSGaugeDesc();

        void Set( VEMSGaugeDesc * vgd );

        void SetType(const wxString& type);
        void SetSymbolName(const wxString& s);
        void SetTitle(const wxString& s);
        void SetName(const wxString& name);
        void SetUnit(const wxString& unit);     //units
        void SetGaugeNumberFormat(const wxString& s); //?? vd  ld -- %4.3f- --
        void SetMinValue(double v);                 // LO
        void SetMaxValue(double v);                 // HI
        void SetMajorDivisions(long majorDivisions); // default
        void SetMinorDivisions(long minorDivisions); // default
        void SetUnitsScaleFactor(long scaleFactor); // 1,10,100,1000

        void SetStartAngle(long v);    // default
        void SetEndAngle(long v);
        void SetVDecimals(long vd);
        void SetLDecimals(long ld);

        void SetProperty(const wxString& propname, const wxString value) { Properties[propname] = value; };
        void SetProperty(const wxString& propname, long value) { Properties[propname] = value; };
        void SetProperty(const wxString& propname, double value) { Properties[propname] = value; };



        static int compare_function(VEMSGaugeDesc **A,VEMSGaugeDesc **B);


        wxString GetType();
        wxString GetTitle() { return m_title; };
        wxString GetSymbolName();
        wxString GetName();
        wxString GetUnit();
        wxString GetGaugeNumberFormat();
        double GetMinValue();
        double GetMaxValue();
        int GetMajorDivisions();
        int GetMinorDivisions();
        int GetTotalDivisions();
        int GetUnitsScaleFactor();

        int GetStartAngle();
        double GetStartAngleRad();
        int GetGaugeAngle();
        double GetGaugeAngleRad();
        int GetEndAngle();
        int GetVDecimals();
        int GetLDecimals();

        int GetTitleAngle();
        int GetTitlePos();
        int GetUnitAngle();
        int GetUnitPos();
        int GetValAngle();
        int GetValPos();


        wxString GetFormat();

        void SetGaugeNumbers();
        wxString toString();

        wxArrayString m_gaugeNumbers;
        ColoredAreaArray coloredA;


        ColoredArea * GetColoredArea(int itemID);

//    protected:
//    private:

        wxVariantHash   Properties;

        wxString m_symbolName;  ///deprecated !!
        wxString m_title;       ///deprecated !!
/*
        wxString m_type;
        wxString m_name;
        wxString m_unit;  //RPM, kPa, etc
        wxString m_gaugeNumberFormat;

        double m_minValue;
        double m_maxValue;

        long m_scaleFactor; //RPM=4000 scaleFactor=100 40 will be displayed in the gauge
        long m_majorDivisions;
        long m_minorDivisions;

        long m_startAngle; // = 45+90;
        long m_gaugeAngle; // gaugeSweep; // = 270;
        long m_endAngle;  //startAngle +gaugeAngle // = 315+90;

		long m_totalDivisions; // = 40;

        long m_vDecimals;
        long m_lDecimals;
*/
    private:

};
WX_DEFINE_ARRAY(VEMSGaugeDesc *, VEMSGaugeDescArray);

class GDDesc
{
    public:
        wxString    Name;
        wxString    Title;
        long        Min;
        long        Max;
        long        Factor;
        wxString    PageName;
        wxString    Type;
        IntArray    ValidGauges;

};

WX_DEFINE_ARRAY(GDDesc *, GDDescArray);



#endif // VEMSGAUGEDESC_H
