#include "BootModeARM.h"

#include <wx/thread.h>

#include "../logger.h"
#include "../CommunicationBase.h"


BootModeARM::BootModeARM(CommunicationBase*  commBase)
:BootModeBase(commBase)
{
    //ctor
    m_type = FirmwareData::HEX;
    m_device = ECUInfo::DEVICE_ARM;
}

BootModeARM::~BootModeARM()
{
    //dtor
}

uint32_t BootModeARM::getPageID(uint32_t pageIdx)
{
    return pageIdx;
}

int BootModeARM::selectPageTMP(uint32_t idx)
{
    //int result = selectPage("A", idx);
    selectPage("A", idx);
    return 0;
}

int BootModeARM::verifyPage(uint32_t idx)
{
    selectPageTMP(idx);
    return verifyPageCommon("Dll", idx);
}

int BootModeARM::uploadPage(uint32_t idx)
{
    selectPageTMP(idx);
    return uploadPageCommon("Dkk", idx);
}

int BootModeARM::verifyFlash()
{
    int error_cnt = verifyFlashCommon();
    if(error_cnt == 0){
        m_commBase->SendString((uint8_t*)"E");
    }
    return error_cnt;
}

int BootModeARM::uploadFlash()
{
    int error_cnt = uploadFlashCommon(0);
    if(error_cnt == 0){
        m_commBase->SendString((uint8_t*)"E");
    }else{
          observerNotify(_T("Error detected ECU left in BOOT Mode!"));
    }

    return error_cnt;
}

bool BootModeARM::failSafeVerifyPage(uint32_t idx)
{
    return failSafePageHandle(idx, &BootModeBase::verifyPage );
}

bool BootModeARM::failSafeUploadPage(uint32_t idx)
{
    return failSafePageHandle(idx, &BootModeBase::uploadPage );
}

////////////////////////

////////////////////////
int BootModeARM::eraseFlash()
{
    return 0;
}


