#ifndef BOOTMODEARM_H
#define BOOTMODEARM_H

#include "BootModeBase.h"

class CommunicationBase;

class BootModeARM : public BootModeBase
{
    public:
        BootModeARM(CommunicationBase* vp);
        virtual ~BootModeARM();
        int       verifyPage(uint32_t idx);
        bool      failSafeVerifyPage(uint32_t idx);
        int       verifyFlash();

        int       uploadPage(uint32_t idx);
        int       uploadFlash();
        bool      failSafeUploadPage(uint32_t idx);
        int eraseFlash();
    protected:
        uint32_t getPageID(uint32_t pageIdx);
        int selectPageTMP(uint32_t idx);
    private:
        //uint32_t getPageChecksum(uint8_t* checksumStr);

};





#endif // BOOTMODEARM_H
