#ifndef BOOTMODEROUND_H
#define BOOTMODEROUND_H

#include "BootModeBase.h"

class CommunicationBase;

class BootModeRound: public BootModeBase
{
    public:
        BootModeRound(CommunicationBase* vp);
        virtual ~BootModeRound();
        int       verifyPage(uint32_t idx);
        bool      failSafeVerifyPage(uint32_t idx);
        int       verifyFlash();

        int       uploadPage(uint32_t idx);
        int       uploadFlash();
        bool      failSafeUploadPage(uint32_t idx);

        int eraseFlash();
    protected:
        bool checksumVerify(uint32_t ecu_checksum, uint32_t file_checksum );
    private:
        //uint32_t getPageChecksum(uint8_t* checksumStr);
        int selectPageTMP(uint32_t idx);
        uint32_t getPageID(uint32_t pageIdx);
};



#endif // BOOTMODEROUND_H
