#ifndef COMCTRLSTATES_H
#define COMCTRLSTATES_H


#include <wx/event.h>


#include "../common/types/IntArray.h"


class VemsCommand;
class InputEvent;
class CommunicationController;


class ComCtrlState //: public wxEvtHandler
{
	public:
		//virtual void request( CommunicationController* ctrl, VemsCommand* command ) {}
		virtual ~ComCtrlState() {}
        virtual void execute( CommunicationController* ctrl ) {}
        virtual void OnSipr( CommunicationController* ctrl, InputEvent& event ) {}
        virtual void reset() {}
        virtual wxString toString() const = 0;

    protected:
        ComCtrlState() {}
};


//class CCS_Detect : public ComCtrlState
//{
//    public:
//        static CCS_Detect*    instance()
//        {
//            if ( !s_pInstance )
//            {
//                s_pInstance = new  CCS_Detect();
//            }
//
//            return s_pInstance;
//        }
//
//    	//void                request( CommunicationController* ctrl, VemsCommand* command );
//    	void                execute( CommunicationController* ctrl );
//    	void                OnSipr( CommunicationController* ctrl, InputEvent& event );
//    	void                reset();
//    	wxString            toString() const { return _T("CCS_Detect"); }
//
//	private:
//        /// how many empty read before try detect in order
//        static const int        MAX_EMPTY_READ  = 20;
//
//        /// how many read before try next protocol
//        static const int        MAX_READ        = 20;
//
//        enum States { IDLE, READ, DETECT, WAIT };
//
//        static CCS_Detect*      s_pInstance;
//        States                  m_state;
//        int                     m_iDetectingIdx;    // detecting index of protocol under detection
//        int                     m_iEmptyReadCount;  //
//        int                     m_iReadCount;       // succesfull read count
//        int                     m_device;
//
//	private:
//                    CCS_Detect() { reset(); }
//        //bool        checkAIM( CommunicationController* controller );
//};


class CCS_GetFirmwareInfoSipr : public ComCtrlState
{
    public:
        static CCS_GetFirmwareInfoSipr*    instance()
        {
            if ( !s_pInstance )
            {
                s_pInstance = new  CCS_GetFirmwareInfoSipr();
            }

            return s_pInstance;
        }

    	//void                request( CommunicationController* ctrl, VemsCommand* command );
    	void                execute( CommunicationController* ctrl );
    	void                OnSipr( CommunicationController* ctrl, InputEvent& event );
    	void                reset() { m_state = IDLE; }
    	wxString            toString() const { return _T("CCS_GetFirmwareInfoSipr"); }

	private:
        enum States { IDLE, WAIT };
        static CCS_GetFirmwareInfoSipr*    s_pInstance;
        States              m_state;

	private:
        CCS_GetFirmwareInfoSipr() { m_state = IDLE; }
};


class CCS_GetFirmwareInfo : public ComCtrlState
{
    public:
        static CCS_GetFirmwareInfo*    instance()
        {
            if ( !s_pInstance )
            {
                s_pInstance = new  CCS_GetFirmwareInfo();
            }

            return s_pInstance;
        }

    	//void                request( CommunicationController* ctrl, VemsCommand* command );
    	void                execute( CommunicationController* ctrl );
    	void                OnSipr( CommunicationController* ctrl, InputEvent& event );
    	void                reset() { m_state = IDLE; }
    	wxString            toString() const { return _T("CCS_GetFirmwareInfo"); }

	private:
        enum States { IDLE, WAIT, WAIT_MEGATUNE };

        static CCS_GetFirmwareInfo*     s_pInstance;
        States                          m_state;

	private:
        CCS_GetFirmwareInfo()
        {
            m_state     = IDLE;
        }
};


class CCS_Sync : public ComCtrlState
{
    public:
        static CCS_Sync*    instance()
        {
            if ( !s_pInstance )
            {
                s_pInstance = new  CCS_Sync();
            }

            return s_pInstance;
        }

    	void                execute( CommunicationController* ctrl );

        wxString            toString() const { return _T("CCS_Sync"); }
        //void request( CommunicationController* ctrl, VemsCommand* command );
        void OnSipr( CommunicationController* ctrl, InputEvent& event );
	private:
        enum States { IDLE, DETECT,WAIT, CHECK_PROTOCOL, WAIT_PROTOCOL, SYNC_DEVICE};
        static CCS_Sync*    s_pInstance;
        States              m_state;
        int                 m_i;

	private:
        CCS_Sync() { m_state = CHECK_PROTOCOL; }
};


class CCS_Normal : public ComCtrlState
{
	public:
        //void                    request( CommunicationController* ctrl, VemsCommand* command );
        void                    OnSipr( CommunicationController* ctrl, InputEvent& event );
        void                    execute( CommunicationController* ctrl );

        static CCS_Normal*      instance()
        {
            if ( !s_pInstance )
            {
                s_pInstance = new  CCS_Normal();
            }

            return s_pInstance;
        }

        wxString            toString() const { return _T("CCS_Normal"); }
	private:
        static CCS_Normal*    s_pInstance;

	private:
        CCS_Normal() {}
};


class CCS_SetState : public ComCtrlState
{
	public:
        //void                    request( CommunicationController* ctrl, VemsCommand* command );
        void                    OnSipr( CommunicationController* ctrl, InputEvent& event );
        void                    execute( CommunicationController* ctrl );

        static CCS_SetState*    instance()
        {
            if ( !s_pInstance )
            {
                s_pInstance = new  CCS_SetState();
            }

            return s_pInstance;
        }

        wxString            toString() const { return _T("CCS_SetState"); }
        int                     m_expectedState;

	private:
        static CCS_SetState*    s_pInstance;
        enum { IDLE, CHANGE, WAIT, WAIT_FOR_IDLE, WAIT_FOR_PING, WAIT_FOR_DISABLED };
        //enum { CHECK_PROTOCOL, }

        /// how many times to change protocol
        static const int        MAX_TRY_COUNT  = 5;
        //static int              s_state;
        int                     m_state;
        IntArray                m_route;
        int                     m_iCurrentStateIdx;
        int                     m_iTryCount;


	private:
        CCS_SetState() { m_state = IDLE; }
};


#endif // COMCTRLSTATES_H
