#ifndef COMMUNICATIONCLIENTBASE_H
#define COMMUNICATIONCLIENTBASE_H


#include <wx/event.h>


#include <wx/hashset.h>


class VemsDeviceController;
class CommunicationDispatcher;
class InputEvent;


class CommunicationClientBase : public wxEvtHandler
{
    public:
                                    CommunicationClientBase(    VemsDeviceController* controller,
                                                                CommunicationDispatcher* dispatcher );
        virtual                     ~CommunicationClientBase();

        virtual void                process() = 0;
        virtual void                OnSIPR( InputEvent& event ) = 0;

        bool                        isIdle() const { return m_bIsIdle; }
        //bool                        isReady() const ;
        bool                        start();
        void                        stop();

        bool                        lockController();
        void                        unlockController();

    protected:
        VemsDeviceController*       m_pController;
        bool                        m_bIsIdle;

    //private:
        CommunicationDispatcher*    m_pDispatcher;

    //private:
        void                        connect();
        void                        disconnect();

};


WX_DECLARE_HASH_SET( CommunicationClientBase*, wxPointerHash, wxPointerEqual, CommunicationClientBaseSet );

#endif // COMMUNICATIONCLIENTBASE_H
