#ifndef CONFIGDOWNLOADCONTROLLER_H
#define CONFIGDOWNLOADCONTROLLER_H


#include "DeviceInfo.h"
#include "SiprPacketReceiver.h"
#include "../communication/clients/DeviceModeSelectorListener.h"
#include "../communication/clients/ConfigDownloadListener.h"
#include "../communication/clients/TimeoutListener.h"


class VemsDeviceControllerBase;


class ConfigDownloadController : public wxEvtHandler, public SiprPacketReceiver
    , public DeviceModeSelectorListener, public ConfigDownloadListener, public TimeoutListener
{
    DECLARE_DYNAMIC_CLASS(ConfigDownloadController)

    public:
        ConfigDownloadController();
        ConfigDownloadController( VemsDeviceControllerBase* deviceController, wxEvtHandler* eventHandler );

        virtual ~ConfigDownloadController();

        void setDeviceController( VemsDeviceControllerBase* deviceController );
        void setEventHandler( wxEvtHandler* eventHandler  );

        void start();

        /// listeners
        void OnDeviceModeSelected( ECUInfo::EcuMode deviceMode );
        void OnConfigDownloaded();
        void OnTimeout();
        void receive( const SIPRPacket& packet );

    private:
        ECUInfo::EcuMode                m_deviceMode;
        wxEvtHandler*                   m_eventHandler;
        VemsDeviceControllerBase*       m_deviceController;
};


#endif // CONFIGDOWNLOADCONTROLLER_H
