#ifndef CONFIGDOWNLOADCONTROLLER_H
#define CONFIGDOWNLOADCONTROLLER_H


#include "DeviceInfo.h"
#include "../communication/CommunicationClientEventHandler.h"
#include "../events/VemsDeviceControllerEvent.h"

class CommunicationControllerClient;
class CommunicationController2;
class CommunicationBase;
class CommunicationEvent;
//class FirmwareData;


class DeviceModeController : public wxEvtHandler, public CommunicationClientEventHandler
{
    DECLARE_DYNAMIC_CLASS(DeviceModeController)

    public:
        DeviceModeController();
        DeviceModeController( wxEvtHandler* eventHandler, const DeviceInfo& deviceInfo, size_t timeout, size_t interWriteDelay );
        virtual ~DeviceModeController();

        void handleEvent( CommunicationClientEvent::Type eventType );

//        void start( const DeviceInfo& deviceInfo, ECUInfo::EcuMode  );
//        void stop();
//        bool isRunning();

        void changeMode( ECUInfo::EcuMode mode );

    private:
        CommunicationControllerClient*  m_communicationClient;
        CommunicationController2*       m_communicationController;
        CommunicationBase*              m_communicationBase;
//        FirmwareData*                   m_firmwareData;
        wxEvtHandler*                   m_eventHandler;

        DeviceInfo                      m_deviceInfo;
        ECUInfo::EcuMode                m_deviceMode;

        size_t  m_timeout;
        size_t  m_interWriteDelay;

        void registerClient( CommunicationControllerClient* client );
        void initCommunication();
        void clearCommunication();
        void sendDeviceControllerEvent( VemsDeviceControllerEventType eventType );

        void onStartEvent( wxCommandEvent& event );
        void onCommunicationEvent( CommunicationEvent& event );
};


#endif // CONFIGDOWNLOADCONTROLLER_H
