#ifndef ECUSTATEMGRBASE_H
#define ECUSTATEMGRBASE_H

#include "ECUStateBase.h"
#include "../CommunicationBase.h"

class ECUStateMgrBase
{
    public:
        ECUStateMgrBase(CommunicationBase* commBase);
        virtual ~ECUStateMgrBase();

        virtual void    reset() = 0;
        virtual int getStoredState() = 0;
        virtual int getDevice() =0;
        virtual int getState() =0;
        virtual int setState( int state ) =0;
        virtual int setState( int fromState, int toState ) =0;
        virtual const ECUStateBaseArray* getStates( int device ) = 0;
        virtual void setBaudRate( int baudRate ) = 0;
        virtual int getBaudRate() = 0;
        CommunicationBase* getCommunicationBase(){ return m_commBase; }
    protected:
        CommunicationBase* m_commBase;

    private:
};



#endif // ECUSTATEMGRBASE_H
