#ifndef EEPROMDOWNLOADCONTROLLER_H
#define EEPROMDOWNLOADCONTROLLER_H

#include <wx/wx.h>

#include "../communication/CommunicationClientEventHandler.h"
#include "ECUInfo.h"

class CommunicationController2;
class CommunicationBase;
class CommunicationControllerClient;
class EepromRawDataEvent;
class GeneralEvent;
class CommunicationEvent;
class VemsTuneController;

class EepromDownloadController : public wxEvtHandler, public CommunicationClientEventHandler
{
    public:
        EepromDownloadController(  VemsTuneController* vtc, CommunicationBase* commbase, bool writeToFile = false, wxEvtHandler* evtHandler = NULL );
        ~EepromDownloadController();

    public:
        void handleEvent( CommunicationClientEvent::Type eventType ) {}

        void start();
        void stop();

    private:
        enum { COMM_START = 4000 };

        bool                            m_writeToFile;

        CommunicationBase*              m_commBase;
        CommunicationController2*       m_controller;
        CommunicationControllerClient*  m_communicationClient;
        wxEvtHandler*                   m_evtHandler;

        ECUInfo::EcuMode                m_mode;
        VemsTuneController*             m_vtc;

        void    onStartEvent( GeneralEvent& event );
        void    onCommunicationEvent( CommunicationEvent& event );
        void    onEepromDownloaded( EepromRawDataEvent& event );
        void    onGeneralEvent( GeneralEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // EEPROMDOWNLOADCONTROLLER_H

