#ifndef FIRMWAREMGR_H
#define FIRMWAREMGR_H

//#include "FirmwareData.h"
//#include "ECUStateMgr.h"

#include <wx/wx.h>
#include "../Observable.h"
//#include "../firmwareconfigitem.h" //FirmwareConfigItemArray
//#include "../SerialException.h"
//#include "BootModeBase.h"

class VemsProtocol;
class FirmwareData;
class BootModeBase;
class FirmwareConfigItemArray;

class FirmwareMgr : public Observable
{
    public:
        enum Result{
            FIRMWARE_IDENTICAL  = 0,
            FIRMWARE_DIFFERENT = 1,
            FIRMWARE_ERASE_FAILED = 2,

            FIRMWARE_COMMUNICATION_ERROR = -1, //FileException
            FIRMWARE_FILE_NOT_FOUND_ERROR = -2 //FileEx...

        };
        FirmwareMgr(VemsProtocol* vp, BootModeBase* bm);
        virtual ~FirmwareMgr();
        int upload(FirmwareConfigItemArray* configIteA);
        int verify(FirmwareConfigItemArray* configIteA);
    protected:
    private:
        int setFirmwareData(FirmwareConfigItemArray* configItemA);
        int addPatchFiles(FirmwareConfigItemArray* configItemA);

        wxString getHexFile(FirmwareConfigItemArray* configItemA);
        wxArrayString* getPatchFiles(FirmwareConfigItemArray* configItemA);

        FirmwareData*  m_firmwareData;
//        ECUStateMgr  * m_ecuStateMgr;
        BootModeBase*  m_bootModeBase;
        VemsProtocol*  m_vp;

};



#endif // FIRMWAREMGR_H
