#ifndef CONFIGDOWNLOADCONTROLLER_H
#define CONFIGDOWNLOADCONTROLLER_H


#include "DeviceInfo.h"
#include "../communication/clients/DeviceModeSelectorListener.h"
#include "../communication/clients/FirmwareVerifierListener.h"
#include "../communication/clients/FirmwareUploaderListener.h"
#include "../communication/clients/TimeoutListener.h"


class FirmwareData;
class VemsDeviceControllerBase;


class FirmwareVerifyController
    : public wxEvtHandler
    , public DeviceModeSelectorListener
    , public FirmwareVerifierListener
    , public FirmwareUploaderListener
    , public TimeoutListener
{
    DECLARE_DYNAMIC_CLASS(FirmwareVerifyController)

    public:
        FirmwareVerifyController();
        FirmwareVerifyController( VemsDeviceControllerBase* deviceController, wxEvtHandler* eventHandler );
        virtual ~FirmwareVerifyController();

        void verify( FirmwareData* firmwareData );
        void upload( FirmwareData* firmwareData );

        void OnDeviceModeSelected( ECUInfo::EcuMode deviceMode );
        void OnFirmwareVerifyEvent( FirmwareVerifyEvent&  event );
        void OnFirmwareUploaderEvent( FirmwareUploadEvent&  event );
        void OnTimeout();

    private:
        VemsDeviceControllerBase*       m_deviceController;
        wxEvtHandler*                   m_eventHandler;
        FirmwareData*                   m_firmwareData;
        ECUInfo::EcuMode                m_deviceMode;

        int                             m_processType;  // UPLOAD/VERIFY

};


#endif // CONFIGDOWNLOADCONTROLLER_H
