#ifndef GPSPROTOCOL_H
#define GPSPROTOCOL_H

#include "wx/wx.h"

#include "ProtocolBase.h"
#include "../GPSNMEA/NMEAParse.h"

class GpsProtocol : public ProtocolBase
{
    public:
        GpsProtocol( wxEvtHandler* eventHandler = NULL );
        virtual ~GpsProtocol();

        ///ProtocolBase virtual functions
        int rx( uint8_t* rxBuff, int rxCount );
        int tx( uint8_t* m_txBuff, int& rxCount );

        //
        bool hasError() { return false; }
    protected:
    private:
        uint8_t m_seqence;
        uint8_t m_packedGpsData[14+3];
        wxEvtHandler*   m_eventHandler;
        NMEAParse       m_parser;

        void packData(uint8_t* packedGpsData);
        void notify();


};

#endif // GPSPROTOCOL_H
