#include "SIPRPacketHelper.h"

#include "SIPRDescriptor.h"
#include "SIPRTypes.h"

SIPRPacketHelper::SIPRPacketHelper()
{
    //ctor
}

SIPRPacketHelper::~SIPRPacketHelper()
{
    //dtor
}

SIPRPacketList SIPRPacketHelper::createSIPRPackets( SIPRDescriptor& siprDesc, uint8_t* pageBuffer, int megatunePageNo)
{
 //Logger::logf(   LOG_MSG, _T("MegatuneProtocol::sendSIPRGetTableEvent() - page: %d"), megatunePageNo );
    SIPRPacketList packetList;
    uint8_t buffer[261];

    int pageType = siprDesc.getPageType( megatunePageNo );
    // unknow type
    //if ( pageType == -1 ) { return packetList; }
    if ( pageType == SIPR_GET_TABLEDATA )
    {
        // send tables
        IntArray siprIDs = siprDesc.getTables( megatunePageNo );
        if ( siprIDs.IsEmpty() ) { return packetList; }

        int pageOffset  = -1;
        int size        = -1;

        for ( size_t i = 0; i < siprIDs.GetCount(); ++i )
        {
            pageOffset  = siprDesc.getOffset( pageType, siprIDs[i] );
            size        = siprDesc.getSize( pageType, siprIDs[i] );
            if ( ( pageOffset == -1 ) || ( size == -1 ) ) { continue; }

            //Logger::logf(   LOG_MSG, _T("MegatuneProtocol::sendSIPRGetTableEvent() - type: table, page: %d, offset: %d, size: %d, sipr: %d"),
            //               megatunePageNo, pageOffset, size, siprIDs[i] );

            buffer[0] = siprIDs[i];
            memcpy( &buffer[1], &pageBuffer[pageOffset], size );

            SIPRPacket* p = new SIPRPacket ( 0, SIPR_GET_TABLEDATA, 1 + size, buffer );
            packetList.push_back(p);
        }
    }
    else if (   ( pageType == SIPR_GET_CONFIG_1 ) ||
                ( pageType == SIPR_GET_CONFIG_2 ) )
    {
        int size = siprDesc.getSize( pageType, pageType);

        memcpy( buffer, pageBuffer, size );
        SIPRPacket* p = new SIPRPacket( 0, pageType, size, buffer );
        packetList.push_back(p);

    }

    return packetList;
}

