#include "STDataModelWriter.h"

#include "../stdatamanager/STDataModelBase.h"
#include "SIPRFileLogger.h"
#include "SIPRDescriptor.h"
#include "SIPRPacketHelper.h"

void STDataModelWriter::logPages(STDataModelBase* model, SIPRFileLogger* filelogger, SIPRDescriptor* siprDesc)
{

    const IntArray&  pagesOrder = siprDesc->getPagesOrder();

    for(size_t i =0; i < pagesOrder.GetCount(); ++i){

        int pageNo = pagesOrder.Item(i);
        uint8_t* pageBuffer = model->getRawBuffer(pageNo);

        SIPRPacketList packets = SIPRPacketHelper::createSIPRPackets(*siprDesc, pageBuffer, pageNo);

        for ( SIPRPacketList::iterator it = packets.begin(); it != packets.end(); ++it ){
            SIPRPacket* p = *it;
            filelogger->process(*p );
            delete p;
        }
    }
}
