#ifndef TERMINALPANEL_H
#define TERMINALPANEL_H


#include <wx/wx.h>
#include "../common/typedef.h"


class TerminalPanel;


class TerminalLog
{
    public:
        static void init( TerminalPanel* terminal );

        //static void rx( uint8_t* );

        static void rxLog( uint8_t* data, int size );
        static void txLog( uint8_t* data, int size );

        static void portLog( const wxString& portName );
        static void baudLog( int baudRate );
        static void protocolLog( const wxString& protocolName );
        //tx( uint8_t* txBuffer, int& size )
    private:
        static TerminalPanel*   s_pTerminal;

    private:
        ~TerminalLog() {}
};


class TerminalPanel: public wxPanel
{
    public:
        TerminalPanel( wxWindow* parent, wxWindowID id = wxID_ANY );
        virtual ~TerminalPanel() {}

        void            rxLog( uint8_t* data, int size );
        void            txLog( uint8_t* data, int size );
        void            portLog( const wxString& portName );
        void            baudLog( int baudRate );
        void            protocolLog( const wxString& protocolName );

    private:
        wxTextCtrl*         m_pTextCtrlRx;
        wxTextCtrl*         m_pTextCtrlTx;

        wxTextCtrl*         m_pTextCtrlRxCount;
        wxTextCtrl*         m_pTextCtrlTxCount;

        wxTextCtrl*         m_pTextCtrlPort;
        wxTextCtrl*         m_pTextCtrlBaud;
        wxTextCtrl*         m_pTextCtrlProtocol;

        int                 m_iRxCount;
        int                 m_iTxCount;

        wxTimer             m_timer;

        wxMemoryBuffer      m_rxBuffer;
        wxMemoryBuffer      m_txBuffer;
        wxCriticalSection   m_criticalSection;

        wxString            createString( const uint8_t* data, size_t size );

        void                OnTimer( wxTimerEvent& event );
        void                OnClearAllButton( wxCommandEvent& event );
        DECLARE_EVENT_TABLE()
};


#endif // TERMINALPANEL_H
