#ifndef DEVICERECOGNIZER_H
#define DEVICERECOGNIZER_H

#include "IRecognizer.h"
#include "../ECUInfo.h"


class DeviceRecognizer : IRecognizer
{
    public:
        DeviceRecognizer( IRecognizer* recognizer, ECUInfo::Device device, ECUInfo::EcuMode mode )
        {
            m_recognizer    = recognizer;
            m_device        = device;
            m_mode          = mode;;
        }

        virtual ~DeviceRecognizer() { delete m_recognizer; }

        bool feed( char c ) { return m_recognizer->feed( c ); }
        void reset() { m_recognizer->reset(); }

        ECUInfo::Device     getDevice() const { return m_device; }
        ECUInfo::EcuMode    getMode() const { return m_mode; }

    private:
        IRecognizer*        m_recognizer;
        ECUInfo::Device     m_device;
        ECUInfo::EcuMode    m_mode;
};

#endif // DEVICERECOGNIZER_H
