#include "FirmwareVersionRecognizer.h"
#include "../../common/TxData.h"

#include <wx/regex.h>

FirmwareVersionRecognizer::FirmwareVersionRecognizer()
{
    m_serial    = wxEmptyString;
    m_state     = WAIT_FIRST_NUM;
}

FirmwareVersionRecognizer::~FirmwareVersionRecognizer()
{

}

bool FirmwareVersionRecognizer::feed( char c )
{
    switch ( m_state )
    {
        case WAIT_FIRST_NUM:
            if ( isdigit(c) ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = WAIT_FIRST_DOT;
            }
            break;

        case WAIT_FIRST_DOT:
            if ( c == '.' ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = WAIT_SECOND_NUM;
            } else if ( isdigit(c) ) {
                m_serial.Clear();
                m_serial.Append( wxString::FromAscii(c) );
            } else {
                m_serial.Clear();
                m_state = WAIT_FIRST_NUM;
            }
            break;

        case WAIT_SECOND_NUM:
            if ( isdigit(c) ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = WAIT_SECOND_DOT;
            } else {
                m_serial.Clear();
                m_state = WAIT_FIRST_NUM;
            }
            break;

        case WAIT_SECOND_DOT:
            if ( c == '.' ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = WAIT_THIRD_NUM;
            } else {
                m_serial.Clear();
                m_state = WAIT_FIRST_NUM;
            }
            break;

        case WAIT_THIRD_NUM:
            if ( isdigit(c) ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = WAIT_FOURTH_NUM;
            } else {
                m_serial.Clear();
                m_state = WAIT_FIRST_NUM;
            }
            break;

        case WAIT_FOURTH_NUM:
            if ( isdigit(c) ) {
                m_serial.Append( wxString::FromAscii(c) );
                m_state = FINISHED;
            } else {
                m_serial.Clear();
                m_state = WAIT_FIRST_NUM;
            }
            break;

        default:
            break;
    }

    return ( m_state == FINISHED );

}

void FirmwareVersionRecognizer::reset()
{
    m_serial.Clear();
    m_state = WAIT_FIRST_NUM;
}

TxData* FirmwareVersionRecognizer::getReceivedData()
{
    return new TxData( m_serial.mb_str() );
}
