#include "LengthRecognizer.h"
#include "../../common/TxData.h"

LengthRecognizer::LengthRecognizer( size_t length )
{
    m_length = length;
    m_received = 0;
    m_buffer = new uint8_t[m_length];
}

LengthRecognizer::~LengthRecognizer()
{
    delete[] m_buffer;
}

bool LengthRecognizer::feed( char c )
{
    if ( m_received < m_length )
    {
        m_buffer[m_received] = (uint8_t)c;
        ++m_received;
    }

    return ( m_received == m_length );
}

void LengthRecognizer::reset()
{
    m_received = 0;
    delete[] m_buffer;
    m_buffer = new uint8_t[m_length];
}

TxData* LengthRecognizer::getReceivedData()
{
    return new TxData( m_buffer, m_received );
}
