#ifndef RangeRecognizer_H
#define RangeRecognizer_H

#include "IRecognizer.h"
#include "../../common/typedef.h"

class RangeRecognizer : public IRecognizer
{
    public:
        RangeRecognizer( size_t minLength, size_t maxLength );
        virtual ~RangeRecognizer();

        bool    feed( char c );
        void    reset();
        TxData* getReceivedData();

    private:
        size_t      m_minLength;
        size_t      m_maxLength;
        size_t      m_received;
        uint8_t*    m_buffer;
};

#endif // RangeRecognizer_H
