#include "ResponseRecognizer.h"
#include "../../common/TxData.h"
#include "../../logger.h"

ResponseRecognizer::ResponseRecognizer( int id, TxData* request, IRecognizer* recognizer, int timeout )
{
    m_id            = id;
    m_timeout       = timeout;
    m_timeoutCount  = 0;
    m_request       = request;
    m_recognizer    = recognizer;
}

ResponseRecognizer::~ResponseRecognizer()
{
    delete m_request;
    delete m_recognizer;
}

bool ResponseRecognizer::feed( char c )
{
    return m_recognizer->feed( c );
}

void ResponseRecognizer::reset()
{
    m_recognizer->reset();
    m_timeoutCount = 0;
}

TxData* ResponseRecognizer::getReceivedData()
{
    return m_recognizer->getReceivedData();
}
