#ifndef DEVICESICON_H
#define DEVICESICON_H


#include "VemsToolIconBase.h"
#include "../vemsprotocol/ECUInfo.h"


class  ProcessBase;
class VemsDeviceControllerEvent;


class DevicesIcon: public VemsToolIconBase
{
    public:
        DevicesIcon(wxWindow* parent, wxWindowID id,  const wxString& icondir, const wxPoint &pos = wxDefaultPosition,
        wxEvtHandler* eventHandler = NULL, ProcessBase* commCtrlState = NULL);
        virtual ~DevicesIcon();

        void IconInit();

    protected:

        enum State{
            DI_NA_RED,
            DI_NA_WHITE,
            DI_ARM,
            DI_V3,
            DI_ROUND
        };



    private:

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);


        wxBitmapLayerHash   m_upBmps;
        wxBitmapLayerHash   m_downBmps;

        State m_state;

        ProcessBase* m_commCtrlState;

        void refresh( State state );
        void refreshDevice( ECUInfo::Device device );

        void OnCannotOpenPort( VemsDeviceControllerEvent& event );
        void OnDeviceNotFound( VemsDeviceControllerEvent& event );
        void OnDeviceConnected( VemsDeviceControllerEvent& event );
        void OnDeviceDisconnected( VemsDeviceControllerEvent& event );
        void OnDeviceControllerStopped( VemsDeviceControllerEvent& event );
        void OnDeviceResumed( VemsDeviceControllerEvent& event );

        DECLARE_EVENT_TABLE();
};


#endif // DEVICESICON_H
