#include "ScreenIcon.h"



BEGIN_EVENT_TABLE(ScreenIcon, VemsToolIconBase)
     //EVT_PAINT(ExitIcon::OnPaint)
     EVT_LEFT_DOWN(ScreenIcon::OnLeftDown)
     EVT_LEFT_UP(ScreenIcon::OnLeftUp)

END_EVENT_TABLE()


ScreenIcon::ScreenIcon(wxWindow *parent, wxWindowID id, const wxString& icondir, const wxPoint &pos)
         :VemsToolIconBase(parent,id,icondir,pos,_T("screen.png"))
{
    //ctor
    m_menu  = NULL;
    m_parent = parent;

    m_screenUpBmp     = new wxBitmapLayer(0, icondir +  _T("screen.png"));
    m_screenDownBmp   = new wxBitmapLayer(0, icondir +  _T("screen-down.png"));

}


ScreenIcon::~ScreenIcon()
{
    //dtor
    delete m_screenUpBmp;
    delete m_screenDownBmp;
}

void ScreenIcon::IconInit()
{

    IconInitBase(m_screenUpBmp);

}

void ScreenIcon::OnLeftDown(wxMouseEvent& evt)
{

    m_bmpLayers->AddBitmap(m_screenDownBmp);
    Refresh(false);

}

void ScreenIcon::OnLeftUp(wxMouseEvent& evt)
{
    m_bmpLayers->AddBitmap(m_screenUpBmp);
    Refresh(false);

    PopupMenu(m_menu);

}

void ScreenIcon::SetMenu(wxMenu *menu)
{
    m_menu = menu;
}
