#ifndef SELECTINPUTICON_H
#define SELECTINPUTICON_H

#include "VemsToolIconBase.h"

#include "../GPSInfo.h"


class VemsTuneController;
class RTDataMgrBase;
class ECUEvent;
class ECUCommEvent;
class GPSEvent;
class GPSCommEvent;
class ECULogEvent;

class SelectInputIcon: public VemsToolIconBase
{
    public:

        //SelectInputIcon(wxWindow* parent, wxWindowID id, const wxPoint pos = wxDefaultPosition);
        SelectInputIcon(wxWindow* parent, wxWindowID id, const wxString& icondir, const wxPoint pos = wxDefaultPosition,
                        RTDataMgrBase   *rtDataMgr = NULL );
        virtual ~SelectInputIcon();

        void SetDataMgr(RTDataMgrBase *rtDataMgr);

        void SetVemsTuneController(VemsTuneController *ctrl);

        void IconInit();
    protected:

        DECLARE_EVENT_TABLE();

        void showEcuState();


    private:

        void OnECUEvent(ECUEvent& event);
        void OnECUCommState(ECUCommEvent& event);

        void OnGPSEvent( GPSEvent& event );
        void OnGPSCommEvent( GPSCommEvent& event );

        void OnLogEvent(ECULogEvent &event);


        void SetMenuState();
        void RefreshIcon();

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);
        void OnSelectGaugeInput(wxCommandEvent& event);
        void OnActivate(wxActivateEvent& evt);



        RTDataMgrBase   *m_rtDataMgr;



        VemsTuneController *m_vemsTuneController;


        wxMenu          *m_menu;

        wxBitmapLayer   *m_iFileBmp;
        wxBitmapLayer   *m_iECUBmp;
        wxBitmapLayer   *m_iNoneBmp;

        wxBitmapLayer   *m_sConnBmp;
        wxBitmapLayer   *m_sNotCBmp;
        wxBitmapLayer   *m_sLoggBmp;

        wxBitmapLayer   *m_inputUpBmp;
        wxBitmapLayer   *m_inputDownBmp;

        int m_EcuState;
        int m_EcuCommState;

        //GPSInfo::State         m_gpsState;
        //GPSInfo::CommState     m_gpsCommState;


};



#endif // SELECTINPUTICON_H
