#ifndef VERSION_H
#define VERSION_H

#ifdef __GNUC__
    #define _UNUSED_ __attribute__((unused))
#else
    #define _UNUSED_
#endif


namespace AutoVersion{

	//Date Version Types
	static const char DATE[] = "22";
	static const char MONTH[] = "12";
	static const char YEAR[] = "2010";
	static const double UBUNTU_VERSION_STYLE = 8.08;

	//Software Status
	static const char STATUS[] = "Beta";
	static const char STATUS_SHORT[] = "b";

	//Standard Version Type
	static const long MAJOR = 0;
	static const long MINOR = 20;
	static const long BUILD = 10;
	static const long REVISION = 00;

	//Miscellaneous Version Types
	static const long BUILDS_COUNT = 00;
	#define RC_FILEVERSION 0,20,10,0
	#define RC_FILEVERSION_STRING "0, 20, 10, 0\0"
	static const char FULLVERSION_STRING[] = "0.20.10.00";

	//These values are to keep track of your versioning state, don't modify them.
	static const long BUILD_HISTORY = 10;

    static wxString getVersion(){
        return wxString::Format(_T("%u.%u.%u"), MAJOR, MINOR, BUILD);
    }

    static wxString getAppName(){
        #if defined (__WINCE_STANDARDSDK__)
            return _T("VemsCockPit");
        #else
            return _T("VemsTune");
        #endif
    }

    static wxString getDateTime(){
        wxString year = wxString::FromAscii(AutoVersion::YEAR);
        wxString month = wxString::FromAscii(AutoVersion::MONTH);
        wxString date = wxString::FromAscii(AutoVersion::DATE);
        wxString dateStr = year +_T(".")+ month +_T(".") +date;
        return dateStr;
    }

    static wxString getFullVersion() _UNUSED_;
    static wxString getFullVersion()
    {
        return getAppName() +_T(" ") + getVersion() + _T(" (") + getDateTime() + _T(")");
    }

}
#endif //VERSION_H
