#ifndef VTFILESMD5CHECKERTHREAD_H
#define VTFILESMD5CHECKERTHREAD_H

#include <string>
#include <wx/wx.h>

#include "../Observable.h"
#include "../common/ProcessBase.h"
#include "../common/types/StringHash.h"

class VTFilesMD5CheckerThread : public ProcessBase
{
    public:
        VTFilesMD5CheckerThread( wxEvtHandler* evtHandler, const StringHash& filesToCheck, const wxString& m_baseDir );

        virtual ~VTFilesMD5CheckerThread()  {}

    public:
        bool            process();
        void            reset() {}

        wxArrayString   getFilesToUpdate() const { return m_filesToUpdate; }

    private:
        StringHash      m_filesToCheck;
        wxArrayString   m_filesToUpdate;
        bool            m_running;
        wxString        m_baseDir;
        wxEvtHandler*   m_evtHandler;

    private:
        void        finished() {}
        wxString    stdString2wxString( const std::string& str );
        std::string wxString2stdString( const wxString& str );
};

#endif // VTFILESMD5CHECKERTHREAD_H
