#include "VTFilesUpdaterSettings.h"

#include "../logger.h"
#include "../configmanager/ConfigHelper2.h"


BEGIN_EVENT_TABLE( VTFilesUpdaterSettings, wxDialog )
    EVT_BUTTON( wxID_ANY, VTFilesUpdaterSettings::OnButton )
END_EVENT_TABLE()

VTFilesUpdaterSettings::VTFilesUpdaterSettings( wxWindow* parent ) :
    wxDialog( parent, wxID_ANY, _T("Automatic updates"), wxDefaultPosition, wxDefaultSize )
{
    // read current settings

    m_config = ConfigHelper2::getConfig( ConfigHelper2::CONFIG_MAIN );

    long int autoUpdate = 0;

    if ( m_config->read( _T("/updates/update"), &autoUpdate ) == false )
    {
        autoUpdate = 0;
    }
    if ( autoUpdate < 0 || autoUpdate > 2 )
    {
        autoUpdate = 0;
    }

    wxBoxSizer* mainsizer = new wxBoxSizer( wxVERTICAL );

    wxStaticBoxSizer* bsizer = new wxStaticBoxSizer( wxHORIZONTAL, this, _T("Automatic updates") );

    wxFlexGridSizer* gsizer = new wxFlexGridSizer( 2 );

    wxStaticText* txt = new wxStaticText( this, -1, _T("Check for updates") );

    wxArrayString arr;
    arr.Add( _T("Never update files") ); arr.Add( _T("Show confirmation dialog on update") ); arr.Add( _T("Update automatically") );

    m_choice1 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, arr );
    m_choice1->SetSelection( autoUpdate );

    gsizer->Add( txt, 0, wxEXPAND | wxALL, 5 );
    gsizer->Add( m_choice1, 1, wxEXPAND | wxALL, 5 );

    bsizer->Add( gsizer, 1, wxEXPAND | wxALL, 5 );

    wxSizer* buttons = CreateButtonSizer( wxOK | wxCANCEL );

    mainsizer->Add( bsizer, 1, wxEXPAND | wxALL, 5 );
    mainsizer->Add( buttons, 0, wxEXPAND | wxALL, 5 );

    SetSizer( mainsizer );
    mainsizer->Fit( this );
    mainsizer->SetSizeHints( this );
}

void VTFilesUpdaterSettings::OnButton( wxCommandEvent& event )
{
    int id = event.GetId();
    if ( id == wxID_OK )
    {
        int sel = m_choice1->GetSelection();
        if ( sel < 0 || sel > 2 )
        {
            sel = 0;
        }

        wxString sVal = wxString::Format( _T("%d"), sel );

        m_config->write( _T("/updates/update"), sVal );
        m_config->save();

        //delete m_config;

        EndModal( wxID_OK );
    }
    if ( id == wxID_CANCEL )
    {
        //delete m_config;

        EndModal( wxID_CANCEL );
    }

    event.Skip();
}
