#ifndef FILEUPLOADERPROVIDERBASE_H
#define FILEUPLOADERPROVIDERBASE_H

#include <wx/wx.h>

#include "../Observable.h"
#include "../common/ProcessBase.h"


class FileUploaderProviderBase: public ProcessBase, public Observable
{
    public:
        FileUploaderProviderBase(wxEvtHandler* eventhandler = NULL);
        virtual ~FileUploaderProviderBase();


        virtual bool UploadFiles(const wxVariantHash& files, const wxString& remotefilepath, wxVariantHash postdata = wxVariantHash()) = 0;
        /**
            files[name] = path
        */
        virtual wxString GetResponse() { return m_responseStr; }

        void SetHost(const wxString host) { m_host = host; };
        void SetHandler(const wxString handler) {  m_handler = handler; };
        void SetUserName(const wxString uname) {  m_userName = uname; };
        void SetPassword(const wxString pass) {  m_pass = pass; };
        void SetPasswordMd5(const wxString passmd5) {  m_passMd5 = passmd5; };

        void SetId(int id) { m_id = id; };
        int GetId() { return m_id; };



    protected:

        wxString    m_host;
        wxString    m_handler;
        wxString    m_userName;
        wxString    m_pass;
        wxString    m_passMd5;

        int         m_id;

        wxEvtHandler* m_eventHandler;

        wxString    m_responseStr;

};

class wxCurlUploader: public FileUploaderProviderBase
{
    public:
        wxCurlUploader(wxEvtHandler* eventhandler = NULL) : FileUploaderProviderBase(eventhandler) {}

        virtual bool UploadFiles(const wxVariantHash& files, const wxString &remotefilepath, wxVariantHash postdata = wxVariantHash());

        virtual bool process();
        virtual void reset();

    private:

        virtual void finished();

        wxVariantHash   m_postData;
        wxVariantHash   m_fileList;

};

/*
class FTPUploader: public FileUploaderProviderBase
{
    public:

        virtual bool UploadFiles(const wxVariantHash& files, const wxString &remotefilepath, wxVariantHash postdata = wxVariantHash());

        virtual bool UploadFile(const wxString &localfilefullpath, const wxString &remotefilepath);

        virtual bool process();
        virtual void reset();

    private:

        virtual void finished();

        wxString m_localFilePath;
        wxString m_remotePath;

};
*/

#endif // FILEUPLOADERPROVIDERBASE_H
