#ifndef MINIMAL_H
#define MINIMAL_H

#include "../rtdatamanager/RTDataRawLogger.h"

#include <wx/taskbar.h>
#include "../VemsTaskBarIcon.h"


#include "../ThreadStatus.h"

#include "../stdatamanager/VemsEvent.h"

class VemsInitialScreen;
class VemsTuneController;

class MyApp : public wxApp, public ThreadStatusListener
{
	public:

		virtual bool OnInit();
		virtual int OnExit();

		void OnInitframeActivate(wxActivateEvent &evt);

		void TSNotify(ThreadState state);
	void checkCommPort();

	private:

        void OnThreadEnd(VemsControlEvent &event);

        bool VemsInit();

        VemsInitialScreen *m_initscreen;
        VemsTuneController *m_vemsTuneController;


		GaugeFrameBase *m_frame;
		WindowReg *wreg;
		VemsTaskBarIcon *m_TaskBarIconApp;
		HWND hWnd;

		RTDataMgrBase * m_rtDataMgr;
		STDataMgrBase * m_stController;
		int m_CurrentAngle;

};

#endif
