#include "mainframe.h"

#include <wx/tokenzr.h>
#include <wx/wxhtml.h>
#include <wx/url.h>
#include <wx/filename.h>
#include <hl_hashwrapper.h>
#include <hl_md5wrapper.h>
#include <wx/zipstrm.h>
#include <wx/wfstream.h>
#include <wx/dcbuffer.h>
#include <wx/regex.h>

#include "common/FunctionMeter.h"

#if 1

#include "DirHelper.h"
#include "logger.h"






#include "web/WebInterfacePanel.h"
#include "SimpleFwDlg.h"

#include "FrameLayoutHandler.h"

#include "stdatamanager/STDataMgrFacade.h"


#include "web/FileUploaderProviderBase.h"

#include "UserLog.h"



#include "VemsMsgListCtrl.h"
#include "common/VemsMessage.h"
#include "common/VemsContext.h"
#include "common/VemsMessageHashHelper.h"

#include "project/ProjectWizard.h"

#include <wx/wxsqlite3.h>


#include "MTConfigHelper.h"
#include "gaugedesc/GaugeDescHelper.h"
#include "gaugedesc/GaugeDescManager.h"



#include "vemsdialog/EconosealPanel.h"
#include "vemsgauge/GaugeFrameBase.h"

#include "vemsgauge/GaugeType.h"
#include "vemsgauge/GaugeCarrierFrame.h"
#include "vemsgauge/GaugeCarrierPanel.h"

#include "vemsdialog/WindowTipper.h"

#include "vemsgauge/TableEditorPanel.h"

#include "vemsgauge/GaugeCarrierMDIChildFrame.h"

#include "vemsgauge/GaugeGroupManager.h"
#include "hotkeys/wxHotKeyManagerGUI.h"

#include "vemsdialog/NewGaugeDescriptorDialog.h"

#include "DrawHelper.h"



#include "common/wxArrayHelper.h"



#include "agg/wxAgg.h"
#include "agg/wxAgg2.h"

#include "loghistory/LogHistoryMgrHelper.h"
#include "loghistory/LogHistoryMgr.h"



/**
    sample: 10000

    A: 3070 ms   , P4: 5922 ms
        - canvas size: 2x4 * 20
        - 307 usec / 1 data

    B: 5576 ms   , P4: 9688 ms
        - canvas size: 2x600 * 1
        - 557 usec / 1 data


*/

#include "expression/RPNParser.h"
#include "expression/RPNTester.h"

#include "customwidgets/AggToolTip.h"
#include "customwidgets/InfoPanel.h"
#include "loghistory/LogHistoryMgrHelper.h"
#include "loghistory/LogHistoryMgr.h"


#include "vemsgauge/GPSRouteGauge.h"

#include "configmanager/ConfigHelper2.h"

#include "vemsgauge/GaugeCarrierFrame.h"
#include "vemsgauge/GaugeType.h"
#include "gaugedesc/GaugeDescHelper.h"

#include "rtdatamanager/RTDataMgrFacade.h"

#include "rtdatamanager/RTDataInputSIPR.h"

#include "RawLogHelper.h"

#include "gaugedesc/GaugeDescManagerSQL.h"
#include "vemsgauge/GaugeGroupManagerSQL.h"

#include "VemsTuneCore.h"

#include "wxHSLColor.h"


#include "bcWidgets/bcParentFrame.h"
#include "bcWidgets/bcTextCtrl.h"
#include "bcWidgets/bcButton.h"
#include "bcWidgets/bcWrapper.h"
#include "bcWidgets/bcStaticBitmap.h"
#include "bcWidgets/bcLabel.h"
#include "bcWidgets/bcRadioButton.h"
#include "bcWidgets/bcCheckBox.h"
#include "bcWidgets/bcProgressBar.h"
#include "bcWidgets/bcParentPanel.h"
#include "bcWidgets/bcStaticLine.h"

#include "customwidgets/wxTextCtrlNullEx.h"
#include "customwidgets/wxCheckBoxEx.h"
#include "bcWidgets/bcCarrierPanel.h"


#include "bcWidgets/bcProgressDialog.h"

#endif

#include <wx/progdlg.h>


#include "web/wxWebBrowser.h"

#include "gui/ErrorReportDialog.h"

#include "ConfigFile.h"

void MainFrame::OnWinCETest(wxCommandEvent& event)
{

    ErrorReportDialog dlg(this);
    dlg.ShowModal();

#if 0
    bcParentFrame* f = new bcParentFrame(this,-1,_T(" bc test"));

    f->Show(1);

    bcCheckBox* cb1 = new bcCheckBox(f, wxID_ANY,_T("TeVeja cb"), wxPoint(5,0) );
    bcCheckBox* cb2 = new bcCheckBox(f, wxID_ANY,_T("TeVeja cb"), wxPoint(5,20));
    bcCheckBox* cb3 = new bcCheckBox(f, wxID_ANY,_T("TeVeja cb"), wxPoint(5,40));
    bcCheckBox* cb4 = new bcCheckBox(f, wxID_ANY,_T("TeVeja cb"), wxPoint(5,60));

    cb2->SetStyle(BCCBS_CROSS);
    cb3->SetStyle(BCCBS_CROSS2);
    cb4->SetStyle(BCCBS_RECT|BCCBS_TEXT_GRAVEN);

    bcRadioButton* bcrb1 = new bcRadioButton(f, wxID_ANY,_T("TeVeja1"),1, wxPoint(5,80));
    bcRadioButton* bcrb2 = new bcRadioButton(f, wxID_ANY,_T("TeVeja2"),1, wxPoint(5,100));
    bcRadioButton* bcrb3 = new bcRadioButton(f, wxID_ANY,_T("TeVejb1"),2, wxPoint(5,120));
    bcRadioButton* bcrb4 = new bcRadioButton(f, wxID_ANY,_T("TeVejb2"),2, wxPoint(5,140));

    bcTextCtrl* bctc = new bcTextCtrl(f, wxID_ANY, _T("muha"), wxPoint(5,160));

    wxBoxSizer* bs = new wxBoxSizer(wxVERTICAL);

    bcButton* bcb1 = new bcButton(f, wxID_ANY, _T("Button1"), wxPoint(5,180));
    bcButton* bcb2 = new bcButton(f, wxID_ANY, _T("Button2"), wxPoint(5,200));
    bcButton* bcb3 = new bcButton(f, wxID_ANY, _T("Button3"), wxPoint(5,220));

    bcButton* bcb4 = new bcButton(f, wxID_ANY, DrawHelper::GetIconImg(_T("colorize16c.png")), wxPoint(5,240) );
    //bcButton* bcb5 = new bcButton(f, wxID_ANY, DrawHelper::GetIconImg(_T("icon_sat.png ")), wxPoint(5,260) );
    bcLabel* bcb5 = new bcLabel(f, wxID_ANY, _T("teve"));
    //bcb5->SetProperty( BCBS_TEXT_COLOR, wxColor(180,0,0), true );
    TextDesc desc = bcb5->GetLabelDesc();
    desc.Color = wxColor(180,0,0);
    bcb5->SetLabel(desc);

    bcb1->SetToggleValue(1);
    bcb1->Disable();
    bcb4->Disable();

    bcb1->SetGroupId(1);
    bcb2->SetGroupId(1);
    bcb3->SetGroupId(1);

    bcb1->SetStyleFlag(bcBUTTON_TOGGLE);
    bcb2->SetStyleFlag(bcBUTTON_TOGGLE);
    bcb3->SetStyleFlag(bcBUTTON_TOGGLE);

    bcb3->SetStyleFlag(bcBUTTON_HOVER_OUTER_GLOW);

    bcProgressBar* bcpb = new bcProgressBar(f, wxID_ANY);
    bcpb->SetStyle(BCPBS_INFINITY);
    bcpb->StartAnim();


    bs->Add( new bcWrapper(bcb1), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcb2), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcb3), 0, wxALL | wxEXPAND, 2 );
    bs->Add( new bcWrapper(cb1), 0, wxALL, 2 );
    bs->Add( new bcWrapper(cb2), 0, wxALL, 2 );
    bs->Add( new bcWrapper(cb3), 0, wxALL, 2 );
    bs->Add( new bcWrapper(cb4), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcrb1), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcrb2), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcrb3), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcrb4), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bctc), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcb4), 0, wxALL, 2 );
    bs->Add( new bcWrapper(bcb5), 0, wxALL, 2 );

    bs->Add( new bcWrapper(bcpb), 0, wxALL, 2 );

    wxCheckBoxEx* cb = new wxCheckBoxEx(f,-1,_T("teve"));
    bs->Add( cb, 0, wxALL, 2 );

    f->SetSizer(bs);
    bs->SetSizeHints(f);
#endif

}

void MainFrame::OnWinCETest3( wxCommandEvent& event )
{
}

#include "triggerlog/TriggerLogGraph.h"

extern int idWinceTestTimerId;

void MainFrame::OnWinCETestTimer( wxTimerEvent& event )
{

}

#include "agg/wxAgg2.h"

#include "rtdatastat/RTLiveAnalyzer.h"
#include "VemsTuneController.h"

void MainFrame::OnWinCETest2( wxCommandEvent& event )
{
    MTConfigData* configData = MTConfigHelper::getMTConfigData();
    if ( !configData ) return;
    VemsTableDescH* tableDescH = configData->getTables();
    VemsTableDesc* tableDesc;

    SymbolMgr* mgr = &configData->getSymbolMgr();

    if ( mgr == NULL )
        return;

    Symbol* as = mgr->getSymbol(_T("alphan"));

    bool alphanMode;
    if ( as != NULL )
    {
        double d = m_stController->getDataFromViewerModel( *as );
        if ( d )
            alphanMode = true;
        else
            alphanMode = false;
    }
    else
    {
        Symbol* sym = mgr->getSymbol(_T("hybrid_rpm_a"));
        Symbol* sym2 = mgr->getSymbol(_T("hybrid_rpm_m"));

        if ( sym == NULL || sym2 == NULL )
            return;

        double d = m_stController->getDataFromViewerModel( *sym );
        double d1 = m_stController->getDataFromViewerModel( *sym2 );

        if ( d == 0 && d1 == 0 )
            alphanMode = false;
        else
            alphanMode = true;
    }

    tableDesc = ( alphanMode ) ? (*tableDescH)[ _T("veTableTblTPS") ] :(*tableDescH)[ _T("veTableTbl") ];
    if(!tableDesc) return;

    MTConfigData* mtcfg = MTConfigHelper::getMTConfigData();

    RTLiveAnalyzer* win = new RTLiveAnalyzer( this, m_vemsTuneController->getRTDataMgr(), m_vemsTuneController->getSTDataMgr(),
                &(mtcfg->getSymbolMgr()), tableDesc );

    win->Show();
}



