#ifndef IACCONTROL_H
#define IACCONTROL_H

#include "../rtdatamanager/RTDataViewerBase.h"

class RTDataMgrBase;
class CommandRequestBase;

class Saver
{
    public:
        Saver(int src, int* dest){
            m_src = src;
            m_dest = dest;
        }

        ~Saver(){
            *m_dest = m_src;
        }

    private:
        int m_src;
        int* m_dest;
};

class IACHistory
{
    public:
        IACHistory();
         void Add(int rpm);
        int getDelta();
    private:
        int getNextIdx(int idx);
        int getPrevIdx(int idx);
        int m_rpmBuff[4];
        int m_timeBuff[4];
        int m_nextIdx;
        int m_sequence;
        wxStopWatch m_timer;
};

class IACControl : public RTDataViewerBase
{
    public:
        IACControl(RTDataMgrBase* mgr, CommandRequestBase* requestMgr, bool doregister = true);

        void SetValue(double value){};

        void Start();
        void Stop();

        void refresh(DoubleHash* table);

        void require();
        void unregisterSymbols();

        void SetValueIdx(int idx);

        void setTargetRPM(int value){
            m_targetRPM = value;
        }

        virtual ~IACControl();

        void SetIntegral(double i);
        void SetDifferential(double d);

        double GetIntegral() const { return m_integral; };
        double GetDiffrential() const { return m_D; };
        double GetTargetRPM() const { return m_targetRPM; }

    protected:
    private:
        CommandRequestBase* m_requestMgr;
        IACHistory m_iacHistory;

        bool m_isSymbolChanged;
        wxArrayString   m_symbolA;
        wxString m_rpm, m_tps, m_iacPos,  m_map;
        int m_targetRPM;
        int m_prevRPM;

        double m_integral;
        double m_D;
        double m_remained;
        void commandRequest(int value);


};


#endif // IACCONTROL_H
