#ifndef IACCONTROLPANEL_H
#define IACCONTROLPANEL_H

#include <wx/wx.h>

class CommandRequestBase;
class IACControl;

class IACControlPanel: public wxPanel
{
    public:
        IACControlPanel(wxWindow* parent, CommandRequestBase* requestMgr, IACControl* autoCtrl = NULL);
        virtual ~IACControlPanel();

        void setAutoControl(IACControl* autoCtrl);

    protected:
    private:

        CommandRequestBase* m_requestMgr;

        wxTextCtrl* m_textctrl;
        wxTextCtrl* m_targetRPMctrl;
        wxTextCtrl* m_intergaralVal;
        wxTextCtrl* m_diffVal;

        wxButton*   m_startButton;
        wxButton*   m_stopButton;

        enum {
            idTargetRPM,
            idIntegralVal,
            idDiffVal,
            idButtonStart,
            idButtonStop
        };


        void buildGUI(wxWindow* parent);
        void OnEnter( wxCommandEvent& event );
        void OnKillFocus( wxFocusEvent& event );
        void OnKeyDown( wxKeyEvent& event );
        void OnCloseButton( wxCommandEvent& event );
        void OnButton( wxCommandEvent& event );

        void SendIACLockVal();

        void commandRequest(int ignition);

        DECLARE_EVENT_TABLE();

        IACControl* m_autoCtrl;
};

#endif // IACCONTROLPANEL_H
