#ifndef WXSQLCOLUMNDESC_H
#define WXSQLCOLUMNDESC_H


class ColumnDesc
{
    public:
        ColumnDesc(const wxString& name, const wxString& type,const wxVariant& defval = wxNullVariant, bool primary = false, bool autoinc = false, bool unique = false, bool notnull = false ) {
            Name = name;
            Type = type;
            DefaultValue = defval;
            Primary = primary;
            AutoIncrement = autoinc;
            Unique = unique;
            Notnull = notnull;
        };

        ColumnDesc() {
            Name = wxEmptyString;
            Type = wxEmptyString;
            DefaultValue = wxNullVariant;
            Primary = false;
            AutoIncrement = false;
            Unique = false;
            Notnull = false;
        };

        wxString    Name;
        wxString    Type;
        wxVariant   DefaultValue;
        bool        Primary;
        bool        AutoIncrement;
        bool        Unique;
        bool        Notnull;

        wxString GetColDefStr();

};

WX_DECLARE_OBJARRAY(ColumnDesc, ColumnDescArray);
WX_DECLARE_STRING_HASH_MAP( ColumnDescArray, ColumnDescArrayHash );

#endif // WXSQLCOLUMNDESC_H
