#include "wxSizerHelper.h"

#include "common/typedef.h"
#include "logger.h"

/// is not recursive
bool wxSizerHelper::DeleteRow(wxGridBagSizer* sizer, int row, bool isDelWindows)
{
    int colc = sizer->GetCols();

    for(int a=0; a<colc; a++) {
        wxGBPosition pos(row,a);
        wxGBSizerItem * sitem = sizer->FindItemAtPosition(pos);
        if(!sitem) continue;
        wxWindow * win = sitem->GetWindow();
        if(!win) continue;

        sizer->Detach(win);
        if( isDelWindows ) delete win;
    }

    for(uint16_t a=row+1; a < sizer->GetRows(); a++) {
        for(int i = 0; i < colc; i++){
            wxGBSizerItem * sItem = sizer->FindItemAtPosition(wxGBPosition(a, i));
            if(sItem)
                sItem->SetPos(wxGBPosition(a-1,i));
        }
    }

    return true;
}

bool wxSizerHelper::DeleteRow(wxGridBagSizer* sizer, wxWindow* windowFromRow, bool isDelWindows)
{
    wxGBSizerItem * sitem = sizer->FindItem( windowFromRow );

    if( !sitem ) return false;

    wxGBPosition gbpos = sitem->GetPos();

    int row = gbpos.GetRow();

    return DeleteRow(sizer, row, isDelWindows);
}
