#include "wxXmlHelper.h"


bool wxXmlHelper::SetPropVal(wxXmlNode* node, const wxString& name, const wxString& value, bool isAdd)
{

    for(wxXmlProperty* properties = node->GetProperties(); properties; properties = properties->GetNext() ){
        if( properties->GetName() == name ) {
            properties->SetValue( value );
            return true;
        }
    }

    if(isAdd)
        node->AddProperty( name, value );

    return false;
}

wxXmlNode * wxXmlHelper::GetLastChildNode(wxXmlNode * node)
{
    wxXmlNode * childNode = node->GetChildren();
    wxXmlNode * tmpNode = NULL;

    if(!childNode) return NULL;

    while( 1 ){
        tmpNode = childNode->GetNext();

        if(!tmpNode) return childNode;

        childNode = tmpNode;
    }

}

wxXmlNode * wxXmlHelper::GetNodeByName(const wxString& name, wxXmlNode *node)
{

    for(wxXmlNode * childNode = node->GetChildren(); childNode;childNode = childNode->GetNext() )
        if( childNode->GetName() == name)
            return childNode;


    return 0;

}


bool wxXmlHelper::FindNameInChildNodes(const wxString& name, wxXmlNode *node)
{

    for(wxXmlNode * childNode = node->GetChildren(); childNode;childNode = childNode->GetNext() )
        if( childNode->GetName() == name)
            return true;


    return false;

}

wxXmlNode* wxXmlHelper::FindChildNodeByProp(wxXmlNode * node, const wxString &propname, const wxString &propvalue )
{
    for(wxXmlNode *childNode = node->GetChildren(); childNode; childNode = childNode->GetNext())
    {
        if ( childNode->GetPropVal(propname,wxEmptyString) == propvalue) return childNode;

        wxXmlNode * tmp = FindChildNodeByProp(childNode, propname, propvalue);

        if ( tmp ) return tmp;
    }

    return NULL;
}
